# Gabs.jl

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://QuantumSavory.github.io/Gabs.jl/stable)
[![](https://img.shields.io/badge/docs-dev-lightblue.svg)](https://QuantumSavory.github.io/Gabs.jl/dev)
[![Build status (Github Actions)](https://github.com/QuantumSavory/Gabs.jl/workflows/CI/badge.svg)](https://github.com/QuantumSavory/Gabs.jl/actions)
[![codecov](https://codecov.io/github/QuantumSavory/Gabs.jl/graph/badge.svg?token=JWMOD4FY6P)](https://codecov.io/github/QuantumSavory/Gabs.jl)
[![JET static analysis](https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a)](https://github.com/aviatesk/JET.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

Gabs.jl is a numerical tooling package for simulating **Gaussian quantum information**.

Gaussian states and operators have the convenient property that they can be
characterized by low-dimensional matrices in the phase space representation.
Thus, a large class of continuous variable quantum information can be efficiently
simulated on a classical computer. Gabs.jl provides a high-level [Julia](https://julialang.org) interface for straightforward and high performance implementations of Gaussian quantum systems.

See the detailed [suggested readings & references page](https://QuantumSavory.github.io/Gabs.jl/dev/bibliography/) for a background on quantum information with Gaussian states.

## Installation

To install Gabs.jl, start Julia and run the following command:

```julia
using Pkg
Pkg.add("Gabs")
```
To use the package, run the command

```julia
using Gabs
```

Now, the entire library is loaded into the current workspace, with access to its
high-level interface and predefined objects.

## Example Usage

```julia
julia> basis = QuadPairBasis(1)
QuadPairBasis(1)

julia> state = vacuumstate(basis) ⊗ coherentstate(basis, 1.0-im)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
  0.0
  0.0
  2.0
 -2.0
covariance: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0

julia> op = beamsplitter(basis ⊕ basis, 0.75)
GaussianUnitary for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  0.5        0.0       0.866025  0.0
  0.0        0.5       0.0       0.866025
 -0.866025   0.0       0.5       0.0
  0.0       -0.866025  0.0       0.5

julia> apply!(state, op)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
  1.7320508075688772
 -1.7320508075688772
  1.0
 -1.0
covariance: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0

julia> ptrace(state, 1)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
  1.0
 -1.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```

@testitem "Non-Gaussian States" begin
    using Gabs
    using LinearAlgebra

    @testset "Cat States - Basic Properties" begin
        basis = QuadPairBasis(1)
        α = 1.0 + 0.5im
        cat_even = catstate_even(basis, α)
        @test cat_even isa GaussianLinearCombination
        @test length(cat_even) == 2
        @test cat_even.basis == basis
        @test cat_even.ħ == 2
        c1, c2 = cat_even.coeffs
        @test abs(c1 - c2) < 1e-12
        @test c1 > 0  
        cat_odd = catstate_odd(basis, α)
        @test cat_odd isa GaussianLinearCombination
        @test length(cat_odd) == 2
        c1, c2 = cat_odd.coeffs
        @test abs(c1 + c2) < 1e-12 
        @test abs(c1) ≈ abs(c2)     
        phase = π/3
        cat_general = catstate(basis, α, phase)
        @test cat_general isa GaussianLinearCombination
        @test length(cat_general) == 2
        cat_even_check = catstate(basis, α, 0.0)
        @test isapprox(cat_even.coeffs, cat_even_check.coeffs, atol=1e-12)
        cat_odd_check = catstate(basis, α, π)
        @test isapprox(cat_odd.coeffs[1], cat_odd_check.coeffs[1], atol=1e-12)
        @test isapprox(cat_odd.coeffs[2], cat_odd_check.coeffs[2], atol=1e-12)
    end
    
    @testset "Cat States - Squeezed Variants" begin
        basis = QuadPairBasis(1)
        α = 1.0
        r, θ = 0.5, π/4
        cat_squeezed_even = catstate_even(basis, α, squeeze_params=(r, θ))
        @test cat_squeezed_even isa GaussianLinearCombination
        @test length(cat_squeezed_even) == 2
        cat_squeezed_odd = catstate_odd(basis, α, squeeze_params=(r, θ))
        @test cat_squeezed_odd isa GaussianLinearCombination
        @test length(cat_squeezed_odd) == 2
        phase = π/6
        cat_squeezed_general = catstate(basis, α, phase, squeeze_params=(r, θ))
        @test cat_squeezed_general isa GaussianLinearCombination
        @test length(cat_squeezed_general) == 2
        regular_cat = catstate_even(basis, α)
        @test !isapprox(cat_squeezed_even.states[1].covar, regular_cat.states[1].covar)
    end
    
    @testset "Cat States - Multi-mode" begin
        basis = QuadPairBasis(2)
        αs = [1.0 + 0.5im, 0.8 - 0.3im]
        cat_multi_even = catstate_even(basis, αs)
        @test cat_multi_even isa GaussianLinearCombination
        @test length(cat_multi_even) == 4  
        @test cat_multi_even.basis == basis
        cat_multi_odd = catstate_odd(basis, αs)
        @test cat_multi_odd isa GaussianLinearCombination
        @test length(cat_multi_odd) == 4
        phases = [π/4, π/6]
        cat_multi_general = catstate(basis, αs, phases)
        @test cat_multi_general isa GaussianLinearCombination
        @test length(cat_multi_general) == 4
        squeeze_params = [(0.3, π/8), (0.4, π/3)]
        cat_multi_squeezed = catstate_even(basis, αs, squeeze_params=squeeze_params)
        @test cat_multi_squeezed isa GaussianLinearCombination
        @test length(cat_multi_squeezed) == 4
    end
    
    @testset "Cat States - Normalization" begin
        basis = QuadPairBasis(1)
        for α in [0.5, 1.0, 1.5, 2.0]
            cat_even = catstate_even(basis, α)
            cat_odd = catstate_odd(basis, α)
            norm_even = sqrt(sum(abs2, cat_even.coeffs))
            norm_odd = sqrt(sum(abs2, cat_odd.coeffs))
            if α > 1.0
                @test abs(cat_even.coeffs[1] - cat_even.coeffs[2]) < 1e-10
                @test abs(abs(cat_odd.coeffs[1]) - abs(cat_odd.coeffs[2])) < 1e-10
            end
        end
    end
    
    @testset "Cat States - Edge Cases" begin
        basis = QuadPairBasis(1)
        α_small = 0.1
        cat_even_small = catstate_even(basis, α_small)
        cat_odd_small = catstate_odd(basis, α_small)
        @test cat_even_small isa GaussianLinearCombination
        @test cat_odd_small isa GaussianLinearCombination
        @test abs(cat_even_small.coeffs[1]) < abs(cat_odd_small.coeffs[1])
        α_large = 3.0
        cat_even_large = catstate_even(basis, α_large)
        cat_odd_large = catstate_odd(basis, α_large)
        @test cat_even_large isa GaussianLinearCombination
        @test cat_odd_large isa GaussianLinearCombination
        expected_coeff = 1/sqrt(2)
        @test abs(abs(cat_even_large.coeffs[1]) - expected_coeff) < 0.01
        @test abs(abs(cat_odd_large.coeffs[1]) - expected_coeff) < 0.01
        α_imag = 1.5im
        cat_imag = catstate_even(basis, α_imag)
        @test cat_imag isa GaussianLinearCombination
        @test length(cat_imag) == 2
    end
    
    @testset "GKP States - Basic Properties" begin
        basis = QuadPairBasis(1)
        gkp_square = gkpstate(basis, lattice="square", delta=0.2, nmax=3)
        @test gkp_square isa GaussianLinearCombination
        @test length(gkp_square) == 7 
        @test gkp_square.basis == basis
        @test gkp_square.ħ == 2
        gkp_hex = gkpstate(basis, lattice="hexagonal", delta=0.2, nmax=2)
        @test gkp_hex isa GaussianLinearCombination
        @test length(gkp_hex) > 0 
        @test gkp_hex.basis == basis
        gkp_small_delta = gkpstate(basis, lattice="square", delta=0.1, nmax=2)
        gkp_large_delta = gkpstate(basis, lattice="square", delta=0.3, nmax=2)
        @test gkp_small_delta isa GaussianLinearCombination
        @test gkp_large_delta isa GaussianLinearCombination
        @test length(gkp_small_delta) == length(gkp_large_delta)  
        gkp_small_nmax = gkpstate(basis, lattice="square", delta=0.2, nmax=2)
        gkp_large_nmax = gkpstate(basis, lattice="square", delta=0.2, nmax=4)
        @test length(gkp_small_nmax) < length(gkp_large_nmax)  
    end
    
    @testset "GKP States - Different Lattices" begin
        basis = QuadPairBasis(1)
        delta = 0.15
        nmax = 2
        gkp_square = gkpstate(basis, lattice="square", delta=delta, nmax=nmax)
        gkp_hex = gkpstate(basis, lattice="hexagonal", delta=delta, nmax=nmax)
        @test gkp_square isa GaussianLinearCombination
        @test gkp_hex isa GaussianLinearCombination
        @test_throws ArgumentError gkpstate(basis, lattice=:triangular)
    end
    
    @testset "GKP States - Custom Parameters" begin
        basis = QuadPairBasis(1)
        
        gkp_custom_hbar = gkpstate(basis, lattice="square", delta=0.2, nmax=2, ħ=1)
        @test gkp_custom_hbar.ħ == 1
        
        basis_block = QuadBlockBasis(1)
        gkp_block = gkpstate(basis_block, lattice="square", delta=0.2, nmax=2)
        @test gkp_block.basis == basis_block
    end
    
    @testset "Helper Functions" begin
        basis = QuadPairBasis(1)
        
        state1 = coherentstate(basis, 1.0)
        state2 = coherentstate(basis, -1.0)
        states = [state1, state2]
        coeffs = [1.0, 1.0]
        
        norm_val = norm_factor(states, coeffs)
        @test norm_val isa Float64
        @test norm_val > 0
        
        coeffs_weighted = [0.6, 0.8]
        norm_factor_weighted = norm_factor(states, coeffs_weighted)
        @test norm_factor_weighted isa Float64
        @test norm_factor_weighted > 0
        
        gkp1 = gkpstate(basis, lattice="square", delta=0.1, nmax=3)
        gkp2 = gkpstate(basis, lattice="square", delta=0.2, nmax=2)
    end
    
    @testset "Integration with Existing Framework" begin
        basis = QuadPairBasis(1)
        cat = catstate_even(basis, 1.0)
        Gabs.simplify!(cat)
        @test cat isa GaussianLinearCombination
        cat_copy = catstate_odd(basis, 1.5)
        original_norm = sqrt(sum(abs2, cat_copy.coeffs))
        Gabs.normalize!(cat_copy)
        new_norm = sqrt(sum(abs2, cat_copy.coeffs))
        @test abs(new_norm - 1.0) < 1e-12
        cat1 = catstate_even(basis, 1.0)
        cat2 = catstate_odd(basis, 1.0)
        cat_sum = cat1 + cat2
        @test cat_sum isa GaussianLinearCombination
        @test length(cat_sum) <= 4 
        cat_scaled = 0.5 * cat1
        @test cat_scaled isa GaussianLinearCombination
        @test all(abs.(cat_scaled.coeffs) .≈ 0.5 * abs.(cat1.coeffs))
        @test cat1 == cat1
        @test isapprox(cat1, cat1)
    end
    
    @testset "Multi-mode Tensor Products" begin
        basis1 = QuadPairBasis(1)
        basis2 = QuadPairBasis(2)
        
        α1, α2 = 1.0, 0.8im
        cat1 = catstate_even(basis1, α1)
        cat2 = catstate_even(basis1, α2)
        
        cat_tensor_manual = Gabs._tensor(cat1, cat2)
        @test cat_tensor_manual isa GaussianLinearCombination
        @test length(cat_tensor_manual) == 4  # 2 × 2 = 4
        @test cat_tensor_manual.basis == basis2
        
        cat_multi = catstate_even(basis2, [α1, α2])
        @test cat_multi isa GaussianLinearCombination
        @test length(cat_multi) == 4
        @test cat_multi.basis == basis2
        
        @test length(cat_tensor_manual) == length(cat_multi)
    end
    
    @testset "Numerical Stability" begin
        basis = QuadPairBasis(1)
        
        cat_tiny = catstate_even(basis, 1e-8)
        @test cat_tiny isa GaussianLinearCombination
        @test all(isfinite.(cat_tiny.coeffs))
        
        cat_large = catstate_even(basis, 10.0)
        @test cat_large isa GaussianLinearCombination
        @test all(isfinite.(cat_large.coeffs))
        
        gkp_small_delta = gkpstate(basis, lattice="square", delta=1e-6, nmax=1)
        @test gkp_small_delta isa GaussianLinearCombination
        @test all(isfinite.(gkp_small_delta.coeffs))
        
        gkp_large_delta = gkpstate(basis, lattice="square", delta=2.0, nmax=1)
        @test gkp_large_delta isa GaussianLinearCombination
        @test all(isfinite.(gkp_large_delta.coeffs))
    end
    
    @testset "Error Handling" begin
        basis = QuadPairBasis(2)
        
        αs_wrong = [1.0]  
        @test_throws AssertionError catstate_even(basis, αs_wrong)
        
        phases_wrong = [π/4] 
        @test_throws AssertionError catstate(basis, [1.0, 1.0], phases_wrong)
        
        squeeze_params_wrong = [(0.5, π/4)]  
        @test_throws AssertionError catstate_even(basis, [1.0, 1.0], squeeze_params=squeeze_params_wrong)
        
        @test_throws ArgumentError gkpstate(basis, lattice=:invalid)
        
        state1 = coherentstate(QuadPairBasis(1), 1.0)
        states = [state1, state1]
        coeffs_wrong = [1.0]  
        @test_throws AssertionError norm_factor(states, coeffs_wrong)
    end

    @testset "GKP state validation coverage" begin
        basis = QuadPairBasis(1)
        
        @test_throws ArgumentError gkpstate(basis, lattice="square", delta=0.0, nmax=2)
        @test_throws ArgumentError gkpstate(basis, lattice="square", delta=-0.1, nmax=2)
        
        gkp_tiny_delta = gkpstate(basis, lattice="square", delta=1e-8, nmax=1)
        @test gkp_tiny_delta isa GaussianLinearCombination
        
        @test_throws ArgumentError gkpstate(basis, lattice="square", delta=0.1, nmax=0)
        @test_throws ArgumentError gkpstate(basis, lattice="square", delta=0.1, nmax=-1)
        
        gkp_large_nmax = gkpstate(basis, lattice="square", delta=0.3, nmax=55)
        @test gkp_large_nmax isa GaussianLinearCombination
        @test length(gkp_large_nmax) == 111
    end

    @testset "Multi-mode catstate_odd squeeze params validation coverage" begin
        basis = QuadPairBasis(2)
        αs = [1.0 + 0.5im, 0.8 - 0.3im]
        
        correct_squeeze_params = [(0.3, π/8), (0.4, π/3)]
        cat_with_squeeze = catstate_odd(basis, αs, squeeze_params=correct_squeeze_params)
        @test cat_with_squeeze isa GaussianLinearCombination
        @test length(cat_with_squeeze) == 4  
        
        wrong_squeeze_params = [(0.3, π/8)] 
        
        @test_throws AssertionError catstate_odd(basis, αs, squeeze_params=wrong_squeeze_params)
        
        cat_no_squeeze = catstate_odd(basis, αs)
        @test cat_no_squeeze isa GaussianLinearCombination
        @test length(cat_no_squeeze) == 4
        
        basis3 = QuadPairBasis(3)
        αs3 = [1.0, 0.5im, -0.8]
        wrong_squeeze_params3 = [(0.3, π/8), (0.4, π/3)]  
        
        @test_throws AssertionError catstate_odd(basis3, αs3, squeeze_params=wrong_squeeze_params3)
    end

    @testset "Multi-mode catstate general squeeze params validation coverage" begin
        basis = QuadPairBasis(2)
        αs = [1.0 + 0.5im, 0.8 - 0.3im]
        phases = [π/4, π/6]
        
        correct_squeeze_params = [(0.3, π/8), (0.4, π/3)]
        cat_with_squeeze = catstate(basis, αs, phases, squeeze_params=correct_squeeze_params)
        @test cat_with_squeeze isa GaussianLinearCombination
        @test length(cat_with_squeeze) == 4  
        
        wrong_squeeze_params = [(0.3, π/8)]  
        
        @test_throws AssertionError catstate(basis, αs, phases, squeeze_params=wrong_squeeze_params)
        
        cat_no_squeeze = catstate(basis, αs, phases)
        @test cat_no_squeeze isa GaussianLinearCombination
        @test length(cat_no_squeeze) == 4
        
        basis1 = QuadPairBasis(1)
        αs1 = [1.0]
        phases1 = [π/3]
        wrong_squeeze_params1 = [(0.3, π/8), (0.4, π/3)] 
        
        @test_throws AssertionError catstate(basis1, αs1, phases1, squeeze_params=wrong_squeeze_params1)
        
        cat_empty_squeeze = catstate(basis, αs, phases, squeeze_params=nothing)
        @test cat_empty_squeeze isa GaussianLinearCombination
    end

    @testset "Additional edge cases for robustness" begin
        basis = QuadPairBasis(1)
        
        gkp_boundary = gkpstate(basis, lattice="square", delta=1e-6, nmax=50)
        @test gkp_boundary isa GaussianLinearCombination
        
        state1 = coherentstate(basis, 1.0)
        state2 = coherentstate(basis, -1.0)
        
        small_coeffs = [1e-10, 1e-10]
        norm_small = norm_factor([state1, state2], small_coeffs)
        @test norm_small isa Float64
        @test norm_small > 0.0
        
        overlap_identical = Gabs._overlap(state1, state1)
        @test overlap_identical ≈ 1.0 + 0.0im
        
        cat_single = catstate_odd(QuadPairBasis(1), [1.0], squeeze_params=[(0.3, π/4)])
        @test cat_single isa GaussianLinearCombination
    end
    
end

module Gabs

import LinearAlgebra
using LinearAlgebra: I, det, mul!, diag, qr, eigvals, Diagonal, cholesky, Symmetric, dot, Hermitian, logdet

import QuantumInterface: StateVector, AbstractOperator, apply!, tensor, ⊗, directsum, ⊕, entropy_vn, fidelity, logarithmic_negativity, ptrace, embed

import Random
using Random: randn!, AbstractRNG

import SymplecticMatrices: williamson, Williamson, polar, Polar, blochmessiah, BlochMessiah, randsymplectic, symplecticform, issymplectic
using SymplecticMatrices: williamson, Williamson, polar, Polar, blochmessiah, BlochMessiah, BlockForm, PairForm

export
    # types
    GaussianState, GaussianUnitary, GaussianChannel, GaussianLinearCombination,
    # Gaussian measurements
    generaldyne, Generaldyne, homodyne, Homodyne,
    # symplectic representations
    QuadPairBasis, QuadBlockBasis, changebasis,
    # operations
    tensor, ⊗, directsum, ⊕, apply!, ptrace, embed,
    # predefined Gaussian states
    vacuumstate, thermalstate, coherentstate, squeezedstate, eprstate,
    # non-Gaussian states
    catstate_even, catstate_odd, catstate, gkpstate,
    norm_factor,
    # predefined Gaussian channels
    displace, squeeze, twosqueeze, phaseshift, beamsplitter,
    attenuator, amplifier,
    # random objects
    randstate, randunitary, randchannel, randsymplectic,
    # wigner functions
    wigner, wignerchar,
    # symplectic form and checks
    symplecticform, issymplectic, isgaussian, sympspectrum,
    # factorizations
    williamson, Williamson, polar, Polar, blochmessiah, BlochMessiah,
    # metrics
    purity, entropy_vn, fidelity, logarithmic_negativity,
    cross_wigner, cross_wignerchar,
    # additional interface
    nmodes
    
include("errors.jl")

include("utils.jl")

include("symplectic.jl")

include("types.jl")

include("states.jl")

include("unitaries.jl")

include("channels.jl")

include("randoms.jl")

include("factorizations.jl")

include("measurements.jl")

include("generaldyne.jl")

include("homodyne.jl")

include("wigner.jl")

include("metrics.jl")

include("linearcombinations.jl")

include("nongaussian_states.jl")

end

module MakieExt

using Makie
using Gabs: GaussianState, GaussianLinearCombination, wigner, wignerchar

Makie.used_attributes(::Type{<:Makie.Heatmap}, ::Any, ::Any, x::GaussianState) = (:dist,)

# Directly use heatmap to create wigner distribution
function Makie.convert_arguments(P::Type{<:Makie.Heatmap}, q, p, state::GaussianState; dist = :wigner)
    isequal(length(state.mean),2) || throw(ArgumentError(Gabs.HEATMAP_ERROR))
    if isequal(dist, :wigner)
        data = [wigner(state, [i,j]) for i in q, j in p]
    elseif isequal(dist, :wignerchar)
        data = [real(wignerchar(state, [i,j])) for i in q, j in p]
    else
        throw(ErrorException("`distribution` should be `:wigner` or `:wignerchar`"))
    end
    return convert_arguments(P, q, p, data)
end

Makie.used_attributes(::Type{<:Makie.Heatmap}, ::Any, ::Any, x::GaussianLinearCombination) = (:dist,)

# Extend convert_arguments to handle GaussianLinearCombination
function Makie.convert_arguments(P::Type{<:Makie.Heatmap}, q, p, lcgs::GaussianLinearCombination; dist = :wigner)
    isequal(lcgs.basis.nmodes, 1) || throw(ArgumentError(Gabs.HEATMAP_ERROR))
    
    if isequal(dist, :wigner)
        data = [wigner(lcgs, [i,j]) for i in q, j in p]
    elseif isequal(dist, :wignerchar)
        data = [real(wignerchar(lcgs, [i,j])) for i in q, j in p]
    else
        throw(ErrorException("`distribution` should be `:wigner` or `:wignerchar`"))
    end
    
    return convert_arguments(P, q, p, data)
end

end

abstract type AbstractGaussianMeasurement end

"""
    _part_state(state::GaussianState{<:QuadPairBasis,M,V}, indices::Vector) -> a, b, A, B, C
    _part_state(state::GaussianState{<:QuadPairBasis,M,V}, indices::Int) -> a, b, A, B, C

Low-level function that partitions `state` into subsystems A and B, 
the latter system's modes specified by `indices`. The vectors `a` and `b`
are mean vectors of systems A and B, respectively. The matrices `A` and `B`
are covariance matrices of systems A and B, respectively. Matrix `C` is the 
correlation matrix between A and B.
"""
function _part_state(state::GaussianState{<:QuadPairBasis,M,V}, indices::I) where {M,V,I}
	indlength = length(indices)
	basis = state.basis
	notindices = setdiff(1:basis.nmodes, indices)
	nmodes = basis.nmodes
	nmodes′ = nmodes - indlength
	mean, covar = state.mean, state.covar
	# partition state into subsystems A and B
	A, B, C = zeros(2*nmodes′, 2*nmodes′), zeros(2*indlength, 2*indlength), zeros(2*nmodes′, 2*indlength)
	a, b = zeros(2*nmodes′), zeros(2*indlength)
	@inbounds for i in eachindex(notindices)
		idx = notindices[i]
		a[2i-1:2i] .= @view(mean[2idx-1:2idx])
		@inbounds for j in eachindex(notindices)
			otheridx = notindices[j]
			if idx == otheridx
				A[2i-1:2i, 2i-1:2i] .= @view(covar[2idx-1:2idx, 2idx-1:2idx])
			else
				A[2i-1:2i, 2j-1:2j] .= @view(covar[2idx-1:2idx, 2otheridx-1:2otheridx])
				A[2j-1:2j, 2i-1:2i] .= @view(covar[2otheridx-1:2otheridx, 2idx-1:2idx])
			end
		end
	end
	@inbounds for i in eachindex(indices)
		idx = indices[i]
		b[2i-1:2i] .= @view(mean[2idx-1:2idx])
		@inbounds for j in eachindex(indices)
			otheridx = indices[j]
			if idx == otheridx
				B[2i-1:2i, 2i-1:2i] .= @view(covar[2idx-1:2idx, 2idx-1:2idx])
			else
				B[2i-1:2i, 2j-1:2j] .= @view(covar[2idx-1:2idx, 2otheridx-1:2otheridx])
				B[2j-1:2j, 2i-1:2i] .= @view(covar[2otheridx-1:2otheridx, 2idx-1:2idx])
			end
		end
		@inbounds for j in eachindex(notindices)
			otheridx = notindices[j]
			C[2j-1:2j, 2i-1:2i] .= @view(covar[2otheridx-1:2otheridx, 2idx-1:2idx])
		end
	end
	return a, b, A, B, C
end
function _part_state(state::GaussianState{<:QuadBlockBasis,M,V}, indices::I) where {M,V,I}
	indlength = length(indices)
	basis = state.basis
	notindices = setdiff(1:basis.nmodes, indices)
	nmodes = basis.nmodes
	nmodes′ = nmodes - indlength
	mean, covar = state.mean, state.covar
	# partition state into subsystems A and B
	A, B, C = zeros(2*nmodes′, 2*nmodes′), zeros(2*indlength, 2*indlength), zeros(2*nmodes′, 2*indlength)
	a, b = zeros(2*nmodes′), zeros(2*indlength)
	@inbounds for i in eachindex(notindices)
		idx = notindices[i]
		a[i] = mean[idx]
		a[i+nmodes′] = mean[idx+nmodes]
		@inbounds for j in eachindex(notindices)
			otheridx = notindices[j]
			if idx == otheridx
				A[i, i] = covar[idx, idx]
				A[i+nmodes′, i] = covar[idx+nmodes, idx]
				A[i, i+nmodes′] = covar[idx, idx+nmodes]
				A[i+nmodes′, i+nmodes′] = covar[idx+nmodes, idx+nmodes]
			else
				A[i, j] = covar[idx, otheridx]
				A[i+nmodes′, j] = covar[idx+nmodes, otheridx]
				A[i, j+nmodes′] = covar[idx, otheridx+nmodes]
				A[i+nmodes′, j+nmodes′] = covar[idx+nmodes, otheridx+nmodes]

				A[j, i] = covar[otheridx, idx]
				A[j+nmodes′, i] = covar[otheridx+nmodes, idx]
				A[j, i+nmodes′] = covar[otheridx, idx+nmodes]
				A[j+nmodes′, i+nmodes′] = covar[otheridx+nmodes, idx+nmodes]
			end
		end
	end
	@inbounds for i in eachindex(indices)
		idx = indices[i]
		b[i] = mean[idx]
		b[i+indlength] = mean[idx+nmodes]
		@inbounds for j in eachindex(indices)
			otheridx = indices[j]
			if idx == otheridx
				B[i, i] = covar[idx, idx]
				B[i+indlength, i] = covar[idx+nmodes, idx]
				B[i, i+indlength] = covar[idx, idx+nmodes]
				B[i+indlength, i+indlength] = covar[idx+nmodes, idx+nmodes]
			else
				B[i, j] = covar[idx, otheridx]
				B[i+indlength, j] = covar[idx+nmodes, otheridx]
				B[i, j+indlength] = covar[idx, otheridx+nmodes]
				B[i+indlength, j+indlength] = covar[idx+nmodes, otheridx+nmodes]

				B[j, i] = covar[otheridx, idx]
				B[j+indlength, i] = covar[otheridx+nmodes, idx]
				B[j, i+indlength] = covar[otheridx, idx+nmodes]
				B[j+indlength, i+indlength] = covar[otheridx+nmodes, idx+nmodes]
			end
		end
		@inbounds for j in eachindex(notindices)
			otheridx = notindices[j]
			C[j, i] = covar[otheridx, idx]
			C[j+nmodes′, i] = covar[otheridx+nmodes, idx]
			C[j, i+indlength] = covar[otheridx, idx+nmodes]
			C[j+nmodes′, i+indlength] = covar[otheridx+nmodes, idx+nmodes]
		end
	end
	return a, b, A, B, C
end

"""
Defines a Gaussian state for an N-mode bosonic system over a 2N-dimensional phase space.

## Fields

- `basis`: Symplectic basis for Gaussian state.
- `mean`: The mean vector of length 2N.
- `covar`: The covariance matrix of size 2N x 2N.
- `ħ = 2`: Reduced Planck's constant.

## Example

```jldoctest
julia> coherentstate(QuadPairBasis(1), 1.0+im)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 2.0
 2.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
"""
@kwdef struct GaussianState{B<:SymplecticBasis,M,V} <: StateVector{M,V}
    basis::B
    mean::M
    covar::V
    ħ::Number = 2
    function GaussianState(b::B, m::M, v::V; ħ::Number = 2) where {B,M,V}
        all(size(v) .== length(m) .== 2*(b.nmodes)) || throw(DimensionMismatch(STATE_ERROR))
        return new{B,M,V}(b, m, v, ħ)
    end
end

Base.:(==)(x::GaussianState, y::GaussianState) = x.basis == y.basis && x.mean == y.mean && x.covar == y.covar && x.ħ == y.ħ
Base.isapprox(x::GaussianState, y::GaussianState; kwargs...) = x.basis == y.basis && isapprox(x.mean, y.mean; kwargs...) && isapprox(x.covar, y.covar; kwargs...) && x.ħ == y.ħ
function Base.show(io::IO, mime::MIME"text/plain", x::GaussianState)
    Base.summary(io, x)
    print(io, "\n  symplectic basis: ")
    printstyled(io, "$(nameof(typeof(x.basis)))"; color = :blue)
    print(io, "\nmean: ")
    Base.show(io, mime, x.mean)
    print(io, "\ncovariance: ")
    Base.show(io, mime, x.covar)
end
Base.copy(x::GaussianState) = GaussianState(x.basis, copy(x.mean), copy(x.covar); ħ = x.ħ)
nmodes(x::GaussianState) = nmodes(x.basis)

"""
Defines a Gaussian unitary for an N-mode bosonic system over a 2N-dimensional phase space.

## Fields

- `basis`: Symplectic basis for Gaussian unitary.
- `disp`: The displacement vector of length 2N.
- `symplectic`: The symplectic matrix of size 2N x 2N.
- `ħ = 2`: Reduced Planck's constant.

## Mathematical description of a Gaussian unitary

An `N`-mode Gaussian unitary, is a unitary
operator characterized by a displacement vector `d` of length `2N` and symplectic
matrix `S` of size `2N x 2N`, such that its action on a Gaussian state
results in a Gaussian state. More specifically, a Gaussian unitary transformation on a
Gaussian state is described by its maps on
the statistical moments `x̄` and `V` of the Gaussian state: `x̄ → Sx̄ + d` and `V → SVSᵀ`.

## Example

```jldoctest
julia> displace(QuadPairBasis(1), 1.0+im)
GaussianUnitary for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 2.0
 2.0
symplectic: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
"""
@kwdef struct GaussianUnitary{B<:SymplecticBasis,D,S} <: AbstractOperator{D,S}
    basis::B
    disp::D
    symplectic::S
    ħ::Number = 2
    function GaussianUnitary(b::B, d::D, s::S; ħ::Number = 2) where {B,D,S}
        all(size(s) .== length(d) .== 2*(b.nmodes)) || throw(DimensionMismatch(UNITARY_ERROR))
        return new{B,D,S}(b, d, s, ħ)
    end
end

Base.:(==)(x::GaussianUnitary, y::GaussianUnitary) = x.basis == y.basis && x.disp == y.disp && x.symplectic == y.symplectic && x.ħ == y.ħ
Base.isapprox(x::GaussianUnitary, y::GaussianUnitary; kwargs...) = x.basis == y.basis && isapprox(x.disp, y.disp; kwargs...) && isapprox(x.symplectic, y.symplectic; kwargs...) && x.ħ == y.ħ
function Base.show(io::IO, mime::MIME"text/plain", x::GaussianUnitary)
    Base.summary(io, x)
    print(io, "\n  symplectic basis: ")
    printstyled(io, "$(nameof(typeof(x.basis)))"; color = :blue)
    print(io, "\ndisplacement: ")
    Base.show(io, mime, x.disp)
    print(io, "\nsymplectic: ")
    Base.show(io, mime, x.symplectic)
end
Base.copy(x::GaussianUnitary) = GaussianUnitary(x.basis, copy(x.disp), copy(x.symplectic); ħ = x.ħ)
nmodes(x::GaussianUnitary) = nmodes(x.basis)

function Base.:(*)(op::GaussianUnitary, state::GaussianState)
    op.basis == state.basis || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    d, S, = op.disp, op.symplectic
    mean′ = S * state.mean .+ d
    covar′ = S * state.covar * transpose(S)
    return GaussianState(state.basis, mean′, covar′; ħ = state.ħ)
end
"""
    apply!(state::GaussianState, op::GaussianUnitary)

In-place application of a Gaussian unitary `op` on a Gaussian state `state`.
"""
function apply!(state::GaussianState, op::GaussianUnitary)
    op.basis == state.basis || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    d, S = op.disp, op.symplectic
    state.mean .= S * state.mean .+ d
    state.covar .= S * state.covar * transpose(S)
    return state
end
"""
    apply!(state::GaussianState, index::Int, op::GaussianUnitary)
    apply!(state::GaussianState, indices::AbstractVector{<:Int}, op::GaussianUnitary)

In-place application of a Gaussian unitary `op` on the mode index or indices of a
Gaussian state `state`.
"""
function apply!(state::GaussianState, index::Int, op::GaussianUnitary)
    return apply!(state, [index], op)
end
function apply!(
    state::GaussianState{B,M,V},
    indices::AbstractVector{<:Int},
    op::GaussianUnitary,
) where {B<:QuadPairBasis,M,V}
    typeof(op.basis) == typeof(state.basis) || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    length(indices) ≤ state.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    quad_indices = Vector{Int}(undef, 2length(indices))
    @inbounds for (k, i) in enumerate(indices)
        quad_indices[2k-1] = 2i - 1
        quad_indices[2k]   = 2i
    end
    d, S = op.disp, op.symplectic
    m = length(quad_indices)
    n = size(state.covar, 1)
    mean_sub = @view state.mean[quad_indices]
    covar_row = @view state.covar[quad_indices, :]
    covar_col = @view state.covar[:, quad_indices]
    # single scratch buffer, reused across the three products (reshaped for the column update)
    buf = similar(state.covar, m, n)
    buf_vec = @view buf[1:m]
    # x̄[q] ← S x̄[q] + d
    mul!(buf_vec, S, mean_sub)
    mean_sub .= buf_vec .+ d
    # V[q,:] ← S V[q,:]
    mul!(buf, S, covar_row)
    covar_row .= buf
    # V[:,q] ← V[:,q] Sᵀ (reads the just-updated V[q,q] block)
    buf_col = reshape(buf, n, m)
    mul!(buf_col, covar_col, transpose(S))
    covar_col .= buf_col
    return state
end
function apply!(
    state::GaussianState{B,M,V},
    indices::AbstractVector{<:Int},
    op::GaussianUnitary,
) where {B<:QuadBlockBasis,M,V}
    typeof(op.basis) == typeof(state.basis) || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    length(indices) ≤ state.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    l = length(indices)
    quad_indices = Vector{Int}(undef, 2l)
    @inbounds for (k, i) in enumerate(indices)
        quad_indices[k]   = i
        quad_indices[k+l] = i + state.basis.nmodes
    end
    d, S = op.disp, op.symplectic
    m = length(quad_indices)
    n = size(state.covar, 1)
    mean_sub = @view state.mean[quad_indices]
    covar_row = @view state.covar[quad_indices, :]
    covar_col = @view state.covar[:, quad_indices]
    # single scratch buffer, reused across the three products (reshaped for the column update)
    buf = similar(state.covar, m, n)
    buf_vec = @view buf[1:m]
    # x̄[q] ← S x̄[q] + d
    mul!(buf_vec, S, mean_sub)
    mean_sub .= buf_vec .+ d
    # V[q,:] ← S V[q,:]
    mul!(buf, S, covar_row)
    covar_row .= buf
    # V[:,q] ← V[:,q] Sᵀ (reads the just-updated V[q,q] block)
    buf_col = reshape(buf, n, m)
    mul!(buf_col, covar_col, transpose(S))
    covar_col .= buf_col
    return state
end

Base.@deprecate(
    apply!(
        state::GaussianState,
        op::GaussianUnitary,
        indices::AbstractVector{<:Int},
    ),
    apply!(state, indices, op)
)

"""
Defines a Gaussian channel for an N-mode bosonic system over a 2N-dimensional phase space.

## Fields

- `basis`: Symplectic representation for Gaussian channel.
- `disp`: The displacement vector of length 2N.
- `transform`: The transformation matrix of size 2N x 2N.
- `noise`: The noise matrix of size 2N x 2N.
- `ħ = 2`: Reduced Planck's constant.

## Mathematical description of a Gaussian channel

An `N`-mode Gaussian channel is an
operator characterized by a displacement vector `d` of length `2N`, as well as
a transformation matrix `T` and noise matrix `N` of size `2N x 2N`,
such that its action on a Gaussian state results in a Gaussian state. More specifically, a Gaussian
channel action on a Gaussian state is described by its maps on
the statistical moments `x̄` and `V` of the Gaussian state: `x̄ → Tx̄ + d` and `V → TVTᵀ + N`.

## Example

```jldoctest
julia> noise = [1.0 -3.0; 4.0 2.0];

julia> displace(QuadPairBasis(1), 1.0+im, noise)
GaussianChannel for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 2.0
 2.0
transform: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
noise: 2×2 Matrix{Float64}:
 1.0  -3.0
 4.0   2.0
```
"""
@kwdef struct GaussianChannel{B<:SymplecticBasis,D,T} <: AbstractOperator{D,T}
    basis::B
    disp::D
    transform::T
    noise::T
    ħ::Number = 2
    function GaussianChannel(b::B, d::D, t::T, n::T; ħ::Number = 2) where {B,D,T}
        all(length(d) .== size(t) .== size(n) .== 2*(b.nmodes)) || throw(DimensionMismatch(CHANNEL_ERROR))
        return new{B,D,T}(b, d, t, n, ħ)
    end
end

Base.:(==)(x::GaussianChannel, y::GaussianChannel) = x.basis == y.basis && x.disp == y.disp && x.transform == y.transform && x.noise == y.noise && x.ħ == y.ħ
Base.isapprox(x::GaussianChannel, y::GaussianChannel; kwargs...) = x.basis == y.basis && isapprox(x.disp, y.disp; kwargs...) && isapprox(x.transform, y.transform; kwargs...) && isapprox(x.noise, y.noise; kwargs...) && x.ħ == y.ħ
function Base.show(io::IO, mime::MIME"text/plain", x::GaussianChannel)
    Base.summary(io, x)
    print(io, "\n  symplectic basis: ")
    printstyled(io, "$(nameof(typeof(x.basis)))"; color = :blue)
    print(io, "\ndisplacement: ")
    Base.show(io, mime, x.disp)
    print(io, "\ntransform: ")
    Base.show(io, mime, x.transform)
    print(io, "\nnoise: ")
    Base.show(io, mime, x.noise)
end
function Base.summary(io::IO, x::Union{GaussianState,GaussianUnitary,GaussianChannel})
    printstyled(io, nameof(typeof(x)); color=:blue)
    basis = x.basis
    modenum = basis.nmodes
    if isone(modenum)
        print(io, " for $(modenum) mode.")
    else
        print(io, " for $(modenum) modes.")
    end
end
Base.copy(x::GaussianChannel) = GaussianChannel(x.basis, copy(x.disp), copy(x.transform), copy(x.noise); ħ = x.ħ)
nmodes(x::GaussianChannel) = nmodes(x.basis)

function Base.:(*)(op::GaussianChannel, state::GaussianState)
    op.basis == state.basis || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    d, T, N = op.disp, op.transform, op.noise
    mean′ = T * state.mean .+ d
    covar′ = T * state.covar * transpose(T) .+ N
    return GaussianState(state.basis, mean′, covar′; ħ = state.ħ)
end
"""
    apply!(state::GaussianState, op::GaussianChannel)
    apply!(state::GaussianState, index::Int, op::GaussianChannel)
    apply!(state::GaussianState, indices::AbstractVector{<:Int}, op::GaussianChannel)

In-place application of a Gaussian channel `op` on all or selected modes of a
Gaussian state `state`.
"""
function apply!(state::GaussianState, op::GaussianChannel)
    op.basis == state.basis || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    d, T, N = op.disp, op.transform, op.noise
    state.mean .= T * state.mean .+ d
    state.covar .= T * state.covar * transpose(T) .+ N
    return state
end
function apply!(state::GaussianState, index::Int, op::GaussianChannel)
    return apply!(state, [index], op)
end
function apply!(
    state::GaussianState{B,M,V},
    indices::AbstractVector{<:Int},
    op::GaussianChannel,
) where {B<:QuadPairBasis,M,V}
    typeof(op.basis) == typeof(state.basis) || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    length(indices) ≤ state.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    quad_indices = Vector{Int}(undef, 2length(indices))
    @inbounds for (k, i) in enumerate(indices)
        quad_indices[2k-1] = 2i - 1
        quad_indices[2k]   = 2i
    end
    d, T, N = op.disp, op.transform, op.noise
    m = length(quad_indices)
    n = size(state.covar, 1)
    mean_sub = @view state.mean[quad_indices]
    covar_row = @view state.covar[quad_indices, :]
    covar_col = @view state.covar[:, quad_indices]
    # single scratch buffer, reused across the three products (reshaped for the column update)
    buf = similar(state.covar, m, n)
    buf_vec = @view buf[1:m]
    # x̄[q] ← T x̄[q] + d
    mul!(buf_vec, T, mean_sub)
    mean_sub .= buf_vec .+ d
    # V[q,:] ← T V[q,:]
    mul!(buf, T, covar_row)
    covar_row .= buf
    # V[:,q] ← V[:,q] Tᵀ (reads the just-updated V[q,q] block)
    buf_col = reshape(buf, n, m)
    mul!(buf_col, covar_col, transpose(T))
    covar_col .= buf_col
    # V[q,q] ← V[q,q] + N after both covariance transformations
    covar_sub = @view state.covar[quad_indices, quad_indices]
    covar_sub .+= N
    return state
end
function apply!(
    state::GaussianState{B,M,V},
    indices::AbstractVector{<:Int},
    op::GaussianChannel,
) where {B<:QuadBlockBasis,M,V}
    typeof(op.basis) == typeof(state.basis) || throw(DimensionMismatch(ACTION_ERROR))
    op.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    length(indices) ≤ state.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    l = length(indices)
    quad_indices = Vector{Int}(undef, 2l)
    @inbounds for (k, i) in enumerate(indices)
        quad_indices[k]   = i
        quad_indices[k+l] = i + state.basis.nmodes
    end
    d, T, N = op.disp, op.transform, op.noise
    m = length(quad_indices)
    n = size(state.covar, 1)
    mean_sub = @view state.mean[quad_indices]
    covar_row = @view state.covar[quad_indices, :]
    covar_col = @view state.covar[:, quad_indices]
    # single scratch buffer, reused across the three products (reshaped for the column update)
    buf = similar(state.covar, m, n)
    buf_vec = @view buf[1:m]
    # x̄[q] ← T x̄[q] + d
    mul!(buf_vec, T, mean_sub)
    mean_sub .= buf_vec .+ d
    # V[q,:] ← T V[q,:]
    mul!(buf, T, covar_row)
    covar_row .= buf
    # V[:,q] ← V[:,q] Tᵀ (reads the just-updated V[q,q] block)
    buf_col = reshape(buf, n, m)
    mul!(buf_col, covar_col, transpose(T))
    covar_col .= buf_col
    # V[q,q] ← V[q,q] + N after both covariance transformations
    covar_sub = @view state.covar[quad_indices, quad_indices]
    covar_sub .+= N
    return state
end

"""
    isgaussian(x::GaussianState)
    isgaussian(x::GaussianUnitary)
    isgaussian(x::GaussianChannel)

Check if `x` satisfies the corresponding Gaussian definition for its type.

## Example

```jldoctest
julia> basis = QuadPairBasis(1);

julia> op = displace(basis, 1.0-im)
GaussianUnitary for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
  2.0
 -2.0
symplectic: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0

julia> isgaussian(op)
true
```
"""
function isgaussian(x::GaussianState; atol::R1 = 0, rtol::R2 = atol) where {R1<:Real, R2<:Real}
    covar = x.covar
    basis = x.basis
    form = symplecticform(Matrix{ComplexF64}, basis)
    @. form = im * (x.ħ/2) * form + covar
    eigs = real(eigvals(form))
    return all(i -> ((i >= 0) || isapprox(i, 0.0; atol = atol, rtol = rtol)), eigs)
end
function isgaussian(x::GaussianUnitary; atol::R1 = 0, rtol::R2 = atol) where {R1<:Real, R2<:Real} 
    return issymplectic(x.basis, x.symplectic; atol = atol, rtol = rtol)
end
function isgaussian(x::GaussianChannel; atol::R1 = 0, rtol::R2 = atol) where {R1<:Real, R2<:Real} 
    transform, noise = x.transform, x.noise
    basis = x.basis
    form = symplecticform(Matrix{ComplexF64}, basis)
    prod = transform * form * transform'
    @. form = noise + im*form - im*prod
    eigs = real(eigvals(form))
    return all(i -> ((i >= 0) || isapprox(i, 0.0; atol = atol, rtol = rtol)), eigs)
end

module QuantumOpticsBaseExt

using LinearAlgebra: I, normalize!
using Gabs
using QuantumInterface: QuantumOpticsRepr, UseAsState
import QuantumInterface: express
using QuantumOpticsBase

function _block_moments(state::Gabs.GaussianState{<:Gabs.QuadBlockBasis}, ::Type{T}) where {T}
    return Vector{T}(state.mean), Matrix{T}(state.covar)
end

function _block_moments(state::Gabs.GaussianState{<:Gabs.QuadPairBasis}, ::Type{T}) where {T}
    nmodes = Int(Gabs.nmodes(state))
    mean = Vector{T}(undef, 2 * nmodes)
    covar = Matrix{T}(undef, 2 * nmodes, 2 * nmodes)

    @inbounds for i in 1:nmodes
        mean[i] = state.mean[2 * i - 1]
        mean[nmodes + i] = state.mean[2 * i]

        for j in 1:nmodes
            covar[j, i] = state.covar[2 * j - 1, 2 * i - 1]
            covar[nmodes + j, i] = state.covar[2 * j, 2 * i - 1]
            covar[j, nmodes + i] = state.covar[2 * j - 1, 2 * i]
            covar[nmodes + j, nmodes + i] = state.covar[2 * j, 2 * i]
        end
    end

    return mean, covar
end

function _fock_basis(cutoff::Integer, nmodes::Integer)
    mode_basis = FockBasis(cutoff)
    return isone(nmodes) ? mode_basis : tensor(ntuple(_ -> mode_basis, nmodes)...)
end

function _vacuum_ket(cutoff::Integer, nmodes::Integer)
    mode_basis = FockBasis(cutoff)
    vacuum = fockstate(mode_basis, 0)
    return isone(nmodes) ? vacuum : tensor(ntuple(_ -> vacuum, nmodes)...)
end

function _creation_ops(cutoff::Integer, nmodes::Integer)
    mode_basis = FockBasis(cutoff)
    if isone(nmodes)
        return [create(mode_basis)]
    end

    basis = _fock_basis(cutoff, nmodes)
    return [embed(basis, i, create(mode_basis)) for i in 1:nmodes]
end

function _creation_generator(create_ops, pair_matrix, linear_terms)
    generator = zero(dense(create_ops[1] * create_ops[1]))

    @inbounds for j in eachindex(create_ops), i in eachindex(create_ops)
        generator += (pair_matrix[i, j] / 2) * dense(create_ops[i] * create_ops[j])
    end

    @inbounds for i in eachindex(create_ops)
        generator += linear_terms[i] * dense(create_ops[i])
    end

    return generator
end

function express(state::Gabs.GaussianState, repr::QuantumOpticsRepr, ::UseAsState)
    T = float(real(promote_type(eltype(state.mean), eltype(state.covar), typeof(state.ħ))))
    C = Complex{T}
    tol = sqrt(eps(T)) * max(Int(Gabs.nmodes(state)), 1)

    isapprox(Gabs.purity(state), one(T); atol=tol, rtol=tol) ||
        throw(ArgumentError("Only pure Gaussian states can be expressed as `QuantumOpticsBase.Ket`s."))

    nmodes = Int(Gabs.nmodes(state))
    mean, covar = _block_moments(state, T)

    q = mean[1:nmodes]
    p = mean[nmodes + 1:2 * nmodes]
    Vqq = covar[1:nmodes, 1:nmodes]
    Vqp = covar[1:nmodes, nmodes + 1:2 * nmodes]
    Vpq = covar[nmodes + 1:2 * nmodes, 1:nmodes]
    Vpp = covar[nmodes + 1:2 * nmodes, nmodes + 1:2 * nmodes]

    α = complex.(q, p) ./ sqrt(2 * T(state.ħ))
    identity_matrix = Matrix{C}(I, nmodes, nmodes)
    pair_matrix = complex.(Vqq - Vpp, Vqp + Vpq) ./ (2 * T(state.ħ))
    occupations = (complex.(Vqq + Vpp, Vqp - Vpq) .- T(state.ħ) * identity_matrix) ./
        (2 * T(state.ħ))

    pair_matrix = pair_matrix / (occupations + identity_matrix)
    pair_matrix = (pair_matrix + transpose(pair_matrix)) / 2
    linear_terms = α - pair_matrix * conj.(α)

    create_ops = _creation_ops(repr.cutoff, nmodes)
    generator = _creation_generator(create_ops, pair_matrix, linear_terms)
    ket = exp(generator) * _vacuum_ket(repr.cutoff, nmodes)
    return normalize!(ket)
end

end

@testitem "Symbolic Channels" begin
    using Gabs
    using Symbolics
    using StaticArrays

    nmodes = 2*rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)
    noise = zeros(Num, 2*nmodes, 2*nmodes)

    @variables a b
    @variables as[1:nmodes] bs[1:nmodes]
    as, bs = collect(as), collect(bs)

    test_configs = [
    (displace, (a, noise), (as, noise), "symbolic displacement operator"), 
    (squeeze, (a, b, noise), (as, bs, noise), "symbolic squeeze operator"), 
    (phaseshift, (a, noise), (as, noise), "symbolic phase-shift operator"),
    (twosqueeze, (a, b, noise), (as, bs, noise), "symbolic two-mode squeeze operator"),
    (beamsplitter, (a, noise), (as, noise), "symbolic beamsplitter operator"),
    (amplifier, (a, b), (as, bs), "symbolic amplifier channel"),
    (attenuator, (a, b), (as, bs), "symbolic attenuator channel")
    ]

    for (op, params, multi_params, desc) in test_configs
        @testset "$desc" begin
            op_pair = op(qpairbasis, params...)
            op_block = op(qblockbasis, params...)  
            @test op_pair isa GaussianChannel && op_block isa GaussianChannel
            @test op(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, params...) isa GaussianChannel
            @test op(Array, qpairbasis, params...) isa GaussianChannel
            @test_throws TypeError isapprox(op_block, changebasis(QuadBlockBasis, op_pair)) # due to equality checks for Num type in Symbolics.jl

            op_pair_multi = op(qpairbasis, multi_params...)
            op_block_multi = op(qblockbasis, multi_params...)
            @test op_pair_multi isa GaussianChannel && op_block_multi isa GaussianChannel
            @test op(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, multi_params...) isa GaussianChannel
            @test op(Array, qpairbasis, multi_params...) isa GaussianChannel
            @test_throws TypeError isapprox(op_block_multi, changebasis(QuadBlockBasis, op_pair_multi)) # due to equality checks for Num type in Symbolics.jl
        end
    end

    @testset "Symbolic tensor products" begin
        noise_ds = [noise zeros(Num, 2*nmodes, 2*nmodes); zeros(Num, 2*nmodes, 2*nmodes) noise]

        d1_pair = displace(qpairbasis, a, noise)
        d2_pair = displace(qpairbasis, b, noise)
        ds_pair = tensor(d1_pair, d2_pair)
        @test ds_pair isa GaussianChannel
        @test_throws TypeError isapprox(ds_pair, d1_pair ⊗ d2_pair) # due to equality checks for Num type in Symbolics.jl
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, d1_pair, d2_pair) isa GaussianChannel
        p_pair = phaseshift(qpairbasis, a, noise)
        @test_throws TypeError isapprox(tensor(tensor(p_pair, d1_pair), d2_pair), p_pair ⊗ d1_pair ⊗ d2_pair) # due to equality checks for Num type in Symbolics.jl
        
        d1_block = displace(qblockbasis, a, noise)
        d2_block = displace(qblockbasis, b, noise)
        ds_block = tensor(d1_block, d2_block)
        @test ds_block isa GaussianChannel
        @test_throws TypeError isapprox(ds_block, d1_block ⊗ d2_block) # due to equality checks for Num type in Symbolics.jl
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, d1_block, d2_block) isa GaussianChannel
        p_block = phaseshift(qblockbasis, a, noise)
        @test_throws TypeError isapprox(tensor(tensor(p_block, d1_block), d2_block), p_block ⊗ d1_block ⊗ d2_block) # due to equality checks for Num type in Symbolics.jl
    end

    @testset "Symbolic actions" begin
        d = displace(qpairbasis, a, noise)
        v = vacuumstate(qpairbasis)
        c = coherentstate(qpairbasis, b)
        @test_broken isapprox(d * v, c) # due to equality checks for Num type in Symbolics.jl
        @test_broken isapprox(apply!(v, d), c)
        v1, v2 = vacuumstate(qpairbasis), vacuumstate(qpairbasis)
        d1 = displace(qpairbasis, a, noise)
        d2 = displace(qpairbasis, b, noise)
        c1 = coherentstate(qpairbasis, a)
        c2 = coherentstate(qpairbasis, b)
        @test_throws TypeError isapprox((d1 ⊗ d2) * (v1 ⊗ v2), c1 ⊗ c2) # due to equality checks for Num type in Symbolics.jl
    end
end

using TestItemRunner

const JET_PROJECT = normpath(joinpath(@__DIR__, "projects", "jet"))
const test_args = isempty(ARGS) ? ["general"] : ARGS
const JET_flag = length(test_args) == 1 && startswith(only(test_args), "jet")

if JET_flag
    @info "Activating the dedicated JET test environment." project=JET_PROJECT
    using Pkg

    Pkg.activate(JET_PROJECT)
    Pkg.instantiate()
    include("jet_tests.jl")
else
    using Gabs

    testfilter = ti -> begin
        exclude = Symbol[:jet]
        if !(VERSION >= v"1.10")
            push!(exclude, :doctests)
            push!(exclude, :aqua)
        end

        return all(!in(exclude), ti.tags)
    end

    println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

    @run_package_tests filter=testfilter
end

using BenchmarkTools
using Gabs
using LinearAlgebra
using PkgBenchmark


const SUITE = BenchmarkGroup()

prob_list = ("operations")
op_list = ("unitary product", "channel product", "tensor product", "partial trace")
for prob in prob_list
    SUITE[prob] = BenchmarkGroup([prob])
end
for op in op_list
    SUITE["operations"][op] = BenchmarkGroup()
end

for nmodes in (2, 10, 50, 100, 200)
    basis = QuadPairBasis(nmodes)
    SUITE["operations"]["unitary product"][string(nmodes)] = @benchmarkable op * state setup=(op = randunitary($basis); state = randstate($basis))
    SUITE["operations"]["channel product"][string(nmodes)] = @benchmarkable ch * state setup=(ch = randchannel($basis); state = randstate($basis))
    SUITE["operations"]["tensor product"][string(nmodes)] = @benchmarkable state1 ⊗ state2 setup=(state1 = randstate($basis); state2 = randstate($basis))
    SUITE["operations"]["partial trace"][string(nmodes)] = @benchmarkable ptrace(state, indices) setup=(state = randstate($basis); indices = collect(2:$nmodes))
end

abstract type SymplecticBasis{N} end

nmodes(x::SymplecticBasis) = x.nmodes

"""
Defines a symplectic basis for a bosonic system of size `nmodes` in which
the quadrature field operators are arranged pairwise.
"""
struct QuadPairBasis{N} <: SymplecticBasis{N}
    nmodes::N
end

"""
Defines a symplectic basis for a bosonic system of size `nmodes` in which
the quadrature field operators are arranged blockwise.
"""
struct QuadBlockBasis{N} <: SymplecticBasis{N}
    nmodes::N
end

function Base.show(io::IO, x::SymplecticBasis)
    print(io, "$(nameof(typeof(x)))($(x.nmodes))")
end
function Base.:(*)(n::N, basis::R) where {N<:Number,R<:SymplecticBasis}
    R(n*basis.nmodes)
end

"""
    directsum(basis1::SymplecticBasis, basis2::SymplecticBasis)

Compute the direct sum of symplectic bases.
"""
function directsum(basis1::R, basis2::R) where {R<:SymplecticBasis}
    R(basis1.nmodes + basis2.nmodes)
end

"""
    symplecticform([T = Matrix{Float64},] basis::SymplecticBasis)

Compute the symplectic form matrix of size 2N x 2N corresponding to `basis`.
"""
function symplecticform(basis::QuadPairBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    Omega = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        Omega[2*i-1, 2*i] = 1.0
        Omega[2*i, 2*i-1] = -1.0
    end
    return Omega
end
function symplecticform(basis::QuadBlockBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    Omega = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in 1:nmodes, j in nmodes:2*nmodes
        if isequal(i, j-nmodes)
            Omega[i,j] = 1.0
        end
    end
    @inbounds for i in nmodes:2*nmodes, j in 1:nmodes
        if isequal(i-nmodes,j)
            Omega[i, j] = -1.0
        end
    end
    return Omega
end
symplecticform(::Type{T}, basis::SymplecticBasis{N}) where {T, N<:Int} = T(symplecticform(basis))

@testitem "QuantumOpticsBase extension" begin
    using Gabs
    using LinearAlgebra
    using QuantumInterface: QuantumOpticsRepr, express
    using QuantumOpticsBase

    const QO = QuantumOpticsBase

    function samestate(ket1, ket2; atol=1e-10)
        return isapprox(QO.dm(ket1), QO.dm(ket2); atol=atol, rtol=0)
    end

    @test Base.get_extension(Gabs, :QuantumOpticsBaseExt) !== nothing

    # This helper keeps only the creation-operator part of the squeezed-vacuum
    # expansion. It matches the Gaussian-to-Ket construction more closely in a
    # truncated Fock basis than `QO.squeeze`, which exponentiates truncated
    # creation/annihilation operators directly.
    function manual_squeezed_state(basis, z)
        λ = -tanh(abs(z)) * exp(im * angle(z))
        return normalize!(exp(QO.dense((λ / 2) * QO.create(basis)^2)) * QO.fockstate(basis, 0))
    end

    # This is the displaced analogue of `manual_squeezed_state`: it rewrites the
    # displaced squeezed vacuum as a creation-only exponential acting on vacuum.
    # `QO.displace * QO.squeeze` is still tested below, but its finite-dimensional
    # matrix exponentials are a bit more sensitive to cutoff effects.
    function manual_displaced_squeezed_state(basis, α, z)
        λ = -tanh(abs(z)) * exp(im * angle(z))
        β = α - λ * conj(α)
        generator = QO.dense((λ / 2) * QO.create(basis)^2 + β * QO.create(basis))
        return normalize!(exp(generator) * QO.fockstate(basis, 0))
    end

    function evolve_with_generator(generator, ket)
        return normalize!(exp(QO.dense(generator)) * ket)
    end

    function two_mode_ops(cutoff)
        mode_basis = QO.FockBasis(cutoff)
        basis = QO.tensor(mode_basis, mode_basis)
        a1 = QO.embed(basis, 1, QO.destroy(mode_basis))
        a2 = QO.embed(basis, 2, QO.destroy(mode_basis))
        ad1 = QO.embed(basis, 1, QO.create(mode_basis))
        ad2 = QO.embed(basis, 2, QO.create(mode_basis))
        n1 = QO.embed(basis, 1, QO.number(mode_basis))
        n2 = QO.embed(basis, 2, QO.number(mode_basis))
        return (; basis, mode_basis, a1, a2, ad1, ad2, n1, n2)
    end

    @testset "single-mode states" begin
        repr = QuantumOpticsRepr(8)
        basis = QO.FockBasis(repr.cutoff)
        vacuum = QO.fockstate(basis, 0)
        builtin_squeeze_atol = 1e-3
        builtin_displaced_squeeze_atol = 1e-2

        @test samestate(express(Gabs.vacuumstate(Gabs.QuadPairBasis(1)), repr), vacuum)
        @test samestate(express(Gabs.vacuumstate(Gabs.QuadBlockBasis(1)), repr), vacuum)

        α = 0.3 - 0.4im
        @test samestate(
            express(Gabs.coherentstate(Gabs.QuadPairBasis(1), α), repr),
            QO.coherentstate(basis, α),
        )
        @test samestate(
            express(Gabs.coherentstate(Gabs.QuadBlockBasis(1), α), repr),
            QO.coherentstate(basis, α),
        )

        z = 0.35 * exp(0.4im)
        squeezed = manual_squeezed_state(basis, z)
        builtin_squeezed = QO.squeeze(basis, z) * vacuum
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadPairBasis(1), abs(z), angle(z)), repr),
            squeezed,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadPairBasis(1), abs(z), angle(z)), repr),
            builtin_squeezed;
            atol=builtin_squeeze_atol,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadBlockBasis(1), abs(z), angle(z)), repr),
            squeezed,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadBlockBasis(1), abs(z), angle(z)), repr),
            builtin_squeezed;
            atol=builtin_squeeze_atol,
        )

        displaced = manual_displaced_squeezed_state(basis, α, z)
        builtin_displaced = QO.displace(basis, α) * QO.squeeze(basis, z) * vacuum
        state_pair = Gabs.displace(Gabs.QuadPairBasis(1), α) *
            Gabs.squeezedstate(Gabs.QuadPairBasis(1), abs(z), angle(z))
        state_block = Gabs.displace(Gabs.QuadBlockBasis(1), α) *
            Gabs.squeezedstate(Gabs.QuadBlockBasis(1), abs(z), angle(z))
        @test samestate(express(state_pair, repr), displaced)
        @test samestate(express(state_block, repr), displaced)
        @test samestate(express(state_pair, repr), builtin_displaced; atol=builtin_displaced_squeeze_atol)
        @test samestate(express(state_block, repr), builtin_displaced; atol=builtin_displaced_squeeze_atol)
    end

    @testset "multi-mode states" begin
        repr = QuantumOpticsRepr(6)
        mode_basis = QO.FockBasis(repr.cutoff)
        basis = QO.tensor(mode_basis, mode_basis)
        vacuum = QO.tensor(QO.fockstate(mode_basis, 0), QO.fockstate(mode_basis, 0))
        builtin_squeeze_atol = 2e-3

        α = [0.2 + 0.1im, -0.15 + 0.3im]
        expected = QO.tensor(QO.coherentstate(mode_basis, α[1]), QO.coherentstate(mode_basis, α[2]))
        @test samestate(express(Gabs.coherentstate(Gabs.QuadPairBasis(2), α), repr), expected)
        @test samestate(express(Gabs.coherentstate(Gabs.QuadBlockBasis(2), α), repr), expected)

        z = [-0.25im, 0.3]
        squeezed = QO.tensor(
            manual_squeezed_state(mode_basis, z[1]),
            manual_squeezed_state(mode_basis, z[2]),
        )
        builtin_squeezed = QO.tensor(
            QO.squeeze(mode_basis, z[1]) * QO.fockstate(mode_basis, 0),
            QO.squeeze(mode_basis, z[2]) * QO.fockstate(mode_basis, 0),
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadPairBasis(2), abs.(z), angle.(z)), repr),
            squeezed;
            atol=1e-9,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadPairBasis(2), abs.(z), angle.(z)), repr),
            builtin_squeezed;
            atol=builtin_squeeze_atol,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadBlockBasis(2), abs.(z), angle.(z)), repr),
            squeezed;
            atol=1e-9,
        )
        @test samestate(
            express(Gabs.squeezedstate(Gabs.QuadBlockBasis(2), abs.(z), angle.(z)), repr),
            builtin_squeezed;
            atol=builtin_squeeze_atol,
        )

        create1 = QO.embed(basis, 1, QO.create(mode_basis))
        create2 = QO.embed(basis, 2, QO.create(mode_basis))
        λ = -tanh(0.27)
        epr = normalize!(exp(QO.dense(λ * create1 * create2)) * vacuum)
        @test samestate(express(Gabs.eprstate(Gabs.QuadPairBasis(2), 0.27, 0.0), repr), epr; atol=1e-8)
        @test samestate(express(Gabs.eprstate(Gabs.QuadBlockBasis(2), 0.27, 0.0), repr), epr; atol=1e-8)
    end

    @testset "operator actions" begin
        repr = QuantumOpticsRepr(12)
        ops = two_mode_ops(repr.cutoff)
        α0 = [0.12 + 0.03im, -0.07 + 0.08im]
        pair_state = Gabs.coherentstate(Gabs.QuadPairBasis(2), α0)
        block_state = Gabs.coherentstate(Gabs.QuadBlockBasis(2), α0)

        @test samestate(express(pair_state, repr), express(block_state, repr))

        function check_operator_action(pair_state, block_state, pair_op, block_op, generator; atol=1e-8)
            quantumoptics_state = express(pair_state, repr)
            qostate_after_op = evolve_with_generator(generator, quantumoptics_state)
            @test samestate(express(pair_op * pair_state, repr), qostate_after_op; atol=atol)
            @test samestate(express(block_op * block_state, repr), qostate_after_op; atol=atol)
        end

        transmit = 0.2
        beamsplitter_generator = asin(sqrt(transmit)) * (ops.ad1 * ops.a2 - ops.a1 * ops.ad2)
        check_operator_action(
            pair_state,
            block_state,
            Gabs.beamsplitter(Gabs.QuadPairBasis(2), transmit),
            Gabs.beamsplitter(Gabs.QuadBlockBasis(2), transmit),
            beamsplitter_generator,
        )

        phases = [0.17, -0.21]
        phaseshift_generator = -im * (phases[1] * ops.n1 + phases[2] * ops.n2)
        check_operator_action(
            pair_state,
            block_state,
            Gabs.phaseshift(Gabs.QuadPairBasis(2), phases),
            Gabs.phaseshift(Gabs.QuadBlockBasis(2), phases),
            phaseshift_generator,
        )

        displacement = [0.04 - 0.01im, -0.03 + 0.02im]
        displacement_generator = displacement[1] * ops.ad1 - conj(displacement[1]) * ops.a1 +
            displacement[2] * ops.ad2 - conj(displacement[2]) * ops.a2
        check_operator_action(
            pair_state,
            block_state,
            Gabs.displace(Gabs.QuadPairBasis(2), displacement),
            Gabs.displace(Gabs.QuadBlockBasis(2), displacement),
            displacement_generator,
        )

        squeeze_parameters = [0.05 * exp(0.2im), -0.04im]
        squeeze_generator = conj(squeeze_parameters[1]) / 2 * ops.a1^2 -
            squeeze_parameters[1] / 2 * ops.ad1^2 +
            conj(squeeze_parameters[2]) / 2 * ops.a2^2 -
            squeeze_parameters[2] / 2 * ops.ad2^2
        check_operator_action(
            pair_state,
            block_state,
            Gabs.squeeze(Gabs.QuadPairBasis(2), abs.(squeeze_parameters), angle.(squeeze_parameters)),
            Gabs.squeeze(Gabs.QuadBlockBasis(2), abs.(squeeze_parameters), angle.(squeeze_parameters)),
            squeeze_generator,
        )

        twosqueeze_r = 0.05
        twosqueeze_phase = -0.3
        twosqueeze_generator = -(twosqueeze_r * exp(im * twosqueeze_phase)) * ops.ad1 * ops.ad2 +
            (twosqueeze_r * exp(-im * twosqueeze_phase)) * ops.a1 * ops.a2
        check_operator_action(
            pair_state,
            block_state,
            Gabs.twosqueeze(Gabs.QuadPairBasis(2), twosqueeze_r, twosqueeze_phase),
            Gabs.twosqueeze(Gabs.QuadBlockBasis(2), twosqueeze_r, twosqueeze_phase),
            twosqueeze_generator,
        )
    end

    @testset "mixed states are rejected" begin
        repr = QuantumOpticsRepr(6)
        @test_throws ArgumentError express(Gabs.thermalstate(Gabs.QuadPairBasis(1), 0.5), repr)
        @test_throws ArgumentError express(Gabs.thermalstate(Gabs.QuadBlockBasis(1), 0.5), repr)
    end
end

struct Generaldyne{R,S<:GaussianState} <: AbstractGaussianMeasurement
	result::R
	state::S
	function Generaldyne(r::R, s::S) where {R,S<:GaussianState}
		return new{R,S}(r, s)
	end
end

# iteration for destructuring into components
Base.iterate(F::Generaldyne) = (F.result, Val(:state))
Base.iterate(F::Generaldyne, ::Val{:state}) = (F.state, Val(:done))
Base.iterate(F::Generaldyne, ::Val{:done}) = nothing

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, H::Generaldyne{<:Any,<:GaussianState})
    Base.summary(io, H); println(io)
    println(io, "result:")
    Base.show(io, mime, H.result)
    println(io, "\noutput state:")
    Base.show(io, mime, H.state)
end

"""
    generaldyne(state::GaussianState, indices::Vector; proj = (ħ/2)I) -> Generaldyne
    generaldyne(state::GaussianState, index::Int; proj = (ħ/2)I) -> Generaldyne

Compute the projection of the subsystem of a Gaussian state `state` indicated by `indices`
on `proj` and return a `Generaldyne` object. The keyword argument `proj` can take the following forms:

- If `proj` is a matrix, then the subsystem is projected onto a Gaussian state with a randomly sampled mean and covariance matrix `result`.
- If `proj` is a Gaussian state, then the subsystem is projected onto `proj`.

The `result` and mapped state `output` can be obtained from the Generaldyne object `M` via `M.result` and `M.output`.
Iterating the decomposition produces the components `result` and `output`.

Note the measured modes are replaced with vacuum states after the general-dyne measurement.

# Examples
```
julia> st = squeezedstate(QuadBlockBasis(3), 1.0, pi/4);

julia> M = generaldyne(st, [1, 3])
Generaldyne{GaussianState{QuadBlockBasis{Int64}, Vector{Float64}, Matrix{Float64}}, GaussianState{QuadBlockBasis{Int64}, Vector{Float64}, Matrix{Float64}}}
result:
GaussianState for 2 modes.
  symplectic basis: QuadBlockBasis
mean: 4-element Vector{Float64}:
  0.26967410461090285
  1.4683993027500133
 -1.84631450059537
  0.16832788926417352
covariance: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0
output state:
GaussianState for 3 modes.
  symplectic basis: QuadBlockBasis
mean: 6-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
 0.0
 0.0
covariance: 6×6 Matrix{Float64}:
 1.0   0.0      0.0  0.0   0.0      0.0
 0.0   1.19762  0.0  0.0  -2.56458  0.0
 0.0   0.0      1.0  0.0   0.0      0.0
 0.0   0.0      0.0  1.0   0.0      0.0
 0.0  -2.56458  0.0  0.0   6.32677  0.0
 0.0   0.0      0.0  0.0   0.0      1.0

julia> result, state = M; # destructuring via iteration

julia> result == M.result && state == M.state
true
```
"""
function generaldyne(state::GaussianState{<:QuadPairBasis,Tm,Tc}, indices::R; 
					 proj::S = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*length(indices), 2*length(indices))) where {Tm,Tc,R,S<:Union{Matrix,GaussianState}}
	basis = state.basis
	nmodes = basis.nmodes
	indlength = length(indices)
	indlength <= nmodes || throw(ArgumentError(INDEX_ERROR))
	if proj isa Matrix
		2*indlength == size(proj)[1] == size(proj)[2] || throw(ArgumentError(GENERALDYNE_ERROR))
	elseif proj isa GaussianState
		2*indlength == length(proj.mean) || throw(ArgumentError(GENERALDYNE_ERROR))
	end
	result′, a, A = _generaldyne_filter(state, indices, proj)
	mean′, covar′ = zeros(eltype(Tm), 2*nmodes), Matrix{eltype(Tc)}((state.ħ/2)*I, 2*nmodes, 2*nmodes)
	# fill in measured modes with vacuum states
	notindices = setdiff(1:nmodes, indices)
	@inbounds for i in eachindex(notindices)
        idx = notindices[i]
		copyto!(@view(mean′[2idx-1:2idx]), @view(a[2i-1:2i]))
        @inbounds for j in i:length(notindices)
            otheridx = notindices[j]
            covar′[2*idx-1, 2*otheridx-1] = A[2*i-1, 2*j-1]
            covar′[2*idx-1, 2*otheridx] = A[2*i-1, 2*j]
            covar′[2*idx, 2*otheridx-1] = A[2*i, 2*j-1]
            covar′[2*idx, 2*otheridx] = A[2*i, 2*j]
            covar′[2*otheridx-1, 2*idx-1] = A[2*j-1, 2*i-1]
            covar′[2*otheridx-1, 2*idx] = A[2*j-1, 2*i]
            covar′[2*otheridx, 2*idx-1] = A[2*j, 2*i-1]
            covar′[2*otheridx, 2*idx] = A[2*j, 2*i]
        end
    end 
	mean′′ = _promote_output_vector(Tm, mean′, 2*nmodes)
    covar′′ = _promote_output_matrix(Tc, covar′, 2*nmodes)
    state′ = GaussianState(basis, mean′′, covar′′, ħ = state.ħ)
	return Generaldyne(result′, state′)
end
function generaldyne(state::GaussianState{<:QuadBlockBasis,Tm,Tc}, indices::R; 
	proj::S = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*length(indices), 2*length(indices))) where {Tm,Tc,R,S<:Union{Matrix,GaussianState}}
	basis = state.basis
	nmodes = basis.nmodes
	indlength = length(indices)
	indlength <= nmodes || throw(ArgumentError(INDEX_ERROR))
	if proj isa Matrix
		2*indlength == size(proj)[1] == size(proj)[2] || throw(ArgumentError(GENERALDYNE_ERROR))
	elseif proj isa GaussianState
		2*indlength == length(proj.mean) || throw(ArgumentError(GENERALDYNE_ERROR))
	end
	result′, a, A = _generaldyne_filter(state, indices, proj)
	mean′, covar′ = zeros(eltype(Tm), 2*nmodes), Matrix{eltype(Tc)}((state.ħ/2)*I, 2*nmodes, 2*nmodes)
	nmodes′ = nmodes - length(indices)
	# fill in measured modes with vacuum states
	notindices = setdiff(1:nmodes, indices)
	@inbounds for i in eachindex(notindices)
        idx = notindices[i]
		mean′[idx] = a[i]
		mean′[idx+nmodes] = a[i+nmodes′]
        @inbounds for j in i:length(notindices)
            otheridx = notindices[j]
            covar′[idx,otheridx] = A[i,j]
            covar′[otheridx,idx] = A[j,i]
            covar′[idx+nmodes,otheridx] = A[i+nmodes′,j]
            covar′[idx,otheridx+nmodes] = A[i,j+nmodes′]
            covar′[otheridx,idx+nmodes] = A[j,i+nmodes′]
            covar′[otheridx+nmodes,idx] = A[j+nmodes′,i]
            covar′[idx+nmodes,otheridx+nmodes] = A[i+nmodes′,j+nmodes′]
            covar′[otheridx+nmodes,idx+nmodes] = A[j+nmodes′,i+nmodes′]
        end
    end 
	mean′′ = _promote_output_vector(Tm, mean′, 2*nmodes)
    covar′′ = _promote_output_matrix(Tc, covar′, 2*nmodes)
    state′ = GaussianState(basis, mean′′, covar′′, ħ = state.ħ)
	return Generaldyne(result′, state′)
end

"""
	rand(::Type{Generaldyne}, state::GaussianState, indices::Vector; shots = 1, proj = (ħ/2)I)

# Examples
```
julia > st = squeezedstate(QuadBlockBasis(3), 1.0, pi/4);

julia> rand(Generaldyne, st, [1, 3], shots = 5)
4×5 Matrix{Float64}:
  0.760996   1.24663    1.785     2.89803  -0.873372
  2.06074   -0.185524  -2.90446  -1.21932  -2.67317
  0.979994   2.44556   -2.20969  -4.12306  -1.31005
 -0.235823  -2.22807    1.11322   1.72146   1.37089
```
"""
function Base.rand(::Type{Generaldyne}, state::GaussianState{<:QuadPairBasis,Tm,Tc}, indices::R; 
				   shots::Int = 1, proj::S = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*length(indices), 2*length(indices))) where {Tm,Tc,R,S<:Matrix}
	basis = state.basis
	indlength = length(indices)
	nmodes′ = basis.nmodes - indlength
	indlength <= basis.nmodes || throw(ArgumentError(INDEX_ERROR))
	2*indlength == size(proj)[1] == size(proj)[2] || throw(ArgumentError(GENERALDYNE_ERROR))
	mean, covar = state.mean, state.covar
	# write mean and covariance matrix of measured modes to vector `b` and matrix `B`, respectively
	b, B = zeros(2*indlength), zeros(2*indlength, 2*indlength)
	@inbounds for i in eachindex(indices)
		idx = indices[i]
		b[2i-1:2i] .= @view(mean[2idx-1:2idx])
		@inbounds for j in eachindex(indices)
			otheridx = indices[j]
			if idx == otheridx
				B[2i-1:2i, 2i-1:2i] .= @view(covar[2idx-1:2idx, 2idx-1:2idx])
			else
				B[2i-1:2i, 2j-1:2j] .= @view(covar[2idx-1:2idx, 2otheridx-1:2otheridx])
				B[2j-1:2j, 2i-1:2i] .= @view(covar[2otheridx-1:2otheridx, 2idx-1:2idx])
			end
		end
	end
	# generate random mean vector samples
	symB = Symmetric(B)
	L = cholesky(symB).L
	buf = zeros(2*indlength)
	results = zeros(2*indlength, shots)
	@inbounds for i in Base.OneTo(shots)
		mul!(@view(results[:,i]), L, randn!(buf))
		@view(results[:,i]) .+= b
	end
	return results
end
function Base.rand(::Type{Generaldyne}, state::GaussianState{<:QuadBlockBasis,Tm,Tc}, indices::R;
				   shots::Int = 1, proj::S = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*length(indices), 2*length(indices))) where {Tm,Tc,R,S<:Matrix}
	basis = state.basis
	nmodes = basis.nmodes
	indlength = length(indices)
	nmodes′ = nmodes - indlength
	indlength <= nmodes || throw(ArgumentError(INDEX_ERROR))
	2*indlength == size(proj)[1] == size(proj)[2] || throw(ArgumentError(GENERALDYNE_ERROR))
	mean, covar = state.mean, state.covar
	# write mean and covariance matrix of measured modes to vector `b` and matrix `B`, respectively
	b, B = zeros(2*indlength), zeros(2*indlength, 2*indlength)
	@inbounds for i in eachindex(indices)
		idx = indices[i]
		b[i] = mean[idx]
		b[i+indlength] = mean[idx+nmodes]
		@inbounds for j in eachindex(indices)
			otheridx = indices[j]
			if idx == otheridx
				B[i, i] = covar[idx, idx]
				B[i+indlength, i] = covar[idx+nmodes, idx]
				B[i, i+indlength] = covar[idx, idx+nmodes]
				B[i+indlength, i+indlength] = covar[idx+nmodes, idx+nmodes]
			else
				B[i, j] = covar[idx, otheridx]
				B[i+indlength, j] = covar[idx+nmodes, otheridx]
				B[i, j+indlength] = covar[idx, otheridx+nmodes]
				B[i+indlength, j+indlength] = covar[idx+nmodes, otheridx+nmodes]

				B[j, i] = covar[otheridx, idx]
				B[j+indlength, i] = covar[otheridx+nmodes, idx]
				B[j, i+indlength] = covar[otheridx, idx+nmodes]
				B[j+indlength, i+indlength] = covar[otheridx+nmodes, idx+nmodes]
			end
		end
	end
	# generate random mean vector samples
	B .+= proj
	symB = Symmetric(B)
	L = cholesky(symB).L
	buf = zeros(2*indlength)
	results = zeros(2*indlength, shots)
	@inbounds for i in Base.OneTo(shots)
		mul!(@view(results[:,i]), L, randn!(buf))
		@view(results[:,i]) .+= b
	end
	return results
end

function _generaldyne_filter(state::GaussianState{<:SymplecticBasis,Tm,Tc}, indices::R, proj::S) where {Tm,Tc,R,S<:Matrix}
	basis = state.basis
	indlength = length(indices)
	nmodes′ = basis.nmodes - indlength
	a, b, A, B, C = _part_state(state, indices)
	# generate random mean vector samples
	B .+= proj
	symB = Symmetric(B)
	L = cholesky(symB).L
	resultmean = L * randn(2*indlength) + b
	meandiff = resultmean - b
	# conditional mapping (see Serafini's Quantum Continuous Variables textbook for reference)
	buf = C * inv(symB)
	a .+= buf * meandiff
	A .-= buf * C'
	resultmean′ = _promote_output_vector(Tm, resultmean, 2*indlength)
	result′ = GaussianState(typeof(basis)(indlength), resultmean′, proj, ħ = state.ħ)
	return result′, a, A
end
function _generaldyne_filter(state::GaussianState{<:SymplecticBasis,Tm,Tc}, indices::R, proj::S) where {Tm,Tc,R,S<:GaussianState}
	basis = state.basis
	indlength = length(indices)
	nmodes′ = basis.nmodes - indlength
	a, b, A, B, C = _part_state(state, indices)
	B .+= proj.covar
	symB = Symmetric(B)
	meandiff = proj.mean - b
	# conditional mapping (see Serafini's Quantum Continuous Variables textbook for reference)
	buf = C * inv(symB)
	a .+= buf * meandiff
	A .-= buf * C'
	result′ = proj
	return result′, a, A
end

"""
    GaussianLinearCombination{B<:SymplecticBasis,C,S}

Represents a linear combination of Gaussian states of the form `Σᵢ cᵢ|ψᵢ⟩` where `cᵢ` are coefficients 
and `|ψᵢ⟩` are Gaussian states, all sharing the same symplectic basis and `ħ` value.

## Fields
- `basis::B`: Symplectic basis shared by all states
- `coeffs::Vector{C}`: Complex coefficients for the linear combination  
- `states::Vector{S}`: Vector of Gaussian states
- `ħ::Number`: Reduced Planck's constant (must be same for all states)

## Examples

julia> basis = QuadPairBasis(1)
QuadPairBasis(1)

julia> state1 = coherentstate(basis, 1.0)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 2.0
 0.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0

julia> state2 = coherentstate(basis, -1.0)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 -2.0
  0.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0

julia> cat_state = 0.5 * state1 + 0.5 * state2
GaussianLinearCombination with 2 terms for 1 mode.
  symplectic basis: QuadPairBasis
  `ħ = 2`
  [1] 0.5 * GaussianState
  [2] 0.5 * GaussianState

julia> lcgs = GaussianLinearCombination([0.6, 0.8], [state1, state2])
GaussianLinearCombination with 2 terms for 1 mode.
  symplectic basis: QuadPairBasis
  `ħ = 2`
  [1] 0.6 * GaussianState
  [2] 0.8 * GaussianState
"""
mutable struct GaussianLinearCombination{B<:SymplecticBasis,C,S}
    basis::B
    coeffs::Vector{C}
    states::Vector{S}
    ħ::Number
    function GaussianLinearCombination(basis::B, coeffs::Vector{C}, states::Vector{S}) where {B<:SymplecticBasis,C,S}
        length(coeffs) == length(states) || throw(DimensionMismatch("Number of coefficients ($(length(coeffs))) must match number of states ($(length(states)))"))
        isempty(states) && throw(ArgumentError("Cannot create an empty linear combination"))
        ħ = first(states).ħ
        @inbounds for (i, state) in enumerate(states)
            state isa GaussianState || throw(ArgumentError("Element $i is not a GaussianState: got $(typeof(state))"))
            if state.basis != basis
                throw(ArgumentError("State $i has incompatible basis: expected $(typeof(basis))($(basis.nmodes)), got $(typeof(state.basis))($(state.basis.nmodes))"))
            end
            if state.ħ != ħ
                throw(ArgumentError("State $i has different ħ: expected $ħ, got $(state.ħ)"))
            end
        end
        return new{B,C,S}(basis, coeffs, states, ħ)
    end
end
"""
    GaussianLinearCombination(state::GaussianState)

Create a linear combination containing a single Gaussian state with coefficient 1.0.
"""
function GaussianLinearCombination(state::GaussianState{B,M,V}) where {B,M,V}
    coeff_type = float(real(promote_type(eltype(M), eltype(V))))
    return GaussianLinearCombination(state.basis, [one(coeff_type)], [state])
end
"""
    GaussianLinearCombination(pairs::Vector{<:Tuple})

Create a linear combination from a vector of (coefficient, state) tuples.
"""
function GaussianLinearCombination(pairs::Vector{<:Tuple})
    isempty(pairs) && throw(ArgumentError("Cannot create an empty linear combination"))
    coeffs = [convert(Number, p[1]) for p in pairs]
    states = [p[2] for p in pairs]
    @inbounds for (i, state) in enumerate(states)
        state isa GaussianState || throw(ArgumentError("Element $i: second element must be a GaussianState"))
    end
    basis = first(states).basis
    return GaussianLinearCombination(basis, coeffs, states)
end
"""
    GaussianLinearCombination(coeffs::Vector{<:Number}, states::Vector{<:GaussianState})

Create a linear combination from separate vectors of coefficients and states.
"""
function GaussianLinearCombination(coeffs::Vector{<:Number}, states::Vector{<:GaussianState})
    isempty(states) && throw(ArgumentError("Cannot create an empty linear combination"))
    basis = first(states).basis
    return GaussianLinearCombination(basis, coeffs, states)
end
"""
    GaussianLinearCombination(pairs::Pair{<:Number,<:GaussianState}...)

Create a linear combination from coefficient => state pairs.
"""
function GaussianLinearCombination(pairs::Pair{<:Number,<:GaussianState}...)
    isempty(pairs) && throw(ArgumentError("Cannot create an empty linear combination"))
    coeffs = [p.first for p in pairs]
    states = [p.second for p in pairs]
    basis = first(states).basis
    return GaussianLinearCombination(basis, coeffs, states)
end

nmodes(x::GaussianLinearCombination) = nmodes(x[1])

"""
    +(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)

Add two linear combinations of Gaussian states. Both must have the same symplectic basis and ħ value.
"""
function Base.:+(lc1::GaussianLinearCombination{B}, lc2::GaussianLinearCombination{B}) where {B<:SymplecticBasis}
    lc1.basis == lc2.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    lc1.ħ == lc2.ħ || throw(ArgumentError(HBAR_ERROR))
    coeffs = vcat(lc1.coeffs, lc2.coeffs)
    states = vcat(lc1.states, lc2.states)
    return GaussianLinearCombination(lc1.basis, coeffs, states)
end
function Base.:+(lc1::GaussianLinearCombination{B1}, lc2::GaussianLinearCombination{B2}) where {B1<:SymplecticBasis,B2<:SymplecticBasis}
    throw(ArgumentError(SYMPLECTIC_ERROR))
end
"""
    -(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)

Subtract two linear combinations of Gaussian states.
"""
function Base.:-(lc1::GaussianLinearCombination{B}, lc2::GaussianLinearCombination{B}) where {B<:SymplecticBasis}
    return lc1 + (-1) * lc2
end
function Base.:-(lc1::GaussianLinearCombination{B1}, lc2::GaussianLinearCombination{B2}) where {B1<:SymplecticBasis,B2<:SymplecticBasis}
    throw(ArgumentError(SYMPLECTIC_ERROR))
end
"""
    -(lc::GaussianLinearCombination)

Negate a linear combination of Gaussian states.
"""
Base.:-(lc::GaussianLinearCombination) = (-1) * lc

"""
    *(α::Number, lc::GaussianLinearCombination)

Multiply a linear combination by a scalar from the left.
"""
function Base.:*(α::Number, lc::GaussianLinearCombination)
    new_coeffs = α .* lc.coeffs
    return GaussianLinearCombination(lc.basis, new_coeffs, copy(lc.states))
end
"""
    *(lc::GaussianLinearCombination, α::Number)

Multiply a linear combination by a scalar from the right.
"""
Base.:*(lc::GaussianLinearCombination, α::Number) = α * lc
"""
    *(α::Number, state::GaussianState)

Multiply a Gaussian state by a scalar to create a linear combination.
"""
function Base.:*(α::Number, state::GaussianState)
    coeff_type = promote_type(typeof(α), eltype(state.mean), eltype(state.covar))
    return GaussianLinearCombination(state.basis, [convert(coeff_type, α)], [state])
end
"""
    *(state::GaussianState, α::Number)

Multiply a Gaussian state by a scalar to create a linear combination.
"""
Base.:*(state::GaussianState, α::Number) = α * state
"""
    +(state1::GaussianState, state2::GaussianState)

Add two Gaussian states to create a linear combination.
"""
function Base.:+(state1::GaussianState, state2::GaussianState)
    state1.basis == state2.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    coeff_type = promote_type(eltype(state1.mean), eltype(state1.covar), 
                              eltype(state2.mean), eltype(state2.covar))
    return GaussianLinearCombination(state1.basis, [one(coeff_type), one(coeff_type)], [state1, state2])
end
"""
    +(state::GaussianState, lc::GaussianLinearCombination)

Add a Gaussian state to a linear combination.
"""
function Base.:+(state::GaussianState, lc::GaussianLinearCombination)
    state.basis == lc.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state.ħ == lc.ħ || throw(ArgumentError(HBAR_ERROR))
    coeff_type = promote_type(eltype(state.mean), eltype(state.covar), eltype(lc.coeffs))
    new_coeffs = vcat(one(coeff_type), convert(Vector{coeff_type}, lc.coeffs))
    new_states = vcat(state, lc.states)
    return GaussianLinearCombination(lc.basis, new_coeffs, new_states)
end
"""
    +(lc::GaussianLinearCombination, state::GaussianState)

Add a linear combination to a Gaussian state.
"""
function Base.:+(lc::GaussianLinearCombination, state::GaussianState)
    lc.basis == state.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    lc.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    coeff_type = promote_type(eltype(state.mean), eltype(state.covar), eltype(lc.coeffs))
    new_coeffs = vcat(convert(Vector{coeff_type}, lc.coeffs), one(coeff_type))
    new_states = vcat(lc.states, state)
    return GaussianLinearCombination(lc.basis, new_coeffs, new_states)
end
"""
    -(state1::GaussianState, state2::GaussianState)

Subtract two Gaussian states to create a linear combination.
"""
function Base.:-(state1::GaussianState, state2::GaussianState)
    state1.basis == state2.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    coeff_type = promote_type(eltype(state1.mean), eltype(state1.covar), 
                              eltype(state2.mean), eltype(state2.covar))
    return GaussianLinearCombination(state1.basis, [one(coeff_type), -one(coeff_type)], [state1, state2])
end
"""
    -(state::GaussianState, lc::GaussianLinearCombination)

Subtract a linear combination from a Gaussian state.
"""
function Base.:-(state::GaussianState, lc::GaussianLinearCombination)
    state.basis == lc.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state.ħ == lc.ħ || throw(ArgumentError(HBAR_ERROR))
    return state + (-1) * lc
end
"""
    -(lc::GaussianLinearCombination, state::GaussianState)

Subtract a Gaussian state from a linear combination.
"""
function Base.:-(lc::GaussianLinearCombination, state::GaussianState)
    lc.basis == state.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    lc.ħ == state.ħ || throw(ArgumentError(HBAR_ERROR))
    coeff_type = promote_type(eltype(state.mean), eltype(state.covar), eltype(lc.coeffs))
    new_coeffs = vcat(convert(Vector{coeff_type}, lc.coeffs), -one(coeff_type))
    new_states = vcat(lc.states, state)
    return GaussianLinearCombination(lc.basis, new_coeffs, new_states)
end
"""
    -(state::GaussianState)

Negate a Gaussian state to create a linear combination with coefficient -1.
"""
Base.:-(state::GaussianState) = (-1) * state

"""
    normalize!(lc::GaussianLinearCombination)

Normalize the coefficients of a linear combination in-place using L2 norm.
"""
function normalize!(lc::GaussianLinearCombination)
    norm_val = sqrt(sum(abs2, lc.coeffs))
    if norm_val > 0
        lc.coeffs ./= norm_val
    end
    return lc
end

"""
    length(lc::GaussianLinearCombination)

Return the number of terms in the linear combination.
"""
Base.length(lc::GaussianLinearCombination) = length(lc.coeffs)

"""
    getindex(lc::GaussianLinearCombination, i::Integer)

Access the i-th term as a (coefficient, state) tuple.
"""
Base.getindex(lc::GaussianLinearCombination, i::Integer) = (lc.coeffs[i], lc.states[i])

"""
    iterate(lc::GaussianLinearCombination, state=1)

Iterate over (coefficient, state) pairs in the linear combination.
"""
function Base.iterate(lc::GaussianLinearCombination, state::Int=1)
    if state > length(lc)
        return nothing
    else
        return ((lc.coeffs[state], lc.states[state]), state + 1)
    end
end

"""
    simplify!(lc::GaussianLinearCombination; atol::Real=1e-14)
    
Simplify a linear combination by:
1. Removing coefficients smaller than `atol`
2. Combining terms with identical states
3. Ensuring at least one term remains (with minimal coefficient vacuum state if all coefficients become negligible)
Returns the modified linear combination.
"""
function simplify!(lc::GaussianLinearCombination; atol::Real=1e-14)
    if isempty(lc.coeffs)
        return lc
    end
    keep_mask = abs.(lc.coeffs) .> atol
    if !any(keep_mask)
        vac = vacuumstate(lc.basis, ħ = lc.ħ)
        coeff_type = eltype(lc.coeffs)
        lc.coeffs = [coeff_type(atol)] 
        lc.states = [vac]
        return lc
    end
    coeffs = lc.coeffs[keep_mask]
    states = lc.states[keep_mask]
    unique_states = Vector{typeof(states[1])}(undef, length(states))
    combined_coeffs = Vector{eltype(coeffs)}(undef, length(states))
    n_unique = 0  
    for (coeff, state) in zip(coeffs, states)
        existing_idx = findfirst(s -> isapprox(s, state, atol=1e-12), @view(unique_states[1:n_unique]))
        if existing_idx === nothing
            n_unique += 1
            unique_states[n_unique] = state
            combined_coeffs[n_unique] = coeff
        else
            combined_coeffs[existing_idx] += coeff
        end
    end
    resize!(unique_states, n_unique)
    resize!(combined_coeffs, n_unique)
    final_mask = abs.(combined_coeffs) .> atol
    if !any(final_mask)
        vac = vacuumstate(lc.basis, ħ = lc.ħ)
        coeff_type = eltype(combined_coeffs)
        lc.coeffs = [coeff_type(atol)]
        lc.states = [vac]
    else
        lc.coeffs = combined_coeffs[final_mask]
        lc.states = unique_states[final_mask]
    end
    return lc
end

function Base.show(io::IO, mime::MIME"text/plain", lc::GaussianLinearCombination)
    basis_name = nameof(typeof(lc.basis))
    nmodes = lc.basis.nmodes
    print(io, "GaussianLinearCombination with $(length(lc)) terms")
    if nmodes == 1
        println(io, " for 1 mode.")
    else
        println(io, " for $(nmodes) modes.")
    end
    println(io, "  symplectic basis: ", basis_name)
    println(io, "  ħ = $(lc.ħ)")
    max_display = min(length(lc), 5)
    @inbounds for i in 1:max_display
        coeff, state = lc[i]
        println(io, "  [$i] $(coeff) * GaussianState")
    end
    if length(lc) > max_display
        println(io, "  ⋮ ($(length(lc) - max_display) more terms)")
    end
end

Base.show(io::IO, lc::GaussianLinearCombination) = print(io, "GaussianLinearCombination($(length(lc)) terms)")

function Base.:(==)(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)
    lc1.basis == lc2.basis || return false
    lc1.ħ == lc2.ħ || return false
    length(lc1) == length(lc2) || return false
    return lc1.coeffs == lc2.coeffs && all(isequal(s1, s2) for (s1, s2) in zip(lc1.states, lc2.states))
end

function Base.isapprox(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination; kwargs...)
    lc1.basis == lc2.basis || return false
    lc1.ħ == lc2.ħ || return false
    length(lc1) == length(lc2) || return false
    return isapprox(lc1.coeffs, lc2.coeffs; kwargs...) && 
           all(isapprox(s1, s2; kwargs...) for (s1, s2) in zip(lc1.states, lc2.states))
end

"""
    *(op::GaussianUnitary, lc::GaussianLinearCombination)

Apply a Gaussian unitary operation to a linear combination of Gaussian states.
The unitary is applied to each component state while preserving coefficients.
"""
function Base.:(*)(op::GaussianUnitary, lc::GaussianLinearCombination)
    op.basis == lc.basis || throw(ArgumentError(ACTION_ERROR))
    op.ħ == lc.ħ || throw(ArgumentError(HBAR_ERROR))
    new_states = [op * state for state in lc.states]
    return GaussianLinearCombination(lc.basis, copy(lc.coeffs), new_states)
end

"""
    *(op::GaussianChannel, lc::GaussianLinearCombination)

Apply a Gaussian channel to a linear combination of Gaussian states.
The channel is applied to each component state while preserving coefficients.
"""
function Base.:(*)(op::GaussianChannel, lc::GaussianLinearCombination)
    op.basis == lc.basis || throw(ArgumentError(ACTION_ERROR))
    op.ħ == lc.ħ || throw(ArgumentError(HBAR_ERROR))
    new_states = [op * state for state in lc.states]
    return GaussianLinearCombination(lc.basis, copy(lc.coeffs), new_states)
end

"""
    tensor(::Type{Tc}, ::Type{Ts}, lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)

Compute tensor product of two linear combinations with specified output types.
Creates all pairwise tensor products: `Σᵢⱼ cᵢcⱼ |ψᵢ⟩ ⊗ |ϕⱼ⟩`.
"""
function tensor(::Type{Tm}, ::Type{Tc}, lc1::GaussianLinearCombination, lc2::GaussianLinearCombination) where {Tm,Tc}
    typeof(lc1.basis) == typeof(lc2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    lc1.ħ == lc2.ħ || throw(ArgumentError(HBAR_ERROR))
    new_basis = lc1.basis ⊕ lc2.basis
    n1, n2 = length(lc1), length(lc2)
    CoeffType = promote_type(eltype(lc1.coeffs), eltype(lc2.coeffs))
    new_coeffs = Vector{CoeffType}(undef, n1 * n2)
    new_states = Vector{GaussianState}(undef, n1 * n2)
    @inbounds for i in 1:n1
        @inbounds for j in 1:n2
            idx = (i-1) * n2 + j
            new_coeffs[idx] = lc1.coeffs[i] * lc2.coeffs[j]
            new_states[idx] = tensor(Tm, Tc, lc1.states[i], lc2.states[j])
        end
    end
    return GaussianLinearCombination(new_basis, new_coeffs, new_states)
end
function tensor(::Type{T}, lc1::GaussianLinearCombination, lc2::GaussianLinearCombination) where {T}
    if T <: AbstractMatrix
        return tensor(Vector{eltype(T)}, T, lc1, lc2)
    else
        return tensor(T, T, lc1, lc2)
    end
end
"""
    tensor(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)

Compute tensor product of two linear combinations of Gaussian states.
"""
function tensor(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)
    typeof(lc1.basis) == typeof(lc2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    lc1.ħ == lc2.ħ || throw(ArgumentError(HBAR_ERROR))
    new_basis = lc1.basis ⊕ lc2.basis
    n1, n2 = length(lc1), length(lc2)
    CoeffType = promote_type(eltype(lc1.coeffs), eltype(lc2.coeffs))
    new_coeffs = Vector{CoeffType}(undef, n1 * n2)
    new_states = Vector{GaussianState}(undef, n1 * n2)
    @inbounds for i in 1:n1
        @inbounds for j in 1:n2
            idx = (i-1) * n2 + j
            new_coeffs[idx] = lc1.coeffs[i] * lc2.coeffs[j]
            new_states[idx] = lc1.states[i] ⊗ lc2.states[j]
        end
    end
    return GaussianLinearCombination(new_basis, new_coeffs, new_states)
end
function _tensor(lc1::GaussianLinearCombination, lc2::GaussianLinearCombination)
    @assert typeof(lc1.basis) == typeof(lc2.basis) "Linear combinations must have compatible bases"
    @assert lc1.ħ == lc2.ħ "Linear combinations must have the same ħ"
    new_basis = lc1.basis ⊕ lc2.basis
    result_size = length(lc1) * length(lc2)
    CoeffType = promote_type(eltype(lc1.coeffs), eltype(lc2.coeffs))
    new_coeffs = Vector{CoeffType}(undef, result_size)
    new_states = Vector{GaussianState}(undef, result_size)
    idx = 1
    @inbounds for (c1, s1) in lc1
        @inbounds for (c2, s2) in lc2
            new_coeffs[idx] = c1 * c2
            new_states[idx] = s1 ⊗ s2
            idx += 1
        end
    end
    return GaussianLinearCombination(new_basis, new_coeffs, new_states)
end

function ptrace(::Type{Tm}, ::Type{Tc}, lc::GaussianLinearCombination, index::Int) where {Tm,Tc}
    length([index]) < lc.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    traced_states = [ptrace(Tm, Tc, state, [index]) for state in lc.states]
    result = GaussianLinearCombination(traced_states[1].basis, copy(lc.coeffs), traced_states)
    simplify!(result)
    return result
end
function ptrace(::Type{Tm}, ::Type{Tc}, lc::GaussianLinearCombination, indices::AbstractVector{<:Int}) where {Tm,Tc}
    length(indices) < lc.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    traced_states = [ptrace(Tm, Tc, state, indices) for state in lc.states]
    result = GaussianLinearCombination(traced_states[1].basis, copy(lc.coeffs), traced_states)
    simplify!(result)
    return result
end
function ptrace(::Type{T}, lc::GaussianLinearCombination, indices::Union{Int, AbstractVector{<:Int}}) where {T}
    if T <: AbstractMatrix
        return ptrace(Vector{eltype(T)}, T, lc, indices)
    else
        return ptrace(T, T, lc, indices)
    end
end
"""
    ptrace(lc::GaussianLinearCombination, index::Int)

Compute partial trace of a linear combination over specified index.
"""
function ptrace(lc::GaussianLinearCombination, index::Int)
    length([index]) < lc.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    traced_states = [ptrace(state, [index]) for state in lc.states]
    result = GaussianLinearCombination(traced_states[1].basis, copy(lc.coeffs), traced_states)
    simplify!(result)
    return result
end
"""
    ptrace(lc::GaussianLinearCombination, indices::AbstractVector{<:Int})

Compute partial trace of a linear combination over specified indices.
Combines identical traced states automatically.
"""
function ptrace(lc::GaussianLinearCombination, indices::AbstractVector{<:Int})
    length(indices) < lc.basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    traced_states = [ptrace(state, indices) for state in lc.states]
    result = GaussianLinearCombination(traced_states[1].basis, copy(lc.coeffs), traced_states)
    simplify!(result)
    return result
end

"""
    embed(basis::SymplecticBasis, idx::Int, lc::GaussianLinearCombination)
    embed(basis::SymplecticBasis, indices::Vector{<:Int}, lc::GaussianLinearCombination)

Embed every state in a `GaussianLinearCombination` into a larger symplectic
basis while preserving coefficients.
"""
function embed(basis::SymplecticBasis, index::Int, lc::GaussianLinearCombination)
    return embed(basis, [index], lc)
end
function embed(basis::SymplecticBasis, indices::Vector{<:Int}, lc::GaussianLinearCombination)
    @assert length(indices) == lc.basis.nmodes "Number of indices must match number of modes in the linear combination"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    embedded_states = [embed(basis, indices, state) for state in lc.states]
    return GaussianLinearCombination(basis, copy(lc.coeffs), embedded_states)
end

"""
    cross_wigner(state1::GaussianState, state2::GaussianState, x::AbstractVector)

Compute the off-diagonal Wigner kernel (cross-Wigner function) between two Gaussian states.

The cross-Wigner function is given by:

    `W₁₂(x) = (1/(2π)ⁿ√det((V₁+V₂)/2)) × exp[-½(x-μ̄)ᵀ((V₁+V₂)/2)⁻¹(x-μ̄)] × exp[i(μ₁-μ₂)ᵀΩ(x-μ̄)/ħ]`

where:
- `μ̄ = (μ₁ + μ₂)/2` is the average of the two mean vectors
- `μ₁`, `μ₂` are the mean vectors of the two states  
- `V₁`, `V₂` are the covariance matrices of the two states
- `Ω` is the symplectic form matrix
- `n` is the number of modes
- `ħ` is the reduced Planck constant

This function captures the quantum interference between two Gaussian states and is 
essential for computing Wigner functions of superposition states. The cross-Wigner 
function appears in the interference terms when computing the Wigner function of 
a linear combination `|ψ⟩ = c₁|ψ₁⟩ + c₂|ψ₂⟩`:

    `W(x) = |c₁|²W₁(x) + |c₂|²W₂(x) + 2Re(c₁*c₂*W₁₂(x))`

The normalization is chosen to ensure the identity property `W₁₁(x) = W₁(x)`.

# Arguments
- `state1::GaussianState`: First Gaussian state
- `state2::GaussianState`: Second Gaussian state  
- `x::AbstractVector`: Phase space point where to evaluate the function

# Returns
- `ComplexF64`: Complex value of the cross-Wigner function at point `x`

# Notes
- The function is Hermitian: `W₁₂(x) = W₂₁*(x)`
- For identical states: `W₁₁(x) = W₁(x)` (reduces to regular Wigner function)
- The implementation uses log-space arithmetic for numerical stability
"""
function cross_wigner(state1::GaussianState, state2::GaussianState, x::AbstractVector)
    μ1, μ2 = state1.mean, state2.mean
    V1, V2 = state1.covar, state2.covar
    n = length(μ1) ÷ 2
    ħ = state1.ħ
    dx = similar(x)
    Vavg = similar(V1)
    @inbounds @. dx = x - 0.5 * (μ1 + μ2)
    @inbounds @. Vavg = 0.5 * (V1 + V2)
    Ω = symplecticform(state1.basis)
    phase_arg = zero(real(eltype(μ1)))
    @inbounds for i in eachindex(μ1)
        Δμi = μ1[i] - μ2[i]
        Ω_dx_i = zero(eltype(dx))
        @simd for j in eachindex(dx)
            Ω_dx_i += Ω[i,j] * dx[j]
        end
        phase_arg += Δμi * Ω_dx_i
    end
    phase = cis(phase_arg / ħ)
    lognorm = -n*log(2π) - 0.5*logdet(Vavg)
    norm = exp(lognorm)
    gauss = exp(-0.5 * dot(dx, Vavg \ dx))  
    return norm * gauss * phase
end

"""
    wigner(lc::GaussianLinearCombination, x::AbstractVector)

Compute Wigner function of a linear combination including quantum interference.
`W(x) = Σᵢ |cᵢ|² Wᵢ(x) + 2 Σᵢ<ⱼ Re(cᵢ*cⱼ W_cross(ψᵢ,ψⱼ,x))`
"""
function wigner(lc::GaussianLinearCombination, x::AbstractVector)
    length(x) == length(lc.states[1].mean) || throw(ArgumentError(WIGNER_ERROR))
    result = 0.0
    @inbounds for i in 1:length(lc)
        ci, si = lc[i]
        result += abs2(ci) * wigner(si, x)
        @inbounds for j in (i+1):length(lc)
            cj, sj = lc[j]
            cross_term = 2 * real(conj(ci) * cj * cross_wigner(si, sj, x))
            result += cross_term
        end
    end
    return result
end

"""
    cross_wignerchar(state1::GaussianState, state2::GaussianState, xi::AbstractVector)

Compute cross-Wigner characteristic function between two Gaussian states.
"""
function cross_wignerchar(state1::GaussianState, state2::GaussianState, xi::AbstractVector)
    state1.basis == state2.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    length(xi) == length(state1.mean) || throw(ArgumentError(WIGNER_ERROR))
    if state1 === state2
        return wignerchar(state1, xi)
    end
    μ1, μ2 = state1.mean, state2.mean
    V1, V2 = state1.covar, state2.covar
    μ12 = similar(μ1)
    V12 = similar(V1)
    temp_vec = similar(μ1)
    temp_mat = similar(V1)
    @inbounds @simd for i in eachindex(μ1)
        μ12[i] = (μ1[i] + μ2[i]) * 0.5  
    end
    @inbounds @simd for i in eachindex(V1)
        V12[i] = (V1[i] + V2[i]) * 0.5
    end
    Omega = symplecticform(state1.basis)
    mul!(temp_mat, Omega, V12)              
    mul!(V12, temp_mat, Omega)              
    V12 .*= -1                              
    mul!(temp_vec, V12, xi)                
    arg1 = -0.5 * dot(xi, temp_vec)
    mul!(temp_vec, Omega, μ12)              
    arg2 = 1im * dot(temp_vec, xi)
    return exp(arg1 - arg2)
end

"""
    wignerchar(lc::GaussianLinearCombination, xi::AbstractVector)

Compute Wigner characteristic function of a linear combination including interference.
"""
function wignerchar(lc::GaussianLinearCombination, xi::AbstractVector)
    length(xi) == length(lc.states[1].mean) || throw(ArgumentError(WIGNER_ERROR))
    result = 0.0 + 0.0im
    @inbounds for i in 1:length(lc)
        ci, si = lc[i]
        result += abs2(ci) * wignerchar(si, xi)        
        @inbounds for j in (i+1):length(lc)
            cj, sj = lc[j]
            cross_term = 2 * real(conj(ci) * cj * cross_wignerchar(si, sj, xi))
            result += cross_term
        end
    end
    return result
end

function purity(lc::GaussianLinearCombination)
    # A GaussianLinearCombination represents a pure superposition state
    # |ψ⟩ = Σᵢ cᵢ|ψᵢ⟩, so purity = Tr(ρ²) = 1
    return 1.0
end

function entropy_vn(lc::GaussianLinearCombination)
    # A GaussianLinearCombination represents a pure superposition state
    # |ψ⟩ = Σᵢ cᵢ|ψᵢ⟩, so S(ρ) = -Tr(ρ log ρ) = 0
    return 0.0
end

@testitem "Factorizations" begin
    using Gabs
    using LinearAlgebra

    @testset "williamson" begin
        nmodes = rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        
        state_pair = randstate(qpairbasis)
        state_block = randstate(qblockbasis)

        F_pair = williamson(state_pair)
        S_pair, spectrum_pair = F_pair
        F_block = williamson(state_block)
        S_block, spectrum_block = F_block

        @test S_pair == F_pair.S && spectrum_pair == F_pair.spectrum
        @test S_block == F_block.S && spectrum_block == F_block.spectrum

        @test isapprox(S_pair * state_pair.covar * S_pair', Diagonal(repeat(spectrum_pair, inner = 2)), atol = 1e-5)
        @test isapprox(S_block * state_block.covar * S_block', Diagonal(repeat(spectrum_block, 2)), atol = 1e-5)

        @test issymplectic(qpairbasis, S_pair, atol = 1e-5)
        @test issymplectic(qblockbasis, S_block, atol = 1e-5)
    end

    @testset "polar" begin
        nmodes = rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        
        uni_pair = randunitary(qpairbasis)
        uni_block = randunitary(qblockbasis)

        F_pair = polar(uni_pair)
        O_pair, P_pair = F_pair
        F_block = polar(uni_block)
        O_block, P_block = F_block

        @test O_pair == F_pair.O && P_pair == F_pair.P
        @test O_block == F_block.O && P_block == F_block.P

        @test isapprox(O_pair * P_pair, uni_pair.symplectic, atol = 1e-5)
        @test isapprox(O_block * P_block, uni_block.symplectic, atol = 1e-5)

        @test issymplectic(qpairbasis, O_pair, atol = 1e-5) & issymplectic(qblockbasis, O_block, atol = 1e-5)
        @test issymplectic(qpairbasis, P_pair, atol = 1e-5) & issymplectic(qblockbasis, P_block, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(P_block, transpose(P_block), atol = 1e-5) && all(i > 0 for i in eigvals(P_block))
        @test isapprox(P_pair, transpose(P_pair), atol = 1e-5) && all(i > 0 for i in eigvals(P_pair))
    end

    @testset "Bloch-Messiah/Euler" begin
        nmodes = rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        
        uni_pair = randunitary(qpairbasis)
        S_pair = uni_pair.symplectic
        uni_block = randunitary(qblockbasis)
        S_block = uni_block.symplectic

        F_pair = blochmessiah(uni_pair)
        O_pair, vals_pair, Q_pair = F_pair
        F_block = blochmessiah(uni_block)
        O_block, vals_block, Q_block = F_block

        @test F_block.O == O_block && F_block.values == vals_block && F_block.Q == Q_block
        @test F_pair.O == O_pair && F_pair.values == vals_pair && F_pair.Q == Q_pair
        @test issymplectic(qpairbasis, O_pair, atol = 1e-5) && issymplectic(qblockbasis, O_block, atol = 1e-5)
        @test issymplectic(qpairbasis, Q_pair, atol = 1e-5) && issymplectic(qblockbasis, Q_block, atol = 1e-5)
        @test isapprox(inv(O_pair), transpose(O_pair), atol = 1e-5) && isapprox(inv(O_block), transpose(O_block), atol = 1e-5)
        @test isapprox(inv(Q_pair), transpose(Q_pair), atol = 1e-5) && isapprox(inv(Q_block), transpose(Q_block), atol = 1e-5)

        @test all(x -> x > 0.0, vals_block) && all(x -> x > 0.0, vals_pair)
        D_block = Diagonal(vcat(vals_block, vals_block .^ (-1)))
        D_pair = Diagonal(collect(Iterators.flatten(zip(vals_pair, vals_pair .^ (-1)))))
        @test isapprox(O_block * D_block * Q_block, S_block, atol = 1e-5)
        @test isapprox(O_pair * D_pair * Q_pair, S_pair, atol = 1e-5)
    end
end

@testitem "Unitaries" begin
    using Gabs
    using StaticArrays

    nmodes = rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)

    @testset "displacement operator" begin
        alpha = rand(ComplexF64)
        alphas = rand(ComplexF64, nmodes)
        op_pair = displace(qpairbasis, alpha)
        op_block = displace(qblockbasis, alpha)
        @test op_pair isa GaussianUnitary && op_block isa GaussianUnitary
        @test displace(Array, qpairbasis, alpha) isa GaussianUnitary
        @test displace(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, alpha) isa GaussianUnitary
        @test op_pair == changebasis(QuadPairBasis, op_block) && op_block == changebasis(QuadBlockBasis, op_pair)
        @test op_pair == changebasis(QuadPairBasis, op_pair) && op_block == changebasis(QuadBlockBasis, op_block)
        @test displace(qblockbasis, alpha) == changebasis(QuadBlockBasis, op_pair)
        @test displace(qblockbasis, alphas) == changebasis(QuadBlockBasis, displace(qpairbasis, alphas))
        @test issymplectic(qpairbasis, op_pair.symplectic, atol = 1e-4)
        @test isgaussian(op_pair, atol = 1e-4)
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end

    @testset "squeeze operator" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        op_pair = squeeze(qpairbasis, r, theta)
        op_block = squeeze(qblockbasis, r, theta)
        @test op_pair isa GaussianUnitary && op_block isa GaussianUnitary
        @test squeeze(Array, qpairbasis, r, theta) isa GaussianUnitary
        @test squeeze(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, r, theta) isa GaussianUnitary
        @test op_pair == changebasis(QuadPairBasis, op_block) && op_block == changebasis(QuadBlockBasis, op_pair)
        @test op_pair == changebasis(QuadPairBasis, op_pair) && op_block == changebasis(QuadBlockBasis, op_block)
        @test squeeze(qblockbasis, r, theta) == changebasis(QuadBlockBasis, op_pair)
        @test squeeze(qblockbasis, rs, thetas) == changebasis(QuadBlockBasis, squeeze(qpairbasis, rs, thetas))
        @test issymplectic(qpairbasis, op_pair.symplectic, atol = 1e-4)
        @test isgaussian(op_pair, atol = 1e-4)
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end

    @testset "two-mode squeeze operator" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        op, op_array, op_static = twosqueeze(2*qpairbasis, r, theta), twosqueeze(Array, 2*qpairbasis, r, theta), twosqueeze(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, r, theta)
        @test op isa GaussianUnitary && op_array isa GaussianUnitary && op_static isa GaussianUnitary
        @test twosqueeze(2*qblockbasis, r, theta) == changebasis(QuadBlockBasis, op)
        @test twosqueeze(2*qblockbasis, rs, thetas) == changebasis(QuadBlockBasis, twosqueeze(2*qpairbasis, rs, thetas))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "phase-shift operator" begin
        theta = rand(Float64)
        thetas = rand(Float64, nmodes)
        op, op_array, op_static = phaseshift(qpairbasis, theta), phaseshift(Array, qpairbasis, theta), phaseshift(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, theta)
        @test op isa GaussianUnitary && op_array isa GaussianUnitary && op_static isa GaussianUnitary
        @test phaseshift(qblockbasis, theta) == changebasis(QuadBlockBasis, op)
        @test phaseshift(qblockbasis, thetas) == changebasis(QuadBlockBasis, phaseshift(qpairbasis, thetas))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "beamsplitter operator" begin
        theta = rand(Float64)
        thetas = rand(Float64, nmodes)
        op, op_array, op_static = beamsplitter(2*qpairbasis, theta), beamsplitter(Array, 2*qpairbasis, theta), beamsplitter(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, theta)
        @test op isa GaussianUnitary && op_array isa GaussianUnitary && op_static isa GaussianUnitary
        @test beamsplitter(2*qblockbasis, theta) == changebasis(QuadBlockBasis, op)
        @test beamsplitter(2*qblockbasis, thetas) == changebasis(QuadBlockBasis, beamsplitter(2*qpairbasis, thetas))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "tensor products" begin
        alpha1, alpha2 = rand(ComplexF64), rand(ComplexF64)
        d1, d2 = displace(qpairbasis, alpha1), displace(qpairbasis, alpha2)
        ds = tensor(d1, d2)
        @test ds isa GaussianUnitary
        @test ds == d1 ⊗ d2
        @test isapprox(ds, d1 ⊗ d2, atol = 1e-10)
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, d1, d2) isa GaussianUnitary

        r, theta = rand(Float64), rand(Float64)
        p = phaseshift(qpairbasis, theta)
        @test tensor(p, tensor(d1, d2)) == p ⊗ d1 ⊗ d2

        p_block = phaseshift(qblockbasis, theta)
        p_blocks = phaseshift(2*qblockbasis, repeat([theta], 2*nmodes))
        @test p_block ⊗ p_block == p_blocks

        dstatic = displace(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, alpha1)
        tpstatic = dstatic ⊗ dstatic ⊗ dstatic
        @test tpstatic.disp isa SVector{6*nmodes}
        @test tpstatic.symplectic isa SMatrix{6*nmodes,6*nmodes}
        tp = dstatic ⊗ d1 ⊗ dstatic
        @test tp.disp isa Vector
        @test tp.symplectic isa Matrix
    end

    @testset "actions" begin
        alpha = rand(ComplexF64)
        d = displace(qpairbasis, alpha)
        v = vacuumstate(qpairbasis)
        c = coherentstate(qpairbasis, alpha)
        @test d * v == c
        @test apply!(v, d) == c

        v1, v2 = vacuumstate(qpairbasis), vacuumstate(qpairbasis)
        alpha1, alpha2 = rand(ComplexF64), rand(ComplexF64)
        d1, d2 = displace(qpairbasis, alpha1), displace(qpairbasis, alpha2)
        c1, c2 = coherentstate(qpairbasis, alpha1), coherentstate(qpairbasis, alpha2)
        @test (d1 ⊗ d2) * (v1 ⊗ v2) == c1 ⊗ c2
    end

    @testset "embed" begin
        α = rand(ComplexF64)
        r, θ = rand(Float64), rand(Float64)

        for basis in (QuadPairBasis(1), QuadBlockBasis(1))
            op = displace(basis, α)
            full_basis = basis ⊕ basis ⊕ basis

            s1, s2, s3 = vacuumstate(basis), vacuumstate(basis), vacuumstate(basis)
            input_state = s1 ⊗ s2 ⊗ s3

            embedded = embed(full_basis, 2, op)
            expected = s1 ⊗ (op * s2) ⊗ s3
            @test embedded.basis == full_basis
            @test embedded * input_state == expected

            inplace_state = copy(input_state)
            @test apply!(inplace_state, 2, op) === inplace_state
            @test inplace_state ≈ expected
        end

        for basis in (QuadPairBasis(2), QuadBlockBasis(2))
            single_basis = typeof(basis)(1)
            op_two = squeeze(basis, r, θ)
            full_basis = basis ⊕ single_basis

            s1 = coherentstate(single_basis, rand())
            s2 = thermalstate(single_basis, rand(1:5))
            s3 = vacuumstate(single_basis)
            input_state = s1 ⊗ s2 ⊗ s3

            embedded_two = embed(full_basis, [1, 3], op_two)
            transformed_13 = op_two * (s1 ⊗ s3)
            result = embedded_two * input_state
            inplace_13 = apply!(input_state, [1, 3], op_two)

            @test ptrace(result, 2) == transformed_13
            @test ptrace(result, [1, 3]) == s2
            @test result ≈ inplace_13
            @test inplace_13 === input_state

            if basis isa QuadPairBasis
                legacy_state = s1 ⊗ s2 ⊗ s3
                legacy_13 = @test_deprecated apply!(legacy_state, op_two, [1, 3])
                @test legacy_13 === legacy_state
                @test legacy_13 ≈ result
            end
        end

        @test_throws AssertionError embed(QuadPairBasis(3), [1, 2, 3, 4], displace(QuadPairBasis(1), α))
    end
end

@testitem "Metrics" begin
    using Gabs

    basis1 = QuadPairBasis(1)
    basis2 = QuadPairBasis(2)
    # helper functions
    thermal(x) = thermalstate(basis1, x)
    coherent(x) = coherentstate(basis1, x)
    squeezed(x, y) = squeezedstate(basis1, x, y)
    EPR(x, y) = eprstate(basis2, x, y)

    atol = 1e-10
    # sample count
    count = 10

    @testset "Von Neumann entropy" begin
        # rand samples [0, 1), set entropy_vn_thermal(0) to 0
        entropy_vn_thermal(x) = x > 0 ? log1p(x) - x * log(x / (x + 1)) : 0
        X = rand(Float64, count)
        Y = rand(Float64, count)
        Z = X .* 10 + Y .* (10 * im)

        @test isapprox(
            entropy_vn.(thermal.(X .* 100)),
            entropy_vn_thermal.(X .* 100);
            atol=atol)
        @test isapprox(
            entropy_vn.(coherent.(Z)),
            fill(0.0, count);
            atol=atol)
        @test isapprox(
            entropy_vn.(squeezed.(X, Y .* pi)),
            fill(0.0, count);
            atol=atol)
        @test isapprox(
            entropy_vn.(EPR.(X, Y .* pi)),
            fill(0.0, count);
            atol=atol)
    end

    @testset "fidelity" begin
        # the expression is numerically unstable and would need a dozen branches
        function fidelity_thermal_thermal(a, b)
            x = BigFloat(a); y = BigFloat(b);
            return 1/(sqrt((x + 1) * (y + 1)) - sqrt(x * y))
        end
        fidelity_thermal_coherent(x, y) = exp(- abs(y)^2 / (2 * (x + 1))) / sqrt(x + 1)
        fidelity_coherent_coherent(x, y) = exp(- abs(x - y)^2 / 2)
        X = rand(Float64, count)
        Y = rand(Float64, count)
        Z = X .* 10 + Y .* (10 * im)
        W = rand(ComplexF64, count) .* 10

        @test isapprox(
            fidelity.(thermal.(X .* 100), thermal.(Y .* 100)),
            fidelity_thermal_thermal.(X .* 100, Y .* 100);
            atol=atol)
        @test isapprox(
            fidelity.(thermal.(X .* 100), coherent.(W)),
            fidelity_thermal_coherent.(X .* 100, W);
            atol=atol)
        @test isapprox(
            fidelity.(coherent.(Z), coherent.(W)),
            fidelity_coherent_coherent.(Z, W);
            atol=atol)
    end

    @testset "logarithmic negativity" begin
        X = rand(Float64, count)
        Y = rand(Float64, count)

        @test isapprox(
            logarithmic_negativity.(EPR.(X, Y .* pi), 2),
            X .* 2;
            atol=atol)
    end
end

@testitem "Channels" begin
    using Gabs
    using StaticArrays

    nmodes = rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)
    noise = rand(2*nmodes, 2*nmodes)
    noise_ds = [noise zeros(2*nmodes,2*nmodes); zeros(2*nmodes,2*nmodes) noise]
    T = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(2*nmodes), j in Base.OneTo(2*nmodes)
        if (j == 2*i-1) || (j + 2*nmodes == 2*i)
            T[i,j] = 1
        end
    end
    T_ds = zeros(4*nmodes, 4*nmodes)
    @inbounds for i in Base.OneTo(4*nmodes), j in Base.OneTo(4*nmodes)
        if (j == 2*i-1) || (j + 2*(2*nmodes) == 2*i)
            T_ds[i,j] = 1
        end
    end

    @testset "displacement operator" begin
        alpha = rand(ComplexF64)
        alphas = rand(ComplexF64, nmodes)
        op_pair = displace(qpairbasis, alpha, noise)
        op_block = displace(qblockbasis, alpha, noise)
        @test op_pair isa GaussianChannel && op_block isa GaussianChannel
        @test displace(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, alpha, noise) isa GaussianChannel
        @test displace(Array, qpairbasis, alpha, noise) isa GaussianChannel
        @test displace(qblockbasis, alpha, T*noise*transpose(T)) == changebasis(QuadBlockBasis, op_pair)
        @test displace(qblockbasis, alphas, T*noise*transpose(T)) == changebasis(QuadBlockBasis, displace(qpairbasis, alphas, noise))
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end

    @testset "squeeze operator" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        op_pair = squeeze(qpairbasis, r, theta, noise)
        op_block = squeeze(qblockbasis, r, theta, noise)
        @test op_pair isa GaussianChannel && op_block isa GaussianChannel
        @test squeeze(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, r, theta, noise) isa GaussianChannel
        @test squeeze(Array, qpairbasis, r, theta, noise) isa GaussianChannel
        @test squeeze(qblockbasis, r, theta, T*noise*transpose(T)) == changebasis(QuadBlockBasis, op_pair)
        @test squeeze(qblockbasis, rs, thetas, T*noise*transpose(T)) == changebasis(QuadBlockBasis, squeeze(qpairbasis, rs, thetas, noise))
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end

    @testset "two-mode squeeze operator" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        op, op_array, op_static = twosqueeze(2*qpairbasis, r, theta, noise_ds), twosqueeze(Array, 2*qpairbasis, r, theta, noise_ds), twosqueeze(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, r, theta, noise_ds)
        @test op isa GaussianChannel && op_array isa GaussianChannel && op_static isa GaussianChannel
        @test twosqueeze(2*qblockbasis, r, theta, T_ds*noise_ds*transpose(T_ds)) == changebasis(QuadBlockBasis, op)
        @test twosqueeze(2*qblockbasis, rs, thetas, T_ds*noise_ds*transpose(T_ds)) == changebasis(QuadBlockBasis, twosqueeze(2*qpairbasis, rs, thetas, noise_ds))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "phase-shift operator" begin
        theta = rand(Float64)
        thetas = rand(Float64, nmodes)
        op, op_array, op_static = phaseshift(qpairbasis, theta, noise), phaseshift(Array, qpairbasis, theta, noise), phaseshift(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, theta, noise)
        @test op isa GaussianChannel && op_array isa GaussianChannel && op_static isa GaussianChannel
        @test phaseshift(qblockbasis, theta, T*noise*transpose(T)) == changebasis(QuadBlockBasis, op)
        @test phaseshift(qblockbasis, thetas, T*noise*transpose(T)) == changebasis(QuadBlockBasis, phaseshift(qpairbasis, thetas, noise))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "beamsplitter operator" begin
        theta = rand(Float64)
        thetas = rand(Float64, nmodes)
        op, op_array, op_static = beamsplitter(2*qpairbasis, theta, noise_ds), beamsplitter(Array, 2*qpairbasis, theta, noise_ds), beamsplitter(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, theta, noise_ds)
        @test op isa GaussianChannel && op_array isa GaussianChannel && op_static isa GaussianChannel
        @test beamsplitter(2*qblockbasis, theta, T_ds*noise_ds*transpose(T_ds)) == changebasis(QuadBlockBasis, op)
        @test beamsplitter(2*qblockbasis, thetas, T_ds*noise_ds*transpose(T_ds)) == changebasis(QuadBlockBasis, beamsplitter(2*qpairbasis, thetas, noise_ds))
        @test op.ħ == 2 && op_array.ħ == 2 && op_static.ħ == 2
    end

    @testset "attenuator channel" begin
        theta = rand(Float64)
        thetas = rand(Float64, nmodes)
        n = rand(1:10)
        ns = rand(1:10, nmodes)
        op_pair = attenuator(qpairbasis, theta, n)
        op_block = attenuator(qblockbasis, theta, n)
        @test op_pair isa GaussianChannel && op_block isa GaussianChannel
        @test attenuator(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, theta, n) isa GaussianChannel
        @test attenuator(Array, qpairbasis, theta, n) isa GaussianChannel
        @test op_pair == changebasis(QuadPairBasis, op_block) && op_block == changebasis(QuadBlockBasis, op_pair)
        @test op_pair == changebasis(QuadPairBasis, op_pair) && op_block == changebasis(QuadBlockBasis, op_block)
        @test attenuator(qblockbasis, theta, n) == changebasis(QuadBlockBasis, op_pair)
        @test attenuator(qblockbasis, thetas, ns) == changebasis(QuadBlockBasis, attenuator(qpairbasis, thetas, ns))
        @test isgaussian(op_pair, atol = 1e-4)
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end

    @testset "amplifier channel" begin
        r = rand(Float64)
        rs = rand(Float64, nmodes)
        n = rand(1:10)
        ns = rand(1:10, nmodes)
        op_pair = amplifier(qpairbasis, r, n)
        op_block = amplifier(qblockbasis, r, n)
        @test op_pair isa GaussianChannel && op_block isa GaussianChannel
        @test amplifier(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, r, n) isa GaussianChannel
        @test amplifier(Array, qpairbasis, r, n) isa GaussianChannel
        @test op_pair == changebasis(QuadPairBasis, op_block) && op_block == changebasis(QuadBlockBasis, op_pair)
        @test op_pair == changebasis(QuadPairBasis, op_pair) && op_block == changebasis(QuadBlockBasis, op_block)
        @test amplifier(qblockbasis, r, n) == changebasis(QuadBlockBasis, op_pair)
        @test amplifier(qblockbasis, rs, ns) == changebasis(QuadBlockBasis, amplifier(qpairbasis, rs, ns))
        @test isgaussian(op_pair, atol = 1e-4)
        @test op_pair.ħ == 2 && op_block.ħ == 2
    end
    
    @testset "tensor products" begin
        alpha1, alpha2 = rand(ComplexF64), rand(ComplexF64)
        d1, d2 = displace(qpairbasis, alpha1, noise), displace(qpairbasis, alpha2, noise)
        ds = tensor(d1, d2)
        @test ds isa GaussianChannel
        @test ds == d1 ⊗ d2
        @test isapprox(ds, d1 ⊗ d2, atol = 1e-10)
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, d1, d2) isa GaussianChannel

        r, theta = rand(Float64), rand(Float64)
        p = phaseshift(qpairbasis, theta, noise)
        @test tensor(tensor(p, d1), d2) == p ⊗ d1 ⊗ d2

        p_block = phaseshift(qblockbasis, theta, T * noise * transpose(T))
        p_blocks = phaseshift(2*qblockbasis, repeat([theta], 2*nmodes), T_ds * noise_ds * transpose(T_ds))
        @test p_block ⊗ p_block == p_blocks

        dstatic = displace(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, alpha1, noise)
        tpstatic = dstatic ⊗ dstatic ⊗ dstatic
        @test tpstatic.disp isa SVector{6*nmodes}
        @test tpstatic.transform isa SMatrix{6*nmodes,6*nmodes}
        @test tpstatic.noise isa SMatrix{6*nmodes,6*nmodes}
        tp = dstatic ⊗ d1 ⊗ dstatic
        @test tp.disp isa Vector
        @test tp.transform isa Matrix
        @test tp.noise isa Matrix
    end

    @testset "actions" begin
        z = zeros(2*nmodes,2*nmodes)
        alpha = rand(ComplexF64)
        d = displace(qpairbasis, alpha, z)
        v = vacuumstate(qpairbasis)
        c = coherentstate(qpairbasis, alpha)
        @test d * v == c
        @test isapprox(d * v, c, atol = 1e-10)
        @test apply!(v, d) == c

        v1, v2 = vacuumstate(qpairbasis), vacuumstate(qpairbasis)
        alpha1, alpha2 = rand(ComplexF64), rand(ComplexF64)
        d1, d2 = displace(qpairbasis, alpha1, z), displace(qpairbasis, alpha2, z)
        c1, c2 = coherentstate(qpairbasis, alpha1), coherentstate(qpairbasis, alpha2)
        @test (d1 ⊗ d2) * (v1 ⊗ v2) == c1 ⊗ c2
    end

    @testset "embed" begin
        α = rand(ComplexF64)
        θ = rand(Float64)
        n = rand(1:5)

        for basis in (QuadPairBasis(1), QuadBlockBasis(1))
            z = zeros(2 * basis.nmodes, 2 * basis.nmodes)
            op = displace(basis, α, z)
            full_basis = basis ⊕ basis ⊕ basis

            s1 = coherentstate(basis, rand())
            s2 = thermalstate(basis, rand(1:5))
            s3 = vacuumstate(basis)
            input_state = s1 ⊗ s2 ⊗ s3

            embedded = embed(full_basis, 3, op)
            expected = s1 ⊗ s2 ⊗ (op * s3)
            @test embedded.basis == full_basis
            @test embedded * input_state == expected

            inplace_state = copy(input_state)
            @test apply!(inplace_state, 3, op) === inplace_state
            @test inplace_state ≈ expected
        end

        for basis in (QuadPairBasis(2), QuadBlockBasis(2))
            z = zeros(2 * basis.nmodes, 2 * basis.nmodes)
            single_basis = typeof(basis)(1)
            op_two = attenuator(basis, θ, n)
            full_basis = basis ⊕ single_basis

            s1 = coherentstate(single_basis, rand())
            s2 = thermalstate(single_basis, rand(1:5))
            s3 = vacuumstate(single_basis)
            input_state = s1 ⊗ s2 ⊗ s3

            embedded_two = embed(full_basis, [1, 3], op_two)
            transformed_13 = op_two * (s1 ⊗ s3)
            result = embedded_two * input_state
            inplace_13 = apply!(input_state, [1, 3], op_two)

            @test ptrace(result, 2) == transformed_13
            @test ptrace(result, [1, 3]) == s2
            @test inplace_13 === input_state
            @test inplace_13 ≈ result
        end

        @test_throws AssertionError embed(QuadPairBasis(3), [1, 2, 3, 4], displace(QuadPairBasis(1), α, zeros(2, 2)))
    end
end

"""
    wigner(state::GaussianState, x)

Compute the Wigner function of an N-mode Gaussian state at `x`, a vector of size 2N.
"""
function wigner(state::GaussianState, x::T) where {T}
    basis = state.basis
    nmodes = basis.nmodes
    mean = state.mean
    isequal(length(mean), length(x)) || throw(ArgumentError(WIGNER_ERROR))

    V = state.covar
    diff = x .- mean
    arg = -(1/2) * transpose(diff) * inv(V) * diff

    return exp(arg)/((2pi)^nmodes * sqrt(det(V)))
end

"""
    wignerchar(state::GaussianState, xi)

Compute the Wigner characteristic function of an N-mode Gaussian state at `xi`, a vector of size 2N.
"""
function wignerchar(state::GaussianState, xi::T) where {T}
    basis = state.basis
    nmodes = basis.nmodes
    mean = state.mean
    isequal(length(mean), length(xi)) || throw(ArgumentError(WIGNER_ERROR))

    V = state.covar
    Omega = symplecticform(basis)

    arg1 = -(1/2) * transpose(xi) * (Omega*V*transpose(Omega))*xi
    arg2 = im * transpose(Omega*mean) * xi

    return exp(arg1 .- arg2)
end

@testitem "Random objects" begin
    using Gabs
    using Random
    using StaticArrays
    using LinearAlgebra: eigvals, adjoint

    @testset "random utils" begin
        nmodes = rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        rng = Random.default_rng()
        U_qpair = Gabs._rand_unitary(rng, qpairbasis)
        U_qblock = Gabs._rand_unitary(rng, qblockbasis)
        @test isapprox(adjoint(U_qpair), inv(U_qpair), atol = 1e-5)
        @test isapprox(adjoint(U_qblock), inv(U_qblock), atol = 1e-5)

        O_qpair = Gabs._rand_orthogonal_symplectic(rng, qpairbasis)
        O_qblock = Gabs._rand_orthogonal_symplectic(rng, qblockbasis)
        @test isapprox(O_qpair', inv(O_qpair), atol = 1e-5)
        @test isapprox(O_qblock', inv(O_qblock), atol = 1e-5)
        @test issymplectic(qpairbasis, O_qpair, atol = 1e-5)
        @test issymplectic(qblockbasis, O_qblock, atol = 1e-5)

        Spassive_qpair = randsymplectic(qpairbasis, passive = true)
        Spassive_qblock = randsymplectic(qblockbasis, passive = true)
        @test isapprox(Spassive_qpair', inv(Spassive_qpair), atol = 1e-5)
        @test issymplectic(qpairbasis, Spassive_qpair, atol = 1e-5)
        @test isapprox(Spassive_qblock', inv(Spassive_qblock), atol = 1e-5)
        @test issymplectic(qblockbasis, Spassive_qblock, atol = 1e-5)

        S_qpair = randsymplectic(qpairbasis)
        S_qblock = randsymplectic(qblockbasis)
        @test issymplectic(qpairbasis, S_qpair, atol = 1e-5)
        @test issymplectic(qblockbasis, S_qblock, atol = 1e-5)

        S_array = randsymplectic(Array, qpairbasis)
        @test issymplectic(qpairbasis, S_array, atol = 1e-5)
    end

    @testset "random states" begin
        nmodes, ħ = rand(1:5), rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        rs_pair = randstate(qpairbasis)
        rs_block = randstate(qblockbasis)
        rc = randchannel(qpairbasis)
        @test rc isa GaussianChannel
        @test rc * rs_pair isa GaussianState
        @test rs_pair.ħ == 2 && rs_block.ħ == 2
        @test isgaussian(rs_pair, atol = 1e-5)
        @test isgaussian(rs_block, atol = 1e-5)
        cp_rs_pair = copy(rs_pair)
        cp_rs_block = copy(rs_block)
        @test cp_rs_pair == rs_pair && cp_rs_block == rs_block
        @test Gabs.nmodes(rs_pair) == nmodes
        @test Gabs.nmodes(rs_block) == nmodes

        rspure_pair = randstate(qpairbasis, pure = true, ħ = ħ)
        rspure_block = randstate(qblockbasis, pure = true, ħ = ħ)
        @test isgaussian(rspure_pair, atol = 1e-5)
        @test isapprox(purity(rspure_pair), 1.0, atol = 1e-5)
        @test isgaussian(rspure_block, atol = 1e-5)
        @test isapprox(purity(rspure_block), 1.0, atol = 1e-5)

        rs_array = randstate(Array, qpairbasis)
        rc_array = randchannel(Array, qpairbasis)
        @test rc_array isa GaussianChannel
        @test rc_array.ħ == 2
        @test rc_array * rs_array isa GaussianState
        @test isgaussian(rs_array, atol = 1e-5)

        rspure_array = randstate(Array, qpairbasis, pure = true)
        @test isgaussian(rspure_array, atol = 1e-5)
        @test isapprox(purity(rspure_array), 1.0, atol = 1e-3)

        rs_static = randstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        rc_static = randchannel(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        @test rc_static isa GaussianChannel
        @test rs_static isa GaussianState
        @test rc_static * rs_static isa GaussianState
        @test isgaussian(rs_static, atol = 1e-5)

        rspure_static = randstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, pure = true)
        @test isgaussian(rspure_static, atol = 1e-5)
        @test isapprox(purity(rspure_static), 1.0, atol = 1e-5)
    end

    @testset "random unitaries" begin
        nmodes, ħ = rand(1:5), rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        ru = randunitary(qpairbasis, ħ = ħ)
        @test isgaussian(ru, atol = 1e-5)

        cp_ru = copy(ru)
        @test cp_ru == ru
        @test Gabs.nmodes(ru) == nmodes

        rupassive = randunitary(qpairbasis, passive = true)
        @test rupassive.ħ == 2
        @test isapprox(rupassive.symplectic', inv(rupassive.symplectic), atol = 1e-5)
        @test isgaussian(rupassive, atol = 1e-5)

        ru_array = randunitary(Array, qpairbasis)
        @test ru_array.ħ == 2
        @test isgaussian(ru_array, atol = 1e-5)

        rupassive_array = randunitary(qpairbasis, passive = true)
        @test isapprox(rupassive_array.symplectic', inv(rupassive_array.symplectic), atol = 1e-5)
        @test isgaussian(rupassive_array, atol = 1e-5)

        ru_static = randunitary(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        @test ru_static.ħ == 2
        @test isgaussian(ru_static, atol = 1e-5)

        rupassive_static = randunitary(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, passive = true)
        @test isapprox(rupassive_static.symplectic', inv(rupassive_static.symplectic), atol = 1e-5)
        @test isgaussian(rupassive_static, atol = 1e-5)
    end

    @testset "random channels" begin
        nmodes, ħ = rand(1:5), rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        rc = randchannel(qpairbasis, ħ = ħ)
        @test isgaussian(rc, atol = 1e-5)

        cp_rc = copy(rc)
        @test cp_rc == rc
        @test Gabs.nmodes(rc) == nmodes

        rc_array = randchannel(Array, qpairbasis)
        @test rc_array.ħ == 2
        @test isgaussian(rc_array, atol = 1e-5)

        rc_static = randchannel(SVector{2*nmodes}, SMatrix{2*nmodes, 2*nmodes}, qpairbasis)
        @test rc_static.ħ == 2
        @test isgaussian(rc_static, atol = 1e-5)
    end

    @testset "rng control" begin
        seed = 2026
        basis = QuadPairBasis(3)

        rs1 = randstate(MersenneTwister(seed), basis)
        rs2 = randstate(MersenneTwister(seed), basis)
        @test rs1 == rs2

        rs_kw = randstate(basis; rng = MersenneTwister(seed))
        rs_pos = randstate(MersenneTwister(seed), basis)
        @test rs_kw == rs_pos

        ru1 = randunitary(MersenneTwister(seed), basis)
        ru2 = randunitary(MersenneTwister(seed), basis)
        @test ru1 == ru2

        rc1 = randchannel(MersenneTwister(seed), basis)
        rc2 = randchannel(MersenneTwister(seed), basis)
        @test rc1 == rc2

        S1 = randsymplectic(MersenneTwister(seed), basis)
        S2 = randsymplectic(MersenneTwister(seed), basis)
        @test S1 == S2
    end
end

@testitem "Quadrature pair basis" begin
    using Gabs
    using StaticArrays

    basis1 = QuadPairBasis(1)
    @testset "symplectic form" begin
        Omega = symplecticform(2*basis1)
        Omega_static = symplecticform(SMatrix{4, 4}, 2*basis1)
        test_Omega = [0.0 1.0 0.0 0.0;
                      -1.0 0.0 0.0 0.0;
                      0.0 0.0 0.0 1.0;
                      0.0 0.0 -1.0 0.0]
        @test isequal(Omega, test_Omega)
        @test Omega_static isa SMatrix
    end

    @testset "wigner functions" begin
        vac = vacuumstate(basis1)
        c = coherentstate(basis1, 1.0)
        @test isapprox(wignerchar(vac, [0.0, 0.0]), 1.0 - 0.0im)
        @test wigner(vac, [rand(), rand()]) > 0.0
        @test wigner(c, [rand(), rand()]) > 0.0
    end
end

@testitem "LinearCombinations_ext Integration and Advanced Features" begin
    using Gabs
    using LinearAlgebra
    using StaticArrays

    nmodes1 = 1
    nmodes2 = 2
    qpairbasis1 = QuadPairBasis(nmodes1)
    qpairbasis2 = QuadPairBasis(nmodes2)
    qblockbasis1 = QuadBlockBasis(nmodes1)
    qblockbasis2 = QuadBlockBasis(nmodes2)

    @testset "Gaussian Operations Integration" begin
        @testset "Gaussian Unitary Operations" begin
            for basis in [qpairbasis1, qblockbasis1]
                coh1 = coherentstate(basis, 1.0 + 0.5im)
                coh2 = coherentstate(basis, -1.0 + 0.3im)
                lc = GaussianLinearCombination(basis, [0.6, 0.8], [coh1, coh2])
                
                disp_op = displace(basis, 0.5 - 0.2im)
                lc_displaced = disp_op * lc
                
                @test lc_displaced isa GaussianLinearCombination
                @test length(lc_displaced) == 2
                @test lc_displaced.basis == basis
                @test lc_displaced.ħ == lc.ħ
                @test lc_displaced.coeffs == lc.coeffs  
                
                expected_state1 = disp_op * coh1
                expected_state2 = disp_op * coh2
                @test isapprox(lc_displaced.states[1], expected_state1)
                @test isapprox(lc_displaced.states[2], expected_state2)
                
                squeeze_op = squeeze(basis, 0.3, π/4)
                lc_squeezed = squeeze_op * lc
                
                @test lc_squeezed isa GaussianLinearCombination
                @test lc_squeezed.coeffs == lc.coeffs
                @test isapprox(lc_squeezed.states[1], squeeze_op * coh1)
                @test isapprox(lc_squeezed.states[2], squeeze_op * coh2)
                
                phase_op = phaseshift(basis, π/3)
                lc_phase = phase_op * lc
                
                @test lc_phase isa GaussianLinearCombination
                @test lc_phase.coeffs == lc.coeffs
                @test isapprox(lc_phase.states[1], phase_op * coh1)
                @test isapprox(lc_phase.states[2], phase_op * coh2)
            end
        end
        
        @testset "Gaussian Channel Operations" begin
            for basis in [qpairbasis1, qblockbasis1]
                coh1 = coherentstate(basis, 1.0)
                coh2 = coherentstate(basis, -1.0)
                lc = GaussianLinearCombination(basis, [0.7, 0.3], [coh1, coh2])
                
                att_channel = attenuator(basis, π/6, 2)
                lc_attenuated = att_channel * lc
                
                @test lc_attenuated isa GaussianLinearCombination
                @test length(lc_attenuated) == 2
                @test lc_attenuated.basis == basis
                @test lc_attenuated.ħ == lc.ħ
                @test lc_attenuated.coeffs == lc.coeffs  
                
                @test isapprox(lc_attenuated.states[1], att_channel * coh1)
                @test isapprox(lc_attenuated.states[2], att_channel * coh2)
                
                amp_channel = amplifier(basis, 0.2, 1.5)
                lc_amplified = amp_channel * lc
                
                @test lc_amplified isa GaussianLinearCombination
                @test lc_amplified.coeffs == lc.coeffs
                @test isapprox(lc_amplified.states[1], amp_channel * coh1)
                @test isapprox(lc_amplified.states[2], amp_channel * coh2)
            end
        end
        
        @testset "Operation Compatibility Checks" begin
            lc1 = GaussianLinearCombination(coherentstate(qpairbasis1, 1.0))
            lc2 = GaussianLinearCombination(coherentstate(qblockbasis1, 1.0))
            op_pair = displace(qpairbasis1, 0.5)
            op_block = displace(qblockbasis1, 0.5)
            
            @test_throws ArgumentError op_block * lc1  
            @test_throws ArgumentError op_pair * lc2   
            
            
            lc_h1 = GaussianLinearCombination(coherentstate(qpairbasis1, 1.0, ħ=1))
            op_h2 = displace(qpairbasis1, 0.5, ħ=2)
            
            @test_throws ArgumentError op_h2 * lc_h1  
        end
    end

    @testset "Tensor Products" begin
        @testset "Basic Tensor Products" begin
            coh1 = coherentstate(qpairbasis1, 1.0)
            coh2 = coherentstate(qpairbasis1, -1.0)
            vac1 = vacuumstate(qpairbasis1)
            sq1 = squeezedstate(qpairbasis1, 0.3, π/6)
            
            lc1 = GaussianLinearCombination(qpairbasis1, [0.6, 0.4], [coh1, coh2])
            lc2 = GaussianLinearCombination(qpairbasis1, [0.8, 0.2], [vac1, sq1])
            
            lc_tensor = tensor(lc1, lc2)
            
            @test lc_tensor isa GaussianLinearCombination
            @test length(lc_tensor) == 4  
            @test lc_tensor.basis == qpairbasis2  
            @test lc_tensor.ħ == lc1.ħ
            
            expected_coeffs = [0.6*0.8, 0.6*0.2, 0.4*0.8, 0.4*0.2]
            @test isapprox(sort(lc_tensor.coeffs), sort(expected_coeffs))
            
            expected_states = [
                coh1 ⊗ vac1, coh1 ⊗ sq1,
                coh2 ⊗ vac1, coh2 ⊗ sq1
            ]
            
            for expected_state in expected_states
                found = false
                for actual_state in lc_tensor.states
                    if isapprox(actual_state, expected_state, atol=1e-12)
                        found = true
                        break
                    end
                end
                @test found
            end
        end
        
        @testset "Typed Tensor Products" begin
            coh1 = coherentstate(qpairbasis1, 1.0)
            vac1 = vacuumstate(qpairbasis1)
            lc1 = GaussianLinearCombination(qpairbasis1, [0.7, 0.3], [coh1, vac1])
            lc2 = GaussianLinearCombination(qpairbasis1, [1.0], [coh1])
            
            lc_tensor_typed = tensor(Vector{Float64}, Matrix{Float64}, lc1, lc2)
            @test lc_tensor_typed isa GaussianLinearCombination
            @test length(lc_tensor_typed) == 2  
            @test lc_tensor_typed.coeffs == [0.7, 0.3]
            
            lc_tensor_single = tensor(Matrix{Float64}, lc1, lc2)
            @test lc_tensor_single isa GaussianLinearCombination
            @test length(lc_tensor_single) == 2
        end
        
        @testset "Tensor Product Properties" begin
            vac = vacuumstate(qpairbasis1)
            coh = coherentstate(qpairbasis1, 1.0)
            sq = squeezedstate(qpairbasis1, 0.2, π/4)
            
            lc1 = GaussianLinearCombination(vac)
            lc2 = GaussianLinearCombination(coh)  
            lc3 = GaussianLinearCombination(sq)
            
            left_assoc = tensor(tensor(lc1, lc2), lc3)
            right_assoc = tensor(lc1, tensor(lc2, lc3))
            
            @test left_assoc.basis.nmodes == right_assoc.basis.nmodes == 3
            @test length(left_assoc) == length(right_assoc) == 1
            
            lc_self = tensor(lc1, lc1)
            @test lc_self.basis.nmodes == 2
            @test length(lc_self) == 1
        end
        
        @testset "Tensor Product Compatibility Checks" begin
            lc_pair = GaussianLinearCombination(coherentstate(qpairbasis1, 1.0))
            lc_block = GaussianLinearCombination(coherentstate(qblockbasis1, 1.0))
            lc_h1 = GaussianLinearCombination(coherentstate(qpairbasis1, 1.0, ħ=1))
            lc_h2 = GaussianLinearCombination(coherentstate(qpairbasis1, 1.0, ħ=2))
            
            @test_throws ArgumentError tensor(lc_pair, lc_block)
            
            @test_throws ArgumentError tensor(lc_h1, lc_h2)
        end
        
        @testset "StaticArrays Compatibility" begin
            coh_static = coherentstate(SVector{2}, SMatrix{2,2}, qpairbasis1, 1.0)
            vac_static = vacuumstate(SVector{2}, SMatrix{2,2}, qpairbasis1)
            
            lc1_static = GaussianLinearCombination(qpairbasis1, [0.6, 0.8], [coh_static, vac_static])
            lc2_static = GaussianLinearCombination(qpairbasis1, [1.0], [coh_static])
            
            lc_tensor_static = tensor(lc1_static, lc2_static)
            @test lc_tensor_static isa GaussianLinearCombination
            @test length(lc_tensor_static) == 2
        end
    end

    @testset "Partial Traces" begin
        @testset "Basic Partial Trace" begin
            basis = qpairbasis2
            coh1 = coherentstate(QuadPairBasis(1), 1.0)
            coh2 = coherentstate(QuadPairBasis(1), -1.0)
            vac = vacuumstate(QuadPairBasis(1))
            
            state1 = coh1 ⊗ vac
            state2 = coh2 ⊗ vac  
            state3 = vac ⊗ coh1
            
            lc = GaussianLinearCombination(basis, [0.5, 0.3, 0.2], [state1, state2, state3])
            
            lc_traced = ptrace(lc, 1)
            
            @test lc_traced isa GaussianLinearCombination
            @test lc_traced.basis.nmodes == 1  
            @test lc_traced.ħ == lc.ħ
            
 
            @test length(lc_traced) <= 2  
            
            lc_traced2 = ptrace(lc, 2)
            @test lc_traced2 isa GaussianLinearCombination
            @test lc_traced2.basis.nmodes == 1
            
            @test_throws ArgumentError ptrace(lc, [1, 2])
        end
        
        @testset "Partial Trace with Multiple Indices" begin
            basis3 = QuadPairBasis(3)
            vac = vacuumstate(QuadPairBasis(1))
            coh = coherentstate(QuadPairBasis(1), 1.0)
            
            state = vac ⊗ coh ⊗ vac
            lc = GaussianLinearCombination(state)
            
            lc_traced = ptrace(lc, [1, 3])
            
            @test lc_traced isa GaussianLinearCombination
            @test lc_traced.basis.nmodes == 1
            @test length(lc_traced) == 1
            @test isapprox(lc_traced.states[1], coh, atol=1e-12)
        end
        
        @testset "Typed Partial Trace" begin
            basis = qpairbasis2
            state1 = coherentstate(QuadPairBasis(1), 1.0) ⊗ vacuumstate(QuadPairBasis(1))
            lc = GaussianLinearCombination(basis, [1.0], [state1])
            lc_traced = ptrace(lc, 1)
            @test lc_traced isa GaussianLinearCombination
            @test lc_traced.basis.nmodes == 1
        end
        
        @testset "Partial Trace Error Handling" begin
            basis = qpairbasis2
            coh = coherentstate(QuadPairBasis(1), 1.0)
            vac = vacuumstate(QuadPairBasis(1))
            state = coh ⊗ vac
            lc = GaussianLinearCombination(basis, [1.0], [state])
            
            @test_throws DimensionMismatch ptrace(lc, 3)  # ..Index too large
            @test_throws DimensionMismatch ptrace(lc, 0)  # Index too small
            @test_throws ArgumentError ptrace(lc, [1, 2])  # Tracing all modes
            @test_throws ArgumentError ptrace(lc, [1, 1])  # Duplicate indices
        end
        
        @testset "Partial Trace Simplification" begin
            basis = qpairbasis2
            coh = coherentstate(QuadPairBasis(1), 1.0)
            vac = vacuumstate(QuadPairBasis(1))
            
            state1 = coh ⊗ vac
            state2 = coh ⊗ squeezedstate(QuadPairBasis(1), 0.1, 0.0) 
            
            lc = GaussianLinearCombination(basis, [0.6, 0.4], [state1, state2])
            
            # note - Trace out the second mode - both should trace to |coh⟩
            lc_traced = ptrace(lc, 2)
            
            @test lc_traced isa GaussianLinearCombination
     
            @test lc_traced.basis.nmodes == 1
        end
    end

    @testset "Wigner Functions with Quantum Interference" begin
        @testset "Cross-Wigner Functions" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, -1.0)
            x = [0.5, 0.3]  
            
            cross_w = cross_wigner(coh1, coh2, x)
            @test cross_w isa ComplexF64
            @test isfinite(cross_w)
            
            cross_w_reverse = cross_wigner(coh2, coh1, x)
            @test isapprox(cross_w, conj(cross_w_reverse), rtol=1e-8)
            
            cross_w_same = cross_wigner(coh1, coh1, x)
            regular_w = wigner(coh1, x)
            
            identity_holds = isapprox(real(cross_w_same), regular_w, rtol=1e-6)
            @test identity_holds || begin
                println("WARNING: Cross-Wigner identity test failed!")
                println("cross_wigner(s,s,x) = ", cross_w_same)
                println("wigner(s,x) = ", regular_w)
                println("Ratio = ", real(cross_w_same)/regular_w)
                println("This indicates a potential bug in the cross_wigner implementation")
                false 
            end
            
            @test abs(imag(cross_w_same)) < 1e-10
            
            vac = vacuumstate(basis)
            sq = squeezedstate(basis, 0.3, π/4)
            
            cross_w_vac_sq = cross_wigner(vac, sq, x)
            @test cross_w_vac_sq isa ComplexF64
            @test isfinite(cross_w_vac_sq)
        end
        
        @testset "Wigner Function with Interference" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, -1.0)
            cat_state = GaussianLinearCombination(basis, [0.7, 0.3], [coh1, coh2])
            
            x = [0.0, 0.0] 
            
            w_interference = wigner(cat_state, x)
            @test w_interference isa Real
            @test isfinite(w_interference)
            
            w1 = wigner(coh1, x)
            w2 = wigner(coh2, x)
            w_cross = cross_wigner(coh1, coh2, x)
            
            expected_w = abs2(0.7) * w1 + abs2(0.3) * w2 + 2 * real(conj(0.7) * 0.3 * w_cross)
            
            @test isapprox(w_interference, expected_w, atol=1e-12)
            
            symmetric_cat = GaussianLinearCombination(basis, [0.5, 0.5], [coh1, coh2])
            x_interference = [0.0, 0.5] 
            w_symmetric = wigner(symmetric_cat, x_interference)
            
            @test isfinite(w_symmetric)
        end
        
        @testset "Cross-Wigner Characteristic Functions" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0 + 0.5im)
            coh2 = coherentstate(basis, -0.5 + 1.0im)
            xi = [0.2, 0.3]  
            
            cross_char = cross_wignerchar(coh1, coh2, xi)
            @test cross_char isa ComplexF64
            @test isfinite(cross_char)
            
            cross_char_reverse = cross_wignerchar(coh2, coh1, -xi) 
            hermitian_holds = isapprox(cross_char, conj(cross_char_reverse), rtol=1e-8)
            @test hermitian_holds || begin
                println("WARNING: Cross-Wigner characteristic function Hermitian property failed!")
                println("χ₁₂(ξ) = ", cross_char)
                println("χ₂₁*(-ξ) = ", conj(cross_char_reverse)) 
                println("Difference = ", cross_char - conj(cross_char_reverse))
                println("This indicates a potential bug in cross_wignerchar implementation")
                false 
            end
            
            cross_char_same = cross_wignerchar(coh1, coh1, xi)
            regular_char = wignerchar(coh1, xi)
            identity_holds = isapprox(cross_char_same, regular_char, rtol=1e-8)
            @test identity_holds || begin
                println("WARNING: Cross-Wigner characteristic function identity failed!")
                println("cross_wignerchar(s,s,ξ) = ", cross_char_same)
                println("wignerchar(s,ξ) = ", regular_char)
                println("This indicates a potential bug in cross_wignerchar implementation")
                false 
            end
        end
        
        @testset "Wigner Characteristic Function with Interference" begin
            basis = qpairbasis1
            
            vac = vacuumstate(basis)
            coh = coherentstate(basis, 1.0)
            superpos = GaussianLinearCombination(basis, [0.6, 0.8], [vac, coh])
            
            xi = [0.1, 0.2]
            
            char_interference = wignerchar(superpos, xi)
            @test char_interference isa ComplexF64
            @test isfinite(char_interference)
            
            char1 = wignerchar(vac, xi)
            char2 = wignerchar(coh, xi)
            char_cross = cross_wignerchar(vac, coh, xi)
            
            expected_char = abs2(0.6) * char1 + abs2(0.8) * char2 + 
                           2 * real(conj(0.6) * 0.8 * char_cross)
                           
            @test isapprox(real(char_interference), real(expected_char), rtol=1e-10)
        end
        
        @testset "Wigner Function Error Handling" begin
            basis = qpairbasis1
            coh = coherentstate(basis, 1.0)
            lc = GaussianLinearCombination(coh)
            
            @test_throws ArgumentError wigner(lc, [1.0])  
            @test_throws ArgumentError wigner(lc, [1.0, 2.0, 3.0])  
            @test_throws ArgumentError wignerchar(lc, [1.0])
            
            cross_w = cross_wigner(coh, coh, [0.5, 0.3])
            @test cross_w isa ComplexF64
            @test isfinite(cross_w)
            
            @test_throws ArgumentError wignerchar(lc, [1.0, 2.0, 3.0])  
        end
        
        @testset "Multi-mode Wigner Functions" begin
            basis = qpairbasis2
            coh1_2mode = coherentstate(QuadPairBasis(1), 1.0) ⊗ vacuumstate(QuadPairBasis(1))
            coh2_2mode = coherentstate(QuadPairBasis(1), -1.0) ⊗ vacuumstate(QuadPairBasis(1))
            
            lc_2mode = GaussianLinearCombination(basis, [0.7, 0.3], [coh1_2mode, coh2_2mode])
            
            x_2mode = [0.1, 0.2, 0.3, 0.4] 
            
            w_2mode = wigner(lc_2mode, x_2mode)
            @test w_2mode isa Real
            @test isfinite(w_2mode)
            
            xi_2mode = [0.05, 0.1, 0.15, 0.2]
            char_2mode = wignerchar(lc_2mode, xi_2mode)
            @test char_2mode isa ComplexF64
            @test isfinite(char_2mode)
        end
    end

    @testset "Advanced State Metrics" begin
        @testset "Purity of Linear Combinations" begin
            basis = qpairbasis1
            
            coh = coherentstate(basis, 1.0)
            lc_single = GaussianLinearCombination(coh)
            @test purity(lc_single) == 1.0
            
            vac = vacuumstate(basis)
            lc_super = GaussianLinearCombination(basis, [0.6, 0.8], [coh, vac])
            @test purity(lc_super) == 1.0  
            
            cat_state = catstate_even(basis, 1.0)
            @test purity(cat_state) == 1.0
            
            gkp_state = gkpstate(basis, lattice="square", delta=0.2, nmax=2)
            @test purity(gkp_state) == 1.0
            
            lc_complex = GaussianLinearCombination(basis, [0.6 + 0.8im, 0.2 - 0.1im], [coh, vac])
            @test purity(lc_complex) == 1.0
        end
        
        @testset "Von Neumann Entropy of Linear Combinations" begin
            basis = qpairbasis1
            
            sq = squeezedstate(basis, 0.3, π/6)
            lc_single = GaussianLinearCombination(sq)
            @test entropy_vn(lc_single) == 0.0
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, -1.0)
            lc_super = GaussianLinearCombination(basis, [0.7, 0.3], [coh1, coh2])
            @test entropy_vn(lc_super) == 0.0  
            
            cat_odd = catstate_odd(basis, 1.5)
            @test entropy_vn(cat_odd) == 0.0
            
            states = [coherentstate(basis, Float64(i)) for i in 1:5]
            coeffs = [1.0/√5 for _ in 1:5] 
            lc_many = GaussianLinearCombination(basis, coeffs, states)
            @test entropy_vn(lc_many) == 0.0
            
            lc_complex = GaussianLinearCombination(basis, [0.6im, 0.8], [coh1, coh2])
            @test entropy_vn(lc_complex) == 0.0
        end
    end

    @testset "Integration with Existing Cat and GKP States" begin
        @testset "Cat State Integration" begin
            basis = qpairbasis1
            
            cat_even = catstate_even(basis, 1.0)
            cat_odd = catstate_odd(basis, 1.5)
            
            disp_op = displace(basis, 0.5)
            cat_displaced = disp_op * cat_even
            
            @test cat_displaced isa GaussianLinearCombination
            @test length(cat_displaced) == 2
            
            cat_tensor = tensor(cat_even, cat_odd)
            @test cat_tensor isa GaussianLinearCombination
            @test length(cat_tensor) == 4  
            @test cat_tensor.basis.nmodes == 2
            
            x = [0.0, 0.0]
            w_cat = wigner(cat_even, x)
            @test w_cat isa Real
            @test isfinite(w_cat)
        end
        
        @testset "GKP State Integration" begin
            basis = qpairbasis1
            
            gkp_square = gkpstate(basis, lattice="square", delta=0.2, nmax=2)
            gkp_hex = gkpstate(basis, lattice="hexagonal", delta=0.2, nmax=1)
            
            squeeze_op = squeeze(basis, 0.1, π/6)
            gkp_squeezed = squeeze_op * gkp_square
            
            @test gkp_squeezed isa GaussianLinearCombination
            @test length(gkp_squeezed) == length(gkp_square)
            
            vac = vacuumstate(QuadPairBasis(1))
            gkp_2mode = tensor(gkp_square, GaussianLinearCombination(vac))
            
            @test gkp_2mode.basis.nmodes == 2
            
            gkp_traced = ptrace(gkp_2mode, 2)
            @test gkp_traced.basis.nmodes == 1
        end
        
        @testset "Mixed Cat and GKP Operations" begin
            basis = qpairbasis1
            
            cat = catstate_even(basis, 1.0)
            gkp = gkpstate(basis, lattice="square", delta=0.3, nmax=1)
            
            mixed = 0.6 * cat + 0.4 * gkp
            @test mixed isa GaussianLinearCombination
            @test mixed.basis == basis
            
            cat_gkp_tensor = tensor(cat, gkp)
            @test cat_gkp_tensor isa GaussianLinearCombination
            @test cat_gkp_tensor.basis.nmodes == 2
            @test length(cat_gkp_tensor) == length(cat) * length(gkp)
            
            x = [0.1, 0.2, 0.3, 0.4]  
            w_mixed = wigner(cat_gkp_tensor, x)
            @test w_mixed isa Real
            @test isfinite(w_mixed)
        end
    end

    @testset "Performance and Numerical Stability" begin
        @testset "Large Linear Combinations" begin
            basis = qpairbasis1
            
            n_states = 50
            states = [coherentstate(basis, 0.1 * i) for i in 1:n_states]
            coeffs = [1.0/√n_states for _ in 1:n_states]  # Normalized
            
            lc_large = GaussianLinearCombination(basis, coeffs, states)
            
            @test length(lc_large) == n_states
            
            x = [0.5, 0.3]
            w_large = wigner(lc_large, x)
            @test isfinite(w_large)
            @test purity(lc_large) == 1.0
            @test entropy_vn(lc_large) == 0.0
        end
        
        @testset "Extreme Parameter Values" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, -1.0)
            lc_tiny = GaussianLinearCombination(basis, [1e-15, 1.0], [coh1, coh2])
            
            @test isfinite(purity(lc_tiny))
            @test isfinite(entropy_vn(lc_tiny))
            
            lc_huge = GaussianLinearCombination(basis, [1e10, 1e10], [coh1, coh2])
            
            x = [0.0, 0.0]
            w_huge = wigner(lc_huge, x)
            @test isfinite(w_huge)
            
            lc_complex = GaussianLinearCombination(basis, [1.0 + 100.0im, 1.0 - 100.0im], [coh1, coh2])
            
            @test isfinite(purity(lc_complex))
            @test entropy_vn(lc_complex) == 0.0
        end
        
        @testset "Numerical Precision" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, 1.0 + 1e-12)  
            
            lc_close = GaussianLinearCombination(basis, [0.7, 0.3], [coh1, coh2])
            
            x = [0.5, 0.5]
            cross_w = cross_wigner(coh1, coh2, x)
            @test isfinite(cross_w)
            @test abs(cross_w) > 0  
            
            w_close = wigner(lc_close, x)
            @test isfinite(w_close)
        end
    end

    @testset "Mathematical Properties Verification" begin
        @testset "Tensor Product Linearity" begin
            basis = qpairbasis1
            
            coh1 = coherentstate(basis, 1.0)
            coh2 = coherentstate(basis, -1.0)
            vac = vacuumstate(basis)
            
            lc1 = GaussianLinearCombination(basis, [0.6, 0.4], [coh1, coh2])
            lc2 = GaussianLinearCombination(basis, [0.8, 0.2], [coh2, vac])
            lc3 = GaussianLinearCombination(vac)
            
            a, b = 0.7, 0.3
            
            left_side = tensor(a * lc1 + b * lc2, lc3)
            right_side = a * tensor(lc1, lc3) + b * tensor(lc2, lc3)
            
            Gabs.simplify!(left_side)
            Gabs.simplify!(right_side)
            
            @test length(left_side) == length(right_side)
            @test isapprox(sum(abs2, left_side.coeffs), sum(abs2, right_side.coeffs), rtol=1e-10)
        end
        
        @testset "Wigner Function Integration Properties" begin
            basis = qpairbasis1
            
            coh = coherentstate(basis, 0.5)
            vac = vacuumstate(basis)
            lc = GaussianLinearCombination(basis, [0.8, 0.6], [coh, vac])
            
            x_vals = [[0.0, 0.0], [0.5, 0.0], [0.0, 0.5], [1.0, 1.0]]
            
            for x in x_vals
                w_val = wigner(lc, x)
                @test isfinite(w_val)
                
                @test abs(w_val) < 1e10 
            end
        end
        
        @testset "Cross-Wigner Symmetry Properties" begin
            basis = qpairbasis1
            
            states = [
                vacuumstate(basis),
                coherentstate(basis, 1.0),
                coherentstate(basis, -1.0),
                squeezedstate(basis, 0.2, π/4)
            ]
            
            x = [0.5, 0.3]
            
            for i in 1:length(states)
                for j in i:length(states)
                    s1, s2 = states[i], states[j]
                    w12 = cross_wigner(s1, s2, x)
                    w21 = cross_wigner(s2, s1, x)
                    
                    @test isapprox(w12, conj(w21), rtol=1e-8)
                    
                    if i == j
                        w_regular = wigner(s1, x)
                        @test isapprox(real(w12), w_regular, rtol=1e-10)
                        @test abs(imag(w12)) < 1e-12  
                    end
                end
            end
        end
        
        @testset "Partial Trace Dimension Consistency" begin
            basis1 = QuadPairBasis(1)
            basis3 = QuadPairBasis(3)
            
            coh = coherentstate(basis1, 1.0)
            vac = vacuumstate(basis1)
            sq = squeezedstate(basis1, 0.3, π/6)
            
            state_3mode = tensor(tensor(coh, vac), sq)
            lc_3mode = GaussianLinearCombination(state_3mode)
            
          
            lc_trace_1 = ptrace(lc_3mode, [1])     
            lc_trace_2 = ptrace(lc_3mode, [2])      
            lc_trace_12 = ptrace(lc_3mode, [1,2])   
            
            @test lc_trace_1.basis.nmodes == 2
            @test lc_trace_2.basis.nmodes == 2
            @test lc_trace_12.basis.nmodes == 1
            
            @test isapprox(lc_trace_12.states[1], sq, rtol=1e-10)
        end
    end
    @testset "Additional Tests" begin
    
        nmodes = 1
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
    
        @testset "Empty states constructor coverage" begin

            coeffs = [1.0, 0.5]
            empty_states = GaussianState[]
            
            @test_throws ArgumentError GaussianLinearCombination(coeffs, empty_states)
            
            state1 = coherentstate(qpairbasis, 1.0)
            state2 = coherentstate(qpairbasis, -1.0)
            states = [state1, state2]
            
            lc = GaussianLinearCombination(coeffs, states)
            @test lc isa GaussianLinearCombination
            @test length(lc) == 2
            @test lc.coeffs == coeffs
            @test lc.states == states
            @test lc.basis == qpairbasis
        end
    
        @testset "Empty coeffs in simplify! coverage" begin
            state = coherentstate(qpairbasis, 1.0)
            lc = GaussianLinearCombination(state)
            lc.coeffs = Float64[]
            lc.states = GaussianState[]
            result = Gabs.simplify!(lc)
            @test result === lc 
            @test isempty(lc.coeffs)
            @test isempty(lc.states)
        end
    
        @testset "Show function 'more terms' coverage" begin
            basis = qpairbasis
            states = [coherentstate(basis, Float64(i)) for i in 1:7]  
            coeffs = [1.0/7 for _ in 1:7]
            lc = GaussianLinearCombination(basis, coeffs, states)
            io = IOBuffer()
            show(io, MIME("text/plain"), lc)
            output = String(take!(io))
            
            @test contains(output, "⋮")
            @test contains(output, "more terms")
            @test contains(output, "GaussianLinearCombination with 7 terms")
            
            @test contains(output, "[5]")
            @test contains(output, "(2 more terms)")
        end
    
        @testset "Typed ptrace functions coverage" begin
            basis = QuadPairBasis(2)
            coh = coherentstate(QuadPairBasis(1), 1.0)
            vac = vacuumstate(QuadPairBasis(1))
            
            state = coh ⊗ vac
            lc = GaussianLinearCombination(basis, [1.0], [state])
            
            lc_traced_single = ptrace(Vector{Float64}, Matrix{Float64}, lc, 1)
            @test lc_traced_single isa GaussianLinearCombination
            @test lc_traced_single.basis.nmodes == 1
            @test lc_traced_single.states[1].mean isa Vector{Float64}
            @test lc_traced_single.states[1].covar isa Matrix{Float64}
            
            lc_traced_vector = ptrace(Vector{Float64}, Matrix{Float64}, lc, [1])
            @test lc_traced_vector isa GaussianLinearCombination
            @test lc_traced_vector.basis.nmodes == 1
            @test lc_traced_vector.states[1].mean isa Vector{Float64}
            @test lc_traced_vector.states[1].covar isa Matrix{Float64}
            
            lc_traced_static = ptrace(SVector{2,Float64}, SMatrix{2,2,Float64}, lc, 1)
            @test lc_traced_static isa GaussianLinearCombination
            @test lc_traced_static.states[1].mean isa SVector{2,Float64}
            @test lc_traced_static.states[1].covar isa SMatrix{2,2,Float64}
        end
    
        @testset "Tensor function else branch coverage" begin
            basis = qpairbasis
            state1 = coherentstate(basis, 1.0)
            state2 = vacuumstate(basis)
            
            lc1 = GaussianLinearCombination(basis, [1.0], [state1])
            lc2 = GaussianLinearCombination(basis, [1.0], [state2])
            
            lc_tensor = tensor(Array{Float64}, lc1, lc2)
            @test lc_tensor isa GaussianLinearCombination
            @test lc_tensor.basis.nmodes == 2
            @test length(lc_tensor) == 1
            @test lc_tensor.states[1].mean isa Array{Float64}
            @test lc_tensor.states[1].covar isa Array{Float64}

            struct TestArrayType{T} <: AbstractArray{T, 2}
                data::Matrix{T}
            end
            TestArrayType(data::Matrix{T}) where T = TestArrayType{T}(data)
            Base.size(a::TestArrayType) = size(a.data)
            Base.getindex(a::TestArrayType, i...) = getindex(a.data, i...)
            Base.setindex!(a::TestArrayType, v, i...) = setindex!(a.data, v, i...)
            TestArrayType{T}(::UndefInitializer, dims...) where T = TestArrayType(Matrix{T}(undef, dims...))
            Base.similar(a::TestArrayType{T}, ::Type{S}, dims::Dims) where {T,S} = TestArrayType(Matrix{S}(undef, dims))
        end
        @testset "Ptrace function else branch coverage" begin
            basis = QuadPairBasis(2)
            coh = coherentstate(QuadPairBasis(1), 1.0)
            vac = vacuumstate(QuadPairBasis(1))
            
            state = coh ⊗ vac
            lc = GaussianLinearCombination(basis, [1.0], [state])
            
            lc_traced = ptrace(Array{Float64}, lc, 1)
            @test lc_traced isa GaussianLinearCombination
            @test lc_traced.basis.nmodes == 1
            @test lc_traced.states[1].mean isa Array{Float64}
            @test lc_traced.states[1].covar isa Array{Float64}
            
            lc_traced_vector = ptrace(Array{Float64}, lc, [1])
            @test lc_traced_vector isa GaussianLinearCombination
            @test lc_traced_vector.basis.nmodes == 1
            @test lc_traced_vector.states[1].mean isa Array{Float64}
            @test lc_traced_vector.states[1].covar isa Array{Float64}
        end
    end
end

@testitem "Measurements" begin
    using Gabs
    using Random
    using StableRNGs
    using StaticArrays
    using LinearAlgebra: det, I, cholesky, Symmetric

    @testset "generaldyne" begin

        qpairbasis, qblockbasis = QuadPairBasis(1), QuadBlockBasis(1)
        for basis in [qpairbasis, qblockbasis]
            vac = vacuumstate(basis)
            @test_throws ArgumentError generaldyne(vac ⊗ vac, [1], proj = zeros(4, 4))
            @test_throws ArgumentError generaldyne(vac ⊗ vac, [1], proj = GaussianState(basis ⊕ basis, zeros(4), zeros(4, 4)))
            vacs = vac ⊗ vac ⊗ vac ⊗ vac
            gd1 = generaldyne(vacs, [2, 4], proj = vac ⊗ vac)
            @test isapprox(gd1.result, vac ⊗ vac, atol = 1e-12)
            @test isapprox(gd1.state, vacs, atol = 1e-12)
            result, state = gd1
            @test result == gd1.result && state == gd1.state

            coh = coherentstate(basis, 1.0+im)
            cohs = coh ⊗ vac ⊗ coh ⊗ vac
            epr = eprstate(basis ⊕ basis, 1.0, 3.0)
            gd2 = generaldyne(cohs, [1, 4], proj = epr)
            @test isapprox(gd2.result, epr, atol = 1e-12)
            @test isapprox(gd2.state, vac ⊗ vac ⊗ coh ⊗ vac, atol = 1e-12)

            single = coherentstate(basis, 0.3 + 0.2im)
            proj = squeezedstate(basis, 0.4, π / 3)
            gd_single_int = generaldyne(single, 1; proj)
            gd_single_vec = generaldyne(single, [1]; proj)
            @test gd_single_int.result == proj
            @test gd_single_vec.result == proj
            @test gd_single_int.state == gd_single_vec.state
            @test isapprox(gd_single_int.state, vac, atol = 1e-12)
            @test_throws ArgumentError ptrace(gd_single_int.state, 1)

            gd_rand_int = generaldyne(single, 1)
            gd_rand_vec = generaldyne(single, [1])
            @test gd_rand_int.result isa GaussianState
            @test gd_rand_vec.result isa GaussianState
            @test gd_rand_int.result.basis == basis
            @test gd_rand_vec.result.basis == basis
            @test isapprox(gd_rand_int.result.covar, vac.covar, atol = 1e-12)
            @test isapprox(gd_rand_vec.result.covar, vac.covar, atol = 1e-12)
            @test isapprox(gd_rand_int.state, vac, atol = 1e-12)
            @test isapprox(gd_rand_vec.state, vac, atol = 1e-12)

            samples_int = rand(Generaldyne, single, 1; shots = 2)
            samples_vec = rand(Generaldyne, single, [1]; shots = 2)
            @test size(samples_int) == size(samples_vec)
            @test size(samples_int) == (2, 2)
        end

        indices, nmodes = [7, 8, 9, 10], 10

        # random Gaussian state tests
        # This seed keeps VB + proj_qpair.covar well conditioned (κ₂ ≈ 11).
        rng = StableRNG(32)
        rs_qpair = randstate(rng, QuadPairBasis(nmodes))
        rs_qblock = changebasis(QuadBlockBasis, rs_qpair)
        proj_qpair = randstate(rng, QuadPairBasis(length(indices)))
        proj_qblock = changebasis(QuadBlockBasis, proj_qpair)
        gd3_qpair = generaldyne(rs_qpair, indices, proj = proj_qpair)
        gd3_qblock = generaldyne(rs_qblock, indices, proj = proj_qblock)

        # analytical calculation of evolved subsystem that is not measured
        xA, xB, VA, VB, VAB = Gabs._part_state(rs_qpair, indices)
        gd3_evolved_mean = xA .+ VAB * ((inv(VB .+ proj_qpair.covar)) * (proj_qpair.mean .- xB))
        gd3_evolved_covar = VA .- VAB * ((inv(VB .+ proj_qpair.covar)) * transpose(VAB))
        out3_mean = vcat(gd3_evolved_mean, zeros(2*length(indices)))
        out3_covar = zeros(2*nmodes, 2*nmodes)
        copyto!(@view(out3_covar[1:2*(nmodes-length(indices)), 1:2*(nmodes-length(indices))]), gd3_evolved_covar)
        copyto!(@view(out3_covar[2*(nmodes-length(indices))+1:2*nmodes, 2*(nmodes-length(indices))+1:2*nmodes]), Matrix{Float64}(I, 2*length(indices), 2*length(indices)))

        evolved_state_qpair = GaussianState(QuadPairBasis(nmodes), out3_mean, out3_covar)
        evolved_state_qblock = changebasis(QuadBlockBasis, evolved_state_qpair)
        @test isapprox(gd3_qpair.state, evolved_state_qpair)
        @test isapprox(gd3_qblock.state, evolved_state_qblock)
        
        # tests to check that static arrays are outputted for generaldyne 
        # measurements of Gaussian states wrapping static arrays
        sstatic = vacuumstate(SVector{2}, SMatrix{2,2}, QuadPairBasis(1))
        statestatic = sstatic ⊗ sstatic ⊗ sstatic ⊗ sstatic
        gdstatic = generaldyne(statestatic, [2])
        @test (gdstatic.state).mean isa SVector && (gdstatic.state).covar isa SMatrix
        @test isequal(gdstatic.state, statestatic)

        # TODO: add more tests for random Generaldyne sampling
        @test_throws ArgumentError rand(Generaldyne, rs_qpair, collect(1:11))
        @test_throws ArgumentError rand(Generaldyne, rs_qblock, collect(1:11))
        @test_throws ArgumentError rand(Generaldyne, rs_qpair, indices, proj = zeros(20, 20))
        @test_throws ArgumentError rand(Generaldyne, rs_qblock, indices, proj = zeros(20, 20))
        @test size(rand(Generaldyne, rs_qpair, [1, 3, 5], shots = 10)) == (6, 10)
        @test size(rand(Generaldyne, rs_qblock, [1, 3, 5], shots = 10)) == (6, 10)

    end

    @testset "homodyne" begin

        @testset "homodyne" begin
            qpairbasis, qblockbasis = QuadPairBasis(1), QuadBlockBasis(1)

            for basis in (qpairbasis, qblockbasis)
                vac = vacuumstate(basis)
                @test_throws ArgumentError homodyne(vac, [1, 2], [0.0])
                @test_throws ArgumentError homodyne(vac, [1], [0.0, π/2])
            end
        
            squeeze = 1e-14
            # simple test case: measuring 1 mode of 2-mode state
            for basis in (QuadPairBasis(2), QuadBlockBasis(2))
                st = vacuumstate(basis) ⊗ vacuumstate(basis)
                M = homodyne(st, [1], [0.0]; squeeze)
                @test M isa Homodyne
                @test M.result isa Vector
                @test M.state isa GaussianState
        
                result, state = M
                @test result == M.result
                @test state == M.state
        
                # check if measured mode is replaced with vacuum
                @test isapprox(state.mean[1:2], zeros(2), atol=1e-12)
                @test isapprox(state.covar[1:2, 1:2], Matrix{Float64}(I,2,2), atol=1e-12)
            end

            for basis in (qpairbasis, qblockbasis)
                seed = 1234
                st = coherentstate(basis, 0.3 + 0.2im)
                h_int = homodyne(MersenneTwister(seed), st, 1, [0.0]; squeeze)
                h_vec = homodyne(MersenneTwister(seed), st, [1], [0.0]; squeeze)
                @test h_int.result == h_vec.result
                @test h_int.state == h_vec.state
                @test isapprox(h_int.state, vacuumstate(basis), atol = 1e-12)
                @test_throws ArgumentError ptrace(h_int.state, 1)

                samples_int = rand(MersenneTwister(seed), Homodyne, st, 1, [0.0]; shots = 2, squeeze)
                samples_vec = rand(MersenneTwister(seed), Homodyne, st, [1], [0.0]; shots = 2, squeeze)
                @test samples_int == samples_vec
                @test size(samples_int) == (2, 2)
            end
        
            st = squeezedstate(QuadPairBasis(4), 0.5, π/2)
            st_block = changebasis(QuadBlockBasis, st)
            indices = [2, 4]
            angles = [0.0, π/2]
            @test size(rand(Homodyne, st, indices, angles; shots=10, squeeze)) == (4, 10)
            @test size(rand(Homodyne, st_block, indices, angles; shots=7, squeeze)) == (4, 7)
        
            indices = [1, 2]
            # Keep the nearly singular finite-squeezing update reproducible.
            # This seed gives ‖B * inv(B) - I‖∞ ≈ 1.2e-17.
            rng = StableRNG(73)
            rs_qpair = randstate(rng, QuadPairBasis(4))
            rs_qblock = changebasis(QuadBlockBasis, rs_qpair)
            M_qpair = homodyne(rng, rs_qpair, indices, [0.0, π/2])
            M_qblock = homodyne(rng, rs_qblock, indices, [0.0, π/2])
        
            # extract analytical conditional update
            xA, xB, VA, VB, VAB = Gabs._part_state(rs_qpair, indices)
            B = copy(VB)
            # apply infinite squeezing (0.0 and π/2)
            θs = [0.0, π/2]
            for i in 1:2
                θ = θs[i]
                sq = 1e-12
                ct, st = cos(θ), sin(θ)
                B[2i-1,2i-1] += ct^2 * sq + st^2 / sq
                B[2i-1,2i]   += ct * st * (sq - 1 / sq)
                B[2i,2i-1]   += ct * st * (sq - 1 / sq)
                B[2i,2i]     += st^2 * sq + ct^2 / sq
            end
            L = cholesky(Symmetric(B)).L
            resultmean = L * randn(rng, 4) + xB
            xA′ = xA .+ VAB * (inv(B) * (resultmean - xB))
            VA′ = VA .- VAB * (inv(B) * transpose(VAB))
        
            nm = 4
            out_mean = zeros(2nm)
            notindices = setdiff(1:nm, indices)
            for i in eachindex(notindices)
                idx = notindices[i]
                out_mean[2idx-1:2idx] .= @view(xA′[2i-1:2i])
            end
            out_covar = Matrix{Float64}(I, 2nm, 2nm)
            for i in eachindex(notindices), j in i:length(notindices)
                idx, jdx = notindices[i], notindices[j]
                out_covar[2idx-1:2idx, 2jdx-1:2jdx] .= @view(VA′[2i-1:2i, 2j-1:2j])
                out_covar[2jdx-1:2jdx, 2idx-1:2idx] .= @view(VA′[2j-1:2j, 2i-1:2i])
            end
            expected_state = GaussianState(QuadPairBasis(nm), out_mean, out_covar)
            @test isapprox(M_qpair.state.covar, expected_state.covar, atol=1e-8)
            @test isapprox(M_qblock.state.covar, changebasis(QuadBlockBasis, expected_state).covar, atol=1e-8)
        
            sstatic = vacuumstate(SVector{2}, SMatrix{2,2}, QuadPairBasis(1))
            statestatic = sstatic ⊗ sstatic ⊗ sstatic ⊗ sstatic
            hstatic = homodyne(statestatic, [2], [π/4])
            @test (hstatic.state).mean isa SVector && (hstatic.state).covar isa SMatrix
            @test isequal(hstatic.state.mean[1:2], zeros(2))

            seed = 4242
            base_state = squeezedstate(QuadPairBasis(2), 0.3, π/4)
            base_state_block = changebasis(QuadBlockBasis, base_state)

            h1 = homodyne(MersenneTwister(seed), base_state, [1], [0.0]; squeeze)
            h2 = homodyne(MersenneTwister(seed), base_state, [1], [0.0]; squeeze)
            @test h1.result == h2.result
            @test h1.state == h2.state

            hb1 = homodyne(MersenneTwister(seed), base_state_block, [1], [0.0]; squeeze)
            hb2 = homodyne(MersenneTwister(seed), base_state_block, [1], [0.0]; squeeze)
            @test hb1.result == hb2.result
            @test hb1.state == hb2.state

            samples_kw = rand(Homodyne, base_state, [1], [π/2]; shots = 3, rng = MersenneTwister(seed), squeeze)
            samples_pos = rand(MersenneTwister(seed), Homodyne, base_state, [1], [π/2]; shots = 3, squeeze)
            @test samples_kw == samples_pos

            @test_throws ArgumentError rand(Homodyne, rs_qpair, collect(1:5), [0.0])
            @test_throws ArgumentError rand(Homodyne, rs_qblock, collect(1:5), [π/2])
        end
    end
end

@testitem "Throws" begin
    using Gabs
    using CairoMakie

    basis1 = QuadPairBasis(1)
    @testset "type throws" begin
        @test_throws DimensionMismatch GaussianState(basis1, [1.0, 2.0, 3.0], [3.0 4.0; 5.0 6.0])
        @test_throws DimensionMismatch GaussianChannel(basis1, [1.0, 2.0, 3.0], [3.0 4.0; 5.0 6.0], [3.0 4.0; 5.0 6.0])
        @test_throws DimensionMismatch GaussianChannel(basis1, [1.0, 2.0], [3.0 4.0; 5.0 6.0], [3.0 4.0 4.0; 5.0 6.0 4.0])
    end

    @testset "action throws" begin
        v = vacuumstate(basis1)
        ts = twosqueeze(2*basis1, rand(), rand())
        @test_throws DimensionMismatch ts * v
        @test_throws DimensionMismatch apply!(v, ts)
    end

    @testset "plot extension throws" begin
        ts = twosqueeze(2*basis1, rand(), rand())
        @test_throws ArgumentError Makie.heatmap(collect(-3.0:0.25:3.0), collect(-3.0:0.25:3.0), ts)
    end

    @testset "hbar throws" begin
        rs1, rs2 = randstate(basis1, ħ = 1), randstate(basis1)
        ru1, ru2 = randunitary(basis1, ħ = 1), randunitary(basis1)
        rc1, rc2 = randchannel(basis1, ħ = 1), randchannel(basis1)
        
        @test_throws ArgumentError ru2 * rs1
        @test_throws ArgumentError rc1 * rs2
        @test_throws ArgumentError apply!(rs1, ru2)
        @test_throws ArgumentError apply!(rs2, rc1)
        @test_throws ArgumentError rs1 ⊗ rs2
        @test_throws ArgumentError ru1 ⊗ ru2
        @test_throws ArgumentError rc1 ⊗ rc2
    end
end

"""
    williamson(state::GaussianState) -> Williamson

Compute the williamson decomposition of the `covar` field
of a `GaussianState` object and return a `Williamson` object.

A symplectic matrix `S` and symplectic spectrum `spectrum` can be obtained
via `F.S` and `F.spectrum`.

Iterating the decomposition produces the components `S` and `spectrum`.

To compute only the symplectic spectrum of a Gaussian state, call [`sympspectrum`](@ref).
"""
function williamson(x::GaussianState{<:QuadBlockBasis,M,V}) where {M,V}
    basis = x.basis
    return williamson(BlockForm(basis.nmodes), x.covar)
end
function williamson(x::GaussianState{<:QuadPairBasis,M,V}) where {M,V}
    basis = x.basis
    return williamson(PairForm(basis.nmodes), x.covar)
end

"""
    polar(state::GaussianUnitary) -> Polar

Compute the Polar decomposition of the `symplectic` field
of a `GaussianUnitary` object and return a `Polar` object.

`O` and `P` can be obtained from the factorization `F` via `F.O` and `F.P`, such that `S = O * P`.
For the symplectic polar decomposition case, `O` is an orthogonal symplectic matrix and `P` is a positive-definite
symmetric symplectic matrix.

Iterating the decomposition produces the components `O` and `P`.
"""
polar(x::GaussianUnitary{B,D,S}) where {B<:SymplecticBasis,D,S} = polar(x.symplectic)

"""
    blochmessiah(state::GaussianUnitary) -> BlochMessiah

Compute the Bloch-Messiah/Euler decomposition of the `symplectic` field
of a `GaussianUnitary` and return a `BlockMessiah` object.

The orthogonal symplectic matrices `O` and `Q` as well as the singular values `values` can be obtained
via `F.O`, `F.Q`, and `F.values`, respectively.

Iterating the decomposition produces the components `O`, `values`, and `Q`, in that order.
"""
function blochmessiah(x::GaussianUnitary{<:QuadBlockBasis,D,S}) where {D,S}
    basis = x.basis
    return blochmessiah(BlockForm(basis.nmodes), x.symplectic)
end
function blochmessiah(x::GaussianUnitary{<:QuadPairBasis,D,S}) where {D,S}
    basis = x.basis
    return blochmessiah(PairForm(basis.nmodes), x.symplectic)
end

Base.@propagate_inbounds function _promote_output_vector(::Type{T1}, ::Type{T2}, vec_out) where {T1,T2}
    T = promote_type(T1, T2)
    T <: Vector{Float64} ? vec_out : T(vec_out)
end
Base.@propagate_inbounds function _promote_output_vector(::Type{T}, vec_out, vec_length::Tl) where {T,Tl<:Int}
    T <: Vector{Float64} ? vec_out : T(vec_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{T1}, ::Type{T2}, mat_out) where {T1,T2}
    T = promote_type(T1, T2)
    T <: Matrix{Float64} ? mat_out : T(mat_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{T}, mat_out, out_dim::Td) where {T,Td<:Int}
    T <: Matrix{Float64} ? mat_out : T(mat_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{T}, mat_out, out_dim::Td) where {T,Td<:Tuple}
    T <: Matrix{Float64} ? mat_out : T(mat_out)
end

@testitem "Doctests" tags=[:doctests] begin
    using Documenter
    using Gabs
    using StaticArrays # Preload the extension before Documenter captures REPL output.

    DocMeta.setdocmeta!(Gabs, :DocTestSetup, :(using Gabs); recursive=true)
    doctest(Gabs)
end

"""
    catstate_even(basis::SymplecticBasis, α::Number; squeeze_params=nothing, ħ=2)

Create an even Schrödinger cat state `|cat+⟩ = (|α⟩ + |-α⟩)/√N` where `N` is the normalization constant.

The even cat state is a quantum superposition of two coherent states (or squeezed states) with 
opposite phases. The normalization accounts for the overlap between the two component states.

# Arguments
- `basis::SymplecticBasis`: The symplectic basis for the state
- `α::Number`: Complex amplitude of the coherent states
- `squeeze_params=nothing`: Optional tuple `(r, θ)` for squeezed cat states where `r` is the squeeze parameter and `θ` is the squeeze angle
- `ħ=2`: Reduced Planck constant

# Mathematical Description:
For coherent states: `|cat+⟩ = (|α⟩ + |-α⟩)/√(2(1 + exp(-2|α|²)))`
For squeezed states: The squeezed vacuum is first created, then displaced to `±α`.
"""
function catstate_even(basis::SymplecticBasis, α::Number; squeeze_params=nothing, ħ=2)
    if squeeze_params === nothing
        state_plus = coherentstate(basis, α, ħ=ħ)
        state_minus = coherentstate(basis, -α, ħ=ħ)
    else
        r, θ = squeeze_params
        squeezed_vac = squeezedstate(basis, r, θ, ħ=ħ) 
        displace_plus = displace(basis, α, ħ=ħ)
        displace_minus = displace(basis, -α, ħ=ħ)
        state_plus = displace_plus * squeezed_vac
        state_minus = displace_minus * squeezed_vac
    end
    overlap = exp(-2 * abs2(α))
    norm_factor = 1 / sqrt(2 * (1 + overlap))
    coeffs = [norm_factor, norm_factor]
    states = [state_plus, state_minus]
    return GaussianLinearCombination(basis, coeffs, states)
end

"""
    catstate_odd(basis::SymplecticBasis, α::Number; squeeze_params=nothing, ħ=2)

Create an odd Schrödinger cat state `|cat-⟩ = (|α⟩ - |-α⟩)/√N` where `N` is the normalization constant.

The odd cat state is a quantum superposition of two coherent states (or squeezed states) with 
opposite phases and a relative minus sign.

# Arguments
- `basis::SymplecticBasis`: The symplectic basis for the state
- `α::Number`: Complex amplitude of the coherent states
- `squeeze_params=nothing`: Optional tuple `(r, θ)` for squeezed cat states
- `ħ=2`: Reduced Planck constant

# Mathematical Description
For coherent states: `|cat-⟩ = (|α⟩ - |-α⟩)/√(2(1 - exp(-2|α|²)))`
"""
function catstate_odd(basis::SymplecticBasis, α::Number; squeeze_params=nothing, ħ=2)
    if squeeze_params === nothing
        state_plus = coherentstate(basis, α, ħ=ħ)
        state_minus = coherentstate(basis, -α, ħ=ħ)
    else
        r, θ = squeeze_params
        squeezed_vac = squeezedstate(basis, r, θ, ħ=ħ)  
        displace_plus = displace(basis, α, ħ=ħ)
        displace_minus = displace(basis, -α, ħ=ħ)
        state_plus = displace_plus * squeezed_vac
        state_minus = displace_minus * squeezed_vac
    end
    overlap = exp(-2 * abs2(α))
    norm_factor = 1 / sqrt(2 * (1 - overlap))
    coeffs = [norm_factor, -norm_factor]
    states = [state_plus, state_minus]
    return GaussianLinearCombination(basis, coeffs, states)
end

"""
    catstate(basis::SymplecticBasis, α::Number, phase::Real=0; squeeze_params=nothing, ħ=2)

Create a general Schrödinger cat state `|cat⟩ = (|α⟩ + e^(iφ)|-α⟩)/√N` where `φ` is the relative phase.

This is the most general form of cat state, which reduces to even `(φ=0)` or odd `(φ=π)` cat states
for specific phase values.

# Arguments
- `basis::SymplecticBasis`: The symplectic basis for the state
- `α::Number`: Complex amplitude of the coherent states
- `phase::Real=0`: Relative phase between the two coherent state components
- `squeeze_params=nothing`: Optional tuple `(r, θ)` for squeezed cat states
- `ħ=2`: Reduced Planck constant

# Mathematical Description
`|cat⟩ = (|α⟩ + e^(iφ)|-α⟩)/√(2(1 + Re(e^(iφ)exp(-2|α|²))))`
"""
function catstate(basis::SymplecticBasis, α::Number, phase::Real=0; squeeze_params=nothing, ħ=2)
    if squeeze_params === nothing
        state_plus = coherentstate(basis, α, ħ=ħ)
        state_minus = coherentstate(basis, -α, ħ=ħ)
    else
        r, θ = squeeze_params
        squeezed_vac = squeezedstate(basis, r, θ, ħ=ħ)  
        displace_plus = displace(basis, α, ħ=ħ)
        displace_minus = displace(basis, -α, ħ=ħ)
        state_plus = displace_plus * squeezed_vac
        state_minus = displace_minus * squeezed_vac
    end
    overlap = exp(-2 * abs2(α))
    phase_factor = exp(1im * phase)
    norm_factor = 1 / sqrt(2 * (1 + real(phase_factor * overlap)))
    coeffs = [norm_factor, norm_factor * phase_factor]
    if abs(phase - π) < 1e-14 || abs(phase) < 1e-14
        coeffs = real.(coeffs)
    end
    states = [state_plus, state_minus]
    return GaussianLinearCombination(basis, coeffs, states)
end

"""
    gkpstate(basis::SymplecticBasis; lattice=:square, delta=0.1, nmax=5, ħ=2)

Create a Gottesman-Kitaev-Preskill (GKP) state as a finite-energy approximation using squeezed states.

GKP states are quantum error-correcting codes that protect against small displacement errors.
They are constructed as superpositions of squeezed states positioned at lattice points in phase space.

# Arguments
- `basis::SymplecticBasis`: The symplectic basis for the state
- `lattice=:square`: Lattice type (:square or :hexagonal)
- `delta=0.1`: Squeezing parameter for finite energy approximation (smaller = more squeezed)
- `nmax=5`: Maximum lattice index for truncation (controls number of peaks)
- `ħ=2`: Reduced Planck constant

# Notes
- Very small `delta` values (< 1e-6) may cause numerical instability
- Large `nmax` values (> 50) create many states and may impact performance
- For square lattice: creates `2*nmax + 1` total states

# Mathematical Description
For square lattice: `|GKP⟩ = Σₖ |xₖ⟩` where `xₖ = √(2πħ) × k` for integer `k ∈ [-nmax, nmax]`
Each `|xₖ⟩` is approximated by a squeezed state with squeezing delta in the conjugate direction.
"""
function gkpstate(basis::SymplecticBasis; lattice="square", delta=0.1, nmax=5, ħ=2)
    if lattice == "square"
        return _square(basis, delta, nmax, ħ)
    elseif lattice == "hexagonal"
        return _hexagonal(basis, delta, nmax, ħ)
    else
        throw(ArgumentError("lattice must be \"square\" or \"hexagonal\", got \"$lattice\""))
    end
end

"""
    _square(basis::SymplecticBasis, delta, nmax, ħ)

Internal function to create square lattice GKP state.
"""
function _square(basis::SymplecticBasis, delta, nmax, ħ)
    if delta <= 0
        throw(ArgumentError("delta must be positive, got $delta"))
    end
    if nmax <= 0
        throw(ArgumentError("nmax must be positive, got $nmax"))
    end
    lattice_spacing = sqrt(2 * π * ħ)
    n_points = 2 * nmax + 1  
    states = Vector{GaussianState}(undef, n_points)
    coeffs = ones(Float64, n_points)
    squeezed_vac = squeezedstate(basis, delta, π/2, ħ=ħ)  
    for (i, k) in enumerate(-nmax:nmax)
        x_pos = k * lattice_spacing
        states[i] = displace(basis, x_pos, ħ=ħ) * squeezed_vac
    end
    lc = GaussianLinearCombination(basis, coeffs, states)
    norm_val = norm_factor(lc.states, lc.coeffs)
    lc.coeffs .= lc.coeffs .* norm_val
    return lc
end

"""
    _hexagonal(basis::SymplecticBasis, delta, nmax, ħ)

Internal function to create hexagonal lattice GKP state.
"""
function _hexagonal(basis::SymplecticBasis, delta, nmax, ħ)
    lattice_spacing = sqrt(2 * π * ħ / sqrt(3))
    total_points = 1 + 2 * nmax * (nmax + 1)
    states = Vector{GaussianState}(undef, total_points)
    coeffs = ones(Float64, total_points)  
    squeezed_vac = squeezedstate(basis, delta, 0.0, ħ=ħ)
    idx = 1
    for m in -nmax:nmax
        for n in -nmax:nmax
            if abs(m) + abs(n) > nmax
                continue
            end
            x_pos = lattice_spacing * (m + 0.5 * n)
            p_pos = lattice_spacing * (sqrt(3) / 2 * n)
            displacement = x_pos + 1im * p_pos
            states[idx] = displace(basis, displacement, ħ=ħ) * squeezed_vac
            idx += 1
        end
    end
    lc = GaussianLinearCombination(basis, coeffs, states)
    norm_val = norm_factor(lc.states, lc.coeffs)
    lc.coeffs .= lc.coeffs .* norm_val
    return lc
end

"""
    norm_factor(states::Vector{GaussianState}, coeffs::Vector{<:Number})

Calculate the normalization factor for a linear combination of Gaussian states.

This function computes the normalization constant needed to ensure `⟨ψ|ψ⟩ = 1` for a state
`|ψ⟩ = Σᵢ cᵢ|ψᵢ⟩` by calculating all overlap integrals between component states.

# Arguments
- `states::Vector{GaussianState}`: Vector of Gaussian states
- `coeffs::Vector{<:Number}`: Vector of coefficients

# Returns
- `Float64`: Normalization factor `N` such that the state `Σᵢ (cᵢ/N)|ψᵢ⟩` is normalized

# Notes
- Returns 1.0 if near-zero or negative normalization is detected (may indicate coefficient cancellation)
- Numerical instabilities can occur with very small coefficients or nearly orthogonal states

# Mathematical Description
`N² = Σᵢⱼ cᵢ* cⱼ ⟨ψᵢ|ψⱼ⟩`
"""
function norm_factor(states::Vector{<:GaussianState}, coeffs::Vector{<:Number})
    n = length(states)
    @assert length(coeffs) == n "Number of coefficients must match number of states"
    norm_squared = 0.0
    @inbounds for i in 1:n
        @inbounds for j in 1:n
            overlap = _overlap(states[i], states[j])
            norm_squared += real(conj(coeffs[i]) * coeffs[j] * overlap)
        end
    end
    if norm_squared <= 1e-15
        return 1.0
    end
    return 1.0 / sqrt(norm_squared)
end

"""
    _overlap(state1::GaussianState, state2::GaussianState)

Calculate the overlap `⟨ψ₁|ψ₂⟩` between two Gaussian states.

# Notes
- Returns 0.0 if numerical instabilities are encountered during calculation
- Handles edge cases like singular covariance matrices gracefully
"""
function _overlap(state1::GaussianState, state2::GaussianState)
    @assert state1.basis == state2.basis "States must have the same basis"
    @assert state1.ħ == state2.ħ "States must have the same ħ"
    if state1 === state2
        return ComplexF64(1.0)
    end
    if isapprox(state1.mean, state2.mean, atol=1e-12) && 
       isapprox(state1.covar, state2.covar, atol=1e-12)
        return ComplexF64(1.0)
    end
    μ1, μ2 = state1.mean, state2.mean
    V1, V2 = state1.covar, state2.covar
    Δμ = μ1 - μ2
    V_sum = V1 + V2
    try
        exp_factor = exp(-0.25 * dot(Δμ, V_sum \ Δμ))
        det_factor = sqrt(det(V1) * det(V2) / det(V_sum))
        overlap = exp_factor * det_factor
        return ComplexF64(overlap)
    catch e
        return ComplexF64(0.0)
    end
end

"""
    catstate_even(basis::SymplecticBasis, αs::AbstractVector; squeeze_params=nothing, ħ=2)

Create multi-mode even cat states as tensor products of single-mode cat states.

# Arguments
- `basis::SymplecticBasis`: The symplectic basis for the multi-mode system
- `αs::AbstractVector`: Vector of complex amplitudes for each mode
- `squeeze_params=nothing`: Optional vector of tuples `(r, θ)` for each mode
- `ħ=2`: Reduced Planck constant
"""
function catstate_even(basis::SymplecticBasis, αs::AbstractVector; squeeze_params=nothing, ħ=2)
    nmodes = basis.nmodes
    @assert length(αs) == nmodes "Number of amplitudes must match number of modes"
    if squeeze_params !== nothing
        @assert length(squeeze_params) == nmodes "Number of squeeze parameters must match number of modes"
    end
    single_mode_basis = typeof(basis)(1)
    cat_states = Vector{GaussianLinearCombination}(undef, nmodes)  
    @inbounds for i in 1:nmodes  
        α = αs[i]
        squeeze_param = squeeze_params === nothing ? nothing : squeeze_params[i]
        cat = catstate_even(single_mode_basis, α, squeeze_params=squeeze_param, ħ=ħ)
        cat_states[i] = cat  
    end
    result = cat_states[1]
    @inbounds for i in 2:nmodes  
        result = tensor(result, cat_states[i])
    end
    return result
end

"""
    catstate_odd(basis::SymplecticBasis, αs::AbstractVector; squeeze_params=nothing, ħ=2)

Create multi-mode odd cat states as tensor products of single-mode cat states.
"""
function catstate_odd(basis::SymplecticBasis, αs::AbstractVector; squeeze_params=nothing, ħ=2)
    nmodes = basis.nmodes
    @assert length(αs) == nmodes "Number of amplitudes must match number of modes"
    if squeeze_params !== nothing
        @assert length(squeeze_params) == nmodes "Number of squeeze parameters must match number of modes"
    end
    single_mode_basis = typeof(basis)(1)
    cat_states = Vector{GaussianLinearCombination}(undef, nmodes)  
    @inbounds for i in 1:nmodes  
        α = αs[i]
        squeeze_param = squeeze_params === nothing ? nothing : squeeze_params[i]
        cat = catstate_even(single_mode_basis, α, squeeze_params=squeeze_param, ħ=ħ)
        cat_states[i] = cat  
    end
    result = cat_states[1]
    @inbounds for i in 2:nmodes  
        result = tensor(result, cat_states[i])
    end
    return result
end

"""
    catstate(basis::SymplecticBasis, αs::AbstractVector, phases::AbstractVector=zeros(length(αs)); squeeze_params=nothing, ħ=2)

Create multi-mode general cat states as tensor products of single-mode cat states.
"""
function catstate(basis::SymplecticBasis, αs::AbstractVector, phases::AbstractVector=zeros(length(αs)); squeeze_params=nothing, ħ=2)
    nmodes = basis.nmodes
    @assert length(αs) == nmodes "Number of amplitudes must match number of modes"
    @assert length(phases) == nmodes "Number of phases must match number of modes"
    if squeeze_params !== nothing
        @assert length(squeeze_params) == nmodes "Number of squeeze parameters must match number of modes"
    end
    single_mode_basis = typeof(basis)(1)
    cat_states = Vector{GaussianLinearCombination}(undef, nmodes)  
    @inbounds for i in 1:nmodes  
        α = αs[i]
        squeeze_param = squeeze_params === nothing ? nothing : squeeze_params[i]
        cat = catstate_even(single_mode_basis, α, squeeze_params=squeeze_param, ħ=ħ)
        cat_states[i] = cat  
    end
    result = cat_states[1]
    @inbounds for i in 2:nmodes  
        result = tensor(result, cat_states[i])
    end
    return result
end

@testitem "Symbolic Unitaries" begin
    using Gabs
    using Symbolics
    using StaticArrays
    using LinearAlgebra: det

    nmodes = rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)

    for (name, op_func, factor) in [("squeeze", squeeze, 1), ("two-mode squeeze", twosqueeze, 2)]
        @testset "Symbolic $name operator" begin
            @variables r theta
            op_pair = op_func(factor * qpairbasis, r, theta)
            op_block = op_func(factor * qblockbasis, r, theta)
            @test op_pair isa GaussianUnitary && op_block isa GaussianUnitary
            @test op_func(Array, factor * qpairbasis, r, theta) isa GaussianUnitary
            @test op_func(SVector{factor * 2 * nmodes}, SMatrix{factor * 2 * nmodes, factor * 2 * nmodes}, factor * qpairbasis, r, theta) isa GaussianUnitary
            @test isequal(op_func(factor * qblockbasis, r, theta).disp, changebasis(QuadBlockBasis, op_pair).disp)
            @test isequal(op_func(factor * qblockbasis, r, theta).symplectic, changebasis(QuadBlockBasis, op_pair).symplectic)
            @variables rs[1:nmodes] thetas[1:nmodes]
            rs_vec = collect(rs)
            thetas_vec = collect(thetas)
            op_pair_arr = op_func(factor * qpairbasis, rs_vec, thetas_vec)
            op_block_arr = op_func(factor * qblockbasis, rs_vec, thetas_vec)
            @test op_pair_arr isa GaussianUnitary && op_block_arr isa GaussianUnitary
            @test op_func(Array, factor * qpairbasis, rs_vec, thetas_vec) isa GaussianUnitary
            @test op_func(SVector{factor * 2 * nmodes}, SMatrix{factor * 2 * nmodes, factor * 2 * nmodes}, factor * qpairbasis, rs_vec, thetas_vec) isa GaussianUnitary
            @test isequal(op_func(factor * qblockbasis, rs_vec, thetas_vec).disp, changebasis(QuadBlockBasis, op_pair_arr).disp)
            @test isequal(op_func(factor * qblockbasis, rs_vec, thetas_vec).symplectic, changebasis(QuadBlockBasis, op_pair_arr).symplectic)
        end
    end

    for (name, op_func, factor) in [("phase-shift", phaseshift, 1), ("beamsplitter", beamsplitter, 2),("displace", displace, 1)]
        @testset "Symbolic $name operator" begin
            @variables theta
            op = op_func(factor * qpairbasis, theta)
            @test op isa GaussianUnitary
            @test op_func(Array, factor * qpairbasis, theta) isa GaussianUnitary
            @test op_func(SVector{factor * 2 * nmodes}, SMatrix{factor * 2 * nmodes, factor * 2 * nmodes}, factor * qpairbasis, theta) isa GaussianUnitary
            @test isequal(op_func(factor * qblockbasis, theta).disp, changebasis(QuadBlockBasis, op).disp)
            @test isequal(op_func(factor * qblockbasis, theta).symplectic, changebasis(QuadBlockBasis, op).symplectic)
            @variables thetas[1:nmodes]
            thetas_vec = collect(thetas)
            op_arr = op_func(factor * qpairbasis, thetas_vec)
            op_block_arr = op_func(factor * qblockbasis, thetas_vec)
            @test op_arr isa GaussianUnitary && op_block_arr isa GaussianUnitary
            @test op_func(Array, factor * qpairbasis, thetas_vec) isa GaussianUnitary
            @test op_func(SVector{factor * 2 * nmodes}, SMatrix{factor * 2 * nmodes, factor * 2 * nmodes}, factor * qpairbasis, thetas_vec) isa GaussianUnitary
            @test isequal(op_func(factor * qblockbasis, thetas_vec).disp, changebasis(QuadBlockBasis, op_arr).disp)
            @test isequal(op_func(factor * qblockbasis, thetas_vec).symplectic, changebasis(QuadBlockBasis, op_arr).symplectic)
        end
    end

    @testset "Symbolic Tensor Products" begin
        @variables alpha1 alpha2
        d1, d2 = displace(qpairbasis, alpha1), displace(qpairbasis, alpha2)
        ds = tensor(d1, d2)
        @test ds isa GaussianUnitary
        @test isequal(ds.disp, (d1 ⊗ d2).disp)
        @test isequal(ds.symplectic, (d1 ⊗ d2).symplectic)
        @test_throws TypeError isapprox(ds, d1 ⊗ d2, atol = 1e-10)  # due to equality checks for Num type in Symbolics.jl
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes, 4*nmodes}, d1, d2) isa GaussianUnitary
        @variables theta
        p = phaseshift(qpairbasis, theta)
        @test isequal(tensor(p, tensor(d1, d2)).disp, (p ⊗ d1 ⊗ d2).disp)
        @test isequal(tensor(p, tensor(d1, d2)).symplectic, (p ⊗ d1 ⊗ d2).symplectic)
        p_block = phaseshift(qblockbasis, theta)
        @variables thetas[1:2*nmodes]
        p_blocks = phaseshift(2 * qblockbasis, collect(thetas))
        @test isequal((p_block ⊗ p_block).disp, p_blocks.disp)
        @test isequal(simplify((p_block ⊗ p_block).symplectic), simplify(substitute(p_blocks.symplectic, Dict(thetas[i] => theta for i in eachindex(thetas)))))
    end

    @testset "Symbolic actions" begin
        @variables α1 α2 r theta r1 theta1
        d = displace(qpairbasis, α1)
        v = vacuumstate(qpairbasis)
        s = squeezedstate(qpairbasis, r, theta)
        c = coherentstate(qpairbasis,α1)
        @test isequal((d * v).mean, c.mean)
        @test isequal((d * v).covar, c.covar)
        @test_broken isequal(apply!(v, d).mean, c.mean)
        @test_broken isequal(apply!(v, d).covar, c.covar)
        @test isequal(apply!(s, d).mean, c.mean)
        d1, d2 = displace(qpairbasis, α1), displace(qpairbasis, α2)
        v1, v2 = vacuumstate(qpairbasis), vacuumstate(qpairbasis)
        s1, s2 = squeezedstate(qpairbasis, r, theta), squeezedstate(qpairbasis, r1, theta1)
        c1, c2 = coherentstate(qpairbasis, α1), coherentstate(qpairbasis, α2)
        @test_throws TypeError simplify(d1 * v1) ≈ simplify(c1) # due to equality checks for Num type in Symbolics.jl
        @test isequal(simplify(d1 * v1).mean, simplify(c1).mean)
        @test isequal(simplify(d1 * v1).covar, simplify(c1).covar)
        @test isequal(apply!(s1, d1).mean, simplify(c1).mean)
        @test isequal(apply!(s2, d1).mean, simplify(c1).mean)
    end
end

using Revise # for interactive work on docs
push!(LOAD_PATH,"../src/")

using Documenter
using DocumenterCitations
using Gabs
using QuantumInterface
import Latexify: latexify
using Symbolics

DocMeta.setdocmeta!(Gabs, :DocTestSetup, :(using Gabs, QuantumInterface); recursive=true)

function main()
    bib = CitationBibliography(joinpath(@__DIR__,"src/references.bib"), style=:authoryear)

    makedocs(
    plugins=[bib],
    doctest = false,
    clean = true,
    sitename = "Gabs.jl",
    format = Documenter.HTML(
        assets=["assets/init.js"],
        canonical = "https://apkille.github.io/Gabs.jl"
    ),
    modules = [Gabs, QuantumInterface],
    checkdocs = :exports,
    warnonly = false,
    authors = "Andrew Kille",
    pages = [
        "Gabs.jl" => "index.md",
        "Getting Started with Gabs" => "intro.md",
        "Manual" => "manual.md",
        "Tutorials" => "tutorials.md",
        "Gaussian Zoos" => "zoos.md",
        "API" => "API.md",
        "Suggested Readings and References" => "bibliography.md"
    ]
    )

    deploydocs(
        repo = "github.com/QuantumSavory/Gabs.jl.git",
        push_preview = true,
    )
end

main()

##
# Predefined Gaussian states
##

"""
    vacuumstate([Tm=Vector{Float64}, Tc=Matrix{Float64}], basis::SymplecticBasis)

Gaussian state with zero photons, known as the vacuum state. The symplectic representation is defined by `basis`.

## Mathematical description of a vacuum state

A vacuum state `|0⟩` is characterized by the zero mean vector and covariance
matrix `(ħ/2)I`.

## Example

```jldoctest
julia> vacuumstate(QuadPairBasis(1))
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 0.0
 0.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
"""
function vacuumstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}; ħ = 2) where {Tm,Tc,N<:Int}
    mean, covar = _vacuumstate(basis; ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar); ħ = ħ)
end
vacuumstate(::Type{T}, basis::SymplecticBasis{N}; ħ = 2) where {T,N<:Int} = vacuumstate(T, T, basis; ħ = ħ)
function vacuumstate(basis::SymplecticBasis{N}; ħ = 2) where {N<:Int}
    mean, covar = _vacuumstate(basis; ħ = ħ)
    return GaussianState(basis, mean, covar; ħ = ħ)
end
function _vacuumstate(basis::SymplecticBasis{N}; ħ = 2) where {N<:Int}
    nmodes = basis.nmodes
    mean = zeros(2*nmodes)
    covar = Matrix{Float64}((ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end

"""
    thermalstate([Tm=Vector{Float64}, Tc=Matrix{Float64},] basis::SymplecticBasis, photons<:Int)

Gaussian state at thermal equilibrium, known as the thermal state. The symplectic representation
is defined by `basis`. The mean photon number of the state is given by `photons`.

## Mathematical description of a thermal state

A thermal state `|n̄⟩`, where `n̄` is the mean number of photons,
is characterized by the zero mean vector and covariance
matrix `ħ(n̄+1/2)I`.

## Example

```jldoctest
julia> thermalstate(QuadPairBasis(1), 4)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 0.0
 0.0
covariance: 2×2 Matrix{Float64}:
 9.0  0.0
 0.0  9.0
```
"""
function thermalstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}, photons::P; ħ = 2) where {Tm,Tc,N<:Int,P}
    mean, covar = _thermalstate(basis, photons; ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar); ħ = ħ)
end
thermalstate(::Type{T}, basis::SymplecticBasis{N}, photons::P; ħ = 2) where {T,N<:Int,P} = thermalstate(T, T, basis, photons; ħ = ħ)
function thermalstate(basis::SymplecticBasis{N}, photons::P; ħ = 2) where {N<:Int,P}
    mean, covar = _thermalstate(basis, photons; ħ = ħ)
    return GaussianState(basis, mean, covar; ħ = ħ)
end
function _thermalstate(basis::Union{QuadPairBasis{N},QuadBlockBasis{N}}, photons::P; ħ = 2) where {N<:Int,P<:Number}
    nmodes = basis.nmodes
    Rt = float(eltype(P))
    mean = zeros(Rt, 2*nmodes)
    covar = Matrix{Rt}((2 * photons + 1) * (ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end
function _thermalstate(basis::QuadPairBasis{N}, photons::P; ħ = 2) where {N<:Int,P<:Vector}
    nmodes = basis.nmodes
    Rt = float(eltype(P))
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        val = (2 * photons[i] + 1) * (ħ/2)
        covar[2*i-1, 2*i-1] = val
        covar[2*i, 2*i] = val
    end
    return mean, covar
end
function _thermalstate(basis::QuadBlockBasis{N}, photons::P; ħ = 2) where {N<:Int,P<:Vector}
    nmodes = basis.nmodes
    Rt = float(eltype(P))
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        val = (2 * photons[i] + 1) * (ħ/2)
        covar[i, i] = val
        covar[i+nmodes, i+nmodes] = val
    end
    return mean, covar
end

"""
    coherentstate([Tm=Vector{Float64}, Tc=Matrix{Float64},] basis::SymplecticBasis, alpha<:Number)

Gaussian state that is the quantum analogue of a monochromatic electromagnetic field, known
as the coherent state. The symplectic representation is defined by `basis`.
The complex amplitude of the state is given by `alpha`.

## Mathematical description of a coherent state

A coherent state `|α⟩`, where `α` is the complex amplitude,
is characterized by the mean vector `√2ħ [real(α), imag(α)]` and covariance
matrix `(ħ/2)I`.

## Example

```jldoctest
julia> coherentstate(QuadPairBasis(1), 1.0+im)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 2.0
 2.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
"""
function coherentstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {Tm,Tc,N<:Int,A}
    mean, covar = _coherentstate(basis, alpha; ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar); ħ = ħ)
end
coherentstate(::Type{T}, basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {T,N<:Int,A} = coherentstate(T, T, basis, alpha; ħ = ħ)
function coherentstate(basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {N<:Int,A}
    mean, covar = _coherentstate(basis, alpha; ħ = ħ)
    return GaussianState(basis, mean, covar; ħ = ħ)
end
function _coherentstate(basis::QuadPairBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Number}
    nmodes = basis.nmodes
    mean = repeat([sqrt(2*ħ) * real(alpha), sqrt(2*ħ) * imag(alpha)], nmodes)
    covar = Matrix{real(A)}((ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end
function _coherentstate(basis::QuadPairBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Vector}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    mean = sqrt(2*ħ) * reinterpret(Rt, alpha)
    covar = Matrix{Rt}((ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end
function _coherentstate(basis::QuadBlockBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Number}
    nmodes = basis.nmodes
    mean = repeat([sqrt(2*ħ) * real(alpha), sqrt(2*ħ) * imag(alpha)], inner = nmodes)
    covar = Matrix{real(A)}((ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end
function _coherentstate(basis::QuadBlockBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Vector}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    re = reinterpret(Rt, alpha)
    mean = vcat(@view(re[1:2:end]), @view(re[2:2:end]))
    mean .*= sqrt(2*ħ)
    covar = Matrix{Rt}((ħ/2) * I, 2*nmodes, 2*nmodes)
    return mean, covar
end

"""
    squeezedstate([Tm=Vector{Float64}, Tc=Matrix{Float64},] basis::SymplecticBasis, r<:Real, theta<:Real)

Gaussian state with quantum uncertainty in its phase and amplitude, known as
the squeezed state. The symplectic representation is defined by `basis`. The amplitude and phase squeezing parameters are given by `r`
and `theta`, respectively.

## Mathematical description of a squeezed state

A squeezed state `|r, θ⟩`, where `r` is the amplitude squeezing
parameter and `θ` is the phase squeezing parameter,
is characterized by the zero mean vector and covariance
matrix `(ħ/2) (cosh(2r)I - sinh(2r)R(θ))`, where `R(θ)` is the rotation matrix.

## Example

```jldoctest
julia> squeezedstate(QuadPairBasis(1), 0.5, pi/4)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 0.0
 0.0
covariance: 2×2 Matrix{Float64}:
  0.712088  -0.830993
 -0.830993   2.37407
```
"""
function squeezedstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {Tm,Tc,N<:Int,R}
    mean, covar = _squeezedstate(basis, r, theta; ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar); ħ = ħ)
end
squeezedstate(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {T,N<:Int,R} = squeezedstate(T, T, basis, r, theta; ħ = ħ)
function squeezedstate(basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R}
    mean, covar = _squeezedstate(basis, r, theta; ħ = ħ)
    return GaussianState(basis, mean, covar; ħ = ħ)
end
function _squeezedstate(basis::QuadPairBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    mean = zeros(R, 2*nmodes)
    covar = zeros(R, 2*nmodes, 2*nmodes)
    cr, sr = cosh(2*r), sinh(2*r)
    ct, st = cos(theta), sin(theta)
    @inbounds for i in Base.OneTo(nmodes)
        covar[2*i-1, 2*i-1] = (ħ/2) * (cr - sr*ct)
        covar[2*i-1, 2*i] = -(ħ/2) * sr * st
        covar[2*i, 2*i-1] = -(ħ/2) * sr * st
        covar[2*i, 2*i] = (ħ/2) * (cr + sr*ct)
    end
    return mean, covar
end
function _squeezedstate(basis::QuadPairBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(2*r[i]), sinh(2*r[i])
        ct, st = cos(theta[i]), sin(theta[i])
        covar[2*i-1, 2*i-1] = (ħ/2) * (cr - sr*ct)
        covar[2*i-1, 2*i] = -(ħ/2) * sr * st
        covar[2*i, 2*i-1] = -(ħ/2) * sr * st
        covar[2*i, 2*i] = (ħ/2) * (cr + sr*ct)
    end
    return mean, covar
end
function _squeezedstate(basis::QuadBlockBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    mean = zeros(R, 2*nmodes)
    covar = zeros(R, 2*nmodes, 2*nmodes)
    cr, sr = cosh(2*r), sinh(2*r)
    ct, st = cos(theta), sin(theta)
    @inbounds for i in Base.OneTo(nmodes)
        covar[i, i] = (ħ/2) * (cr - sr*ct)
        covar[i, i+nmodes] = -(ħ/2) * sr * st
        covar[i+nmodes, i] = -(ħ/2) * sr * st
        covar[i+nmodes, i+nmodes] = (ħ/2) * (cr + sr*ct)
    end
    return mean, covar
end
function _squeezedstate(basis::QuadBlockBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(2*r[i]), sinh(2*r[i])
        ct, st = cos(theta[i]), sin(theta[i])
        covar[i, i] = (ħ/2) * (cr - sr*ct)
        covar[i, i+nmodes] = -(ħ/2) * sr * st
        covar[i+nmodes, i] = -(ħ/2) * sr * st
        covar[i+nmodes, i+nmodes] = (ħ/2) * (cr + sr*ct)
    end
    return mean, covar
end

"""
    eprstate([Tm=Vector{Float64}, Tc=Matrix{Float64},] basis::SymplecticBasis, r<:Real, theta<:Real)

Gaussian state that is a two-mode squeezed state, known as the Einstein-Podolski-Rosen (EPR) state. The symplectic
representation is defined by `basis`. The amplitude and phase squeezing parameters are given by `r` and `theta`, respectively.

## Mathematical description of an EPR state

An EPR state `|r, θ⟩ₑₚᵣ`, where `r` is the amplitude squeezing
parameter and `θ` is the phase squeezing parameter,
is characterized by the zero mean vector and covariance
matrix `(ħ/2)[cosh(2r)I -sinh(2r)R(θ); -sinh(2r)R(θ) cosh(2r)I]`, 
where `R(θ)` is the rotation matrix.

## Example

```jldoctest
julia> eprstate(QuadPairBasis(2), 0.5, pi/4)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
  1.54308    0.0       -0.830993  -0.830993
  0.0        1.54308   -0.830993   0.830993
 -0.830993  -0.830993   1.54308    0.0
 -0.830993   0.830993   0.0        1.54308
```
"""
function eprstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {Tm,Tc,N<:Int,R}
    mean, covar = _eprstate(basis, r, theta; ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar); ħ = ħ)
end
eprstate(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {T,N<:Int,R} = eprstate(T, T, basis, r, theta; ħ = ħ)
function eprstate(basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R}
    mean, covar = _eprstate(basis, r, theta; ħ = ħ)
    return GaussianState(basis, mean, covar; ħ = ħ)
end
function _eprstate(basis::QuadPairBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    mean = zeros(R, 2*nmodes)
    cr, sr = (ħ/2)*cosh(2*r), (ħ/2)*sinh(2*r)
    ct, st = cos(theta), sin(theta)
    covar = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        covar[4*i-3, 4*i-3] = cr
        covar[4*i-3, 4*i-1] = -sr * ct
        covar[4*i-3, 4*i] = -sr * st

        covar[4*i-2, 4*i-2] = cr
        covar[4*i-2, 4*i-1] = -sr * st
        covar[4*i-2, 4*i] = sr * ct

        covar[4*i-1, 4*i-3] = -sr * ct
        covar[4*i-1, 4*i-2] = -sr * st
        covar[4*i-1, 4*i-1] = cr

        covar[4*i, 4*i-3] = -sr * st
        covar[4*i, 4*i-2] = sr * ct
        covar[4*i, 4*i] = cr
    end
    return mean, covar
end
function _eprstate(basis::QuadPairBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        cr, sr = (ħ/2)*cosh(2*r[i]), (ħ/2)*sinh(2*r[i])
        ct, st = cos(theta[i]), sin(theta[i])

        covar[4*i-3, 4*i-3] = cr
        covar[4*i-3, 4*i-1] = -sr * ct
        covar[4*i-3, 4*i] = -sr * st

        covar[4*i-2, 4*i-2] = cr
        covar[4*i-2, 4*i-1] = -sr * st
        covar[4*i-2, 4*i] = sr * ct

        covar[4*i-1, 4*i-3] = -sr * ct
        covar[4*i-1, 4*i-2] = -sr * st
        covar[4*i-1, 4*i-1] = cr

        covar[4*i, 4*i-3] = -sr * st
        covar[4*i, 4*i-2] = sr * ct
        covar[4*i, 4*i] = cr
    end
    return mean, covar
end
function _eprstate(basis::QuadBlockBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    mean = zeros(R, 2*nmodes)
    cr, sr = (ħ/2)*cosh(2*r), (ħ/2)*sinh(2*r)
    ct, st = cos(theta), sin(theta)
    covar = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        covar[2*i-1, 2*i-1] = cr
        covar[2*i-1, 2*i] = -sr * ct
        covar[2*i, 2*i-1] = -sr * ct
        covar[2*i, 2*i] = cr

        covar[2*i-1, 2*i+nmodes] = -sr * st
        covar[2*i, 2*i+nmodes-1] = -sr * st

        covar[2*i+nmodes-1, 2*i+nmodes-1] = cr
        covar[2*i+nmodes-1, 2*i+nmodes] = sr * ct
        covar[2*i+nmodes, 2*i+nmodes-1] = sr * ct
        covar[2*i+nmodes, 2*i+nmodes] = cr

        covar[2*i+nmodes-1, 2*i] = -sr * st
        covar[2*i+nmodes, 2*i-1] = -sr * st
    end
    return mean, covar
end
function _eprstate(basis::QuadBlockBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    mean = zeros(Rt, 2*nmodes)
    covar = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        cr, sr = (ħ/2)*cosh(2*r[i]), (ħ/2)*sinh(2*r[i])
        ct, st = cos(theta[i]), sin(theta[i])

        covar[2*i-1, 2*i-1] = cr
        covar[2*i-1, 2*i] = -sr * ct
        covar[2*i, 2*i-1] = -sr * ct
        covar[2*i, 2*i] = cr

        covar[2*i-1, 2*i+nmodes] = -sr * st
        covar[2*i, 2*i+nmodes-1] = -sr * st

        covar[2*i+nmodes-1, 2*i+nmodes-1] = cr
        covar[2*i+nmodes-1, 2*i+nmodes] = sr * ct
        covar[2*i+nmodes, 2*i+nmodes-1] = sr * ct
        covar[2*i+nmodes, 2*i+nmodes] = cr

        covar[2*i+nmodes-1, 2*i] = -sr * st
        covar[2*i+nmodes, 2*i-1] = -sr * st
    end
    return mean, covar
end

##
# Operations on Gaussian states
##

"""
    tensor(state1::GaussianState, state2::GaussianState)

tensor product of Gaussian states, which can also be called with `⊗`.

## Example
```jldoctest
julia> basis = QuadPairBasis(1);

julia> coherentstate(basis, 1.0+im) ⊗ thermalstate(basis, 2)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
 2.0
 2.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  5.0  0.0
 0.0  0.0  0.0  5.0
```
"""
function tensor(::Type{Tm}, ::Type{Tc}, state1::GaussianState, state2::GaussianState) where {Tm,Tc}
    typeof(state1.basis) == typeof(state2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    mean, covar = _tensor(state1, state2)
    return GaussianState(state1.basis ⊕ state2.basis, Tm(mean), Tc(covar); ħ = state1.ħ)
end
tensor(::Type{T}, state1::GaussianState, state2::GaussianState) where {T} = tensor(T, T, state1, state2)
function tensor(state1::GaussianState, state2::GaussianState)
    typeof(state1.basis) == typeof(state2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    mean, covar = _tensor(state1, state2)
    return GaussianState(state1.basis ⊕ state2.basis, mean, covar; ħ = state1.ħ)
end
function _tensor(state1::GaussianState{B1,M1,V1}, state2::GaussianState{B2,M2,V2}) where {B1<:QuadPairBasis,B2<:QuadPairBasis,M1,M2,V1,V2}
    mean1, mean2 = state1.mean, state2.mean
    Mt = promote_type(eltype(mean1), eltype(mean2))
    basis1, basis2 = state1.basis, state2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(2*nmodes1), Base.OneTo(2*nmodes2)
    # initialize direct sum of mean vectors
    mean′ = zeros(Mt, 2*nmodes)
    @inbounds for i in block1
        mean′[i] = mean1[i]
    end
    @inbounds for i in block2
        mean′[i+2*nmodes1] = mean2[i]
    end
    # initialize direct sum of covariance matrices
    covar1, covar2 = state1.covar, state2.covar
    Vt = promote_type(eltype(covar1), eltype(covar2))
    covar′ = zeros(Vt, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        covar′[i,j] = covar1[i,j]
    end
    @inbounds for i in block2, j in block2
        covar′[i+2*nmodes1,j+2*nmodes1] = covar2[i,j]
    end
    # extract output array types
    mean′′ = _promote_output_vector(typeof(mean1), typeof(mean2), mean′)
    covar′′ = _promote_output_matrix(typeof(covar1), typeof(covar2), covar′)
    return mean′′, covar′′
end
function _tensor(state1::GaussianState{B1,M1,V1}, state2::GaussianState{B2,M2,V2}) where {B1<:QuadBlockBasis,B2<:QuadBlockBasis,M1,M2,V1,V2}
    mean1, mean2 = state1.mean, state2.mean
    Mt = promote_type(eltype(mean1), eltype(mean2))
    basis1, basis2 = state1.basis, state2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(nmodes1), Base.OneTo(nmodes2)
    # initialize direct sum of mean vectors
    mean1, mean2 = state1.mean, state2.mean
    mean′ = zeros(Mt, 2*nmodes)
    @inbounds for i in block1
        mean′[i] = mean1[i]
        mean′[i+nmodes] = mean1[i+nmodes1]
    end
    @inbounds for i in block2
        mean′[i+nmodes1] = mean2[i]
        mean′[i+nmodes+nmodes1] = mean2[i+nmodes2]
    end
    # initialize direct sum of covariance matrices
    covar1, covar2 = state1.covar, state2.covar
    Vt = promote_type(eltype(covar1), eltype(covar2))
    covar′ = zeros(Vt, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        covar′[i,j] = covar1[i,j]
        covar′[i,j+nmodes] = covar1[i,j+nmodes1]
        covar′[i+nmodes,j] = covar1[i+nmodes1,j]
        covar′[i+nmodes,j+nmodes] = covar1[i+nmodes1,j+nmodes1]
    end
    @inbounds for i in block2, j in block2
        covar′[i+nmodes1,j+nmodes1] = covar2[i,j]
        covar′[i+nmodes1,j+nmodes+nmodes1] = covar2[i,j+nmodes2]
        covar′[i+nmodes+nmodes1,j+nmodes1] = covar2[i+nmodes2,j]
        covar′[i+nmodes+nmodes1,j+nmodes+nmodes1] = covar2[i+nmodes2,j+nmodes2]
    end
    # extract output array types
    mean′′ = _promote_output_vector(typeof(mean1), typeof(mean2), mean′)
    covar′′ = _promote_output_matrix(typeof(covar1), typeof(covar2), covar′)
    return mean′′, covar′′
end

"""
    ptrace([Tm=Vector{Float64}, Tc=Matrix{Float64},] state::GaussianState, idx<:Int)
    ptrace([Tm=Vector{Float64}, Tc=Matrix{Float64},] state::GaussianState, indices<:AbstractVector)

Partial trace of a Gaussian state over a subsystem indicated by `idx`, or multiple subsystems
indicated by `indices`.

## Example
```jldoctest
julia> basis = QuadPairBasis(1);

julia> state = coherentstate(basis, 1.0+im) ⊗ thermalstate(basis, 2) ⊗ squeezedstate(basis, 3.0, pi/4);

julia> ptrace(state, 2)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
 2.0
 2.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
 1.0  0.0     0.0        0.0
 0.0  1.0     0.0        0.0
 0.0  0.0    59.0829  -142.633
 0.0  0.0  -142.633    344.348

julia> ptrace(state, [1, 3])
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
 0.0
 0.0
covariance: 2×2 Matrix{Float64}:
 5.0  0.0
 0.0  5.0
```
"""
function ptrace(::Type{Tm}, ::Type{Tc}, state::GaussianState, indices::N) where {Tm,Tc,N}
    basis = state.basis
    mean, covar = _ptrace(state, indices)
    return GaussianState(typeof(basis)(basis.nmodes - length(indices)), Tm(mean), Tc(covar); ħ = state.ħ)
end
ptrace(::Type{T}, state::GaussianState, indices::N) where {T,N} = ptrace(T, T, state, indices)
function ptrace(state::GaussianState, indices::T) where {T}
    basis = state.basis
    mean, covar = _ptrace(state, indices)
    return GaussianState(typeof(basis)(basis.nmodes - length(indices)), mean, covar; ħ = state.ħ)
end
function _ptrace(state::GaussianState{B,M,V}, indices::T) where {B<:QuadPairBasis,M,V,T}
    basis, mean, covar = state.basis, state.mean, state.covar
    length(indices) < basis.nmodes || throw(ArgumentError(INDEX_ERROR))
    notindices = setdiff(1:basis.nmodes, indices)
    notidxlength = length(notindices)
    # initialize partial trace of mean vector
    mean′ = zeros(eltype(mean), 2*notidxlength)
    @inbounds for i in eachindex(notindices)
        idx = notindices[i]
        mean′[2*i-1] = mean[2*idx-1]
        mean′[2*i] = mean[2*idx]
    end
    # initialize partial trace of covariance matrix
    covar′ = zeros(eltype(covar), 2*notidxlength, 2*notidxlength)
    @inbounds for i in eachindex(notindices)
        idx = notindices[i]
        @inbounds for j in i:notidxlength
            otheridx = notindices[j]
            covar′[2*i-1, 2*j-1] = covar[2*idx-1, 2*otheridx-1]
            covar′[2*i-1, 2*j] = covar[2*idx-1, 2*otheridx]
            covar′[2*i, 2*j-1] = covar[2*idx, 2*otheridx-1]
            covar′[2*i, 2*j] = covar[2*idx, 2*otheridx]
            covar′[2*j-1, 2*i-1] = covar[2*otheridx-1, 2*idx-1]
            covar′[2*j-1, 2*i] = covar[2*otheridx-1, 2*idx]
            covar′[2*j, 2*i-1] = covar[2*otheridx, 2*idx-1]
            covar′[2*j, 2*i] = covar[2*otheridx, 2*idx]
        end
    end 
    mean′′ = _promote_output_vector(typeof(mean), mean′, 2*notidxlength)
    covar′′ = _promote_output_matrix(typeof(covar), covar′, 2*notidxlength)
    return mean′′, covar′′
end
function _ptrace(state::GaussianState{B,M,V}, indices::T) where {B<:QuadBlockBasis,M,V,T}
    basis, mean, covar = state.basis, state.mean, state.covar
    nmodes = basis.nmodes
    length(indices) < nmodes || throw(ArgumentError(INDEX_ERROR))
    notindices = setdiff(1:basis.nmodes, indices)
    notidxlength = length(notindices)
    # initialize partial trace of mean vector
    mean′ = zeros(eltype(mean), 2*notidxlength)
    @inbounds for i in eachindex(notindices)
        idx = notindices[i]
        mean′[i] = mean[idx]
        mean′[i+notidxlength] = mean[idx+nmodes]
    end
    # initialize partial trace of covariance matrix
    covar′ = zeros(eltype(covar), 2*notidxlength, 2*notidxlength)
    @inbounds for i in Base.OneTo(notidxlength)
        idx = notindices[i]
        @inbounds for j in i:notidxlength
            otheridx = notindices[j]
            covar′[i,j] = covar[idx,otheridx]
            covar′[j,i] = covar[otheridx,idx]
            covar′[i+notidxlength,j] = covar[idx+nmodes,otheridx]
            covar′[i,j+notidxlength] = covar[idx,otheridx+nmodes]
            covar′[j,i+notidxlength] = covar[otheridx,idx+nmodes]
            covar′[j+notidxlength,i] = covar[otheridx+nmodes,idx]
            covar′[i+notidxlength,j+notidxlength] = covar[idx+nmodes, otheridx+nmodes]
            covar′[j+notidxlength,i+notidxlength] = covar[otheridx+nmodes, idx+nmodes]
        end
    end 
    mean′′ = _promote_output_vector(typeof(mean), mean′, 2*notidxlength)
    covar′′ = _promote_output_matrix(typeof(covar), covar′, 2*notidxlength)
    return mean′′, covar′′
end

"""
    embed(basis::SymplecticBasis, idx::Int, state::GaussianState)
    embed(basis::SymplecticBasis, indices::AbstractVector{<:Int}, state::GaussianState)

Embed a smaller Gaussian state into a larger Hilbert space specified by a target
symplectic basis, inserting it at the mode index (or indices) specified by `idx` or `indices`.

The embedded state's mean vector and covariance matrix are inserted into the larger space,
and all other modes are initialized in the vacuum state (zero mean, covariance equal to ħ/2 × I).
The function returns a new `GaussianState` with the full `basis`.

## Example
```jldoctest
julia> state = squeezedstate(QuadBlockBasis(1), 1.0, pi/4);

julia> embed(QuadBlockBasis(3), 2, state)
GaussianState for 3 modes.
  symplectic basis: QuadBlockBasis
mean: 6-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
 0.0
 0.0
covariance: 6×6 Matrix{Float64}:
 1.0   0.0      0.0  0.0   0.0      0.0
 0.0   1.19762  0.0  0.0  -2.56458  0.0
 0.0   0.0      1.0  0.0   0.0      0.0
 0.0   0.0      0.0  1.0   0.0      0.0
 0.0  -2.56458  0.0  0.0   6.32677  0.0
 0.0   0.0      0.0  0.0   0.0      1.0
```
"""
function embed(
    basis::QuadPairBasis, index::Int, state::GaussianState{<:QuadPairBasis,M,V}
    ) where {M,V}
    return embed(basis, [index], state)
end
function embed(
    basis::QuadPairBasis, indices::Vector{<:Int}, state::GaussianState{<:QuadPairBasis,M,V}
) where {M,V}
    @assert length(indices) == state.basis.nmodes "Number of indices must match number of modes in the state"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = (state.basis).nmodes
    dim = 2 * total_modes
    ħ = state.ħ
    # initialize mean and covariance with vacuum
    mean = zeros(eltype(state.mean), dim)
    covar = Matrix{eltype(state.covar)}(I, dim, dim) .* (ħ / 2)

    # map substate mean and covar into full system
    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        mean[2idx-1] = state.mean[2i-1]
        mean[2idx]   = state.mean[2i]
    end

    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            covar[2idx_i-1, 2idx_j-1] = state.covar[2i-1, 2j-1]
            covar[2idx_i-1, 2idx_j]   = state.covar[2i-1, 2j]
            covar[2idx_i,   2idx_j-1] = state.covar[2i,   2j-1]
            covar[2idx_i,   2idx_j]   = state.covar[2i,   2j]
        end
    end
    return Gabs.GaussianState(basis, mean, covar; ħ)
end
function embed(
    basis::QuadBlockBasis, index::Int, state::GaussianState{<:QuadBlockBasis,M,V}
) where {M,V}
    return embed(basis, [index], state)
end
function embed(
    basis::QuadBlockBasis, indices::Vector{<:Int}, state::GaussianState{<:QuadBlockBasis,M,V}
) where {M,V}
    @assert length(indices) == state.basis.nmodes "Number of indices must match number of modes in the state"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = state.basis.nmodes
    ħ = state.ħ

    mean = zeros(eltype(state.mean), 2 * total_modes)
    covar = Matrix{eltype(state.covar)}(I*(ħ / 2), 2 * total_modes, 2 * total_modes)

    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        mean[idx] = state.mean[i]
        mean[idx + total_modes] = state.mean[i + sub_modes]
    end
    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            covar[idx_i, idx_j] = state.covar[i, j]
            covar[idx_i, idx_j + total_modes] = state.covar[i, j + sub_modes]
            covar[idx_i + total_modes, idx_j] = state.covar[i + sub_modes, j]
            covar[idx_i + total_modes, idx_j + total_modes] = state.covar[i + sub_modes, j + sub_modes]
        end
    end
    return GaussianState(basis, mean, covar; ħ)
end

"""
    changebasis(::SymplecticBasis, state::GaussianState)

Change the symplectic basis of a Gaussian state.

# Example

```jldoctest
julia> st = squeezedstate(QuadBlockBasis(2), 1.0, 2.0)
GaussianState for 2 modes.
  symplectic basis: QuadBlockBasis
mean: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
  5.2715    0.0      -3.29789   0.0
  0.0       5.2715    0.0      -3.29789
 -3.29789   0.0       2.25289   0.0
  0.0      -3.29789   0.0       2.25289

julia> changebasis(QuadPairBasis, st)
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
  5.2715   -3.29789   0.0       0.0
 -3.29789   2.25289   0.0       0.0
  0.0       0.0       5.2715   -3.29789
  0.0       0.0      -3.29789   2.25289
```
"""
function changebasis(::Type{B1}, state::GaussianState{B2,M,V}) where {B1<:QuadBlockBasis,B2<:QuadPairBasis,M,V}
    nmodes = state.basis.nmodes
    mean = similar(state.mean)
    covar = similar(state.covar)
    @inbounds for i in Base.OneTo(nmodes)
        mean[i] = state.mean[2*i - 1]
        mean[nmodes + i] = state.mean[2*i]
        # split into two loops for better cache efficiency
        @inbounds for j in Base.OneTo(nmodes)
            covar[j, i] = state.covar[2*j - 1, 2*i - 1]
            covar[nmodes + j, i] = state.covar[2*j, 2*i - 1]
        end
        @inbounds for j in Base.OneTo(nmodes)
            covar[j, nmodes + i] = state.covar[2*j - 1, 2*i]
            covar[nmodes + j, nmodes + i] = state.covar[2*j, 2*i]
        end
    end
    return GaussianState(B1(nmodes), mean, covar)
end
function changebasis(::Type{B1}, state::GaussianState{B2,M,V}) where {B1<:QuadPairBasis,B2<:QuadBlockBasis,M,V}
    nmodes = state.basis.nmodes
    mean = similar(state.mean)
    covar = similar(state.covar)
    @inbounds for i in Base.OneTo(nmodes)
        mean[2*i - 1] = state.mean[i]
        mean[2*i] = state.mean[nmodes + i]
        # split into two loops for better cache efficiency
        @inbounds for j in Base.OneTo(nmodes)
            covar[2*j - 1, 2*i - 1] = state.covar[j, i]
            covar[2*j, 2*i - 1] = state.covar[nmodes + j, i]
        end
        @inbounds for j in Base.OneTo(nmodes)
            covar[2*j - 1, 2*i] = state.covar[j, nmodes + i]
            covar[2*j, 2*i] = state.covar[nmodes + j, nmodes + i]
        end
    end
    return GaussianState(B1(nmodes), mean, covar)
end
changebasis(::Type{<:QuadBlockBasis}, state::GaussianState{<:QuadBlockBasis,M,V}) where {M,V} = state
changebasis(::Type{<:QuadPairBasis}, state::GaussianState{<:QuadPairBasis,M,V}) where {M,V} = state


"""
    sympspectrum(state::GaussianState)

Compute the symplectic spectrum of a Gaussian state.
"""
sympspectrum(state::GaussianState) = _sympspectrum(state.covar, x -> x > 0; pre = symplecticform(state.basis))
function _sympspectrum(M::AbstractMatrix{<:Number}, select::Function; pre::Union{Nothing, AbstractMatrix{<:Number}} = nothing, post::Union{Nothing, AbstractMatrix{<:Number}} = nothing, invscale::Union{Nothing, Real} = nothing)
    M = isnothing(pre) ? M : pre * M
    M = isnothing(post) ? M : M * post
    M = isnothing(invscale) ? imag.(eigvals(M)) : imag.(eigvals(M)) ./ invscale
    return filter(x -> select(x), M)
end

Base.@propagate_inbounds function _promote_output_vector(::Type{T1}, ::Type{T2}, vec_out) where {T1<:SVector, T2<:SVector}
    lengths = length(T1) + length(T2)
    return SVector{lengths}(vec_out)
end
Base.@propagate_inbounds function _promote_output_vector(::Type{<:SVector}, vec_out, vec_length::Int)
    return SVector{vec_length}(vec_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{T1}, ::Type{T2}, mat_out) where {T1<:SMatrix,T2<:SMatrix}
    dim = size(T1)[1] + size(T2)[1]
    return SMatrix{dim,dim}(mat_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{<:SMatrix}, mat_out, out_dim::Int)
    return SMatrix{out_dim,out_dim}(mat_out)
end
Base.@propagate_inbounds function _promote_output_matrix(::Type{<:SMatrix}, mat_out, out_dim::Tuple)
    return SMatrix{out_dim[1],out_dim[2]}(mat_out)
end

"""
    randstate([Tm=Vector{Float64}, Tc=Matrix{Float64},] basis::SymplecticBasis; pure=false, rng=Random.default_rng())

Calculate a random Gaussian state in symplectic representation defined by `basis`.
"""
function randstate(::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}; pure = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {Tm,Tc,N<:Int}
    mean, covar = _randstate(rng, basis; pure = pure, ħ = ħ)
    return GaussianState(basis, Tm(mean), Tc(covar), ħ = ħ)
end
randstate(::Type{T}, basis::SymplecticBasis{N}; pure = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {T,N<:Int} = randstate(T,T,basis; pure = pure, ħ = ħ, rng = rng)
function randstate(basis::SymplecticBasis{N}; pure = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {N<:Int}
    mean, covar = _randstate(rng, basis; pure = pure, ħ = ħ)
    return GaussianState(basis, mean, covar, ħ = ħ)
end
randstate(rng::AbstractRNG, ::Type{Tm}, ::Type{Tc}, basis::SymplecticBasis{N}; pure = false, ħ = 2) where {Tm,Tc,N<:Int} = randstate(Tm, Tc, basis; pure = pure, ħ = ħ, rng = rng)
randstate(rng::AbstractRNG, ::Type{T}, basis::SymplecticBasis{N}; pure = false, ħ = 2) where {T,N<:Int} = randstate(T, basis; pure = pure, ħ = ħ, rng = rng)
randstate(rng::AbstractRNG, basis::SymplecticBasis{N}; pure = false, ħ = 2) where {N<:Int} = randstate(basis; pure = pure, ħ = ħ, rng = rng)
function _randstate(rng::AbstractRNG, basis::QuadPairBasis{N}; pure = false, ħ = 2) where {N<:Int}
    nmodes = basis.nmodes
    mean = randn(rng, 2*nmodes)
    covar = zeros(2*nmodes, 2*nmodes)
    symp = randsymplectic(rng, basis)
    # generate pure Gaussian state
    if pure
        mul!(covar, symp, symp')
        covar .*= (ħ/2)
        return mean, covar
    end
    # create buffer for matrix multiplication
    buf = zeros(2*nmodes, 2*nmodes)
    # William decomposition for mixed Gaussian states
    sympeigs = (ħ/2)*(abs.(rand(rng, nmodes)) .+ 1.0)
    will = Diagonal(repeat(sympeigs, inner = 2))
    mul!(covar, symp, mul!(buf, will, symp'))
    return mean, covar
end
function _randstate(rng::AbstractRNG, basis::QuadBlockBasis{N}; pure = false, ħ = 2) where {N<:Int}
    nmodes = basis.nmodes
    mean = randn(rng, 2*nmodes)
    covar = zeros(2*nmodes, 2*nmodes)
    symp = randsymplectic(rng, basis)
    # generate pure Gaussian state
    if pure
        mul!(covar, symp, symp')
        covar .*= (ħ/2)
        return mean, covar
    end
    # create buffer for matrix multiplication
    buf = zeros(2*nmodes, 2*nmodes)
    # William decomposition for mixed Gaussian states
    sympeigs = (ħ/2)*(abs.(rand(rng, nmodes)) .+ 1.0)
    will = Diagonal(repeat(sympeigs, outer = 2))
    mul!(covar, symp, mul!(buf, will, symp'))
    return mean, covar
end

"""
    randunitary([Td=Vector{Float64}, Ts=Matrix{Float64},] basis::SymplecticBasis; passive=false, rng=Random.default_rng())

Calculate a random Gaussian unitary operator in symplectic representation defined by `basis`.
"""
function randunitary(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}; passive = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {Td,Ts,N<:Int}
    disp, symp = _randunitary(rng, basis, passive = passive)
    return GaussianUnitary(basis, Td(disp), Ts(symp), ħ = ħ)
end
randunitary(::Type{T}, basis::SymplecticBasis{N}; passive = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {T,N<:Int} = randunitary(T,T,basis; passive = passive, ħ = ħ, rng = rng)
function randunitary(basis::SymplecticBasis{N}; passive = false, ħ = 2, rng::AbstractRNG = Random.default_rng()) where {N<:Int}
    disp, symp = _randunitary(rng, basis, passive = passive)
    return GaussianUnitary(basis, disp, symp, ħ = ħ)
end
randunitary(rng::AbstractRNG, ::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}; passive = false, ħ = 2) where {Td,Ts,N<:Int} = randunitary(Td, Ts, basis; passive = passive, ħ = ħ, rng = rng)
randunitary(rng::AbstractRNG, ::Type{T}, basis::SymplecticBasis{N}; passive = false, ħ = 2) where {T,N<:Int} = randunitary(T, basis; passive = passive, ħ = ħ, rng = rng)
randunitary(rng::AbstractRNG, basis::SymplecticBasis{N}; passive = false, ħ = 2) where {N<:Int} = randunitary(basis; passive = passive, ħ = ħ, rng = rng)
function _randunitary(rng::AbstractRNG, basis::SymplecticBasis{N}; passive = false) where {N<:Int}
    nmodes = basis.nmodes
    disp = rand(rng, 2*nmodes)
    symp = randsymplectic(rng, basis, passive = passive)
    return disp, symp
end

"""
    randchannel([Td=Vector{Float64}, Tt=Matrix{Float64},] basis::SymplecticBasis; rng=Random.default_rng())

Calculate a random Gaussian channel in symplectic representation defined by `basis`.
"""
function randchannel(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}; ħ = 2, rng::AbstractRNG = Random.default_rng()) where {Td,Tt,N<:Int}
    disp, transform, noise = _randchannel(rng, basis)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise), ħ = ħ)
end
randchannel(::Type{T}, basis::SymplecticBasis{N}; ħ = 2, rng::AbstractRNG = Random.default_rng()) where {T,N<:Int} = randchannel(T,T,basis; ħ = ħ, rng = rng)
function randchannel(basis::SymplecticBasis{N}; ħ = 2, rng::AbstractRNG = Random.default_rng()) where {N<:Int}
    disp, transform, noise = _randchannel(rng, basis)
    return GaussianChannel(basis, disp, transform, noise, ħ = ħ)
end
randchannel(rng::AbstractRNG, ::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}; ħ = 2) where {Td,Tt,N<:Int} = randchannel(Td, Tt, basis; ħ = ħ, rng = rng)
randchannel(rng::AbstractRNG, ::Type{T}, basis::SymplecticBasis{N}; ħ = 2) where {T,N<:Int} = randchannel(T, basis; ħ = ħ, rng = rng)
randchannel(rng::AbstractRNG, basis::SymplecticBasis{N}; ħ = 2) where {N<:Int} = randchannel(basis; ħ = ħ, rng = rng)
function _randchannel(rng::AbstractRNG, basis::SymplecticBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    disp = randn(rng, 2*nmodes)
    # generate symplectic matrix describing the evolution of the system with N modes
    # and environment with 2N modes
    symp = randsymplectic(rng, typeof(basis)(3*nmodes))
    transform, B = symp[1:2*nmodes, 1:2*nmodes], @view(symp[1:2*nmodes, 2*nmodes+1:6*nmodes])
    # generate noise matrix from evolution of environment
    noise = zeros(2*nmodes, 2*nmodes)
    mul!(noise, B, B')
    return disp, transform, noise
end

"""
    randsymplectic([T=Matrix{Float64},] basis::SymplecticBasis, passive=false, rng=Random.default_rng())

Calculate a random symplectic matrix in symplectic representation defined by `basis`.
"""
function randsymplectic(::Type{T}, basis::SymplecticBasis{N}; passive = false, rng::AbstractRNG = Random.default_rng()) where {T, N<:Int}
    symp = randsymplectic(rng, basis; passive = passive)
    return T(symp)
end
function randsymplectic(rng::AbstractRNG, ::Type{T}, basis::SymplecticBasis{N}; passive = false) where {T, N<:Int}
    symp = randsymplectic(rng, basis; passive = passive)
    return T(symp)
end
randsymplectic(basis::SymplecticBasis{N}; passive = false, rng::AbstractRNG = Random.default_rng()) where {N<:Int} = _randsymplectic(rng, basis, passive = passive)
randsymplectic(rng::AbstractRNG, basis::SymplecticBasis{N}; passive = false) where {N<:Int} = _randsymplectic(rng, basis, passive = passive)
function _randsymplectic(rng::AbstractRNG, basis::QuadPairBasis{N}; passive = false) where {N<:Int}
    nmodes = basis.nmodes
    # generate random orthogonal symplectic matrix
    O = _rand_orthogonal_symplectic(rng, basis)
    if passive
        return O
    end
    # instead generate random active symplectic matrix
    O′ = _rand_orthogonal_symplectic(rng, basis)
    # direct sum of symplectic matrices for single-mode squeeze transformations
    rs = rand(rng, nmodes)
    squeezes = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        val = rs[i]
        squeezes[2*i-1, 2*i-1] = val
        squeezes[2*i, 2*i] = 1/val
    end
    return O * squeezes * O′
end
function _randsymplectic(rng::AbstractRNG, basis::QuadBlockBasis{N}; passive = false) where {N<:Int}
    nmodes = basis.nmodes
    # generate random orthogonal symplectic matrix
    O = _rand_orthogonal_symplectic(rng, basis)
    if passive
        return O
    end
    # instead generate random active symplectic matrix
    O′ = _rand_orthogonal_symplectic(rng, basis)
    # direct sum of symplectic matrices for single-mode squeeze transformations
    rs = rand(rng, nmodes)
    squeezes = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        val = rs[i]
        squeezes[i, i] = val
        squeezes[i+nmodes, i+nmodes] = 1/val
    end
    return O * squeezes * O′
end


# Generates random orthogonal symplectic matrix by blocking real
# and imaginary parts of a random unitary matrix
function _rand_orthogonal_symplectic(rng::AbstractRNG, basis::QuadPairBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    U = _rand_unitary(rng, basis)
    O = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes), j in Base.OneTo(nmodes)
        val = U[i,j]
        O[2*i-1,2*j-1] = real(val)
        O[2*i, 2*j-1] = -imag(val)
        O[2*i-1, 2*j] = imag(val)
        O[2*i, 2*j] = real(val)
    end
    return O
end
function _rand_orthogonal_symplectic(rng::AbstractRNG, basis::QuadBlockBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    U = _rand_unitary(rng, basis)
    O = zeros(2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes), j in Base.OneTo(nmodes)
        val = U[i,j]
        O[i,j] = real(val)
        O[i+nmodes, j] = -imag(val)
        O[i, j+nmodes] = imag(val)
        O[i+nmodes, j+nmodes] = real(val)
    end
    return O
end
"""
Generates unitary matrix randomly distributed over Haar measure;
see https://arxiv.org/abs/math-ph/0609050 for algorithm.
This approach is faster and creates less allocations than rand(Haar(2), nmodes) from RandomMatrices.jl
"""
function _rand_unitary(rng::AbstractRNG, basis::SymplecticBasis{N}) where {N<:Int}
    nmodes = basis.nmodes
    M = rand(rng, ComplexF64, nmodes, nmodes) ./ sqrt(2.0)
    q, r = qr(M)
    d = Diagonal([r[i, i] / abs(r[i, i]) for i in Base.OneTo(nmodes)])
    return q * d
end

##
# Predefined Gaussian unitaries
##

"""
    displace([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, alpha<:Number)
    displace([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, alpha<:Number, noise::Ts)

Gaussian operator that displaces the vacuum state into a coherent state, known
as the displacement operator. The symplectic representation is given by `basis`. The complex amplitude is given by `alpha`. Noise can
be added to the operation with `noise`.

## Mathematical description of a displacement operator

A displacement operator `D(α)` is defined by the operation
`D(α)|0⟩ = |α⟩`, where `α` is a complex amplitude. The operator `D(α)` 
is characterized by the displacement vector `√2ħ [real(α), imag(α)]` 
and symplectic matrix `I`.

## Example

```jldoctest
julia> displace(QuadPairBasis(1), 1.0+im)
GaussianUnitary for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 2.0
 2.0
symplectic: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
"""
function displace(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {Td,Ts,N<:Int,A}
    disp, symplectic = _displace(basis, alpha; ħ = ħ)
    return GaussianUnitary(basis, Td(disp), Ts(symplectic); ħ = ħ)
end
displace(::Type{T}, basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {T,N<:Int,A} = displace(T, T, basis, alpha; ħ = ħ)
function displace(basis::SymplecticBasis{N}, alpha::A; ħ = 2) where {N<:Int,A}
    disp, symplectic = _displace(basis, alpha; ħ = ħ)
    return GaussianUnitary(basis, disp, symplectic; ħ = ħ)
end
function _displace(basis::QuadPairBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Number}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    disp = repeat([sqrt(2*ħ) * real(alpha), sqrt(2*ħ) * imag(alpha)], nmodes)
    symplectic = Matrix{Rt}(I, 2*nmodes, 2*nmodes)
    return disp, symplectic
end
function _displace(basis::QuadPairBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Vector}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    disp = collect(Iterators.flatten((real(i), imag(i)) for i in alpha))
    disp .*= sqrt(2*ħ)
    symplectic = Matrix{Rt}(I, 2*nmodes, 2*nmodes)
    return disp, symplectic
end
function _displace(basis::QuadBlockBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Number}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    disp = repeat([sqrt(2*ħ) * real(alpha), sqrt(2*ħ) * imag(alpha)], inner = nmodes)
    symplectic = Matrix{Rt}(I, 2*nmodes, 2*nmodes)
    return disp, symplectic
end
function _displace(basis::QuadBlockBasis{N}, alpha::A; ħ = 2) where {N<:Int,A<:Vector}
    nmodes = basis.nmodes
    Rt = real(eltype(A))
    re = collect(Iterators.flatten((real(i), imag(i)) for i in alpha))
    disp = vcat(@view(re[1:2:end]), @view(re[2:2:end]))
    disp .*= sqrt(2*ħ)
    symplectic = Matrix{Rt}(I, 2*nmodes, 2*nmodes)
    return disp, symplectic
end

"""
    squeeze([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, r<:Real, theta<:Real)
    squeeze([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, r<:Real, theta<:Real, noise::Ts)

Gaussian operator that squeezes the vacuum state into a squeezed state, known
as the squeezing operator. The symplectic representation is given by `basis`. The amplitude and phase squeezing parameters 
are given by `r` and `theta`, respectively. Noise can be added to the operation
with `noise`.

## Mathematical description of a squeezing operator

A squeeze operator `S(r, θ)` is defined by the operation
`S(r, θ)|0⟩ = |r, θ⟩`, where `r` and `θ` are the real amplitude and phase parameters, 
respectively. The operator `S(r, θ)` is characterized by 
the zero displacement vector and symplectic
matrix `cosh(r)I - sinh(r)R(θ)`, where `R(θ)` is the rotation matrix.

## Example

```jldoctest
julia> squeeze(QuadPairBasis(1), 0.25, pi/4)
GaussianUnitary for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 0.0
 0.0
symplectic: 2×2 Matrix{Float64}:
  0.852789  -0.178624
 -0.178624   1.21004
```
"""
function squeeze(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {Td,Ts,N<:Int,R}
    disp, symplectic = _squeeze(basis, r, theta)
    return GaussianUnitary(basis, Td(disp), Ts(symplectic); ħ = ħ)
end
squeeze(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {T,N<:Int,R} = squeeze(T, T, basis, r, theta; ħ = ħ)
function squeeze(basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int, R}
    disp, symplectic = _squeeze(basis, r, theta)
    return GaussianUnitary(basis, disp, symplectic; ħ = ħ)
end
function _squeeze(basis::QuadPairBasis{N}, r::R, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    Rt = real(eltype(R))
    disp = zeros(R, 2*nmodes)
    cr, sr = cosh(r), sinh(r)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        symplectic[2*i-1, 2*i-1] = cr - sr*ct
        symplectic[2*i-1, 2*i] = -sr * st
        symplectic[2*i, 2*i-1] = -sr * st
        symplectic[2*i, 2*i] = cr + sr*ct
    end
    return disp, symplectic
end
function _squeeze(basis::QuadPairBasis{N}, r::R, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(r[i]), sinh(r[i])
        ct, st = cos(theta[i]), sin(theta[i])
        symplectic[2*i-1, 2*i-1] = cr - sr*ct
        symplectic[2*i-1, 2*i] = -sr * st
        symplectic[2*i, 2*i-1] = -sr * st
        symplectic[2*i, 2*i] = cr + sr*ct
    end
    return disp, symplectic
end
function _squeeze(basis::QuadBlockBasis{N}, r::R, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    Rt = real(eltype(R))
    disp = zeros(R, 2*nmodes)
    cr, sr = cosh(r), sinh(r)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        symplectic[i, i] = cr - sr*ct
        symplectic[i, i+nmodes] = -sr * st
        symplectic[i+nmodes, i] = -sr * st
        symplectic[i+nmodes, i+nmodes] = cr + sr*ct
    end
    return disp, symplectic
end
function _squeeze(basis::QuadBlockBasis{N}, r::R, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(r[i]), sinh(r[i])
        ct, st = cos(theta[i]), sin(theta[i])
        symplectic[i, i] = cr - sr*ct
        symplectic[i, i+nmodes] = -sr * st
        symplectic[i+nmodes, i] = -sr * st
        symplectic[i+nmodes, i+nmodes] = cr + sr*ct
    end
    return disp, symplectic
end

"""
    twosqueeze([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, r<:Real, theta<:Real)
    twosqueeze([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, r<:Real, theta<:Real, noise::Ts)

Gaussian operator that squeezes a two-mode vacuum state into a two-mode squeezed state,
known as the two-mode squeezing operator. The symplectic representation is given by `basis`. The amplitude and phase squeezing parameters 
are given by `r` and `theta`, respectively. Noise can be added to the operation
with `noise`.

## Mathematical description of a two-mode squeezing operator

A two-mode squeeze operator `S₂(r, θ)` is defined by the operation
`S₂(r, θ)|0⟩ = |r, θ⟩`, where `r` and `θ`
are the real amplitude and phase parameters, respectively. The operator 
`S₂(r, θ)` is characterized by the zero displacement vector and symplectic
matrix `[cosh(r)I -sinh(r)R(θ); -sinh(r)R(θ) cosh(r)I]`, where `R(θ)` is the rotation matrix.

## Example

```jldoctest
julia> twosqueeze(QuadPairBasis(2), 0.25, pi/4)
GaussianUnitary for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  1.03141    0.0       -0.178624  -0.178624
  0.0        1.03141   -0.178624   0.178624
 -0.178624  -0.178624   1.03141    0.0
 -0.178624   0.178624   0.0        1.03141
```
"""
function twosqueeze(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {Td,Ts,N<:Int,R}
    disp, symplectic = _twosqueeze(basis, r, theta)
    return GaussianUnitary(basis, Td(disp), Ts(symplectic); ħ = ħ)
end
twosqueeze(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {T,N<:Int,R} = twosqueeze(T, T, basis, r, theta; ħ = ħ)
function twosqueeze(basis::SymplecticBasis{N}, r::R, theta::R; ħ = 2) where {N<:Int,R}
    disp, symplectic = _twosqueeze(basis, r, theta)
    return GaussianUnitary(basis, disp, symplectic; ħ = ħ)
end
function _twosqueeze(basis::QuadPairBasis{N}, r::R, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    cr, sr = cosh(r), sinh(r)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        symplectic[4*i-3, 4*i-3] = cr
        symplectic[4*i-3, 4*i-1] = -sr * ct
        symplectic[4*i-3, 4*i] = -sr * st

        symplectic[4*i-2, 4*i-2] = cr
        symplectic[4*i-2, 4*i-1] = -sr * st
        symplectic[4*i-2, 4*i] = sr * ct

        symplectic[4*i-1, 4*i-3] = -sr * ct
        symplectic[4*i-1, 4*i-2] = -sr * st
        symplectic[4*i-1, 4*i-1] = cr

        symplectic[4*i, 4*i-3] = -sr * st
        symplectic[4*i, 4*i-2] = sr * ct
        symplectic[4*i, 4*i] = cr
    end
    return disp, symplectic
end
function _twosqueeze(basis::QuadPairBasis{N}, r::R, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        cr, sr = cosh(r[i]), sinh(r[i])
        ct, st = cos(theta[i]), sin(theta[i])

        symplectic[4*i-3, 4*i-3] = cr
        symplectic[4*i-3, 4*i-1] = -sr * ct
        symplectic[4*i-3, 4*i] = -sr * st

        symplectic[4*i-2, 4*i-2] = cr
        symplectic[4*i-2, 4*i-1] = -sr * st
        symplectic[4*i-2, 4*i] = sr * ct

        symplectic[4*i-1, 4*i-3] = -sr * ct
        symplectic[4*i-1, 4*i-2] = -sr * st
        symplectic[4*i-1, 4*i-1] = cr

        symplectic[4*i, 4*i-3] = -sr * st
        symplectic[4*i, 4*i-2] = sr * ct
        symplectic[4*i, 4*i] = cr
    end
    return disp, symplectic
end
function _twosqueeze(basis::QuadBlockBasis{N}, r::R, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    cr, sr = cosh(r), sinh(r)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    for i in Base.OneTo(Int(nmodes/2))
        symplectic[2*i-1, 2*i-1] = cr
        symplectic[2*i-1, 2*i] = -sr * ct
        symplectic[2*i, 2*i-1] = -sr * ct
        symplectic[2*i, 2*i] = cr

        symplectic[2*i-1, 2*i+nmodes] = -sr * st
        symplectic[2*i, 2*i+nmodes-1] = -sr * st

        symplectic[2*i+nmodes-1, 2*i+nmodes-1] = cr
        symplectic[2*i+nmodes-1, 2*i+nmodes] = sr * ct
        symplectic[2*i+nmodes, 2*i+nmodes-1] = sr * ct
        symplectic[2*i+nmodes, 2*i+nmodes] = cr

        symplectic[2*i+nmodes-1, 2*i] = -sr * st
        symplectic[2*i+nmodes, 2*i-1] = -sr * st
    end
    return disp, symplectic
end
function _twosqueeze(basis::QuadBlockBasis{N}, r::R, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        cr, sr = cosh(r[i]), sinh(r[i])
        ct, st = cos(theta[i]), sin(theta[i])

        symplectic[2*i-1, 2*i-1] = cr
        symplectic[2*i-1, 2*i] = -sr * ct
        symplectic[2*i, 2*i-1] = -sr * ct
        symplectic[2*i, 2*i] = cr

        symplectic[2*i-1, 2*i+nmodes] = -sr * st
        symplectic[2*i, 2*i+nmodes-1] = -sr * st

        symplectic[2*i+nmodes-1, 2*i+nmodes-1] = cr
        symplectic[2*i+nmodes-1, 2*i+nmodes] = sr * ct
        symplectic[2*i+nmodes, 2*i+nmodes-1] = sr * ct
        symplectic[2*i+nmodes, 2*i+nmodes] = cr

        symplectic[2*i+nmodes-1, 2*i] = -sr * st
        symplectic[2*i+nmodes, 2*i-1] = -sr * st
    end
    return disp, symplectic
end

"""
    phaseshift([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, theta<:Real)
    phaseshift([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, theta<:Real, noise::Ts)

Gaussian operator that rotates the phase of a given Gaussian mode by `theta`,
as the phase shift operator. The symplectic representation is given by `basis`. Noise can be added to the operation
with `noise`.

## Mathematical description of a phase shift operator

A phase shift operator is defined by the operation
`U(θ) = exp(-iθâᵗâ)`, where `θ` is
the phase parameter, and `âᵗ` and `â` are the raising
and lowering operators, respectively. The operator `U(θ)` is characterized by 
the zero displacement vector and symplectic
matrix `[cos(θ) sin(θ); -sin(θ) cos(θ)]`.

## Example

```jldoctest
julia> phaseshift(QuadPairBasis(1), 3pi/4)
GaussianUnitary for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 0.0
 0.0
symplectic: 2×2 Matrix{Float64}:
 -0.707107   0.707107
 -0.707107  -0.707107
```
"""
function phaseshift(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}, theta::R; ħ = 2) where {Td,Ts,N<:Int,R}
    disp, symplectic = _phaseshift(basis, theta)
    return GaussianUnitary(basis, Td(disp), Ts(symplectic); ħ = ħ)
end
phaseshift(::Type{T}, basis::SymplecticBasis{N}, theta::R; ħ = 2) where {T,N<:Int,R} = phaseshift(T, T, basis, theta; ħ = ħ)
function phaseshift(basis::SymplecticBasis{N}, theta::R; ħ = 2) where {N<:Int,R}
    disp, symplectic = _phaseshift(basis, theta)
    return GaussianUnitary(basis, disp, symplectic; ħ = ħ)
end
function _phaseshift(basis::QuadPairBasis{N}, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        symplectic[2*i-1, 2*i-1] = ct
        symplectic[2*i-1, 2*i] = st
        symplectic[2*i, 2*i-1] = -st
        symplectic[2*i, 2*i] = ct
    end
    return disp, symplectic
end
function _phaseshift(basis::QuadPairBasis{N}, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        ct, st = cos(theta[i]), sin(theta[i])
        symplectic[2*i-1, 2*i-1] = ct
        symplectic[2*i-1, 2*i] = st
        symplectic[2*i, 2*i-1] = -st
        symplectic[2*i, 2*i] = ct
    end
    return disp, symplectic
end
function _phaseshift(basis::QuadBlockBasis{N}, theta::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    ct, st = cos(theta), sin(theta)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        symplectic[i, i] = ct
        symplectic[i, i+nmodes] = st
        symplectic[i+nmodes, i] = -st
        symplectic[i+nmodes, i+nmodes] = ct
    end
    return disp, symplectic
end
function _phaseshift(basis::QuadBlockBasis{N}, theta::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        ct, st = cos(theta[i]), sin(theta[i])
        symplectic[i, i] = ct
        symplectic[i, i+nmodes] = st
        symplectic[i+nmodes, i] = -st
        symplectic[i+nmodes, i+nmodes] = ct
    end
    return disp, symplectic
end

"""
    beamsplitter([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, transmit<:Real)
    beamsplitter([Tm=Vector{Float64}, Ts=Matrix{Float64}], basis::SymplecticBasis, transmit<:Real, noise::Ts)

Gaussian operator that serves as the beam splitter transformation of a
two-mode Gaussian state, known as the beam splitter operator. The symplectic representation is given
by `basis`. The transmittivity of the operator is given by `transmit`. Noise can be added to the operation
with `noise`.

## Mathematical description of a beam splitter operator

A beam splitter operator `B(τ)` is defined by the operation
`B(τ) = exp(θ(âᵗb̂ - âb̂ᵗ))`, where `θ` is defined by `τ = cos²θ`, 
and `â` and `b̂` are the annihilation operators of the two modes, 
respectively. The operator `B(τ)` is characterized by 
the zero displacement vector and symplectic
matrix `[√τI √(1-τ)I; -√(1-τ)I √τI]`.

## Example

```jldoctest
julia> beamsplitter(QuadPairBasis(2), 0.75)
GaussianUnitary for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  0.5        0.0       0.866025  0.0
  0.0        0.5       0.0       0.866025
 -0.866025   0.0       0.5       0.0
  0.0       -0.866025  0.0       0.5
```
"""
function beamsplitter(::Type{Td}, ::Type{Ts}, basis::SymplecticBasis{N}, transmit::R; ħ = 2) where {Td,Ts,N<:Int,R}
    disp, symplectic = _beamsplitter(basis, transmit)
    return GaussianUnitary(basis, Td(disp), Ts(symplectic); ħ = ħ)
end
beamsplitter(::Type{T}, basis::SymplecticBasis{N}, transmit::R; ħ = 2) where {T,N<:Int,R} = beamsplitter(T, T, basis, transmit; ħ = ħ)
function beamsplitter(basis::SymplecticBasis{N}, transmit::R; ħ = 2) where {N<:Int,R}
    disp, symplectic = _beamsplitter(basis, transmit)
    return GaussianUnitary(basis, disp, symplectic; ħ = ħ)
end
function _beamsplitter(basis::QuadPairBasis{N}, transmit::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    a1, a2 = sqrt(transmit), sqrt(1 - transmit)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        symplectic[4*i-3, 4*i-3] = a2
        symplectic[4*i-3, 4*i-1] = a1

        symplectic[4*i-2, 4*i-2] = a2
        symplectic[4*i-2, 4*i] = a1
    
        symplectic[4*i-1, 4*i-3] = -a1
        symplectic[4*i-1, 4*i-1] = a2

        symplectic[4*i, 4*i-2] = -a1
        symplectic[4*i, 4*i] = a2
    end
    return disp, symplectic
end
function _beamsplitter(basis::QuadPairBasis{N}, transmit::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        a1, a2 = sqrt(transmit[i]), sqrt(1 - transmit[i])

        symplectic[4*i-3, 4*i-3] = a2
        symplectic[4*i-3, 4*i-1] = a1

        symplectic[4*i-2, 4*i-2] = a2
        symplectic[4*i-2, 4*i] = a1
    
        symplectic[4*i-1, 4*i-3] = -a1
        symplectic[4*i-1, 4*i-1] = a2

        symplectic[4*i, 4*i-2] = -a1
        symplectic[4*i, 4*i] = a2
    end
    return disp, symplectic
end
function _beamsplitter(basis::QuadBlockBasis{N}, transmit::R) where {N<:Int,R<:Real}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    a1, a2 = sqrt(transmit), sqrt(1 - transmit)
    symplectic = zeros(R, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        symplectic[2*i-1, 2*i-1] = a2
        symplectic[2*i-1, 2*i] = a1
        symplectic[2*i, 2*i-1] = -a1
        symplectic[2*i, 2*i] = a2
    end
    return disp, symplectic
end
function _beamsplitter(basis::QuadBlockBasis{N}, transmit::R) where {N<:Int,R<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    symplectic = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(Int(nmodes/2))
        a1, a2 = sqrt(transmit[i]), sqrt(1 - transmit[i])

        symplectic[2*i-1, 2*i-1] = a2
        symplectic[2*i-1, 2*i] = a1
        symplectic[2*i, 2*i-1] = -a1
        symplectic[2*i, 2*i] = a2

        symplectic[2*i+nmodes-1, 2*i+nmodes-1] = a2
        symplectic[2*i+nmodes-1, 2*i+nmodes] = a1
        symplectic[2*i+nmodes, 2*i+nmodes-1] = -a1
        symplectic[2*i+nmodes, 2*i+nmodes] = a2
    end
    return disp, symplectic
end

##
# Operations on Gaussian unitaries
##

function tensor(::Type{Td}, ::Type{Ts}, op1::GaussianUnitary, op2::GaussianUnitary) where {Td,Ts}
    typeof(op1.basis) == typeof(op2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    op1.ħ == op2.ħ || throw(ArgumentError(HBAR_ERROR))
    disp, symplectic = _tensor(op1, op2)
    return GaussianUnitary(op1.basis ⊕ op2.basis, Td(disp), Ts(symplectic); ħ = op1.ħ)
end
tensor(::Type{T}, op1::GaussianUnitary, op2::GaussianUnitary) where {T} = tensor(T, T, op1, op2)
function tensor(op1::GaussianUnitary, op2::GaussianUnitary)
    typeof(op1.basis) == typeof(op2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    op1.ħ == op2.ħ || throw(ArgumentError(HBAR_ERROR))
    disp, symplectic = _tensor(op1, op2)
    return GaussianUnitary(op1.basis ⊕ op2.basis, disp, symplectic; ħ = op1.ħ)
end
function _tensor(op1::GaussianUnitary{B1,D1,S1}, op2::GaussianUnitary{B2,D2,S2}) where {B1<:QuadPairBasis,B2<:QuadPairBasis,D1,D2,S1,S2}
    basis1, basis2 = op1.basis, op2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(2*nmodes1), Base.OneTo(2*nmodes2)
    # initialize direct sum of displacement vectors
    disp1, disp2 = op1.disp, op2.disp
    Dt = promote_type(eltype(disp1), eltype(disp2))
    disp′ = zeros(Dt, 2*nmodes)
    @inbounds for i in block1
        disp′[i] = disp1[i]
    end
    @inbounds for i in block2
        disp′[i+2*nmodes1] = disp2[i]
    end
    # initialize direct sum of symplectic matrices
    symp1, symp2 = op1.symplectic, op2.symplectic
    St = promote_type(eltype(symp1), eltype(symp2))
    symp′ = zeros(St, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        symp′[i,j] = symp1[i,j]
    end
    @inbounds for i in block2, j in block2
        symp′[i+2*nmodes1,j+2*nmodes1] = symp2[i,j]
        symp′[i+2*nmodes1,j+2*nmodes1] = symp2[i,j]
    end
    # extract output array types
    disp′′ = _promote_output_vector(typeof(disp1), typeof(disp2), disp′)
    symp′′ = _promote_output_matrix(typeof(symp1), typeof(symp2), symp′)
    return disp′′, symp′′
end
function _tensor(op1::GaussianUnitary{B1,D1,S1}, op2::GaussianUnitary{B2,D2,S2}) where {B1<:QuadBlockBasis,B2<:QuadBlockBasis,D1,D2,S1,S2}
    basis1, basis2 = op1.basis, op2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(nmodes1), Base.OneTo(nmodes2)
    # initialize direct sum of displacement vectors
    disp1, disp2 = op1.disp, op2.disp
    Dt = promote_type(eltype(disp1), eltype(disp2))
    disp′ = zeros(Dt, 2*nmodes)
    @inbounds for i in block1
        disp′[i] = disp1[i]
        disp′[i+nmodes] = disp1[i+nmodes1]
    end
    @inbounds for i in block2
        disp′[i+nmodes1] = disp2[i]
        disp′[i+nmodes+nmodes1] = disp2[i+nmodes2]
    end
    # initialize direct sum of symplectic matrices
    symp1, symp2 = op1.symplectic, op2.symplectic
    St = promote_type(eltype(symp1), eltype(symp2))
    symp′ = zeros(St, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        symp′[i,j] = symp1[i,j]
        symp′[i,j+nmodes] = symp1[i,j+nmodes1]
        symp′[i+nmodes,j] = symp1[i+nmodes1,j]
        symp′[i+nmodes,j+nmodes] = symp1[i+nmodes1,j+nmodes1]
    end
    @inbounds for i in block2, j in block2
        symp′[i+nmodes1,j+nmodes1] = symp2[i,j]
        symp′[i+nmodes1,j+nmodes+nmodes1] = symp2[i,j+nmodes2]
        symp′[i+nmodes+nmodes1,j+nmodes1] = symp2[i+nmodes2,j]
        symp′[i+nmodes+nmodes1,j+nmodes+nmodes1] = symp2[i+nmodes2,j+nmodes2]
   end
    # extract output array types
    disp′′ = _promote_output_vector(typeof(disp1), typeof(disp2), disp′)
    symp′′ = _promote_output_matrix(typeof(symp1), typeof(symp2), symp′)
    return disp′′, symp′′
end

##
# Embedding Gaussian unitaries
##

"""
    embed(basis::SymplecticBasis, idx::Int, op::GaussianUnitary)
    embed(basis::SymplecticBasis, indices::Vector{<:Int}, op::GaussianUnitary)

Embed a smaller Gaussian unitary into a larger symplectic basis. The unitary
acts on the modes specified by `idx`/`indices` and the identity acts elsewhere.
"""
function embed(
    basis::QuadPairBasis, index::Int, op::GaussianUnitary{<:QuadPairBasis,D,S}
) where {D,S}
    return embed(basis, [index], op)
end
function embed(
    basis::QuadPairBasis, indices::Vector{<:Int}, op::GaussianUnitary{<:QuadPairBasis,D,S}
) where {D,S}
    @assert length(indices) == op.basis.nmodes "Number of indices must match number of modes in the unitary"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = op.basis.nmodes
    disp = zeros(eltype(op.disp), 2 * total_modes)
    symp = Matrix{eltype(op.symplectic)}(I, 2 * total_modes, 2 * total_modes)

    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        disp[2idx-1] = op.disp[2i-1]
        disp[2idx] = op.disp[2i]
    end
    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            symp[2idx_i-1, 2idx_j-1] = op.symplectic[2i-1, 2j-1]
            symp[2idx_i-1, 2idx_j] = op.symplectic[2i-1, 2j]
            symp[2idx_i, 2idx_j-1] = op.symplectic[2i, 2j-1]
            symp[2idx_i, 2idx_j] = op.symplectic[2i, 2j]
        end
    end
    return GaussianUnitary(basis, disp, symp; ħ = op.ħ)
end
function embed(
    basis::QuadBlockBasis, index::Int, op::GaussianUnitary{<:QuadBlockBasis,D,S}
) where {D,S}
    return embed(basis, [index], op)
end
function embed(
    basis::QuadBlockBasis, indices::Vector{<:Int}, op::GaussianUnitary{<:QuadBlockBasis,D,S}
) where {D,S}
    @assert length(indices) == op.basis.nmodes "Number of indices must match number of modes in the unitary"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = op.basis.nmodes
    disp = zeros(eltype(op.disp), 2 * total_modes)
    symp = Matrix{eltype(op.symplectic)}(I, 2 * total_modes, 2 * total_modes)

    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        disp[idx] = op.disp[i]
        disp[idx + total_modes] = op.disp[i + sub_modes]
    end
    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            symp[idx_i, idx_j] = op.symplectic[i, j]
            symp[idx_i, idx_j + total_modes] = op.symplectic[i, j + sub_modes]
            symp[idx_i + total_modes, idx_j] = op.symplectic[i + sub_modes, j]
            symp[idx_i + total_modes, idx_j + total_modes] = op.symplectic[i + sub_modes, j + sub_modes]
        end
    end
    return GaussianUnitary(basis, disp, symp; ħ = op.ħ)
end

"""
    issymplectic(basis::SymplecticBasis, x::T)

Check if input matrix satisfies symplectic definition.

## Example

```jldoctest
julia> basis = QuadPairBasis(1);

julia> issymplectic(basis, [1.0 0.0; 0.0 1.0])
true
```
"""
function issymplectic(basis::SymplecticBasis, x::T; atol::R1 = 0, rtol::R2 = atol) where {T,R1<:Real,R2<:Real}
    form = symplecticform(basis)
    return isapprox(x * form * x', form; atol = atol, rtol = rtol)
end

"""
    changebasis(::SymplecticBasis, state::GaussianUnitary)

Change the symplectic basis of a Gaussian unitary.

## Example

```jldoctest
julia> op = displace(QuadBlockBasis(2), 1.0-im)
GaussianUnitary for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
  2.0
  2.0
 -2.0
 -2.0
symplectic: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0

julia> changebasis(QuadPairBasis, op)
GaussianUnitary for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
  2.0
 -2.0
  2.0
 -2.0
symplectic: 4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0
```
"""
function changebasis(::Type{B1}, op::GaussianUnitary{B2,D,S}) where {B1<:QuadBlockBasis,B2<:QuadPairBasis,D,S}
    basis = op.basis
    nmodes = basis.nmodes
    T = zeros(eltype(S), 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(2*nmodes), j in Base.OneTo(2*nmodes)
        if (j == 2*i-1) || (j + 2*nmodes == 2*i)
            T[i,j] = 1.0
        end
    end
    T = typeof(T) == S ? T : S(T)
    disp = T * op.disp
    symp = T * op.symplectic * transpose(T)
    return GaussianUnitary(B1(nmodes), disp, symp; ħ = op.ħ)
end
function changebasis(::Type{B1}, op::GaussianUnitary{B2,D,S}) where {B1<:QuadPairBasis,B2<:QuadBlockBasis,D,S}
    basis = op.basis
    nmodes = basis.nmodes
    T = zeros(eltype(S), 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(2*nmodes), j in Base.OneTo(2*nmodes)
        if (i == 2*j-1) || (i + 2*nmodes == 2*j)
            T[i,j] = 1.0
        end
    end
    T = typeof(T) == S ? T : S(T)
    disp = T * op.disp
    symp = T * op.symplectic * transpose(T)
    return GaussianUnitary(B1(nmodes), disp, symp; ħ = op.ħ)
end
changebasis(::Type{<:QuadBlockBasis}, op::GaussianUnitary{<:QuadBlockBasis,D,S}) where {D,S} = op
changebasis(::Type{<:QuadPairBasis}, op::GaussianUnitary{<:QuadPairBasis,D,S}) where {D,S} = op

@testitem "Symbolic States" begin
    using Gabs
    using Symbolics
    using StaticArrays
    using LinearAlgebra: det

    nmodes = rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)

    @testset "Symbolic EPR states" begin
        @variables r θ
        nmodes = rand(1:5)
        @variables rs[1:nmodes] thetas[1:nmodes]
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        state = eprstate(2 * qpairbasis, r, θ)
        @test state isa GaussianState
        @test eprstate(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, r, θ) isa GaussianState
        @test iszero(simplify(eprstate(2*qblockbasis, r, θ).covar - changebasis(QuadBlockBasis, state).covar))
        @test iszero(simplify(eprstate(2*qblockbasis, r, θ).mean - changebasis(QuadBlockBasis, state).mean))
        state_pair = eprstate(2*qpairbasis, collect(rs), collect(thetas))
        state_block = eprstate(2*qblockbasis, collect(rs), collect(thetas))
        @test iszero(simplify(state_block.covar - changebasis(QuadBlockBasis, state_pair).covar))
        @test iszero(simplify(state_block.mean - changebasis(QuadBlockBasis, state_pair).mean))
        @test all(isequal.(eprstate(2 * qblockbasis, collect(rs), collect(thetas)).covar, changebasis(QuadBlockBasis, state_pair).covar))
        @test all(isequal.(eprstate(2 * qblockbasis, collect(rs), collect(thetas)).mean, changebasis(QuadBlockBasis, state_pair).mean))
    end

    @testset "Symbolic squeezed states" begin
        @variables r theta
        @variables rs[1:nmodes] thetas[1:nmodes]
        state = squeezedstate(qpairbasis, r, theta)
        @test state isa GaussianState
        @test squeezedstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, r, theta) isa GaussianState
        @test all(isequal.(squeezedstate(qblockbasis, r, theta).covar, changebasis(QuadBlockBasis, state).covar))
        @test all(isequal.(squeezedstate(qblockbasis, r, theta).mean, changebasis(QuadBlockBasis, state).mean))
        rs_vec = collect(rs)
        thetas_vec = collect(thetas)
        state = squeezedstate(qpairbasis, rs_vec, thetas_vec)
        @test state isa GaussianState
        @test all(isequal.(squeezedstate(qblockbasis, rs_vec, thetas_vec).covar, changebasis(QuadBlockBasis, state).covar))
        @test all(isequal.(squeezedstate(qblockbasis, rs_vec, thetas_vec).mean, changebasis(QuadBlockBasis, state).mean))
    end

    @testset "Symbolic coherent states" begin
        @variables α
        @variables alphas[1:nmodes]
        state_pair = coherentstate(qpairbasis, α)
        state_block = coherentstate(qblockbasis, α)
        @test state_pair isa GaussianState && state_block isa GaussianState
        @test coherentstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, α) isa GaussianState
        @test coherentstate(qblockbasis, α).covar == changebasis(QuadBlockBasis, state_pair).covar
        @test isequal(coherentstate(qblockbasis, α).mean, changebasis(QuadBlockBasis, state_pair).mean)
        alphas_vec = vcat([real(alphas[i]) for i in 1:nmodes], [imag(alphas[i]) for i in 1:nmodes])
        @test all.(isequal(coherentstate(qblockbasis, alphas_vec).mean, changebasis(QuadBlockBasis, coherentstate(qpairbasis, alphas_vec)).mean))
        @test all.(isequal(coherentstate(qblockbasis, alphas_vec).covar, changebasis(QuadBlockBasis, coherentstate(qpairbasis, alphas_vec)).covar))
    end

    @testset "Symbolic tensor products" begin
        @variables α r θ
        @variables rs[1:nmodes] thetas[1:nmodes]
        state1 = coherentstate(qpairbasis, α)
        state2 = squeezedstate(qpairbasis, r, θ)
        tensor_state = tensor(state1, state2)
        simplified_tensor = simplify(tensor_state.covar)
        simplified_mean = simplify(tensor_state.mean)
        @test iszero(simplified_tensor - tensor_state.covar)
        @test iszero(simplified_mean - tensor_state.mean)
        rs_vec = collect(rs)
        thetas_vec = collect(thetas)
        state_vec = squeezedstate(qpairbasis, rs_vec, thetas_vec)
        tensor_state_arr = tensor(state1, state_vec)
        simplified_tensor_arr = simplify(tensor_state_arr.covar)
        simplified_mean_arr = simplify(tensor_state_arr.mean)
        @test iszero(simplified_tensor_arr - tensor_state_arr.covar)
        @test iszero(simplified_mean_arr - tensor_state_arr.mean)
    end

    @testset "Symbolic thermal states" begin
        @variables n
        state_pair = thermalstate(qpairbasis, n)
        state_block = thermalstate(qblockbasis, n)
        @test state_pair isa GaussianState && state_block isa GaussianState
        @test thermalstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, n) isa GaussianState
        @test isequal(thermalstate(qblockbasis, n).covar, changebasis(QuadBlockBasis, state_pair).covar)
        @test isequal(thermalstate(qblockbasis, n).mean, changebasis(QuadBlockBasis, state_pair).mean)
        @variables ns[1:nmodes]
        n_vec = [n for _ in 1:nmodes]
        state_pair = thermalstate(qpairbasis, n_vec)
        state_block = thermalstate(qblockbasis, n_vec)
        @test state_pair isa GaussianState && state_block isa GaussianState
        @test thermalstate(SVector{2*nmodes}, SMatrix{2*nmodes, 2*nmodes}, qpairbasis, n_vec) isa GaussianState
        @test all.(isequal(thermalstate(qblockbasis, n_vec).mean, changebasis(QuadBlockBasis, thermalstate(qpairbasis, n_vec)).mean))
        @test all.(isequal(thermalstate(qblockbasis, n_vec).covar, changebasis(QuadBlockBasis, thermalstate(qpairbasis, n_vec)).covar))
    end
end

struct Homodyne{R,S<:GaussianState} <: Gabs.AbstractGaussianMeasurement
    result::R
    state::S
    function Homodyne(r::R, s::S) where {R,S<:GaussianState}
        return new{R,S}(r, s)
    end
end

# iteration for destructuring into components
Base.iterate(F::Homodyne) = (F.result, Val(:state))
Base.iterate(F::Homodyne, ::Val{:state}) = (F.state, Val(:done))
Base.iterate(F::Homodyne, ::Val{:done}) = nothing

# printing method
function Base.show(
    io::IO, 
    mime::MIME{Symbol("text/plain")}, 
    H::Homodyne{<:Any,<:GaussianState}
)
    Base.summary(io, H); println(io)
    println(io, "result:")
    Base.show(io, mime, H.result)
    println(io, "\noutput state:")
    Base.show(io, mime, H.state)
end

"""
    homodyne(state::GaussianState, indices::Vector, angles::Vector) -> Homodyne
    homodyne(state::GaussianState, index::Int, angle::Float64) -> Homodyne

Compute the projection of the subsystem of a Gaussian state `state` indicated by `indices`
on rotated quadrature states with homodyne phases given by `angles` and return a `Homodyne` object. 
The `result` and mapped state `output` can be obtained from the Homodyne object `M` via `M.result` and `M.output`.
Iterating the decomposition produces the components `result` and `output`.

Note the measured modes are replaced with vacuum states after the homodyne measurement.

# Keyword arguments
- `rng::AbstractRNG = Random.default_rng()`: Random number generator that determines a random projection.
- `squeeze::Real = 1e-12`: Finite squeezing parameter.

# Examples
```
julia> st = squeezedstate(QuadBlockBasis(3), 1.0, pi/4);

julia> M = homodyne(st, [1, 3], [0.0, pi/2])
Homodyne{Vector{Float64}, GaussianState{QuadBlockBasis{Int64}, Vector{Float64}, Matrix{Float64}}}
result:
4-element Vector{Float64}:
        -0.10967467526473408
    431152.803479904
    199553.173299574
        2.6446626022416964
output state:
GaussianState for 3 modes.
    symplectic basis: QuadBlockBasis
mean: 6-element Vector{Float64}:
    0.0
    0.0
    0.0
    0.0
    0.0
    0.0
covariance: 6×6 Matrix{Float64}:
    1.0   0.0      0.0  0.0   0.0      0.0
    0.0   1.19762  0.0  0.0  -2.56458  0.0
    0.0   0.0      1.0  0.0   0.0      0.0
    0.0   0.0      0.0  1.0   0.0      0.0
    0.0  -2.56458  0.0  0.0   6.32677  0.0
    0.0   0.0      0.0  0.0   0.0      1.0

julia> result, state = M; # destructuring via iteration

julia> result == M.result && state == M.state
true
```
"""
function homodyne(
    state::GaussianState{<:QuadPairBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    rng::AbstractRNG = Random.default_rng(),
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    nmodes = basis.nmodes
    indlength = length(indices)
    indlength <= nmodes || throw(ArgumentError(Gabs.INDEX_ERROR))
    indlength == length(angles) || throw(ArgumentError(Gabs.GENERALDYNE_ERROR))
    # perform conditional mapping of Gaussian quantum state
    result′, a, A = _homodyne_filter(rng, state, indices, angles; squeeze)
    mean′ = zeros(eltype(Tm), 2*nmodes)
    covar′ = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*nmodes, 2*nmodes)
    # fill in measured modes with vacuum states 
    notindices = setdiff(1:nmodes, indices)
    @inbounds for i in eachindex(notindices)
        idx = notindices[i]
        copyto!(@view(mean′[2idx-1:2idx]), @view(a[2i-1:2i]))
        @inbounds for j in i:length(notindices)
            otheridx = notindices[j]
            covar′[2*idx-1, 2*otheridx-1] = A[2*i-1, 2*j-1]
            covar′[2*idx-1, 2*otheridx] = A[2*i-1, 2*j]
            covar′[2*idx, 2*otheridx-1] = A[2*i, 2*j-1]
            covar′[2*idx, 2*otheridx] = A[2*i, 2*j]
            covar′[2*otheridx-1, 2*idx-1] = A[2*j-1, 2*i-1]
            covar′[2*otheridx-1, 2*idx] = A[2*j-1, 2*i]
            covar′[2*otheridx, 2*idx-1] = A[2*j, 2*i-1]
            covar′[2*otheridx, 2*idx] = A[2*j, 2*i]
        end
    end
    # promote output array type to ensure it matches the input array type
    mean′′ = Gabs._promote_output_vector(Tm, mean′, 2*nmodes)
    covar′′ = Gabs._promote_output_matrix(Tc, covar′, 2*nmodes)
    state′ = GaussianState(basis, mean′′, covar′′, ħ = state.ħ)
    return Homodyne(result′, state′)
end
function homodyne(
    state::GaussianState{<:QuadBlockBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    rng::AbstractRNG = Random.default_rng(),
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    nmodes = basis.nmodes
    indlength = length(indices)
    indlength <= nmodes || throw(ArgumentError(Gabs.INDEX_ERROR))
    indlength == length(angles) || throw(ArgumentError(Gabs.GENERALDYNE_ERROR))
    # perform conditional mapping of Gaussian quantum state
    result′, a, A = _homodyne_filter(rng, state, indices, angles; squeeze)
    mean′ = zeros(eltype(Tm), 2*nmodes)
    covar′ = Matrix{eltype(Tc)}((state.ħ/2)*I, 2*nmodes, 2*nmodes)
    nmodes′ = nmodes - length(indices)
    # fill in measured modes with vacuum states
    notindices = setdiff(1:nmodes, indices)
    @inbounds for i in eachindex(notindices)
        idx = notindices[i]
        mean′[idx] = a[i]
        mean′[idx+nmodes] = a[i+nmodes′]
        @inbounds for j in i:length(notindices)
            otheridx = notindices[j]
            covar′[idx,otheridx] = A[i,j]
            covar′[otheridx,idx] = A[j,i]
            covar′[idx+nmodes,otheridx] = A[i+nmodes′,j]
            covar′[idx,otheridx+nmodes] = A[i,j+nmodes′]
            covar′[otheridx,idx+nmodes] = A[j,i+nmodes′]
            covar′[otheridx+nmodes,idx] = A[j+nmodes′,i]
            covar′[idx+nmodes,otheridx+nmodes] = A[i+nmodes′,j+nmodes′]
            covar′[otheridx+nmodes,idx+nmodes] = A[j+nmodes′,i+nmodes′]
        end
    end
    # promote output array type to ensure it matches the input array type
    mean′′ = Gabs._promote_output_vector(Tm, mean′, 2*nmodes)
    covar′′ = Gabs._promote_output_matrix(Tc, covar′, 2*nmodes)
    state′ = GaussianState(basis, mean′′, covar′′, ħ = state.ħ)
    return Homodyne(result′, state′)
end
homodyne(rng::AbstractRNG, state::GaussianState{<:QuadPairBasis,Tm,Tc}, indices::R, angles::G; squeeze::Real = 1e-12) where {Tm,Tc,R,G} = homodyne(state, indices, angles; rng, squeeze)
homodyne(rng::AbstractRNG, state::GaussianState{<:QuadBlockBasis,Tm,Tc}, indices::R, angles::G; squeeze::Real = 1e-12) where {Tm,Tc,R,G} = homodyne(state, indices, angles; rng, squeeze)

"""
    rand([rng::AbstractRNG], ::Type{Homodyne}, state::GaussianState, indices::Vector, angles::Vector; shots = 1, squeeze = 1e-12) -> Array

Compute the projection of the subsystem of a Gaussian state `state` indicated by `indices`
on rotated quadrature states with homodyne phases given by `angles` and return an array of measured modes.
The number of shots is given by `shots`, which determines how many repeated and random homodyne measurements
are performed on the quantum system. The `squeeze` parameter determines the finite squeezing performed during the projection.

The output is an `2*length(indices) × shots` array, which contains the measured position and momentum modes columnwise
for each measurement, the ordering basis of the input Gaussian state `state`.

# Examples
```
julia > st = squeezedstate(QuadBlockBasis(3), 1.0, pi/4);

julia> rand(Homodyne, st, [1, 3], [pi/2, 0], shots = 5)
4×5 Matrix{Float64}:
8.53668e5   5.23331e5  -8.46171e5   4.66993e5  -1.093e6
-1.8943     -0.388814    0.179409    0.245702   -0.896928
-1.77362    -3.96152     0.351279   -3.2279     -1.74368
1.09432e6  -7.7091e5   -2.0881e5    1.31099e6  -5.16098e5
```
"""
function Base.rand(
    ::Type{Homodyne}, 
    state::GaussianState{<:QuadPairBasis,Tm,Tc}, 
    indices::R, 
    angles::G; 
    shots::Int = 1,
    rng::AbstractRNG = Random.default_rng(),
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    return Base.rand(rng, Homodyne, state, indices, angles; shots, squeeze)
end
function Base.rand(
    rng::AbstractRNG,
    ::Type{Homodyne}, 
    state::GaussianState{<:QuadPairBasis,Tm,Tc}, 
    indices::R, 
    angles::G; 
    shots::Int = 1,
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    indlength = length(indices)
    indlength <= basis.nmodes || throw(ArgumentError(Gabs.INDEX_ERROR))
    indlength == length(angles) || throw(ArgumentError(Gabs.GENERALDYNE_ERROR))
    nmodes′ = basis.nmodes - indlength
    mean, covar = state.mean, state.covar
    # write mean and covariance matrix of measured modes to vector `b` and matrix `B`, respectively
    b, B = zeros(2*indlength), zeros(2*indlength, 2*indlength)
    @inbounds for i in eachindex(indices)
        idx = indices[i]
        b[2i-1:2i] .= @view(mean[2idx-1:2idx])
        @inbounds for j in eachindex(indices)
            otheridx = indices[j]
            if idx == otheridx
                B[2i-1:2i, 2i-1:2i] .= @view(covar[2idx-1:2idx, 2idx-1:2idx])
            else
                B[2i-1:2i, 2j-1:2j] .= @view(covar[2idx-1:2idx, 2otheridx-1:2otheridx])
                B[2j-1:2j, 2i-1:2i] .= @view(covar[2otheridx-1:2otheridx, 2idx-1:2idx])
            end
        end
    end
    # infinite squeezing along axis defined by `angles`
    @inbounds for i in Base.OneTo(indlength)
        θ = angles[i]
        ct, st = cos(θ), sin(θ)
        B[i,i] += ct^2 * squeeze + st^2 / squeeze
        B[i,i+indlength] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i+indlength] += st^2 * squeeze + ct^2 / squeeze
    end
    # sample from probability distribution by taking the displaced 
    # Cholesky decomposition of the covariance matrix
    symB = Symmetric(B)
    L = cholesky(symB).L
    buf = zeros(2*indlength)
    results = zeros(2*indlength, shots)
    @inbounds for i in Base.OneTo(shots)
        mul!(@view(results[:,i]), L, randn!(rng, buf))
        @view(results[:,i]) .+= b
    end
    return results
end
function Base.rand(
    ::Type{Homodyne}, 
    state::GaussianState{<:QuadBlockBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    shots::Int = 1,
    rng::AbstractRNG = Random.default_rng(),
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    return Base.rand(rng, Homodyne, state, indices, angles; shots, squeeze)
end
function Base.rand(
    rng::AbstractRNG,
    ::Type{Homodyne}, 
    state::GaussianState{<:QuadBlockBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    shots::Int = 1,
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    nmodes = basis.nmodes
    indlength = length(indices)
    indlength <= nmodes || throw(ArgumentError(Gabs.INDEX_ERROR))
    indlength == length(angles) || throw(ArgumentError(Gabs.GENERALDYNE_ERROR))
    nmodes′ = nmodes - indlength
    mean, covar = state.mean, state.covar
    # write mean and covariance matrix of measured modes to vector `b` and matrix `B`, respectively
    b, B = zeros(2*indlength), zeros(2*indlength, 2*indlength)
    @inbounds for i in eachindex(indices)
        idx = indices[i]
        b[i] = mean[idx]
        b[i+indlength] = mean[idx+nmodes]
        @inbounds for j in eachindex(indices)
            otheridx = indices[j]
            if idx == otheridx
                B[i, i] = covar[idx, idx]
                B[i+indlength, i] = covar[idx+nmodes, idx]
                B[i, i+indlength] = covar[idx, idx+nmodes]
                B[i+indlength, i+indlength] = covar[idx+nmodes, idx+nmodes]
            else
                B[i, j] = covar[idx, otheridx]
                B[i+indlength, j] = covar[idx+nmodes, otheridx]
                B[i, j+indlength] = covar[idx, otheridx+nmodes]
                B[i+indlength, j+indlength] = covar[idx+nmodes, otheridx+nmodes]

                B[j, i] = covar[otheridx, idx]
                B[j+indlength, i] = covar[otheridx+nmodes, idx]
                B[j, i+indlength] = covar[otheridx, idx+nmodes]
                B[j+indlength, i+indlength] = covar[otheridx+nmodes, idx+nmodes]
            end
        end
    end
    # infinite squeezing along axis defined by `angles`
    @inbounds for i in Base.OneTo(indlength)
        θ = angles[i]
        ct, st = cos(θ), sin(θ)
        B[i,i] += ct^2 * squeeze + st^2 / squeeze
        B[i,i+indlength] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i+indlength] += st^2 * squeeze + ct^2 / squeeze
    end
    # sample from probability distribution by taking the displaced 
    # Cholesky decomposition of the covariance matrix
    symB = Symmetric(B)
    L = cholesky(symB).L
    buf = zeros(2*indlength)
    results = zeros(2*indlength, shots)
    @inbounds for i in Base.OneTo(shots)
        mul!(@view(results[:,i]), L, randn!(rng, buf))
        @view(results[:,i]) .+= b
    end
    return results
end

function _homodyne_filter(
    rng::AbstractRNG,
    state::GaussianState{<:QuadPairBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    squeeze::Real = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    indlength = length(indices)
    nmodes′ = basis.nmodes - indlength
    a, b, A, B, C = _part_state(state, indices)
    # infinite squeezing along axis defined by `angles`
    @inbounds for i in Base.OneTo(indlength)
        θ = angles[i]
        ct, st = cos(θ), sin(θ)
        B[2i-1,2i-1] += ct^2 * squeeze + st^2 / squeeze
        B[2i-1,2i] += ct * st * (squeeze - 1 / squeeze)
        B[2i,2i-1] += ct * st * (squeeze - 1 / squeeze)
        B[2i,2i] += st^2 * squeeze + ct^2 / squeeze
    end
    # sample from probability distribution by taking the displaced 
    # Cholesky decomposition of the covariance matrix
    symB = Symmetric(B)
    L = cholesky(symB).L
    resultmean = L * randn(rng, 2*indlength) + b
    meandiff = resultmean - b
    # conditional mapping (see Serafini's Quantum Continuous Variables textbook for reference)
    buf = C * inv(symB)
    a .+= buf * meandiff
    A .-= buf * C'
    # promote output array type to ensure it matches the input array type
    result′ = Gabs._promote_output_vector(Tm, resultmean, 2*indlength)
    return result′, a, A
end
function _homodyne_filter(
    rng::AbstractRNG,
    state::GaussianState{<:QuadBlockBasis,Tm,Tc}, 
    indices::R, 
    angles::G;
    squeeze = 1e-12
) where {Tm,Tc,R,G}
    basis = state.basis
    indlength = length(indices)
    nmodes′ = basis.nmodes - indlength
    a, b, A, B, C = _part_state(state, indices)
    # infinite squeezing along axis defined by `angles`
    @inbounds for i in Base.OneTo(indlength)
        θ = angles[i]
        ct, st = cos(θ), sin(θ)
        B[i,i] += ct^2 * squeeze + st^2 / squeeze
        B[i,i+indlength] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i] += ct * st * (squeeze - 1 / squeeze)
        B[i+indlength,i+indlength] += st^2 * squeeze + ct^2 / squeeze
    end
    # sample from probability distribution by taking the displaced 
    # Cholesky decomposition of the covariance matrix
    symB = Symmetric(B)
    L = cholesky(symB).L
    resultmean = L * randn(rng, 2*indlength) + b
    meandiff = resultmean - b
    # conditional mapping (see Serafini's Quantum Continuous Variables textbook for reference)
    buf = C * inv(symB)
    a .+= buf * meandiff
    A .-= buf * C'
    # promote output array type to ensure it matches the input array type
    result′ = Gabs._promote_output_vector(Tm, resultmean, 2*indlength)
    return result′, a, A
end

@testitem "Linear Combinations" begin
    using Gabs
    using StaticArrays
    using LinearAlgebra

    nmodes = rand(1:3)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)

    @testset "Basic constructors" begin
        vac = vacuumstate(qpairbasis)
        lc1 = GaussianLinearCombination(vac)
        @test lc1 isa GaussianLinearCombination

        @test length(lc1) == 1
        @test lc1[1][1] == 1.0
        @test lc1[1][2] == vac
        @test lc1.basis == qpairbasis
        @test lc1.ħ == 2

        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        coeffs = [0.5, 0.5]
        states = [coh1, coh2]
        lc2 = GaussianLinearCombination(qpairbasis, coeffs, states)
        @test lc2 isa GaussianLinearCombination
        @test length(lc2) == 2
        @test lc2.coeffs == coeffs
        @test lc2.states == states

        pairs = [(0.6, coh1), (0.8, coh2)]
        lc3 = GaussianLinearCombination(pairs)
        @test lc3 isa GaussianLinearCombination
        @test length(lc3) == 2
        @test lc3.coeffs == [0.6, 0.8]

        lc4 = GaussianLinearCombination(0.6 => coh1, 0.8 => coh2)
        @test lc4 isa GaussianLinearCombination
        @test length(lc4) == 2
        @test lc4.coeffs == [0.6, 0.8]

        vac_block = vacuumstate(qblockbasis)
        lc_block = GaussianLinearCombination(vac_block)
        @test lc_block.basis == qblockbasis
        @test Gabs.nmodes(vac_block) == nmodes
    end
    
    @testset "Convenient GaussianState Arithmetic Interface" begin
        nmodes = rand(1:3)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)
        
        @testset "Scalar multiplication of GaussianState" begin
            for basis in [qpairbasis, qblockbasis]
                state = coherentstate(basis, 1.0 + 0.5im)
                
                lc1 = 0.6 * state
                @test lc1 isa GaussianLinearCombination
                @test length(lc1) == 1
                @test lc1.basis == basis
                @test lc1.ħ == state.ħ
                @test lc1.coeffs[1] == 0.6
                @test lc1.states[1] == state
                
                lc2 = state * 0.6
                @test lc2 isa GaussianLinearCombination
                @test lc1 == lc2
                
                lc3 = (0.5 + 0.3im) * state
                @test lc3 isa GaussianLinearCombination
                @test lc3.coeffs[1] == 0.5 + 0.3im
                @test eltype(lc3.coeffs) <: Complex
                
                lc_explicit = GaussianLinearCombination(basis, [0.6], [state])
                @test isapprox(lc1, lc_explicit)
            end
        end
        
        @testset "Addition of GaussianStates" begin
            for basis in [qpairbasis, qblockbasis]
                state1 = coherentstate(basis, 1.0)
                state2 = coherentstate(basis, -1.0)
                
                lc = state1 + state2
                @test lc isa GaussianLinearCombination
                @test length(lc) == 2
                @test lc.basis == basis
                @test lc.ħ == state1.ħ
                @test lc.coeffs == [1.0, 1.0]
                @test lc.states == [state1, state2]
                
                lc_explicit = GaussianLinearCombination(basis, [1.0, 1.0], [state1, state2])
                @test lc == lc_explicit
                
                vac = vacuumstate(basis)
                sq = squeezedstate(basis, 0.3, π/4)
                lc2 = vac + sq
                @test lc2 isa GaussianLinearCombination
                @test length(lc2) == 2
                @test lc2.states == [vac, sq]
            end
        end
        
        @testset "Subtraction of GaussianStates" begin
            for basis in [qpairbasis, qblockbasis]
                state1 = coherentstate(basis, 1.0)
                state2 = coherentstate(basis, -1.0)
                
                lc = state1 - state2
                @test lc isa GaussianLinearCombination
                @test length(lc) == 2
                @test lc.basis == basis
                @test lc.coeffs == [1.0, -1.0]
                @test lc.states == [state1, state2]
                
                lc_explicit = GaussianLinearCombination(basis, [1.0, -1.0], [state1, state2])
                @test lc == lc_explicit
            end
        end
        
        @testset "Negation of GaussianState" begin
            for basis in [qpairbasis, qblockbasis]
                state = coherentstate(basis, 1.0 + 0.5im)
                
                lc = -state
                @test lc isa GaussianLinearCombination
                @test length(lc) == 1
                @test lc.coeffs[1] == -1.0
                @test lc.states[1] == state
                
                lc_equiv = (-1) * state
                @test lc == lc_equiv
            end
        end
        
        @testset "Mixed operations: GaussianState with GaussianLinearCombination" begin
            for basis in [qpairbasis, qblockbasis]
                state1 = coherentstate(basis, 1.0)
                state2 = coherentstate(basis, -1.0)
                state3 = vacuumstate(basis)
                
                lc = GaussianLinearCombination(basis, [0.6, 0.8], [state1, state2])
                
                lc_plus = state3 + lc
                @test lc_plus isa GaussianLinearCombination
                @test length(lc_plus) == 3
                @test lc_plus.coeffs == [1.0, 0.6, 0.8]
                @test lc_plus.states == [state3, state1, state2]
                
                lc_plus2 = lc + state3
                @test lc_plus2 isa GaussianLinearCombination
                @test length(lc_plus2) == 3
                @test lc_plus2.coeffs == [0.6, 0.8, 1.0]
                @test lc_plus2.states == [state1, state2, state3]
                
                lc_minus = state3 - lc
                @test lc_minus isa GaussianLinearCombination
                @test length(lc_minus) == 3
                @test lc_minus.coeffs == [1.0, -0.6, -0.8]
                @test lc_minus.states == [state3, state1, state2]
                
                lc_minus2 = lc - state3
                @test lc_minus2 isa GaussianLinearCombination
                @test length(lc_minus2) == 3
                @test lc_minus2.coeffs == [0.6, 0.8, -1.0]
                @test lc_minus2.states == [state1, state2, state3]
            end
        end
        
        @testset "Complex expressions and equivalences" begin
            basis = qpairbasis
            state1 = coherentstate(basis, 1.0)
            state2 = coherentstate(basis, -1.0)
            state3 = vacuumstate(basis)
            
            lc_complex = 0.5 * state1 + 0.3 * state2 - 0.2 * state3
            @test lc_complex isa GaussianLinearCombination
            @test length(lc_complex) == 3
            
            lc_step1 = 0.5 * state1
            lc_step2 = lc_step1 + 0.3 * state2
            lc_step3 = lc_step2 - 0.2 * state3
            @test isapprox(lc_complex.coeffs, lc_step3.coeffs)
            
            cat_state = 0.5 * state1 + 0.5 * state2
            @test cat_state isa GaussianLinearCombination
            @test length(cat_state) == 2
            @test cat_state.coeffs == [0.5, 0.5]
            @test cat_state.states == [state1, state2]
            
            old_approach = 0.5 * GaussianLinearCombination(state1) + 0.5 * GaussianLinearCombination(state2)
            @test isapprox(cat_state.coeffs, old_approach.coeffs)
        end
        
        @testset "Error handling for incompatible states" begin
            state_pair = coherentstate(qpairbasis, 1.0)
            state_block = coherentstate(qblockbasis, 1.0)
            state_h1 = coherentstate(qpairbasis, 1.0, ħ=1)
            state_h2 = coherentstate(qpairbasis, 1.0, ħ=2)
            
            @test_throws ArgumentError state_pair + state_block
            @test_throws ArgumentError state_pair - state_block
            
            @test_throws ArgumentError state_h1 + state_h2
            @test_throws ArgumentError state_h1 - state_h2
            
            lc_pair = GaussianLinearCombination(state_pair)
            lc_h1 = GaussianLinearCombination(state_h1)
            
            @test_throws ArgumentError state_block + lc_pair
            @test_throws ArgumentError state_h2 + lc_h1
            @test_throws ArgumentError state_pair - lc_h1
            @test_throws ArgumentError lc_pair - state_h1
        end
        
        @testset "Type promotion and coefficient types" begin
            basis = qpairbasis
            state = coherentstate(basis, 1.0)
            
            lc_int = 2 * state
            @test lc_int.coeffs[1] == 2.0
            @test eltype(lc_int.coeffs) <: Real
            
            lc_float = 2.5 * state
            @test lc_float.coeffs[1] == 2.5
            
            lc_complex = (1.0 + 2.0im) * state
            @test lc_complex.coeffs[1] == 1.0 + 2.0im
            @test eltype(lc_complex.coeffs) <: Complex
            
            lc_mixed = lc_int + lc_complex
            @test eltype(lc_mixed.coeffs) <: Complex
        end
        
        @testset "StaticArrays compatibility" begin
            coh_static = coherentstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, 1.0)
            vac_static = vacuumstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
            
            lc_static_mult = 0.7 * coh_static
            @test lc_static_mult isa GaussianLinearCombination
            @test lc_static_mult.states[1].mean isa SVector
            @test lc_static_mult.states[1].covar isa SMatrix
            
            lc_static_add = coh_static + vac_static
            @test lc_static_add isa GaussianLinearCombination
            @test lc_static_add.states[1].mean isa SVector
            @test lc_static_add.states[2].covar isa SMatrix
            
            lc_regular = GaussianLinearCombination(coherentstate(qpairbasis, -1.0))
            lc_mixed = coh_static + lc_regular
            @test lc_mixed isa GaussianLinearCombination
            @test length(lc_mixed) == 2
        end
        
        @testset "Real-world usage examples" begin
            basis = QuadPairBasis(1)
            
            state_pos = coherentstate(basis, 1.0 + 1.0im)
            state_neg = coherentstate(basis, 1.0 - 1.0im)
            
            superposition = 0.5 * state_pos + 0.5 * state_neg
            @test superposition isa GaussianLinearCombination
            @test length(superposition) == 2
            
            vac = vacuumstate(basis)
            coh = coherentstate(basis, 2.0)
            sq = squeezedstate(basis, 0.5, π/4)
            
            complex_state = 0.6 * vac + 0.3 * coh - 0.1 * sq
            @test complex_state isa GaussianLinearCombination
            @test length(complex_state) == 3
            @test isapprox(complex_state.coeffs, [0.6, 0.3, -0.1])
            
            Gabs.normalize!(complex_state)
            norm_val = sqrt(sum(abs2, complex_state.coeffs))
            @test isapprox(norm_val, 1.0, atol=1e-15)
        end
    end

    @testset "Constructor validation" begin
        vac = vacuumstate(qpairbasis)
        vac_block = vacuumstate(qblockbasis)
        vac_diff_h = vacuumstate(qpairbasis, ħ = 1)

        @test_throws ArgumentError GaussianLinearCombination(qpairbasis, [1.0, 1.0], [vac, vac_block])
        
        @test_throws ArgumentError GaussianLinearCombination(qpairbasis, [1.0, 1.0], [vac, vac_diff_h])
        
        @test_throws DimensionMismatch GaussianLinearCombination(qpairbasis, [1.0], [vac, vac])
        
        @test_throws ArgumentError GaussianLinearCombination(qpairbasis, Float64[], GaussianState[])
        @test_throws ArgumentError GaussianLinearCombination(Tuple{Float64,GaussianState}[])
    end

    @testset "Arithmetic operations" begin
        
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        lc1 = GaussianLinearCombination(coh1)
        lc2 = GaussianLinearCombination(coh2)

        lc_sum = lc1 + lc2
        @test lc_sum isa GaussianLinearCombination
        @test length(lc_sum) == 2
        @test lc_sum.coeffs == [1.0, 1.0]
        @test lc_sum.states == [coh1, coh2]

        lc_scaled1 = 0.5 * lc1
        @test lc_scaled1 isa GaussianLinearCombination
        @test lc_scaled1.coeffs == [0.5]
        @test lc_scaled1.states == [coh1]

        lc_scaled2 = lc1 * 0.5
        @test lc_scaled2 isa GaussianLinearCombination
        @test lc_scaled2.coeffs == [0.5]
        @test lc_scaled2 == lc_scaled1

        lc_complex = (1.0 + 2.0im) * lc1
        @test lc_complex.coeffs == [1.0 + 2.0im]

        lc_diff = lc1 - lc2
        @test lc_diff isa GaussianLinearCombination
        @test length(lc_diff) == 2
        @test lc_diff.coeffs == [1.0, -1.0]

        lc_neg = -lc1
        @test lc_neg isa GaussianLinearCombination
        @test lc_neg.coeffs == [-1.0]
    end

    @testset "Arithmetic validation" begin
        vac = vacuumstate(qpairbasis)
        vac_block = vacuumstate(qblockbasis)
        vac_diff_h = vacuumstate(qpairbasis, ħ = 1)
        
        lc1 = GaussianLinearCombination(vac)
        lc_block = GaussianLinearCombination(vac_block)
        lc_diff_h = GaussianLinearCombination(vac_diff_h)

        @test_throws ArgumentError lc1 + lc_block
        @test_throws ArgumentError lc1 - lc_block
        
        @test_throws ArgumentError lc1 + lc_diff_h
        @test_throws ArgumentError lc1 - lc_diff_h
    end

    @testset "Utility functions" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        lc = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh1, coh2])

        @test length(lc) == 2

        @test lc[1] == (0.6, coh1)
        @test lc[2] == (0.8, coh2)

        pairs = collect(lc)
        @test pairs == [(0.6, coh1), (0.8, coh2)]
        
        coeffs_iter = [c for (c, s) in lc]
        states_iter = [s for (c, s) in lc]
        @test coeffs_iter == [0.6, 0.8]
        @test states_iter == [coh1, coh2]
    end

    @testset "Normalization" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        lc = GaussianLinearCombination(qpairbasis, [3.0, 4.0], [coh1, coh2])
        
        initial_norm = sqrt(sum(abs2, lc.coeffs))
        @test initial_norm == 5.0
        
        result = Gabs.normalize!(lc)
        @test result === lc  
        @test isapprox(sqrt(sum(abs2, lc.coeffs)), 1.0, atol=1e-15)
        @test lc.coeffs ≈ [0.6, 0.8]

        lc_zero = GaussianLinearCombination(qpairbasis, [0.0, 0.0], [coh1, coh2])
        Gabs.normalize!(lc_zero)
        @test all(lc_zero.coeffs .== 0.0)
    end

    @testset "Simplification" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        vac = vacuumstate(qpairbasis)

        lc1 = GaussianLinearCombination(qpairbasis, [1.0, 1e-16, 0.5], [coh1, coh2, vac])
        Gabs.simplify!(lc1)
        @test length(lc1) == 2
        @test lc1.coeffs ≈ [1.0, 0.5]
        @test lc1.states == [coh1, vac]

        lc2 = GaussianLinearCombination(qpairbasis, [0.5, 0.3, 0.2], [coh1, coh2, coh1])
        Gabs.simplify!(lc2)
        @test length(lc2) == 2
        if lc2.states[1] == coh1
            @test lc2.coeffs ≈ [0.7, 0.3]
            @test lc2.states == [coh1, coh2]
        else
            @test lc2.coeffs ≈ [0.3, 0.7]
            @test lc2.states == [coh2, coh1]
        end

        lc3 = GaussianLinearCombination(qpairbasis, [1e-16, -1e-16], [coh1, coh2])
        Gabs.simplify!(lc3)
        @test length(lc3) == 1
        @test lc3.coeffs[1] ≈ 1e-14
        @test lc3.states[1] == vacuumstate(qpairbasis)

        lc4 = GaussianLinearCombination(qpairbasis, [1.0, -1.0], [coh1, coh1])
        Gabs.simplify!(lc4)
        @test length(lc4) == 1
        @test lc4.coeffs[1] ≈ 1e-14

        lc5 = GaussianLinearCombination(qpairbasis, [1.0, 1e-10], [coh1, coh2])
        Gabs.simplify!(lc5, atol=1e-12)
        @test length(lc5) == 2  # 1e-10 > 1e-12, so keep both
        Gabs.simplify!(lc5, atol=1e-8)
        @test length(lc5) == 1   # 1e-10 < 1e-8, so remove small one
    end

    @testset "Equality and approximation" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        
        lc1 = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh1, coh2])
        lc2 = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh1, coh2])
        lc3 = GaussianLinearCombination(qpairbasis, [0.6, 0.8001], [coh1, coh2])
        
        @test lc1 == lc2
        @test lc1 != lc3
        
        @test isapprox(lc1, lc3, atol=1e-3)
        @test !isapprox(lc1, lc3, atol=1e-5)

        lc_block = GaussianLinearCombination(qblockbasis, [0.6, 0.8], 
                                           [coherentstate(qblockbasis, 1.0), coherentstate(qblockbasis, -1.0)])
        @test lc1 != lc_block
        @test !isapprox(lc1, lc_block)
    end

    @testset "Display methods" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        lc = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh1, coh2])
        
        io = IOBuffer()
        show(io, lc)
        output_short = String(take!(io))
        @test contains(output_short, "GaussianLinearCombination")
        
        show(io, MIME("text/plain"), lc)
        output_long = String(take!(io))
        @test contains(output_long, "GaussianLinearCombination")
        @test contains(output_long, "QuadPairBasis")
        @test contains(output_long, "mode")
    end

    @testset "Complex coefficients" begin
        coh = coherentstate(qpairbasis, 1.0)
        vac = vacuumstate(qpairbasis)
        
        lc_complex = GaussianLinearCombination(qpairbasis, [1.0 + 2.0im, 0.5 - 1.0im], [coh, vac])
        @test lc_complex isa GaussianLinearCombination
        @test eltype(lc_complex.coeffs) <: Complex
        
        lc_scaled = (0.5 + 0.5im) * lc_complex
        @test eltype(lc_scaled.coeffs) <: Complex
        
        Gabs.normalize!(lc_complex)
        norm_val = sqrt(sum(abs2, lc_complex.coeffs))
        @test isapprox(norm_val, 1.0, atol=1e-15)
    end

    @testset "Integration with existing Gabs types" begin
        for basis in [qpairbasis, qblockbasis]
            coh = coherentstate(basis, 2.0)
            vac = vacuumstate(basis)
            sq = squeezedstate(basis, 0.5, π/4)
            
            lc = GaussianLinearCombination(basis, [0.5, 0.3, 0.2], [coh, vac, sq])
            @test lc.basis == basis
            @test all(s.basis == basis for s in lc.states)
        end
        
        coh_h1 = coherentstate(qpairbasis, 1.0, ħ = 1)
        coh_h2 = coherentstate(qpairbasis, -1.0, ħ = 1)
        lc_h1 = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh_h1, coh_h2])
        @test lc_h1.ħ == 1
        
        lc_h1_scaled = 2.0 * lc_h1
        @test lc_h1_scaled.ħ == 1
    end

    @testset "Embedding" begin
        α = rand(ComplexF64)

        for basis in [qpairbasis, qblockbasis]
            lc = GaussianLinearCombination(basis, [0.7, 0.3], [coherentstate(basis, α), vacuumstate(basis)])
            big_basis = basis ⊕ basis
            indices = collect(basis.nmodes + 1:2*basis.nmodes)
            embedded = embed(big_basis, indices, lc)
            expected_states = [embed(big_basis, indices, state) for state in lc.states]

            @test embedded.basis == big_basis
            @test embedded.coeffs == lc.coeffs
            @test embedded.states == expected_states
            @test embedded.ħ == lc.ħ
        end

        small_pair = QuadPairBasis(2)
        pair_coeffs = [0.6, 0.4]
        r_vec = rand(Float64, small_pair.nmodes)
        θ_vec = rand(Float64, small_pair.nmodes)
        pair_states = [coherentstate(small_pair, rand(ComplexF64, small_pair.nmodes)), squeezedstate(small_pair, r_vec, θ_vec)]
        lc_pair = GaussianLinearCombination(small_pair, pair_coeffs, pair_states)
        full_pair = small_pair ⊕ QuadPairBasis(1)
        embedded_pair = embed(full_pair, [1, 3], lc_pair)
        expected_pair_states = [embed(full_pair, [1, 3], state) for state in pair_states]
        @test embedded_pair.coeffs == pair_coeffs
        @test embedded_pair.states == expected_pair_states

        small_block = QuadBlockBasis(2)
        block_coeffs = [0.5, 0.5]
        block_states = [thermalstate(small_block, fill(2, small_block.nmodes)), coherentstate(small_block, rand(ComplexF64, small_block.nmodes))]
        lc_block = GaussianLinearCombination(small_block, block_coeffs, block_states)
        full_block = small_block ⊕ QuadBlockBasis(1)
        embedded_block = embed(full_block, [1, 3], lc_block)
        expected_block_states = [embed(full_block, [1, 3], state) for state in block_states]
        @test embedded_block.coeffs == block_coeffs
        @test embedded_block.states == expected_block_states

        @test_throws AssertionError embed(full_pair, [1], lc_pair)
    end

    @testset "Static arrays compatibility" begin
        coh_static = coherentstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, 1.0)
        vac_static = vacuumstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        
        lc_static = GaussianLinearCombination(qpairbasis, [0.6, 0.8], [coh_static, vac_static])
        @test lc_static isa GaussianLinearCombination
        @test lc_static.states[1].mean isa SVector
        @test lc_static.states[1].covar isa SMatrix
        
        lc_static_scaled = 0.5 * lc_static
        @test lc_static_scaled isa GaussianLinearCombination
    end

    @testset "Cat state example" begin
        basis = QuadPairBasis(1)
        state1 = coherentstate(basis, 1.0)
        state2 = coherentstate(basis, -1.0)
        
        lcgs = 0.5 * GaussianLinearCombination(state1) + 0.5 * GaussianLinearCombination(state2)
        
        @test lcgs isa GaussianLinearCombination
        @test length(lcgs) == 2
        @test lcgs.coeffs == [0.5, 0.5]
        @test lcgs.states[1] == state1
        @test lcgs.states[2] == state2
        
        norm_val = sqrt(sum(abs2, lcgs.coeffs))
        @test isapprox(norm_val, sqrt(0.5), atol=1e-15)
        
        cat_state = GaussianLinearCombination(0.5 => state1, 0.5 => state2)
        @test cat_state.coeffs == [0.5, 0.5]
    end

    @testset "Edge cases" begin
        coh1 = coherentstate(qpairbasis, 1.0)
        coh2 = coherentstate(qpairbasis, -1.0)
        
        lc_single = GaussianLinearCombination(coh1)
        @test length(lc_single) == 1
        @test lc_single.coeffs == [1.0]
        
        lc_with_zero = GaussianLinearCombination(qpairbasis, [0.0, 1.0], [coh1, coh2])
        @test length(lc_with_zero) == 2
        Gabs.simplify!(lc_with_zero)
        @test length(lc_with_zero) == 1
        @test lc_with_zero.states[1] == coh2
        
        many_states = [coherentstate(qpairbasis, Float64(i)) for i in 1:100]
        many_coeffs = [1.0/100 for _ in 1:100]
        lc_many = GaussianLinearCombination(qpairbasis, many_coeffs, many_states)
        @test length(lc_many) == 100
        
        lc_identical = GaussianLinearCombination(qpairbasis, [0.2, 0.3, 0.5], [coh1, coh1, coh1])
        Gabs.simplify!(lc_identical)
        @test length(lc_identical) == 1
        @test lc_identical.coeffs[1] ≈ 1.0
        @test lc_identical.states[1] == coh1
    end
end

@testitem "States" begin
    using Gabs
    using StaticArrays
    using LinearAlgebra: det

    nmodes = rand(1:5)
    qpairbasis = QuadPairBasis(nmodes)
    qblockbasis = QuadBlockBasis(nmodes)

    @testset "vacuum states" begin
        state, array_state, static_state = vacuumstate(qpairbasis), vacuumstate(Array, qpairbasis), vacuumstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        @test state isa GaussianState && array_state isa GaussianState && static_state isa GaussianState
        @test vacuumstate(qblockbasis) == changebasis(QuadBlockBasis, state)
        @test state.ħ == 2 && array_state.ħ == 2 && static_state.ħ == 2
    end

    @testset "thermal states" begin
        n = rand(1:5)
        ns = rand(1:5, nmodes)
        state_pair = thermalstate(qpairbasis, n)
        state_block = thermalstate(qblockbasis, n)
        @test state_pair isa GaussianState && state_block isa GaussianState
        @test thermalstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, n) isa GaussianState
        @test thermalstate(qblockbasis, n) == changebasis(QuadBlockBasis, state_pair)
        @test state_pair == changebasis(QuadPairBasis, state_block) && state_block == changebasis(QuadBlockBasis, state_pair)
        @test state_pair == changebasis(QuadPairBasis, state_pair) && state_block == changebasis(QuadBlockBasis, state_block)
        @test thermalstate(qblockbasis, ns) == changebasis(QuadBlockBasis, thermalstate(qpairbasis, ns))
        @test isgaussian(state_pair, atol = 1e-4)
        @test state_pair.ħ == 2 && state_block.ħ == 2
    end

    @testset "coherent states" begin
        alpha = rand(ComplexF64)
        alphas = rand(ComplexF64, nmodes)
        state_pair = coherentstate(qpairbasis, alpha)
        state_block = coherentstate(qblockbasis, alpha)
        @test state_pair isa GaussianState && state_block isa GaussianState
        @test coherentstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, alpha) isa GaussianState
        @test coherentstate(qblockbasis, alpha) == changebasis(QuadBlockBasis, state_pair)
        @test state_pair == changebasis(QuadPairBasis, state_block) && state_block == changebasis(QuadBlockBasis, state_pair)
        @test state_pair == changebasis(QuadPairBasis, state_pair) && state_block == changebasis(QuadBlockBasis, state_block)
        @test coherentstate(qblockbasis, alphas) == changebasis(QuadBlockBasis, coherentstate(qpairbasis, alphas))
        @test isgaussian(state_pair, atol = 1e-4)
        @test state_pair.ħ == 2 && state_block.ħ == 2
    end

    @testset "squeezed states" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        state, array_state, static_state = squeezedstate(qpairbasis, r, theta), squeezedstate(Array, qpairbasis, r, theta), squeezedstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis, r, theta)
        @test state isa GaussianState && array_state isa GaussianState && static_state isa GaussianState
        @test squeezedstate(qblockbasis, r, theta) == changebasis(QuadBlockBasis, state)
        @test squeezedstate(qblockbasis, rs, thetas) == changebasis(QuadBlockBasis, squeezedstate(qpairbasis, rs, thetas))
        @test state.ħ == 2 && array_state.ħ == 2 && static_state.ħ == 2
    end

    @testset "epr states" begin
        r, theta = rand(Float64), rand(Float64)
        rs, thetas = rand(Float64, nmodes), rand(Float64, nmodes)
        state, array_state, static_state = eprstate(2*qpairbasis, r, theta), eprstate(Array, 2*qpairbasis, r, theta), eprstate(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, r, theta)
        @test state isa GaussianState && array_state isa GaussianState && static_state isa GaussianState
        @test eprstate(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, 2*qpairbasis, r, theta) isa GaussianState
        @test eprstate(2*qblockbasis, r, theta) == changebasis(QuadBlockBasis, state)
        @test eprstate(2*qblockbasis, rs, thetas) == changebasis(QuadBlockBasis, eprstate(2*qpairbasis, rs, thetas))
        @test state.ħ == 2 && array_state.ħ == 2 && static_state.ħ == 2
    end

    @testset "tensor products" begin
        v = vacuumstate(qpairbasis)
        vs = tensor(v, v)
        @test vs isa GaussianState
        @test tensor(SVector{4*nmodes}, SMatrix{4*nmodes,4*nmodes}, v, v) isa GaussianState
        @test vs == v ⊗ v
        @test isapprox(vs, v ⊗ v, atol = 1e-10)

        alpha = rand(ComplexF64)
        c = coherentstate(qpairbasis, alpha)
        @test tensor(c, tensor(v, v)) == c ⊗ v ⊗ v

        r, theta = rand(Float64), rand(Float64)
        sq = squeezedstate(qblockbasis, r, theta)
        sqs = squeezedstate(2*qblockbasis, repeat([r], 2*nmodes), repeat([theta], 2*nmodes))
        @test sq ⊗ sq == sqs

        vstatic = vacuumstate(SVector{2*nmodes}, SMatrix{2*nmodes,2*nmodes}, qpairbasis)
        tpstatic = vstatic ⊗ vstatic ⊗ vstatic
        @test tpstatic.mean isa SVector{6*nmodes}
        @test tpstatic.covar isa SMatrix{6*nmodes,6*nmodes}
        tp = vstatic ⊗ v ⊗ vstatic
        @test tp.mean isa Vector
        @test tp.covar isa Matrix
    end

    @testset "partial trace" begin
        qpairbasis, qblockbasis = QuadPairBasis(1), QuadBlockBasis(1)
        alpha = rand(Float64)
        r, theta = rand(Float64), rand(Float64)
        n = rand(Int)

        for basis in [qpairbasis, qblockbasis]
            s1, s2, s3 = coherentstate(basis, alpha), squeezedstate(basis, r, theta), thermalstate(basis, n)
            state = s1 ⊗ s2 ⊗ s3
            @test ptrace(state, 1) == s2 ⊗ s3
            @test ptrace(state, 2) == s1 ⊗ s3
            @test ptrace(state, 3) == s1 ⊗ s2
            @test ptrace(state, [1, 2]) == s3
            @test ptrace(state, [1, 3]) == s2
            @test ptrace(state, [2, 3]) == s1
            @test_throws ArgumentError ptrace(state, [1, 2, 3, 4])

            single_mode = coherentstate(basis, alpha)
            @test_throws ArgumentError ptrace(single_mode, 1)

            sstatic = coherentstate(SVector{2}, SMatrix{2,2}, basis, alpha)
            tpstatic = sstatic ⊗ sstatic ⊗ sstatic
            @test ptrace(tpstatic, 1) == sstatic ⊗ sstatic
            @test ptrace(tpstatic, [1,3]) == sstatic

            @test ptrace(SVector{2}, SMatrix{2,2}, state, [1, 3]) isa GaussianState
            @test ptrace(SVector{4}, SMatrix{4,4}, state, 1) isa GaussianState

            eprstates = eprstate(basis ⊕ basis ⊕ basis ⊕ basis, r, theta)

            @test ptrace(eprstates, [1, 2]) == eprstate(basis ⊕ basis, r, theta)
        end
    end

    @testset "embed" begin
        qpairbasis = QuadPairBasis(1)
        qblockbasis = QuadBlockBasis(1)
    
        α = rand(Float64) + im * randn(Float64)
        r, θ = rand(Float64), 2π * rand(Float64)
        n = rand(1:5)
    
        for basis in [qpairbasis, qblockbasis]
            s1 = coherentstate(basis, α)
            s2 = squeezedstate(basis, r, θ)
            s3 = thermalstate(basis, n)
            full_basis = basis ⊕ basis ⊕ basis
            state = s1 ⊗ s2 ⊗ s3
    
            @test embed(full_basis, 1, s1) == s1 ⊗ vacuumstate(basis) ⊗ vacuumstate(basis)
            @test embed(full_basis, 2, s2) == vacuumstate(basis) ⊗ s2 ⊗ vacuumstate(basis)
            @test embed(full_basis, 3, s3) == vacuumstate(basis) ⊗ vacuumstate(basis) ⊗ s3
            @test embed(full_basis, [1,2], s1 ⊗ s2) == s1 ⊗ s2 ⊗ vacuumstate(basis)
            @test embed(full_basis, [1,3], s1 ⊗ s3) == s1 ⊗ vacuumstate(basis) ⊗ s3
            @test embed(full_basis, [2,3], s2 ⊗ s3) == vacuumstate(basis) ⊗ s2 ⊗ s3

            @test ptrace(embed(full_basis, 2, s1), [1,3]) == s1
            @test ptrace(embed(full_basis, [2,3], s1 ⊗ s2), [1]) == s1 ⊗ s2
    
            @test_throws AssertionError embed(full_basis, [1,2,3,4], s1 ⊗ s2 ⊗ s3)
            @test_throws AssertionError embed(full_basis, [1, 2], s1)  # wrong number of modes
        end
    end    

    @testset "symplectic spectrum" begin
        nmodes = rand(1:5)
        qpairbasis = QuadPairBasis(nmodes)
        qblockbasis = QuadBlockBasis(nmodes)

        s_qpair = randstate(qpairbasis)
        s_qblock = randstate(qblockbasis)

        spec_qpair = sympspectrum(s_qpair)
        spec_qblock = sympspectrum(s_qblock)

        @test all(i > 1 || isapprox(i, 1, atol=1e-5) for i in spec_qpair)
        @test all(i > 1 || isapprox(i, 1, atol=1e-5) for i in spec_qblock)

        @test isapprox(det(s_qpair.covar), prod(abs2, spec_qpair), atol=1e-3)
        @test isapprox(det(s_qblock.covar), prod(abs2, spec_qblock), atol=1e-3)
    end
end

SYMPLECTIC_ERROR = lazy"The symplectic forms of the Gaussian objects do not match.
    To resolve this issue, either revise the Gaussian objects or consider using
    the function `changebasis` to arrive at a common symplectic form."

STATE_ERROR = lazy"Either the input covariance matrix is not
    square or its dimensions do not match the mean vector. An
    arbitrary N-mode Gaussian state is characterized by a mean
    vector of length 2N and a covariance matrix of size 2N x 2N."

UNITARY_ERROR = lazy"Either the input symplectic matrix is not square 
    or there is a dimension mismatch. An arbitrary N-mode Gaussian 
    unitary operator is characterized by a displacement vector of 
    length 2N and a symplectic matrix of size 2N x 2N." 

CHANNEL_ERROR = lazy"Either an input matrix is not square or 
    there is a dimension mismatch. An arbitrary N-mode Gaussian 
    channel is characterized by a displacement vector of length
    2N, a transform matrix of size 2N x 2N, and a noise matrix
    of size 2N x 2N." 

ACTION_ERROR = lazy"The number of modes for the Gaussian operator
    does not match the number of modes for the Gaussian state, or the symplectic representations for
    the two types are different."

GENERALDYNE_ERROR = lazy"The number of modes for the measurement state
    does not match the number of modes for the projected subsystem."

WIGNER_ERROR = lazy"The length of your input array does not match the
    number of modes for the Gaussian state."

HEATMAP_ERROR = lazy"The input Gaussian state describes more than one mode. 
    A heat map visualization for a multi-mode Gaussian state is not possible."

HBAR_ERROR = lazy"There are at least two different conventions for `ħ` used in this operation. Make sure
    that each Gaussian object has the same convention for `ħ`."

INDEX_ERROR = lazy"The provided indices must all be positive integer values that are no greater than the number of modes encompassed within the Gaussian state."

"""
    purity(state::GaussianState)

Calculate the purity of a Gaussian state, defined by `1/sqrt((2/ħ) det(V))`.
"""
purity(x::GaussianState) = (b = x.basis; (x.ħ/2)^(b.nmodes)/sqrt(det(x.covar)))

"""
    entropy_vn(state::GaussianState; tol::Real = 128 * eps(1/2))

Calculate the Von Neumann entropy of a Gaussian state, defined as

```math
S(\\rho) = -Tr(\\rho \\log(\\rho)) = \\sum_i f(v_i)
```

such that ``\\log`` denotes the natural logarithm, ``v_i`` is the symplectic
spectrum of ``\\mathbf{V}/\\hbar``, and the ``f`` is taken to be

```math
f(x) = (x + 1/2) \\log(x + 1/2) - (x - 1/2) \\log(x - 1/2)
```
wherein it is understood that ``0 \\log(0) \\equiv 0``.

# Arguments
* `state`: Gaussian state whose Von Neumann entropy is to be calculated.
* `tol`: Tolerance (exclusive) above the cut-off at ``1/2`` for computing ``f(x)``.
"""
function entropy_vn(state::GaussianState{B, M, V}; tol::Real = real(eltype(V)) <: AbstractFloat ? 128 * eps(real(eltype(V))(1) / real(eltype(V))(2)) : 128 * eps(1/2)) where {B, M, V}
    T = real(eltype(V))
    T = T <: AbstractFloat ? T : Float64
    S = _sympspectrum(state.covar, x -> (x - (T(1) / T(2))) > tol; pre = symplecticform(state.basis), invscale = state.ħ)
    return reduce(+, _entropy_vn.(S))
end

# this is the same as f(x)
_entropy_vn(x) = x < 19 ?
    (x + (1/2)) * log(x + (1/2)) - (x - (1/2)) * log(x - (1/2)) :
    log(x) + 1 - (1/(24 * x^2)) - (1/(320 * x^4)) - (1/(2688 * x^6))

"""
    fidelity(state1::GaussianState, state2::GaussianState; tol::Real = 128 * eps(1))

Calculate the joint fidelity of two Gaussian states, defined as

```math
F(\\rho, \\sigma) = Tr(\\sqrt{\\sqrt{\\rho} \\sigma \\sqrt{\\rho}}).
```

See: Banchi, Braunstein, and Pirandola, Phys. Rev. Lett. 115, 260501 (2015)

# Arguments
* `state1`, `state2`: Gaussian states whose joint fidelity is to be calculated.
* `tol`: Tolerance (inclusive) above the cut-off at ``1`` for computing ``x + \\sqrt{x^2 - 1}``.
"""
function fidelity(state1::GaussianState{B1, M1, V1}, state2::GaussianState{B2, M2, V2}; tol::Real = real(promote_type(eltype(V1), eltype(V2))) <: AbstractFloat ? 128 * eps(real(promote_type(eltype(V1), eltype(V2)))) : 128 * eps(1/1)) where {B1, M1, V1, B2, M2, V2}
    state1.basis == state2.basis || throw(ArgumentError(SYMPLECTIC_ERROR))
    state1.ħ == state2.ħ || throw(ArgumentError(HBAR_ERROR))
    A = state2.mean - state1.mean
    B = state1.covar + state2.covar
    # many nasty factors of ħ ahead, tread carefully
    output = state1.ħ^(state1.basis.nmodes/2) * exp(- (transpose(A) * (B \ A)) / 4) / (det(B))^(1/4)
    A = symplecticform(state1.basis)
    # slightly different from Banachi, Braunstein, and Pirandola
    B = (B \ ((A .* ((state1.ħ^2)/4)) + (state2.covar * A * state1.covar)))
    T = real(promote_type(eltype(V1), eltype(V2)))
    T = T <: AbstractFloat ? T : Float64
    B = _sympspectrum(B, x -> (x - T(1)) >= tol; invscale = (state1.ħ / T(2)))
    return output * sqrt(reduce(*, _fidelity.(B)))
end

# this is the same as x + sqrt(x^2 - 1) when x > 0, but overflows gradually
_fidelity(x) = x^2 < floatmax(typeof(x)) ? x + sqrt(x^2 - 1) : 2 * x

"""
    logarithmic_negativity(state::GaussianState, indices::Union{Integer, AbstractVector{<:Integer}}; tola::Real = 0, tolb::Real = 128 * eps(1))

Calculate the logarithmic negativity of a Gaussian state partition, defined as

```math
N(\\rho) = \\log\\|\\rho^{T_B}\\|_1 = - \\sum_i \\log(2 \\tilde{v}_i^<)
```

such that ``\\log`` denotes the natural logarithm, ``\\tilde{v}_i^<`` is the
symplectic spectrum of ``\\mathbf{\\tilde{V}}/\\hbar`` which is ``< 1/2``.

Therein, ``\\mathbf{\\tilde{V}} = \\mathbf{T} \\mathbf{V} \\mathbf{T}`` where
```math
\\forall k : \\mathbf{T} q_k = q_k
\\forall k \\in \\mathrm{B} : \\mathbf{T} p_k = -p_k
\\forall k \\notin \\mathrm{B} : \\mathbf{T} p_k = p_k
```

# Arguments
* `state`: Gaussian state whose logarithmic negativity is to be calculated.
* `indices`: Integer or collection thereof, specifying the binary partition.
* `tola`: Tolerance (inclusive) above the cut-off at ``0`` for computing ``\\log(x)``.
* `tolb`: Tolerance (inclusive) below the cut-off at ``1`` for computing ``\\log(x)``.
"""
function logarithmic_negativity(state::GaussianState{B, M, V}, indices::Union{Integer, AbstractVector{<:Integer}}; tola::Real = 0, tolb::Real = real(eltype(V)) <: AbstractFloat ? 128 * eps(real(eltype(V))) : 128 * eps(1/1)) where {B, M, V}
    S = _tilde(state, indices)
    T = real(eltype(V))
    T = T <: AbstractFloat ? T : Float64
    S = _sympspectrum(S, x -> x >= tola && (T(1) - x) >= tolb; pre = symplecticform(state.basis), invscale = (state.ħ / T(2)))
    S = reduce(+, log.(S))
    # in case the reduction happened over an empty set
    return S < 0 ? -S : S
end

function _tilde(state::GaussianState{B,M,V}, indices::Union{Integer, AbstractVector{<:Integer}}) where {B<:QuadPairBasis,M,V}
    nmodes = state.basis.nmodes
    indices = collect(indices)
    all(x -> x >= 1 && x <= nmodes, indices) || throw(ArgumentError(INDEX_ERROR))
    T = copy(state.covar)
    @inbounds for i in indices
        # first loop is cache friendly, second one thrashes
        @inbounds for j in Base.OneTo(2*nmodes)
            T[j, 2*i] *= -1
        end
        @inbounds for j in Base.OneTo(2*nmodes)
            T[2*i, j] *= -1
        end
    end
    return T
end
function _tilde(state::GaussianState{B,M,V}, indices::Union{Integer, AbstractVector{<:Integer}}) where {B<:QuadBlockBasis,M,V}
    nmodes = state.basis.nmodes
    indices = collect(indices)
    all(x -> x >= 1 && x <= nmodes, indices) || throw(ArgumentError(INDEX_ERROR))
    T = copy(state.covar)
    @inbounds for i in indices
        # first loop is cache friendly, second one thrashes
        @inbounds for j in Base.OneTo(2*nmodes)
            T[j, nmodes + i] *= -1
        end
        @inbounds for j in Base.OneTo(2*nmodes)
            T[nmodes + i, j] *= -1
        end
    end
    return T
end

@testitem "Automatic differentiation" begin
    using Gabs
    using DifferentiationInterface
    import ForwardDiff
    import FiniteDiff


    @testset "derivatives" begin

        n = rand(1:5)
        xs = rand(Float64)

        function f1(x::R) where {R<:Real}
            basis = QuadPairBasis(n)
            state = vacuumstate(basis)
            op = attenuator(basis, x, 2)
            newstate = op * state
            return abs(1 - purity(newstate))^2
        end

        findiff_f1 = derivative(f1, AutoFiniteDiff(), xs)
        fordiff_f1 = derivative(f1, AutoForwardDiff(), xs)

        @test isapprox(findiff_f1, fordiff_f1, atol = 1e-4)

    end

    @testset "gradients" begin

        n = rand(1:5)
        xs = rand(n)

        function f1(x::AbstractVector{<:Real})
            basis = QuadPairBasis(length(x))
            state = squeezedstate(basis, x, x)
            op = amplifier(basis, x, ones(length(x)))
            newstate = op * state
            return abs(1 - purity(newstate))^2
        end

        findiff_f1 = gradient(f1, AutoFiniteDiff(), xs)
        fordiff_f1 = gradient(f1, AutoForwardDiff(), xs)

        @test isapprox(findiff_f1, fordiff_f1, atol = 1e-4)

    end
end
        

##
# Predefined Gaussian channels
##

function displace(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, alpha::A, noise::M) where {Td,Tt,N<:Int,A,M}
    disp, transform = _displace(basis, alpha)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise))
end
displace(::Type{T}, basis::SymplecticBasis{N}, alpha::A, noise::M) where {T,N<:Int,A,M} = displace(T, T, basis, alpha, noise)
function displace(basis::SymplecticBasis{N}, alpha::A, noise::M) where {N<:Int,A,M}
    disp, transform = _displace(basis, alpha)
    return GaussianChannel(basis, disp, transform, noise)
end

function squeeze(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {Td,Tt,N<:Int,R,M}
    disp, transform = _squeeze(basis, r, theta)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise))
end
squeeze(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {T,N<:Int,R,M} = squeeze(T, T, basis, r, theta, noise)
function squeeze(basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {N<:Int,R,M}
    disp, transform = _squeeze(basis, r, theta)
    return GaussianChannel(basis, disp, transform, noise)
end

function twosqueeze(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {Td,Tt,N<:Int,R,M}
    disp, transform = _twosqueeze(basis, r, theta)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise))
end
twosqueeze(::Type{T}, basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {T,N<:Int,R,M} = twosqueeze(T, T, basis, r, theta, noise)
function twosqueeze(basis::SymplecticBasis{N}, r::R, theta::R, noise::M) where {N<:Int,R,M}
    disp, transform = _twosqueeze(basis, r, theta)
    return GaussianChannel(basis, disp, transform, noise)
end

function phaseshift(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, theta::R, noise::M) where {Td,Tt,N<:Int,R,M}
    disp, transform = _phaseshift(basis, theta)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise))
end
phaseshift(::Type{T}, basis::SymplecticBasis{N}, theta::R, noise::M) where {T,N<:Int,R,M} = phaseshift(T, T, basis, theta, noise)
function phaseshift(basis::SymplecticBasis{N}, theta::R, noise::M) where {N<:Int,R,M}
    disp, transform = _phaseshift(basis, theta)
    return GaussianChannel(basis, disp, transform, noise)
end

function beamsplitter(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, transmit::R, noise::M) where {Td,Tt,N<:Int,R,M}
    disp, transform = _beamsplitter(basis, transmit)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise))
end
beamsplitter(::Type{T}, basis::SymplecticBasis{N}, transmit::R, noise::M) where {T,N<:Int,R,M} = beamsplitter(T, T, basis, transmit, noise)
function beamsplitter(basis::SymplecticBasis{N}, transmit::R, noise::M) where {N<:Int,R,M}
    disp, transform = _beamsplitter(basis, transmit)
    return GaussianChannel(basis, disp, transform, noise)
end

"""
    attenuator([Td=Vector{Float64}, Tt=Matrix{Float64},] basis::SymplecticBasis, theta<:Real, n<:Int)

Gaussian channel describing the coupling of an input
single mode Gaussian state and its environment via a beam splitter operation. The channel is paramatrized
by beam splitter rotation angle `theta` and thermal noise `n`.

## Mathematical description of an attenuator channel

An attenuator channel, `E(θ, nₜₕ)`, where `θ` is
the beam splitter rotation parameter and `nₜₕ ≥ 1` is the thermal noise parameter,
is characterized by the zero displacement vector, transformation matrix `cos(θ)I`,
and noise matrix `nₜₕsin²(θ)I`.

## Example

```jldoctest
julia> attenuator(QuadPairBasis(1), pi/6, 3)
GaussianChannel for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 0.0
 0.0
transform: 2×2 Matrix{Float64}:
 0.866025  0.0
 0.0       0.866025
noise: 2×2 Matrix{Float64}:
 0.75  0.0
 0.0   0.75
```
"""
function attenuator(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, theta::R, n::M; ħ = 2) where {Td,Tt,N<:Int,R,M}
    disp, transform, noise = _attenuator(basis, theta, n)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise); ħ = ħ)
end
attenuator(::Type{T}, basis::SymplecticBasis{N}, theta::R, n::M; ħ = 2) where {T,N<:Int,R,M} = attenuator(T, T, basis, theta, n; ħ = ħ)
function attenuator(basis::SymplecticBasis{N}, theta::R, n::M; ħ = 2) where {N<:Int,R,M}
    disp, transform, noise = _attenuator(basis, theta, n)
    return GaussianChannel(basis, disp, transform, noise; ħ = ħ)
end
function _attenuator(basis::Union{QuadPairBasis{N},QuadBlockBasis{N}}, theta::R, n::M) where {N<:Int,R,M}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes)
    transform = Matrix{R}(cos(theta) * I, 2*nmodes, 2*nmodes)
    noise = Matrix{R}((sin(theta))^2 * n * I, 2*nmodes, 2*nmodes)
    return disp, transform, noise
end
function _attenuator(basis::QuadPairBasis{N}, theta::R, n::M) where {N<:Int,R<:Vector,M<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    transform = zeros(Rt, 2*nmodes, 2*nmodes)
    noise = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        ct, st = cos(theta[i]), sin(theta[i])
        ni = n[i]

        transform[2*i-1, 2*i-1] = ct
        transform[2*i, 2*i] = ct

        noise[2*i-1, 2*i-1] = st^2 * ni
        noise[2*i, 2*i] = st^2 * ni
    end
    return disp, transform, noise
end
function _attenuator(basis::QuadBlockBasis{N}, theta::R, n::M) where {N<:Int,R<:Vector,M<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes)
    transform = zeros(Rt, 2*nmodes, 2*nmodes)
    noise = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        ct, st = cos(theta[i]), sin(theta[i])
        ni = n[i]

        transform[i, i] = ct
        transform[i+nmodes, i+nmodes] = ct

        noise[i, i] = st^2 * ni
        noise[i+nmodes, i+nmodes] = st^2 * ni
    end
    return disp, transform, noise
end

"""
    amplifier([Td=Vector{Float64}, Tt=Matrix{Float64},] basis::SymplecticBasis, r<:Real, n<:Int)

Gaussian channel describing the interaction of an input
single mode Gaussian state and its environment via a two-mode squeezing operation. The channel is paramatrized
by squeezing amplitude parameter `r` and thermal noise `n`.

## Mathematical description of an amplifier channel

An amplifier channel, `A(r, nₜₕ)`, where `r` is
the squeezing amplitude parameter and `nₜₕ ≥ 1` is the thermal noise parameter,
is characterized by the zero displacement vector, transformation matrix `cosh(r)I`,
and noise matrix `nₜₕsinh²(r)I`.

## Example

```jldoctest
julia> amplifier(QuadPairBasis(1), 2.0, 3)
GaussianChannel for 1 mode.
  symplectic basis: QuadPairBasis
displacement: 2-element Vector{Float64}:
 0.0
 0.0
transform: 2×2 Matrix{Float64}:
 3.7622  0.0
 0.0     3.7622
noise: 2×2 Matrix{Float64}:
 39.4623   0.0
  0.0     39.4623
```
"""
function amplifier(::Type{Td}, ::Type{Tt}, basis::SymplecticBasis{N}, r::R, n::M; ħ = 2) where {Td,Tt,N<:Int,R,M}
    disp, transform, noise = _amplifier(basis, r, n)
    return GaussianChannel(basis, Td(disp), Tt(transform), Tt(noise); ħ = ħ)
end
amplifier(::Type{T}, basis::SymplecticBasis{N}, r::R, n::M; ħ = 2) where {T,N<:Int,R,M} = amplifier(T, T, basis, r, n; ħ = ħ)
function amplifier(basis::SymplecticBasis{N}, r::R, n::M; ħ = 2) where {N<:Int,R,M}
    disp, transform, noise = _amplifier(basis, r, n)
    return GaussianChannel(basis, disp, transform, noise; ħ = ħ)
end
function _amplifier(basis::Union{QuadPairBasis{N},QuadBlockBasis{N}}, r::R, n::M) where {N<:Int,R,M}
    nmodes = basis.nmodes
    disp = zeros(R, 2*nmodes) 
    transform = Matrix{R}(cosh(r) * I, 2*nmodes, 2*nmodes)
    noise = Matrix{R}((sinh(r))^2 * n * I, 2*nmodes, 2*nmodes)
    return disp, transform, noise
end
function _amplifier(basis::QuadPairBasis{N}, r::R, n::M) where {N<:Int,R<:Vector,M<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes) 
    transform = zeros(Rt, 2*nmodes, 2*nmodes)
    noise = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(r[i]), sinh(r[i])
        ni = n[i]

        transform[2*i-1, 2*i-1] = cr
        transform[2*i, 2*i] = cr

        noise[2*i-1, 2*i-1] = sr^2 * ni
        noise[2*i, 2*i] = sr^2 * ni
    end
    return disp, transform, noise
end
function _amplifier(basis::QuadBlockBasis{N}, r::R, n::M) where {N<:Int,R<:Vector,M<:Vector}
    nmodes = basis.nmodes
    Rt = eltype(R)
    disp = zeros(Rt, 2*nmodes) 
    transform = zeros(Rt, 2*nmodes, 2*nmodes)
    noise = zeros(Rt, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(nmodes)
        cr, sr = cosh(r[i]), sinh(r[i])
        ni = n[i]

        transform[i, i] = cr
        transform[i+nmodes, i+nmodes] = cr

        noise[i, i] = sr^2 * ni
        noise[i+nmodes, i+nmodes] = sr^2 * ni
    end
    return disp, transform, noise
end

##
# Predefined operations on Gaussian channels
##

function tensor(::Type{Td}, ::Type{Tt}, op1::GaussianChannel, op2::GaussianChannel) where {Td,Tt}
    typeof(op1.basis) == typeof(op2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    op1.ħ == op2.ħ || throw(ArgumentError(HBAR_ERROR))
    disp, transform, noise = _tensor(op1, op2)
    return GaussianChannel(op1.basis ⊕ op2.basis, Td(disp), Tt(transform), Tt(noise); ħ = op1.ħ)
end
tensor(::Type{T}, op1::GaussianChannel, op2::GaussianChannel) where {T} = tensor(T, T, op1, op2)
function tensor(op1::GaussianChannel, op2::GaussianChannel)
    typeof(op1.basis) == typeof(op2.basis) || throw(ArgumentError(SYMPLECTIC_ERROR))
    op1.ħ == op2.ħ || throw(ArgumentError(HBAR_ERROR))
    disp, transform, noise = _tensor(op1, op2)
    return GaussianChannel(op1.basis ⊕ op2.basis, disp, transform, noise; ħ = op1.ħ)
end
function _tensor(op1::GaussianChannel{B1,D1,T1}, op2::GaussianChannel{B2,D2,T2}) where {B1<:QuadPairBasis,B2<:QuadPairBasis,D1,D2,T1,T2}
    basis1, basis2 = op1.basis, op2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(2*nmodes1), Base.OneTo(2*nmodes2)
    # initialize direct sum of displacement vectors
    disp1, disp2 = op1.disp, op2.disp
    Dt = promote_type(eltype(disp1), eltype(disp2))
    disp′ = zeros(Dt, 2*nmodes)
    @inbounds for i in block1
        disp′[i] = disp1[i]
    end
    @inbounds for i in block2
        disp′[i+2*nmodes1] = disp2[i]
    end
    # initialize direct sum of transform and noise matrices
    trans1, trans2 = op1.transform, op2.transform
    Tt = promote_type(eltype(trans1), eltype(trans2))
    transform′ = zeros(Tt, 2*nmodes, 2*nmodes)
    noise1, noise2 = op1.noise, op2.noise
    noise′ = zeros(Tt, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        transform′[i,j] = trans1[i,j]
        noise′[i,j] = noise1[i,j]
    end
    @inbounds for i in block2, j in block2
        transform′[i+2*nmodes1,j+2*nmodes1] = trans2[i,j]
        noise′[i+2*nmodes1,j+2*nmodes1] = noise2[i,j]
    end
    # extract output array types
    disp′′ = _promote_output_vector(typeof(disp1), typeof(disp2), disp′)
    transform′′ = _promote_output_matrix(typeof(trans1), typeof(trans2), transform′)
    noise′′ = _promote_output_matrix(typeof(noise1), typeof(noise2), noise′)
    return disp′′, transform′′, noise′′
end
function _tensor(op1::GaussianChannel{B1,D1,T1}, op2::GaussianChannel{B2,D2,T2}) where {B1<:QuadBlockBasis,B2<:QuadBlockBasis,D1,D2,T1,T2}
    basis1, basis2 = op1.basis, op2.basis
    nmodes1, nmodes2 = basis1.nmodes, basis2.nmodes
    nmodes = nmodes1 + nmodes2
    block1, block2 = Base.OneTo(nmodes1), Base.OneTo(nmodes2)
    # initialize direct sum of displacement vectors
    disp1, disp2 = op1.disp, op2.disp
    Dt = promote_type(eltype(disp1), eltype(disp2))
    disp′ = zeros(Dt, 2*nmodes)
    @inbounds for i in block1
        disp′[i] = disp1[i]
        disp′[i+nmodes] = disp1[i+nmodes1]
    end
    @inbounds for i in block2
        disp′[i+nmodes1] = disp2[i]
        disp′[i+nmodes+nmodes1] = disp2[i+nmodes2]
    end
    # initialize direct sum of transform and noise matrices
    trans1, trans2 = op1.transform, op2.transform
    Tt = promote_type(eltype(trans1), eltype(trans2))
    transform′ = zeros(Tt, 2*nmodes, 2*nmodes)
    noise1, noise2 = op1.noise, op2.noise
    noise′ = zeros(Tt, 2*nmodes, 2*nmodes)
    @inbounds for i in block1, j in block1
        transform′[i,j] = trans1[i,j]
        transform′[i,j+nmodes] = trans1[i,j+nmodes1]
        transform′[i+nmodes,j] = trans1[i+nmodes1,j]
        transform′[i+nmodes,j+nmodes] = trans1[i+nmodes1,j+nmodes1]

        noise′[i,j] = noise1[i,j]
        noise′[i,j+nmodes] = noise1[i,j+nmodes1]
        noise′[i+nmodes,j] = noise1[i+nmodes1,j]
        noise′[i+nmodes,j+nmodes] = noise1[i+nmodes1,j+nmodes1]
    end
    @inbounds for i in block2, j in block2
        transform′[i+nmodes1,j+nmodes1] = trans2[i,j]
        transform′[i+nmodes1,j+nmodes+nmodes1] = trans2[i,j+nmodes2]
        transform′[i+nmodes+nmodes1,j+nmodes1] = trans2[i+nmodes2,j]
        transform′[i+nmodes+nmodes1,j+nmodes+nmodes1] = trans2[i+nmodes2,j+nmodes2]

        noise′[i+nmodes1,j+nmodes1] = noise2[i,j]
        noise′[i+nmodes1,j+nmodes+nmodes1] = noise2[i,j+nmodes2]
        noise′[i+nmodes+nmodes1,j+nmodes1] = noise2[i+nmodes2,j]
        noise′[i+nmodes+nmodes1,j+nmodes+nmodes1] = noise2[i+nmodes2,j+nmodes2]
    end
    # extract output array types
    disp′′ = _promote_output_vector(typeof(disp1), typeof(disp2), disp′)
    transform′′ = _promote_output_matrix(typeof(trans1), typeof(trans2), transform′)
    noise′′ = _promote_output_matrix(typeof(noise1), typeof(noise2), noise′)
    return disp′′, transform′′, noise′′
end

##
# Embedding Gaussian channels
##

"""
    embed(basis::SymplecticBasis, idx::Int, op::GaussianChannel)
    embed(basis::SymplecticBasis, indices::Vector{<:Int}, op::GaussianChannel)

Embed a smaller Gaussian channel into a larger symplectic basis. The channel
acts on the modes specified by `idx`/`indices` and leaves other modes unchanged.
"""
function embed(
    basis::QuadPairBasis, index::Int, op::GaussianChannel{<:QuadPairBasis,D,S}
) where {D,S}
    return embed(basis, [index], op)
end
function embed(
    basis::QuadPairBasis, indices::Vector{<:Int}, op::GaussianChannel{<:QuadPairBasis,D,S}
) where {D,S}
    @assert length(indices) == op.basis.nmodes "Number of indices must match number of modes in the channel"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = op.basis.nmodes
    disp = zeros(eltype(op.disp), 2 * total_modes)
    transform = Matrix{eltype(op.transform)}(I, 2 * total_modes, 2 * total_modes)
    noise = zeros(eltype(op.noise), 2 * total_modes, 2 * total_modes)

    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        disp[2idx-1] = op.disp[2i-1]
        disp[2idx] = op.disp[2i]
    end
    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            transform[2idx_i-1, 2idx_j-1] = op.transform[2i-1, 2j-1]
            transform[2idx_i-1, 2idx_j] = op.transform[2i-1, 2j]
            transform[2idx_i, 2idx_j-1] = op.transform[2i, 2j-1]
            transform[2idx_i, 2idx_j] = op.transform[2i, 2j]

            noise[2idx_i-1, 2idx_j-1] = op.noise[2i-1, 2j-1]
            noise[2idx_i-1, 2idx_j] = op.noise[2i-1, 2j]
            noise[2idx_i, 2idx_j-1] = op.noise[2i, 2j-1]
            noise[2idx_i, 2idx_j] = op.noise[2i, 2j]
        end
    end
    return GaussianChannel(basis, disp, transform, noise; ħ = op.ħ)
end
function embed(
    basis::QuadBlockBasis, index::Int, op::GaussianChannel{<:QuadBlockBasis,D,S}
) where {D,S}
    return embed(basis, [index], op)
end
function embed(
    basis::QuadBlockBasis, indices::Vector{<:Int}, op::GaussianChannel{<:QuadBlockBasis,D,S}
) where {D,S}
    @assert length(indices) == op.basis.nmodes "Number of indices must match number of modes in the channel"
    @assert basis.nmodes ≥ length(indices) "Target basis must be large enough"

    total_modes = basis.nmodes
    sub_modes = op.basis.nmodes
    disp = zeros(eltype(op.disp), 2 * total_modes)
    transform = Matrix{eltype(op.transform)}(I, 2 * total_modes, 2 * total_modes)
    noise = zeros(eltype(op.noise), 2 * total_modes, 2 * total_modes)

    @inbounds for i in Base.OneTo(sub_modes)
        idx = indices[i]
        disp[idx] = op.disp[i]
        disp[idx + total_modes] = op.disp[i + sub_modes]
    end
    @inbounds for i in Base.OneTo(sub_modes)
        idx_i = indices[i]
        @inbounds for j in Base.OneTo(sub_modes)
            idx_j = indices[j]
            transform[idx_i, idx_j] = op.transform[i, j]
            transform[idx_i, idx_j + total_modes] = op.transform[i, j + sub_modes]
            transform[idx_i + total_modes, idx_j] = op.transform[i + sub_modes, j]
            transform[idx_i + total_modes, idx_j + total_modes] = op.transform[i + sub_modes, j + sub_modes]

            noise[idx_i, idx_j] = op.noise[i, j]
            noise[idx_i, idx_j + total_modes] = op.noise[i, j + sub_modes]
            noise[idx_i + total_modes, idx_j] = op.noise[i + sub_modes, j]
            noise[idx_i + total_modes, idx_j + total_modes] = op.noise[i + sub_modes, j + sub_modes]
        end
    end
    return GaussianChannel(basis, disp, transform, noise; ħ = op.ħ)
end

"""
    changebasis(::SymplecticBasis, state::GaussianChannel)

Change the symplectic basis of a Gaussian channel.

# Example

```jldoctest
julia> ch = attenuator(QuadBlockBasis(2), [1.0, 2.0], [2, 4])
GaussianChannel for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
transform: 4×4 Matrix{Float64}:
 0.540302   0.0       0.0        0.0
 0.0       -0.416147  0.0        0.0
 0.0        0.0       0.540302   0.0
 0.0        0.0       0.0       -0.416147
noise: 4×4 Matrix{Float64}:
 1.41615  0.0      0.0      0.0
 0.0      3.30729  0.0      0.0
 0.0      0.0      1.41615  0.0
 0.0      0.0      0.0      3.30729

julia> changebasis(QuadPairBasis, ch)
GaussianChannel for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
transform: 4×4 Matrix{Float64}:
 0.540302  0.0        0.0        0.0
 0.0       0.540302   0.0        0.0
 0.0       0.0       -0.416147   0.0
 0.0       0.0        0.0       -0.416147
noise: 4×4 Matrix{Float64}:
 1.41615  0.0      0.0      0.0
 0.0      1.41615  0.0      0.0
 0.0      0.0      3.30729  0.0
 0.0      0.0      0.0      3.30729
```
"""
function changebasis(::Type{B1}, op::GaussianChannel{B2,D,S}) where {B1<:QuadBlockBasis,B2<:QuadPairBasis,D,S}
    basis = op.basis
    nmodes = basis.nmodes
    St = eltype(S)
    T = zeros(St, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(2*nmodes), j in Base.OneTo(2*nmodes)
        if (j == 2*i-1) || (j + 2*nmodes == 2*i)
            T[i,j] = oneunit(St)
        end
    end
    T = typeof(T) == S ? T : S(T)
    disp = T * op.disp
    transform = T * op.transform * transpose(T)
    noise = T * op.noise * transpose(T)
    return GaussianChannel(B1(nmodes), disp, transform, noise)
end
function changebasis(::Type{B1}, op::GaussianChannel{B2,D,S}) where {B1<:QuadPairBasis,B2<:QuadBlockBasis,D,S}
    basis = op.basis
    nmodes = basis.nmodes
    St = eltype(S)
    T = zeros(St, 2*nmodes, 2*nmodes)
    @inbounds for i in Base.OneTo(2*nmodes), j in Base.OneTo(2*nmodes)
        if (i == 2*j-1) || (i + 2*nmodes == 2*j)
            T[i,j] = oneunit(St)
        end
    end
    T = typeof(T) == S ? T : S(T)
    disp = T * op.disp
    transform = T * op.transform * transpose(T)
    noise = T * op.noise * transpose(T)
    return GaussianChannel(B1(nmodes), disp, transform, noise)
end
changebasis(::Type{<:QuadBlockBasis}, op::GaussianChannel{<:QuadBlockBasis,D,S}) where {D,S} = op
changebasis(::Type{<:QuadPairBasis}, op::GaussianChannel{<:QuadPairBasis,D,S}) where {D,S} = op

using Gabs
using JET
using Test

@testset "JET checks" begin
    rep = JET.report_package(Gabs; target_modules=(Gabs,))
    @show rep

    reports = JET.get_reports(rep)
    # Baseline from Julia 1.12.6 and JET 0.11.6; lower this as reports are fixed.
    @test length(reports) <= 15
    @test_broken isempty(reports)
end

# [Tutorials](@id Tutorials)

```@meta
DocTestSetup = quote
    using Gabs
end
```

## Visualizations

Quasiprobability distributions of Gaussian states can be visualized with [Makie.jl](https://github.com/MakieOrg/Makie.jl). Gabs.jl
currently has support for the following distributions, which can be called with the keyword argument `dist`:
- [`wigner`](@ref)
- [`wignerchar`](@ref)

Below is a code example that plots the wigner distribution of a vacuum state:
```@example
using Gabs, CairoMakie
basis = QuadPairBasis(1)
state = vacuumstate(basis)
q, p = collect(-5.0:0.5:5.0), collect(-5.0:0.5:5.0) # phase space coordinates
heatmap(q, p, state, dist = :wigner)
```
Of course, more plotting sugar can be added to this example with internal Makie attributes:
```@example
using Gabs, CairoMakie
basis = QuadPairBasis(1)
state = vacuumstate(basis)
q, p = collect(-5.0:0.5:5.0), collect(-5.0:0.5:5.0) # phase space coordinates
fig = Figure(fontsize=15, size = (375, 300), fonts = (; regular="CMU Serif"))
ax = Axis(fig[1,1], xlabel = L"q", ylabel = L"p")
hm = heatmap!(ax, q, p, state, dist = :wigner, colormap = :heat)
Colorbar(fig[1,2], hm)
fig
```
## Using Custom Arrays

Types such as [`GaussianState`](@ref), [`GaussianUnitary`](@ref), and
[`GaussianChannel`](@ref) are agnostic array wrappers, so they can hold any custom array that exists
in the Julia ecosystem. Operations in Gabs.jl preserve these custom array types, provided they
follow the [`AbstractArray` interface](https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-array).

Let's explore this feature in detail, using [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) and [SparseArrays.jl](https://github.com/JuliaSparse/SparseArrays.jl) as a case study. To create a coherent state that wraps around pure Julia arrays, the function
[`coherentstate`](@ref) can be called with a single complex argument:
```jldoctest
julia> coherentstate(QuadPairBasis(1), 1.0-im)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element Vector{Float64}:
  2.0
 -2.0
covariance: 2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
```
Here, a [`GaussianState`](@ref) object containing a `Vector{Float64}` of size two (mean vector)
and a `Matrix{Float64}` of size two by two (covariance matrix) was initialized. If we want to potentially optimize and boost the performance of our code,
then one approach would be to wrap our [`GaussianState`](@ref) around different array types, for instance, an [`SVector`](https://juliaarrays.github.io/StaticArrays.jl/stable/api/#StaticArraysCore.SVector) from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) or a [`SparseVector`](https://docs.julialang.org/en/v1/stdlib/SparseArrays/#SparseArrays.SparseVector) from [SparseArrays.jl](https://github.com/JuliaSparse/SparseArrays.jl). Any defined method in Gabs.jl that (i) creates a custom type or (ii) transforms a custom type
can specify an array type in its first (and second) arguments. Let's see an example with [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl):
```jldoctest
julia> using StaticArrays

julia> state = coherentstate(SVector{2}, SMatrix{2,2}, QuadPairBasis(1), 1.0-im)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element SVector{2, Float64} with indices SOneTo(2):
  2.0
 -2.0
covariance: 2×2 SMatrix{2, 2, Float64, 4} with indices SOneTo(2)×SOneTo(2):
 1.0  0.0
 0.0  1.0

julia> tp = state ⊗ state
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element SVector{4, Float64} with indices SOneTo(4):
  2.0
 -2.0
  2.0
 -2.0
covariance: 4×4 SMatrix{4, 4, Float64, 16} with indices SOneTo(4)×SOneTo(4):
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0

julia> using SparseArrays

julia> ptrace(SparseVector, SparseMatrixCSC, tp, 1)
GaussianState for 1 mode.
  symplectic basis: QuadPairBasis
mean: 2-element SparseVector{Float64, Int64} with 2 stored entries:
  [1]  =  2.0
  [2]  =  -2.0
covariance: 2×2 SparseMatrixCSC{Float64, Int64} with 2 stored entries:
 1.0   ⋅ 
  ⋅   1.0
```
Importantly, methods that create or manipulate a Gaussian state, such as [`tensor`](@ref) and [`ptrace`](@ref), preserve array types, but can also opt for a different array type.

!!! note
    If you have an array wrapper that initializes both vectors
    and matrices, then you can specify the array type with a single argument. For instance, to initialize a state that contains `Array`s holding numbers of type `Float32` rather
    than `Float64`, simply pass `Array{Float32}` to any relevant Gabs.jl method:
    ```jldoctest
    julia> state = displace(Array{Float32}, QuadPairBasis(1), 1.0-im)
    GaussianUnitary for 1 mode.
      symplectic basis: QuadPairBasis
    displacement: 2-element Vector{Float32}:
      2.0
     -2.0
    symplectic: 2×2 Matrix{Float32}:
     1.0  0.0
     0.0  1.0
    ```

## Creating Symbolic Gaussian States

Create Gaussian states with symbolic variables using [Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl):

```julia
julia> using Symbolics

julia> @variables r θ τ
3-element Vector{Num}:
 r
 θ
 τ

julia> b = QuadBlockBasis(2);

julia> st = eprstate(b, r, θ)
GaussianState for 2 modes.
  symplectic basis: QuadBlockBasis
mean: 4-element Vector{Num}:
 0
 0
 0
 0
covariance: 4×4 Matrix{Num}:
         cosh(2r)  -sinh(2r)*cos(θ)                 0  -sinh(2r)*sin(θ)
 -sinh(2r)*cos(θ)          cosh(2r)  -sinh(2r)*sin(θ)                 0
                0  -sinh(2r)*sin(θ)          cosh(2r)   sinh(2r)*cos(θ)
 -sinh(2r)*sin(θ)                 0   sinh(2r)*cos(θ)          cosh(2r)

julia> op = beamsplitter(b, τ)
GaussianUnitary for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Num}:
 0
 0
 0
 0
symplectic: 4×4 Matrix{Num}:
 sqrt(1 - τ)      sqrt(τ)            0            0
    -sqrt(τ)  sqrt(1 - τ)            0            0
           0            0  sqrt(1 - τ)      sqrt(τ)
           0            0     -sqrt(τ)  sqrt(1 - τ)

julia> newst = ptrace(op * st, 1);
```

Use [Latexify](https://github.com/korsbo/Latexify.jl) to render the covariance matrix of `newst` in LaTeX with the command `latexify(newst.covar) |> print`:

```math
\begin{equation}
\left[
\begin{array}{cc}
\left( \cosh\left( 2 r \right) \sqrt{1 - \tau} + \cos\left( \theta \right) \sinh\left( 2 r \right) \sqrt{\tau} \right) \sqrt{1 - \tau} - \left(  - \sqrt{\tau} \cosh\left( 2 r \right) - \cos\left( \theta \right) \sinh\left( 2 r \right) \sqrt{1 - \tau} \right) \sqrt{\tau} & 2 \sinh\left( 2 r \right) \sin\left( \theta \right) \sqrt{\tau} \sqrt{1 - \tau} \\
2 \sinh\left( 2 r \right) \sin\left( \theta \right) \sqrt{\tau} \sqrt{1 - \tau} & \left( \cosh\left( 2 r \right) \sqrt{1 - \tau} - \cos\left( \theta \right) \sinh\left( 2 r \right) \sqrt{\tau} \right) \sqrt{1 - \tau} - \left(  - \sqrt{\tau} \cosh\left( 2 r \right) + \cos\left( \theta \right) \sinh\left( 2 r \right) \sqrt{1 - \tau} \right) \sqrt{\tau} \\
\end{array}
\right]
\end{equation}
```

## GPU Acceleration

## Multithreading

## Benchmarking and Profiling

# [Manual](@id Manual)

```@meta
DocTestSetup = quote
    using Gabs
end
```

Simply put, Gabs is a package for creating and transforming Gaussian bosonic systems. This section discusses the "lower level" tools for simulating such phenomena, with
mathematical explanations when appropriate. For comprehensive reviews of Gaussian
quantum information, see the [suggested readings page](@ref References).

## The Symplectic Formalism

The underlying geometry of Gaussian informatics in the phase space is *symplectic*. From the basic canonical commutation
relations (CCRs) of quantized continuous variable systems, manifestations of the symplectic group $\text{Sp}(2N, \mathbb{R})$
appear everywhere. In Gabs, symplectic basis types must be defined from the beginning. Here's how they are laid out in this library:

| canonical ordering | symplectic form | basis type |
| :---: | :---: | :---: |
| $(\hat{x}_1, \hat{p}_1, \cdots, \hat{x}_N, \hat{p}_N)$ | $\begin{pmatrix} 0 & 1 \\ - 1 & 0 \end{pmatrix} \otimes \mathbf{I}_N$ | [`QuadPairBasis`](@ref) |
| $(\hat{x}_1, \cdots, \hat{x}_N, \hat{p}_1, \cdots, \hat{p}_N)$ | $\begin{pmatrix} 0 & \mathbf{I}_N \\ -\mathbf{I}_N & 0 \end{pmatrix}$ | [`QuadBlockBasis`](@ref) |

Each symplectic basis type is wrapped around the number of bosonic modes $N$. We can compose a larger symplectic basis
with [`directsum`](@ref) or `⊕`, the direct sum symbol which can be typed in the Julia REPL as `\oplus<TAB>`:

```jldoctest
julia> b = QuadPairBasis(2)
QuadPairBasis(2)

julia> b ⊕ b
QuadPairBasis(4)
```
Of course, this type of behavior will occur implicitly when we take tensor products of Gaussian states and operators, as discussed
in the following sections.

!!! note
    A matrix $\mathbf{S}$ of size $2N\times 2N$ is symplectic when it satisfies the relation $\mathbf{S} \mathbf{\Omega} \mathbf{S}^{\text{T}} = \mathbf{\Omega},$ where $\mathbf{\Omega}$ is an invertible skew-symmetric matrix known as the *symplectic form*.

## Gaussian States

The star of this package is the [`GaussianState`](@ref) type, which allows us to initialize
and manipulate a phase space description of an arbitrary Gaussian state.

```@docs; canonical = false
GaussianState
```

Functions to create instances of elementary Gaussian states are provided as part of the package API. 
Listed below are supported predefined Gaussian states:

- [`vacuumstate`](@ref)
- [`thermalstate`](@ref)
- [`coherentstate`](@ref)
- [`squeezedstate`](@ref)
- [`eprstate`](@ref)

Detailed discussions and mathematical descriptions for each of these states are given in the
[Gaussian Zoos](@ref) page.

!!! note
    In Gabs, the default convention $\hbar = 2$ is used for the commutation relation $[\hat{x}, \hat{p}] = i\hbar$. To change this convention, pass a new value to `ħ` as a keyword argument in any predefined method that creates a Gaussian object. For instance, to change the convention to `ħ = 1` for a coherent state, call `coherentstate(basis, α, ħ = 1)`. This is a more performant and safer approach compared to setting a global variable in a package. An error will be thrown for operations between Gaussian objects with different `ħ` conventions.

## Gaussian Unitaries

To transform Gaussian states into Gaussian states, we need Gaussian maps. Let's begin with the simplest Gaussian transformation, a unitary transformation, which can be created with the [`GaussianUnitary`](@ref) type:

```@docs; canonical = false
GaussianUnitary
```

This is a rather clean way to characterize a large group of Gaussian transformations on
an `N`-mode Gaussian bosonic system. As long as we have a displacement vector of size `2N` and symplectic matrix of size `2N x 2N`, we can create a Gaussian transformation. 

This library has a number of predefined Gaussian unitaries, which are listed below:

- [`displace`](@ref)
- [`squeeze`](@ref)
- [`twosqueeze`](@ref)
- [`phaseshift`](@ref)
- [`beamsplitter`](@ref)
  
Detailed discussions and mathematical descriptions for each of these unitaries are given in the [Gaussian Zoos](@ref) page.

## Gaussian Channels

Noisy bosonic channels are an important model for describing the interaction between a Gaussian state and its environment. Similar to Gaussian unitaries, Gaussian channels are linear bosonic channels that map Gaussian states to Gaussian states. Such objects can be created with the [`GaussianChannel`](@ref) type:

```@docs; canonical = false
GaussianChannel
```

Listed below are a list of predefined Gaussian channels supported by Gabs:

- [`attenuator`](@ref)
- [`amplifier`](@ref)
  
!!! note
    Any predefined Gaussian unitary
    method can be called with an additional noise matrix to create a [`GaussianChannel`](@ref) object. For instance, a noisy displacement operator can be called with [`displace`](@ref) as follows:

    ```jldoctest
    julia> basis = QuadPairBasis(1);

    julia> noise = [1.0 -2.0; 4.0 -3.0];

    julia> displace(basis, 1.0-im, noise)
    GaussianChannel for 1 mode.
      symplectic basis: QuadPairBasis
    displacement: 2-element Vector{Float64}:
      2.0
     -2.0
    transform: 2×2 Matrix{Float64}:
     1.0  0.0
     0.0  1.0
    noise: 2×2 Matrix{Float64}:
     1.0  -2.0
     4.0  -3.0
    ```

## Actions

Out-of-place actions of Gaussian unitaries and Gaussian channels on Gaussian states
are called with `*`, while in-place ones are called with [`apply!`](@ref):

```jldoctest
julia> basis = QuadBlockBasis(2); state = vacuumstate(basis);

julia> un = squeeze(basis, 1.0, 2.0)
GaussianUnitary for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  2.03214   0.0      -1.06861   0.0
  0.0       2.03214   0.0      -1.06861
 -1.06861   0.0       1.05402   0.0
  0.0      -1.06861   0.0       1.05402

julia> un * state
GaussianState for 2 modes.
  symplectic basis: QuadBlockBasis
mean: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
  5.2715    0.0      -3.29789   0.0
  0.0       5.2715    0.0      -3.29789
 -3.29789   0.0       2.25289   0.0
  0.0      -3.29789   0.0       2.25289

julia> ch = attenuator(basis, 0.25, 5)
GaussianChannel for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
transform: 4×4 Matrix{Float64}:
 0.968912  0.0       0.0       0.0
 0.0       0.968912  0.0       0.0
 0.0       0.0       0.968912  0.0
 0.0       0.0       0.0       0.968912
noise: 4×4 Matrix{Float64}:
 0.306044  0.0       0.0       0.0
 0.0       0.306044  0.0       0.0
 0.0       0.0       0.306044  0.0
 0.0       0.0       0.0       0.306044

julia> apply!(state, ch)
GaussianState for 2 modes.
  symplectic basis: QuadBlockBasis
mean: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
covariance: 4×4 Matrix{Float64}:
 1.24483  0.0      0.0      0.0
 0.0      1.24483  0.0      0.0
 0.0      0.0      1.24483  0.0
 0.0      0.0      0.0      1.24483
```

To apply a Gaussian unitary or channel to selected modes, place the mode index or
indices before the operation: `apply!(state, indices, op)`.

## Tensor Products

If we were operating in the state (Fock) space, and wanted to describe multi-mode Gaussian states,
we would take the tensor product of multiple density operators. That method, however,
is quite computationally expensive and requires a finite truncation of the Fock basis. To create
such state vector simulations, we recommend using the [QuantumOptics.jl](https://github.com/qojulia/QuantumOptics.jl) library. For our purposes in the phase space, we efficiently create multi-mode Gaussian systems via direct sum, which corresponds to a tensor product of infinite-dimensional Hilbert spaces. A tensor product of Gaussian states can be called with either [`tensor`](@ref) or `⊗`, the Kronecker product symbol
which can be typed in the Julia REPL as `\otimes<TAB>`. Take the following example, where we produce a 3-mode Gaussian state that consists of a coherent state, vacuumstate, and squeezed state:

```jldoctest
julia> basis = QuadPairBasis(1);

julia> coherentstate(basis, -1.0+im) ⊗ vacuumstate(basis) ⊗ squeezedstate(basis, 0.25, pi/4)
GaussianState for 3 modes.
  symplectic basis: QuadPairBasis
mean: 6-element Vector{Float64}:
 -2.0
  2.0
  0.0
  0.0
  0.0
  0.0
covariance: 6×6 Matrix{Float64}:
 1.0  0.0  0.0  0.0   0.0        0.0
 0.0  1.0  0.0  0.0   0.0        0.0
 0.0  0.0  1.0  0.0   0.0        0.0
 0.0  0.0  0.0  1.0   0.0        0.0
 0.0  0.0  0.0  0.0   0.759156  -0.36847
 0.0  0.0  0.0  0.0  -0.36847    1.4961
```

Note that in the above example, we defined the symplectic basis to be of type [`QuadPairBasis`](@ref). If we wanted the canonical field operators to be ordered blockwise, then we would call [`QuadBlockBasis`](@ref) instead:

```jldoctest
julia> basis = QuadBlockBasis(1);

julia> coherentstate(basis, -1.0+im) ⊗ vacuumstate(basis) ⊗ squeezedstate(basis, 0.25, pi/4)
GaussianState for 3 modes.
  symplectic basis: QuadBlockBasis
mean: 6-element Vector{Float64}:
 -2.0
  0.0
  0.0
  2.0
  0.0
  0.0
covariance: 6×6 Matrix{Float64}:
 1.0  0.0   0.0       0.0  0.0   0.0
 0.0  1.0   0.0       0.0  0.0   0.0
 0.0  0.0   0.759156  0.0  0.0  -0.36847
 0.0  0.0   0.0       1.0  0.0   0.0
 0.0  0.0   0.0       0.0  1.0   0.0
 0.0  0.0  -0.36847   0.0  0.0   1.4961
```
These tensor product methods are also available for Gaussian unitaries and channels:

```jldoctest
julia> basis = QuadBlockBasis(1);

julia> squeeze(basis, 2.0, pi/3) ⊗ phaseshift(basis, pi/6)
GaussianUnitary for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  1.94877   0.0       -3.14095  0.0
  0.0       0.866025   0.0      0.5
 -3.14095   0.0        5.57563  0.0
  0.0      -0.5        0.0      0.866025
```

For applying the same predefined operator to a multi-mode system, simply call
the operator on the corresponding multi-mode basis. For instance, if we wanted to
apply a phase shift of `π/4` to a three-mode Gaussian system, then we would
create the following operation:

```jldoctest
julia> basis = QuadPairBasis(3);

julia> phaseshift(basis, pi/4)
GaussianUnitary for 3 modes.
  symplectic basis: QuadPairBasis
displacement: 6-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
 0.0
 0.0
symplectic: 6×6 Matrix{Float64}:
  0.707107  0.707107   0.0       0.0        0.0       0.0
 -0.707107  0.707107   0.0       0.0        0.0       0.0
  0.0       0.0        0.707107  0.707107   0.0       0.0
  0.0       0.0       -0.707107  0.707107   0.0       0.0
  0.0       0.0        0.0       0.0        0.707107  0.707107
  0.0       0.0        0.0       0.0       -0.707107  0.707107
```

If, instead we wanted to apply phase shifts of `π/3`, `π/4`, and `π/5`
to the respective-modes of a three-mode Gaussian system, then we would dispatch
`phaseshift` on a vector of the phase shifts:

```jldoctest
julia> basis = QuadPairBasis(3);

julia> phaseshift(basis, [pi/3, pi/4, pi/5])
GaussianUnitary for 3 modes.
  symplectic basis: QuadPairBasis
displacement: 6-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
 0.0
 0.0
symplectic: 6×6 Matrix{Float64}:
  0.5       0.866025   0.0       0.0        0.0       0.0
 -0.866025  0.5        0.0       0.0        0.0       0.0
  0.0       0.0        0.707107  0.707107   0.0       0.0
  0.0       0.0       -0.707107  0.707107   0.0       0.0
  0.0       0.0        0.0       0.0        0.809017  0.587785
  0.0       0.0        0.0       0.0       -0.587785  0.809017
```

Similar properties hold for Gaussian channels and states. Let's see some examples
for multi-mode coherent states:

```jldoctest
julia> basis = QuadPairBasis(3);

julia> coherentstate(basis, 1.0-im)
GaussianState for 3 modes.
  symplectic basis: QuadPairBasis
mean: 6-element Vector{Float64}:
  2.0
 -2.0
  2.0
 -2.0
  2.0
 -2.0
covariance: 6×6 Matrix{Float64}:
 1.0  0.0  0.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0  0.0  0.0
 0.0  0.0  1.0  0.0  0.0  0.0
 0.0  0.0  0.0  1.0  0.0  0.0
 0.0  0.0  0.0  0.0  1.0  0.0
 0.0  0.0  0.0  0.0  0.0  1.0

julia> coherentstate(basis, [1.0-im, 2.0-2.0im, 3.0-3.0im])
GaussianState for 3 modes.
  symplectic basis: QuadPairBasis
mean: 6-element Vector{Float64}:
  2.0
 -2.0
  4.0
 -4.0
  6.0
 -6.0
covariance: 6×6 Matrix{Float64}:
 1.0  0.0  0.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0  0.0  0.0
 0.0  0.0  1.0  0.0  0.0  0.0
 0.0  0.0  0.0  1.0  0.0  0.0
 0.0  0.0  0.0  0.0  1.0  0.0
 0.0  0.0  0.0  0.0  0.0  1.0
```

## Partial Traces

Partial traces of Gaussian states can be performed with [`ptrace`](@ref). For tracing 
out a single-mode, call an integer corresponding to the mode of choice in a multi-mode Gaussian system. For tracing out several modes, call instead a vector of integers. 
Let's see some examples:
```jldoctest
julia> basis = QuadPairBasis(2);

julia> state = coherentstate(basis, [1.0-im, 2.0-2.0im]) ⊗ eprstate(basis, 2.0, pi/3)
GaussianState for 4 modes.
  symplectic basis: QuadPairBasis
mean: 8-element Vector{Float64}:
  2.0
 -2.0
  4.0
 -4.0
  0.0
  0.0
  0.0
  0.0
covariance: 8×8 Matrix{Float64}:
 1.0  0.0  0.0  0.0    0.0       0.0       0.0       0.0
 0.0  1.0  0.0  0.0    0.0       0.0       0.0       0.0
 0.0  0.0  1.0  0.0    0.0       0.0       0.0       0.0
 0.0  0.0  0.0  1.0    0.0       0.0       0.0       0.0
 0.0  0.0  0.0  0.0   27.3082    0.0     -13.645   -23.6338
 0.0  0.0  0.0  0.0    0.0      27.3082  -23.6338   13.645
 0.0  0.0  0.0  0.0  -13.645   -23.6338   27.3082    0.0
 0.0  0.0  0.0  0.0  -23.6338   13.645     0.0      27.3082

julia> ptrace(state, 1)
GaussianState for 3 modes.
  symplectic basis: QuadPairBasis
mean: 6-element Vector{Float64}:
  4.0
 -4.0
  0.0
  0.0
  0.0
  0.0
covariance: 6×6 Matrix{Float64}:
 1.0  0.0    0.0       0.0       0.0       0.0
 0.0  1.0    0.0       0.0       0.0       0.0
 0.0  0.0   27.3082    0.0     -13.645   -23.6338
 0.0  0.0    0.0      27.3082  -23.6338   13.645
 0.0  0.0  -13.645   -23.6338   27.3082    0.0
 0.0  0.0  -23.6338   13.645     0.0      27.3082

julia> ptrace(state, [1, 4])
GaussianState for 2 modes.
  symplectic basis: QuadPairBasis
mean: 4-element Vector{Float64}:
  4.0
 -4.0
  0.0
  0.0
covariance: 4×4 Matrix{Float64}:
 1.0  0.0   0.0      0.0
 0.0  1.0   0.0      0.0
 0.0  0.0  27.3082   0.0
 0.0  0.0   0.0     27.3082
```

## Symplectic Analysis

Gabs provides different tools for analyzing symplectic transformations and properties
of Gaussian states and operators. Under the hood, the aforementioned types such 
as [`GaussianState`](@ref), [`GaussianUnitary`](@ref), and [`GaussianChannel`](@ref)
keep track of symplectic bases, i.e., ordering of bosonic mode operators. To change
symplectic bases, simply call [`changebasis`](@ref). As an example, consider the phase shift operator, defined by the quadrature transformations
```math
\hat{x} \to \cos(\theta) \hat{x} + \sin(\theta) \hat{p}, \qquad \hat{p} \to -\sin(\theta) \hat{x} + \cos(\theta) \hat{p}.
```
The symplectic transformation corresponding to the action of a tensor product of phase shift operators
on a bosonic system is dependent on the ordering of the bosonic mode observables, so it is useful to swap
symplectic bases. Consider a simple example for a two-mode system:
```jldoctest
julia> op = phaseshift(QuadBlockBasis(2), 0.5)
GaussianUnitary for 2 modes.
  symplectic basis: QuadBlockBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  0.877583   0.0       0.479426  0.0
  0.0        0.877583  0.0       0.479426
 -0.479426   0.0       0.877583  0.0
  0.0       -0.479426  0.0       0.877583

julia> changebasis(QuadPairBasis, op)
GaussianUnitary for 2 modes.
  symplectic basis: QuadPairBasis
displacement: 4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0
symplectic: 4×4 Matrix{Float64}:
  0.877583  0.479426   0.0       0.0
 -0.479426  0.877583   0.0       0.0
  0.0       0.0        0.877583  0.479426
  0.0       0.0       -0.479426  0.877583
```
Various symplectic decompositions are supported in Gabs through the symplectic linear algebra package [SymplecticFactorizations.jl](https://github.com/apkille/SymplecticFactorizations.jl). Particularly important
ones are the Williamson decomposition ([`williamson`](@ref)), Bloch-Messiah/Euler decomposition ([`blochmessiah`](@ref)), and the symplectic polar decomposition ([`polar`](@ref)):
```@docs; canonical = false
williamson
```
```@docs; canonical = false
blochmessiah
```
```@docs; canonical = false
polar
```
Let's see an example with the Williamson decomposition:
```@repl; using Gabs
using Gabs, LinearAlgebra
state = randstate(QuadBlockBasis(1))
F = williamson(state)
isapprox(Diagonal(repeat(F.spectrum, 2)), F.S * state.covar * F.S', atol = 1e-12)
S, spectrum = F; # destructuring via iteration
S == F.S && spectrum == F.spectrum
issymplectic(QuadBlockBasis(1), S, atol = 1e-12)
```
In the last line of code, we used the symplectic check [`issymplectic`](@ref). In general, we can
check if a state or operator is Gaussian with [`isgaussian`](@ref).

# [Suggested Readings and References](@id References)

## Tutorials on Gaussian Quantum Information

```@bibliography
Pages = []
Canonical = false

weedbrook2012
wang2007
adesso2014
olivares2011
```

## Tutorials and Books on Quantum Continuous Variables

```@bibliography
Pages = []
Canonical = false

serafini2023
cerf2007(a)
braunstein2005
walschaers2021
```

## Technical Reviews on Quantum Continuous Variables

```@bibliography
Pages = []
Canonical = false

andersen2010
fukui2022
cerf2007(b)
vanLoock2002
pirandola2006
lvovsky2009
jankowski2024
goldberg2020
```

## Seminal Papers related to Gaussian Quantum Information

```@bibliography
Pages = []
Canonical = false

simon1988
lloyd1999
duan2000
bartlett2002
eisert2002a
fiurasek2002
eisert2002b
giedke2002
grosshans2002
giedke2003
wenger2004
braunstein2005squeezing
```

## No-Go Theorems and Fundamental Limitations in Gaussian Quantum Information

```@bibliography
Pages = []
Canonical = false

eisert2002a
eisert2002b
fiurasek2002
giedke2002
werner2001
```

## Publications on Gaussian Quantum Measurements

```@bibliography
Pages = []
Canonical = false

zhang2018
genoni2016
kiukas2013
cenni2022
```

# [Getting Started with Gabs](@id intro)

Gabs is a numerical tooling package for simulating Gaussian quantum information.
Gaussian states and operators have the convenient property that they can be
characterized by low-dimensional matrices in the phase space representation.
Thus, a large class of continuous variable quantum information can be efficiently
simulated on a classical computer. Gabs provides a high-level [Julia](https://julialang.org) interface for performing such efficient simulations in a straightforward manner.

In the sections below, a getting started tutorial is provided to introduce the capabilities of Gabs. The rest of the documentation is structured as follows:

- [Manual](@ref) - an overview of the package types and inner-workings,
- [Tutorials](@ref) - explanations for using particular features of the library,
- [Gaussian Zoos](@ref) - a description of predefined Gaussian states and operators,
- [API](@ref Full-API) - the full API of the library,
- [Suggested Readings and References](@ref References) - publications and learning resources on Gaussian quantum information.

!!! note
    This documentation assumes familiarity with linear algebra and quantum information.
    Introductory books and tutorials for these topics are provided in the [Suggested Readings and References page](@ref References).

!!! tip "Contributing"
    Any contribution to Gabs is welcome! Feature suggestions, pull requests, and bug reports
    can be submitted on [Github](https://github.com/apkille/Gabs.jl). The maintainers of Gabs
    subscribe to the [Julia Community Standards](https://julialang.org/community/standards/).

## Installation

To install Gabs.jl, start Julia and run the following command:

```julia
using Pkg
Pkg.add("Gabs")
```
To use the package, run the command

```julia
using Gabs
```

Now, the entire library is loaded into the current workspace, with access to its
high-level interface and predefined objects.

# [Gaussian Zoos](@id Gaussian Zoos)

## State Zoo

```@docs; canonical = false
vacuumstate
thermalstate
coherentstate
squeezedstate
eprstate
```

## Operator Zoo

```@docs; canonical = false
displace
squeeze
twosqueeze
phaseshift
beamsplitter
attenuator
amplifier
```

# Gabs.jl

```@meta
DocTestSetup = quote
    using Gabs
end
```

A numerical package for simulating Gaussian quantum information in the phase space representation.

Visit the [getting started page](@ref intro) for an introduction to Gabs
and its documentation.
